from typing import *
import pymel.util as _util
import pymel.core.datatypes as datatypes
from builtins import str
from pymel.core import animation as animation, effects as effects, general as general, modeling as modeling, other as other, rendering as rendering, system as system, windows as windows
from pymel.core.system import FileReference as _FileReference
from pymel.util.enum import Enum as Enum
from typing import Any, Optional

mayaTypeNameToPymelTypeName: Any
pymelTypeNameToMayaTypeName: Any

class NodetypesLazyLoadModule(_util.LazyLoadModule):
    def __getattr__(self, name: Any): ...

class DependNode:
    __apicls__: Any = ...
    def __melobject__(self): ...
    def name(self, update: bool=..., stripNamespace: bool=..., levels: int=..., long: bool=..., stripUnderWorld: bool=...) -> str: ...
    def namespace(self, root: bool=...) -> str: ...
    def shortName(self, **kwargs: Any) -> str: ...
    def longName(self, **kwargs: Any) -> str: ...
    def nodeName(self, **kwargs: Any) -> str: ...
    def rename(self, name: Any, **kwargs: Any) -> DependNode: ...
    def __apiobject__(self): ...
    def __apimobject__(self): ...
    def __apihandle__(self): ...
    def __hash__(self) -> Any: ...
    def node(self) -> DependNode: ...
    def lock(self, **kwargs: Any): ...
    def unlock(self, **kwargs: Any): ...
    def cast(self, swapNode: Any, **kwargs: Any): ...
    duplicate: Any = ...
    def savePreset(self, presetName: Any, custom: Optional[Any] = ..., attributes: Any = ...): ...
    def loadPreset(self, presetName: Any): ...
    def deletePreset(self, presetName: Any): ...
    def listPresets(self): ...
    type: Any = ...
    @classmethod
    def typeName(cls): ...
    def referenceFile(self) -> Optional[_FileReference]: ...
    def classification(self, **kwargs: Any): ...
    def inputs(self, **kwargs: Any) -> List[general.PyNode]: ...
    def outputs(self, **kwargs: Any) -> List[general.PyNode]: ...
    def sources(self, **kwargs: Any) -> List[general.PyNode]: ...
    def destinations(self, **kwargs: Any) -> List[general.PyNode]: ...
    def shadingGroups(self) -> List[ShadingEngine]: ...
    def __getattr__(self, attr: Any): ...
    def attrSpec(obj: Any, attr: Any): ...
    attrDefaults: Any = ...
    def attr(self, attr: Any) -> general.Attribute: ...
    hasAttr: Any = ...
    def setAttr(self, attr: Any, *args: Any, **kwargs: Any): ...
    def setDynamicAttr(self, attr: Any, *args: Any, **kwargs: Any): ...
    def getAttr(self, attr: Any, *args: Any, **kwargs: Any): ...
    def addAttr(self, attr: Any, **kwargs: Any): ...
    def deleteAttr(self, attr: Any, *args: Any, **kwargs: Any): ...
    removeAttribute: Any = ...
    def connectAttr(self, attr: Any, destination: Any, **kwargs: Any): ...
    def disconnectAttr(self, attr: Any, destination: Optional[Any] = ..., **kwargs: Any): ...
    listAnimatable: Any = ...
    def listAttr(self, **kwargs: Any) -> List[general.Attribute]: ...
    def listAliases(self) -> List[Tuple[str, general.Attribute]]: ...
    def attrInfo(self, **kwargs: Any) -> List[general.Attribute]: ...
    def stripNum(self) -> str: ...
    def extractNum(self) -> str: ...
    def nextUniqueName(self) -> str: ...
    def nextName(self) -> str: ...
    def prevName(self) -> str: ...
    @classmethod
    def registerVirtualSubClass(cls, nameRequired: bool = ...) -> None: ...
    __melnode__: str = ...
    MAttrClass: Any = ...
    MdgTimerMetric: Any = ...
    MdgTimerState: Any = ...
    MdgTimerType: Any = ...
    def absoluteName(self) -> str: ...
    @classmethod
    def allocateFlag(self, pluginName: str) -> int: ...
    def attributeClass(self, attribute: general.PyNode) -> DependencyNode.MAttrClass: ...
    def attributeCount(self) -> int: ...
    def canBeWritten(self) -> bool: ...
    @classmethod
    def deallocateAllFlags(self, pluginName: str) -> None: ...
    @classmethod
    def deallocateFlag(self, pluginName: str, flag: int) -> None: ...
    def dgCallbacks(self, timerType: DependencyNode.MdgTimerType, callbackName: List[str], value: List[float]) -> None: ...
    def dgTimer(self, timerMetric: DependencyNode.MdgTimerMetric, timerType: DependencyNode.MdgTimerType) -> float: ...
    def dgTimerOff(self) -> None: ...
    def dgTimerOn(self) -> None: ...
    def dgTimerQueryState(self) -> DependencyNode.MdgTimerState: ...
    def dgTimerReset(self) -> None: ...
    @classmethod
    def enableDGTiming(self, enable: bool) -> None: ...
    def getAffectsAnimation(self) -> bool: ...
    def getAliasAttr(self, force: bool) -> general.PyNode: ...
    def getIcon(self) -> str: ...
    def getName(self) -> str: ...
    def hasAttribute(self, attrName: str) -> bool: ...
    def hasUniqueName(self) -> bool: ...
    isUniquelyNamed: Any = ...
    def isDefaultNode(self) -> bool: ...
    def isFlagSet(self, flag: int) -> bool: ...
    def isFromReferencedFile(self) -> bool: ...
    isReadOnly: Any = ...
    isReferenced: Any = ...
    def isLocked(self) -> bool: ...
    def isNewAttribute(self, attr: general.PyNode) -> bool: ...
    def isShared(self) -> bool: ...
    def isTrackingEdits(self) -> bool: ...
    def parentNamespace(self) -> str: ...
    def pluginName(self) -> str: ...
    def setAffectsAnimation(self) -> None: ...
    def setDoNotWrite(self, flag: bool) -> None: ...
    def setFlag(self, flag: int, state: bool) -> None: ...
    def setIcon(self, filename: str) -> None: ...
    def setLocked(self, lock: bool) -> None: ...
    def setName(self, name: str, createNamespace: bool=...) -> str: ...

class ContainerBase(DependNode):
    __melnode__: str = ...

class Entity(ContainerBase):
    __melnode__: str = ...

class DagNode(Entity):
    __apicls__: Any = ...
    def comp(self, compName: Any) -> Optional[general.Component]: ...
    def listComp(self, names: bool=...) -> List[str]: ...
    def name(self, update: bool=..., long: Optional[bool]=..., stripNamespace: bool=..., levels: int=..., stripUnderWorld: bool=...) -> str: ...
    def longName(self, **kwargs: Any) -> str: ...
    fullPath: Any = ...
    def shortName(self, **kwargs: Any) -> str: ...
    def nodeName(self, stripUnderWorld: Any=..., **kwargs: Any) -> str: ...
    def __apiobject__(self): ...
    def __apimdagpath__(self): ...
    def __apihandle__(self): ...
    def root(self) -> str: ...
    def hasParent(self, parent: Any): ...
    def hasChild(self, child: Any): ...
    def isChildOf(self, parent: Any): ...
    def isParentOf(self, child: Any): ...
    def isInstanceOf(self, other: Any) -> bool: ...
    def instanceNumber(self) -> int: ...
    def getInstances(self, includeSelf: Any=...) -> List[DagNode]: ...
    def getOtherInstances(self) -> List[DagNode]: ...
    def firstParent(self) -> DagNode: ...
    def firstParent2(self, **kwargs: Any): ...
    def getParent(self, generations: Any=...) -> Optional[DagNode]: ...
    def getAllParents(self) -> List[DagNode]: ...
    def getChildren(self, **kwargs: Any) -> List[DagNode]: ...
    def getSiblings(self, **kwargs: Any) -> List[DagNode]: ...
    def listRelatives(self, **kwargs: Any) -> List[DagNode]: ...
    def setParent(self, *args: Any, **kwargs: Any): ...
    def addChild(self, child: Any, **kwargs: Any) -> DagNode: ...
    def __or__(self, child: Any, **kwargs: Any) -> DagNode: ...
    def isDisplaced(self) -> bool: ...
    def hide(self) -> None: ...
    def show(self) -> None: ...
    def isVisible(self, checkOverride: bool = ...): ...
    def setObjectColor(self, color: Optional[Any] = ...) -> None: ...
    def makeLive(self, state: bool = ...) -> None: ...
    __melnode__: str = ...
    MObjectColorType: Any = ...
    def activeColor(self) -> datatypes.Color: ...
    def boundingBox(self) -> datatypes.BoundingBox: ...
    def child(self, i: int) -> general.PyNode: ...
    childAtIndex: Any = ...
    def childCount(self) -> int: ...
    numChildren: Any = ...
    def dagRoot(self) -> general.PyNode: ...
    root: Any = ...
    def dormantColor(self) -> datatypes.Color: ...
    def drawOverrideColor(self) -> Tuple[bool, datatypes.Color]: ...
    def drawOverrideEnabled(self) -> bool: ...
    def drawOverrideIsReference(self) -> bool: ...
    def drawOverrideIsTemplate(self) -> bool: ...
    def fullPathName(self) -> str: ...
    def getAllPaths(self) -> List[general.PyNode]: ...
    def getConnectedSetsAndMembers(self, instanceNumber: int, renderableSetsOnly: bool) -> Tuple[List[general.PyNode], List[general.PyNode]]: ...
    def getObjectColor(self) -> int: ...
    def getObjectColorType(self) -> DagNode.MObjectColorType: ...
    def hiliteColor(self) -> datatypes.Color: ...
    def inModel(self) -> bool: ...
    def inUnderWorld(self) -> bool: ...
    def instanceCount(self, total: bool=...) -> int: ...
    def isInstanceable(self) -> bool: ...
    def isInstanced(self, indirect: bool=...) -> bool: ...
    def isInstancedAttribute(self, attribute: general.PyNode) -> bool: ...
    def isIntermediateObject(self) -> bool: ...
    isIntermediate: Any = ...
    def objectColorIndex(self) -> int: ...
    def objectColorRGB(self) -> datatypes.Color: ...
    def objectGroupComponent(self, groupId: int, compList: List[str]) -> None: ...
    def parent(self, i: int) -> general.PyNode: ...
    parentAtIndex: Any = ...
    def parentCount(self) -> int: ...
    def partialPathName(self) -> str: ...
    def setInstanceable(self, how: bool) -> None: ...
    def setIntermediateObject(self, isIntermediate: bool) -> None: ...
    setIntermediate: Any = ...
    def setObjectColorType(self, type: DagNode.MObjectColorType) -> None: ...
    def setUseObjectColor(self, useObjectColor: bool) -> None: ...
    def transformationMatrix(self) -> datatypes.Matrix: ...
    def usingHiliteColor(self) -> bool: ...
    def usingObjectColor(self) -> bool: ...
    isUsingObjectColor: Any = ...

class Shape(DagNode):
    def getTransform(self): ...
    def setParent(self, *args: Any, **kwargs: Any) -> None: ...
    __melnode__: str = ...

class Camera(Shape):
    orbit: Any = ...
    track: Any = ...
    tumble: Any = ...
    def applyBookmark(self, bookmark: Any) -> None: ...
    def addBookmark(self, bookmark: Optional[Any] = ...) -> None: ...
    def removeBookmark(self, bookmark: Any) -> None: ...
    def updateBookmark(self, bookmark: Any) -> None: ...
    def listBookmarks(self): ...
    def dolly(self, distance: Any, relative: bool = ...) -> None: ...
    def roll(self, degree: Any, relative: bool = ...) -> None: ...
    def setNearFarClippingPlanes(self, dNear: Any, dFar: Any) -> None: ...
    setNearFarClipPlanes: Any = ...
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    FilmFit: Any = ...
    RollOrder: Any = ...
    def computeDepthOfField(self) -> None: ...
    def copyViewFrom(self, otherCamera: general.PyNode) -> None: ...
    def getAspectRatio(self) -> float: ...
    def getAspectRatioLimits(self) -> Tuple[float, float]: ...
    def getCameraScale(self) -> float: ...
    def getCenterOfInterest(self) -> float: ...
    def getCenterOfInterestPoint(self, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def getDisplayFieldChart(self, **kwargs: Any): ...
    def getDisplayFilmOrigin(self, **kwargs: Any): ...
    def getDisplayFilmPivot(self, **kwargs: Any): ...
    def getDisplayGateMask(self, **kwargs: Any): ...
    def getDisplayResolution(self, **kwargs: Any): ...
    def getDisplaySafeAction(self, **kwargs: Any): ...
    def getDisplaySafeTitle(self, **kwargs: Any): ...
    def getEyePoint(self, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def getFStop(self) -> float: ...
    def getFarClippingPlane(self) -> float: ...
    getFarClipPlane: Any = ...
    def getFarFocusDistance(self) -> float: ...
    def getFilmApertureLimits(self) -> Tuple[float, float]: ...
    def getFilmFit(self) -> Camera.FilmFit: ...
    def getFilmFitOffset(self) -> float: ...
    def getFilmFrustum(self, distance: float, applyPanZoom: bool=...) -> Tuple[float, float, float, float]: ...
    def getFilmRollOrder(self) -> Camera.RollOrder: ...
    def getFilmRollValue(self) -> float: ...
    def getFilmTranslateH(self) -> float: ...
    def getFilmTranslateV(self) -> float: ...
    def getFocalLength(self) -> float: ...
    def getFocalLengthLimits(self) -> Tuple[float, float]: ...
    def getFocusDistance(self) -> float: ...
    def getHomeCommand(self, **kwargs: Any): ...
    def getHorizontalFieldOfView(self) -> float: ...
    def getHorizontalFilmAperture(self) -> float: ...
    def getHorizontalFilmOffset(self) -> float: ...
    def getHorizontalPan(self) -> float: ...
    def getHorizontalRollPivot(self) -> float: ...
    def getHorizontalShake(self) -> float: ...
    def getJournalCommand(self, **kwargs: Any): ...
    def getLensSqueezeRatio(self) -> float: ...
    def getLockTransform(self, **kwargs: Any): ...
    def getNearClippingPlane(self) -> float: ...
    getNearClipPlane: Any = ...
    def getNearFocusDistance(self) -> float: ...
    def getOrthoWidth(self) -> float: ...
    def getOverscan(self) -> float: ...
    def getPanZoomEnabled(self) -> bool: ...
    def getPortFieldOfView(self, width: int, height: int) -> Tuple[float, float]: ...
    def getPostScale(self) -> float: ...
    def getPreScale(self) -> float: ...
    def getRenderPanZoom(self) -> bool: ...
    def getRenderingFrustum(self, windowAspect: float) -> Tuple[float, float, float, float]: ...
    def getShakeEnabled(self) -> bool: ...
    def getShakeOverscan(self) -> float: ...
    def getShakeOverscanEnabled(self) -> bool: ...
    def getShutterAngle(self) -> float: ...
    def getStartupCamera(self, **kwargs: Any): ...
    def getStereoHIT(self) -> float: ...
    def getStereoHITEnabled(self) -> bool: ...
    def getTumblePivot(self) -> datatypes.Point: ...
    def getUsePivotAsLocalSpace(self) -> bool: ...
    def getVerticalFieldOfView(self) -> float: ...
    def getVerticalFilmAperture(self) -> float: ...
    def getVerticalFilmOffset(self) -> float: ...
    def getVerticalPan(self) -> float: ...
    def getVerticalRollPivot(self) -> float: ...
    def getVerticalShake(self) -> float: ...
    def getViewParameters(self, windowAspect: float, applyOverscan: bool=..., applySqueeze: bool=..., applyPanZoom: bool=...) -> Tuple[float, float, float, float]: ...
    def getViewingFrustum(self, windowAspect: float, applyOverscan: bool=..., applySqueeze: bool=..., applyPanZoom: bool=...) -> Tuple[float, float, float, float]: ...
    def getWorldCenterOfInterest(self, **kwargs: Any): ...
    def getWorldUp(self, **kwargs: Any): ...
    def getZoom(self) -> float: ...
    def hasSamePerspective(self, otherCamera: general.PyNode) -> bool: ...
    def isClippingPlanes(self) -> bool: ...
    def isDepthOfField(self) -> bool: ...
    def isDisplayFilmGate(self) -> bool: ...
    def isDisplayGateMask(self) -> bool: ...
    def isMotionBlur(self) -> bool: ...
    isMotionBlurred: Any = ...
    def isOrtho(self) -> bool: ...
    def isVerticalLock(self) -> bool: ...
    def postProjectionMatrix(self) -> datatypes.FloatMatrix: ...
    def projectionMatrix(self) -> datatypes.FloatMatrix: ...
    def rightDirection(self, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def set(self, wsEyeLocation: datatypes.Point, wsViewDirection: datatypes.Vector, wsUpDirection: datatypes.Vector, horizFieldOfView: float, aspectRatio: float) -> None: ...
    setupCamera: Any = ...
    def setAspectRatio(self, aspectRatio: float) -> None: ...
    def setCameraScale(self, scale: float) -> None: ...
    def setCenterOfInterest(self, dist: float) -> None: ...
    def setCenterOfInterestPoint(self, centerOfInterest: datatypes.Point, space: datatypes.Space.Space=...) -> None: ...
    def setClippingPlanes(self, ClippingPlanes: bool) -> None: ...
    def setDepthOfField(self, depthOfField: bool) -> None: ...
    def setDisplayFieldChart(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayFilmGate(self, displayFilmGate: bool) -> None: ...
    def setDisplayFilmOrigin(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayFilmPivot(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayGateMask(self, displayGateMask: bool) -> None: ...
    def setDisplayResolution(self, val: bool = ..., **kwargs: Any): ...
    def setDisplaySafeAction(self, val: bool = ..., **kwargs: Any): ...
    def setDisplaySafeTitle(self, val: bool = ..., **kwargs: Any): ...
    def setEyePoint(self, eyeLocation: datatypes.Point, space: datatypes.Space.Space=...) -> None: ...
    def setFStop(self, fStop: float) -> None: ...
    def setFarClippingPlane(self, dFar: float) -> None: ...
    setFarClipPlane: Any = ...
    def setFarFocusDistance(self, farFocusDistance: float) -> None: ...
    def setFilmFit(self, filmFit: Camera.FilmFit) -> None: ...
    def setFilmFitOffset(self, filmFitOffset: float) -> None: ...
    def setFilmRollOrder(self, filmRollOrder: Camera.RollOrder) -> None: ...
    def setFilmRollValue(self, filmRollValue: float) -> None: ...
    def setFilmTranslateH(self, translate: float) -> None: ...
    def setFilmTranslateV(self, translate: float) -> None: ...
    def setFocalLength(self, focalLength: float) -> None: ...
    def setFocusDistance(self, distance: float) -> None: ...
    def setHomeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setHorizontalFieldOfView(self, fov: float) -> None: ...
    def setHorizontalFilmAperture(self, hFilmAperture: float) -> None: ...
    def setHorizontalFilmOffset(self, hOffset: float) -> None: ...
    def setHorizontalPan(self, hPan: float) -> None: ...
    def setHorizontalRollPivot(self, horizontalRollPivot: float) -> None: ...
    def setHorizontalShake(self, hOffset: float) -> None: ...
    def setJournalCommand(self, val: bool = ..., **kwargs: Any): ...
    def setLensSqueezeRatio(self, aspectRatio: float) -> None: ...
    def setLockTransform(self, val: bool = ..., **kwargs: Any): ...
    def setMotionBlur(self, motionBlur: bool) -> None: ...
    setMotionBlurred: Any = ...
    def setNearClippingPlane(self, dNear: float) -> None: ...
    setNearClipPlane: Any = ...
    def setNearFocusDistance(self, nearFocusDistance: float) -> None: ...
    def setOrtho(self, orthoState: bool) -> None: ...
    def setOrthoWidth(self, orthoWidth: float) -> None: ...
    def setOverscan(self, overscan: float) -> None: ...
    def setPanZoomEnabled(self, enabled: bool) -> None: ...
    def setPostScale(self, sf: float) -> None: ...
    def setPreScale(self, sf: float) -> None: ...
    def setRenderPanZoom(self, render: bool) -> None: ...
    def setShakeEnabled(self, enabled: bool) -> None: ...
    def setShakeOverscan(self, overscan: float) -> None: ...
    def setShakeOverscanEnabled(self, enabled: bool) -> None: ...
    def setShutterAngle(self, shutterAngle: float) -> None: ...
    def setStartupCamera(self, val: bool = ..., **kwargs: Any): ...
    def setStereoHIT(self, hit: float) -> None: ...
    def setStereoHITEnabled(self, enabled: bool) -> None: ...
    def setTumblePivot(self, point: datatypes.Point) -> None: ...
    def setUsePivotAsLocalSpace(self, how: bool) -> None: ...
    def setVerticalFieldOfView(self, fov: float) -> None: ...
    def setVerticalFilmAperture(self, vFilmAperture: float) -> None: ...
    def setVerticalFilmOffset(self, vOffset: float) -> None: ...
    def setVerticalLock(self, lockFlag: bool) -> None: ...
    def setVerticalPan(self, vPan: float) -> None: ...
    def setVerticalRollPivot(self, verticalRollPivot: float) -> None: ...
    def setVerticalShake(self, vOffset: float) -> None: ...
    def setWorldCenterOfInterest(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUp(self, val: bool = ..., **kwargs: Any): ...
    def setZoom(self, zoom: float) -> None: ...
    def unnormalizedFarClippingPlane(self) -> float: ...
    def unnormalizedNearClippingPlane(self) -> float: ...
    def upDirection(self, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def viewDirection(self, space: datatypes.Space.Space=...) -> datatypes.Vector: ...

class Transform(DagNode):
    def __getattr__(self, attr: Any): ...
    def __setattr__(self, attr: Any, val: Any): ...
    def attr(self, attr: Any, checkShape: Any=...) -> general.Attribute: ...
    def getShape(self, **kwargs: Any) -> DagNode: ...
    def getShapes(self, **kwargs: Any) -> List[DagNode]: ...
    def ungroup(self, **kwargs: Any): ...
    def setMatrix(self, val: Any, **kwargs: Any) -> None: ...
    def setTranslation(self, vector: Any, space: str = ..., **kwargs: Any): ...
    def getTranslation(self, space: str = ..., **kwargs: Any): ...
    def translateBy(self, vector: Any, space: str = ..., **kwargs: Any) -> None: ...
    def setScale(self, scale: Any, **kwargs: Any): ...
    def scaleBy(self, scale: Any, **kwargs: Any) -> None: ...
    def setShear(self, shear: Any, **kwargs: Any): ...
    def shearBy(self, shear: Any, **kwargs: Any) -> None: ...
    def setRotatePivot(self, point: Any, space: str = ..., balance: bool = ..., **kwargs: Any): ...
    def getRotatePivot(self, space: str = ..., **kwargs: Any): ...
    def setRotatePivotTranslation(self, vector: Any, space: str = ..., **kwargs: Any): ...
    def getRotatePivotTranslation(self, space: str = ..., **kwargs: Any): ...
    def setRotation(self, rotation: Any, space: str = ..., **kwargs: Any): ...
    def getRotation(self, space: str = ..., quaternion: bool = ..., **kwargs: Any): ...
    def rotateBy(self, rotation: Any, space: str = ..., **kwargs: Any) -> None: ...
    def rotateByQuaternion(self, xOrQuaternion: Union[float, Quaternion, List[float], Tuple[float]], y: float=..., z: float=..., w: float=..., space: datatypes.Space.Space=...) -> None: ...
    def setScalePivot(self, point: Any, space: str = ..., balance: bool = ..., **kwargs: Any): ...
    def getScalePivot(self, space: str = ..., **kwargs: Any): ...
    def setScalePivotTranslation(self, vector: Any, space: str = ..., **kwargs: Any): ...
    def getScalePivotTranslation(self, space: str = ..., **kwargs: Any): ...
    def getPivots(self, **kwargs: Any): ...
    def getRotateAxis(self, **kwargs: Any): ...
    def getRotateOrientation(self, space: str = ...): ...
    def setRotateOrientation(self, quat: Any, space: str = ..., balance: bool = ...): ...
    def getMatrix(self, **kwargs: Any): ...
    def getBoundingBox(self, invisible: Any=..., space: Any=...) -> datatypes.BoundingBox: ...
    def getBoundingBoxMin(self, invisible: Any=..., space: Any=...) -> datatypes.Vector: ...
    def getBoundingBoxMax(self, invisible: Any=..., space: Any=...) -> datatypes.Vector: ...
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    LimitType: Any = ...
    def centerPivots(self, val: bool = ..., **kwargs: Any): ...
    def centerPivotsOnComponents(self, val: bool = ..., **kwargs: Any): ...
    def clearRestPosition(self) -> None: ...
    def deletePriorHistory(self, val: bool = ..., **kwargs: Any): ...
    def enableLimit(self, type: Transform.LimitType, flag: bool) -> None: ...
    setLimited: Any = ...
    def getBoundingBoxInvisible(self, **kwargs: Any): ...
    def getRestPosition(self) -> datatypes.TransformationMatrix: ...
    def getRotationOrder(self) -> datatypes.TransformationMatrix.RotationOrder: ...
    def getScale(self) -> Tuple[float, float, float]: ...
    def getShear(self) -> Tuple[float, float, float]: ...
    def isLimited(self, type: Transform.LimitType) -> bool: ...
    def limitValue(self, type: Transform.LimitType) -> float: ...
    getLimit: Any = ...
    def preserveUV(self, val: bool = ..., **kwargs: Any): ...
    def reflection(self, val: bool = ..., **kwargs: Any): ...
    def reflectionAboutBBox(self, val: bool = ..., **kwargs: Any): ...
    def reflectionAboutOrigin(self, val: bool = ..., **kwargs: Any): ...
    def reflectionAboutX(self, val: bool = ..., **kwargs: Any): ...
    def reflectionAboutY(self, val: bool = ..., **kwargs: Any): ...
    def reflectionAboutZ(self, val: bool = ..., **kwargs: Any): ...
    def reflectionTolerance(self, val: bool = ..., **kwargs: Any): ...
    def resetFromRestPosition(self) -> None: ...
    def set(self, transform: datatypes.TransformationMatrix) -> None: ...
    setTransformation: Any = ...
    def setLimit(self, type: Transform.LimitType, value: float) -> None: ...
    def setPivots(self, val: bool = ..., **kwargs: Any): ...
    def setRestPosition(self, matrix: datatypes.TransformationMatrix) -> None: ...
    def setRotateAxis(self, val: bool = ..., **kwargs: Any): ...
    def setRotationOrder(self, order: datatypes.TransformationMatrix.RotationOrder, reorder: bool) -> None: ...
    def transformation(self) -> datatypes.TransformationMatrix: ...
    getTransformation: Any = ...
    def zeroTransformPivots(self, val: bool = ..., **kwargs: Any): ...

class Joint(Transform):
    connect: Any = ...
    disconnect: Any = ...
    insert: Any = ...
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    Axis: Any = ...
    def assumePreferredAngles(self, val: bool = ..., **kwargs: Any): ...
    def children(self, val: bool = ..., **kwargs: Any): ...
    def component(self, val: bool = ..., **kwargs: Any): ...
    def getAngleX(self, **kwargs: Any): ...
    def getAngleY(self, **kwargs: Any): ...
    def getAngleZ(self, **kwargs: Any): ...
    def getDegreeOfFreedom(self, **kwargs: Any): ...
    def getDegreesOfFreedom(self) -> Tuple[bool, bool, bool]: ...
    def getExists(self, **kwargs: Any): ...
    def getLimitSwitchX(self, **kwargs: Any): ...
    def getLimitSwitchY(self, **kwargs: Any): ...
    def getLimitSwitchZ(self, **kwargs: Any): ...
    def getLimitX(self, **kwargs: Any): ...
    def getLimitY(self, **kwargs: Any): ...
    def getLimitZ(self, **kwargs: Any): ...
    def getMaxRotateDampXRange(self) -> float: ...
    def getMaxRotateDampXStrength(self) -> float: ...
    def getMaxRotateDampYRange(self) -> float: ...
    def getMaxRotateDampYStrength(self) -> float: ...
    def getMaxRotateDampZRange(self) -> float: ...
    def getMaxRotateDampZStrength(self) -> float: ...
    def getMinRotateDampXRange(self) -> float: ...
    def getMinRotateDampXStrength(self) -> float: ...
    def getMinRotateDampYRange(self) -> float: ...
    def getMinRotateDampYStrength(self) -> float: ...
    def getMinRotateDampZRange(self) -> float: ...
    def getMinRotateDampZStrength(self) -> float: ...
    def getOrientation(self) -> datatypes.Quaternion: ...
    def getPreferedAngle(self) -> Tuple[float, float, float]: ...
    def getPreferredAngle(self) -> Tuple[float, float, float]: ...
    def getRadius(self, **kwargs: Any): ...
    def getScaleCompensate(self, **kwargs: Any): ...
    def getScaleOrientation(self) -> datatypes.Quaternion: ...
    def getSegmentScale(self) -> Tuple[float, float, float]: ...
    def getStiffness(self) -> Tuple[float, float, float]: ...
    def getStiffnessX(self, **kwargs: Any): ...
    def getStiffnessY(self, **kwargs: Any): ...
    def getStiffnessZ(self, **kwargs: Any): ...
    def hikJointName(self) -> str: ...
    def orientJoint(self, val: bool = ..., **kwargs: Any): ...
    def secondaryAxisOrient(self, val: bool = ..., **kwargs: Any): ...
    def setAngleX(self, val: bool = ..., **kwargs: Any): ...
    def setAngleY(self, val: bool = ..., **kwargs: Any): ...
    def setAngleZ(self, val: bool = ..., **kwargs: Any): ...
    def setDegreeOfFreedom(self, val: bool = ..., **kwargs: Any): ...
    def setDegreesOfFreedom(self, freeInX: bool, freeInY: bool, freeInZ: bool) -> None: ...
    def setLimitSwitchX(self, val: bool = ..., **kwargs: Any): ...
    def setLimitSwitchY(self, val: bool = ..., **kwargs: Any): ...
    def setLimitSwitchZ(self, val: bool = ..., **kwargs: Any): ...
    def setLimitX(self, val: bool = ..., **kwargs: Any): ...
    def setLimitY(self, val: bool = ..., **kwargs: Any): ...
    def setLimitZ(self, val: bool = ..., **kwargs: Any): ...
    def setMaxRotateDampXRange(self, angle: float) -> None: ...
    def setMaxRotateDampXStrength(self, angle: float) -> None: ...
    def setMaxRotateDampYRange(self, angle: float) -> None: ...
    def setMaxRotateDampYStrength(self, angle: float) -> None: ...
    def setMaxRotateDampZRange(self, angle: float) -> None: ...
    def setMaxRotateDampZStrength(self, angle: float) -> None: ...
    def setMinRotateDampXRange(self, angle: float) -> None: ...
    def setMinRotateDampXStrength(self, angle: float) -> None: ...
    def setMinRotateDampYRange(self, angle: float) -> None: ...
    def setMinRotateDampYStrength(self, angle: float) -> None: ...
    def setMinRotateDampZRange(self, angle: float) -> None: ...
    def setMinRotateDampZStrength(self, angle: float) -> None: ...
    def setOrientation(self, quaternion: datatypes.Quaternion) -> None: ...
    def setPreferedAngle(self, rotation: Tuple[float, float, float]) -> None: ...
    def setPreferredAngle(self, rotation: Tuple[float, float, float]) -> None: ...
    def setPreferredAngles(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setScaleCompensate(self, val: bool = ..., **kwargs: Any): ...
    def setScaleOrientation(self, quaternion: datatypes.Quaternion) -> None: ...
    def setSegmentScale(self, scale: Tuple[float, float, float]) -> None: ...
    def setStiffness(self, stiffness: Tuple[float, float, float]) -> None: ...
    def setStiffnessX(self, val: bool = ..., **kwargs: Any): ...
    def setStiffnessY(self, val: bool = ..., **kwargs: Any): ...
    def setStiffnessZ(self, val: bool = ..., **kwargs: Any): ...
    def symmetry(self, val: bool = ..., **kwargs: Any): ...
    def symmetryAxis(self, val: bool = ..., **kwargs: Any): ...
    def zeroScaleOrient(self, val: bool = ..., **kwargs: Any): ...

class DynBase(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class PointEmitter(DynBase):
    __melnode__: str = ...

class FluidEmitter(PointEmitter):
    fluidVoxelInfo: Any = ...
    loadFluid: Any = ...
    resampleFluid: Any = ...
    saveFluid: Any = ...
    setFluidAttr: Any = ...
    getFluidAttr: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCycleEmission(self, **kwargs: Any): ...
    def getCycleInterval(self, **kwargs: Any): ...
    def getDensityEmissionRate(self, **kwargs: Any): ...
    def getFluidDropoff(self, **kwargs: Any): ...
    def getFuelEmissionRate(self, **kwargs: Any): ...
    def getHeatEmissionRate(self, **kwargs: Any): ...
    def getMaxDistance(self, **kwargs: Any): ...
    def getMinDistance(self, **kwargs: Any): ...
    def getPosition(self, **kwargs: Any): ...
    def getRate(self, **kwargs: Any): ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getType(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setCycleEmission(self, val: bool = ..., **kwargs: Any): ...
    def setCycleInterval(self, val: bool = ..., **kwargs: Any): ...
    def setDensityEmissionRate(self, val: bool = ..., **kwargs: Any): ...
    def setFluidDropoff(self, val: bool = ..., **kwargs: Any): ...
    def setFuelEmissionRate(self, val: bool = ..., **kwargs: Any): ...
    def setHeatEmissionRate(self, val: bool = ..., **kwargs: Any): ...
    def setMaxDistance(self, val: bool = ..., **kwargs: Any): ...
    def setMinDistance(self, val: bool = ..., **kwargs: Any): ...
    def setPosition(self, val: bool = ..., **kwargs: Any): ...
    def setRate(self, val: bool = ..., **kwargs: Any): ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setType(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class RenderLayer(DependNode):
    __melcmdname__: str = ...
    def __new__(cls, *args: Any, **kwargs: Any): ...
    def listMembers(self, fullNames: bool = ...): ...
    def addMembers(self, members: Any, noRecurse: bool = ...) -> None: ...
    def removeMembers(self, members: Any) -> None: ...
    def listAdjustments(self): ...
    def addAdjustments(self, members: Any): ...
    def removeAdjustments(self, members: Any): ...
    def setCurrent(self) -> None: ...
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melnode__: str = ...
    def adjustmentPlug(self, scenePlug: general.Attribute) -> general.Attribute: ...
    @classmethod
    def currentLayer(self) -> general.PyNode: ...
    @classmethod
    def defaultRenderLayer(self) -> general.PyNode: ...
    def externalRenderPasses(self) -> List[general.PyNode]: ...
    @classmethod
    def findLayerByName(self, renderLayer: str) -> general.PyNode: ...
    def inCurrentRenderLayer(self, objectPath: general.PyNode) -> bool: ...
    def inLayer(self, transform: general.PyNode) -> bool: ...
    def isPlugAdjusted(self, scenePlug: general.Attribute) -> bool: ...
    def layerChildren(self, recurse: bool=...) -> List[general.PyNode]: ...
    @classmethod
    def listAllRenderLayers(self) -> List[general.PyNode]: ...
    def passHasLight(self, renderPass: general.PyNode, light: general.PyNode) -> bool: ...
    def passHasObject(self, renderPass: general.PyNode, objectInstance: general.PyNode) -> bool: ...

class DisplayLayer(DependNode):
    __melcmdname__: str = ...
    def __new__(cls, *args: Any, **kwargs: Any): ...
    def listMembers(self, fullNames: bool = ...): ...
    def addMembers(self, members: Any, noRecurse: bool = ...) -> None: ...
    def removeMembers(self, members: Any, noRecurse: bool = ...) -> None: ...
    def setCurrent(self) -> None: ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Constraint(Transform):
    def setWeight(self, weight: Any, *targetObjects: Any): ...
    def getWeight(self, *targetObjects: Any): ...
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class GeometryShape(Shape):
    def __getattr__(self, attr: Any): ...
    __melnode__: str = ...

class DeformableShape(GeometryShape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class ControlPoint(DeformableShape):
    __melnode__: str = ...

class CurveShape(DeformableShape):
    __melnode__: str = ...

class NurbsCurve(CurveShape):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    Form: Any = ...
    def area(self, tolerance: float=...) -> float: ...
    def closestPoint(self, toThisPoint: datatypes.Point, param: float=..., tolerance: float=..., space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def copy(self, source: general.PyNode, parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def createWithEditPoints(self, editPoints: List[datatypes.Point], degree: int, form: NurbsCurve.Form, create2D: bool, createRational: bool, uniformParam: bool, parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def cvs(self, startIndex: int, endIndex: int) -> general.PyNode: ...
    def degree(self) -> int: ...
    def distanceToPoint(self, pt: datatypes.Point, space: datatypes.Space.Space=...) -> float: ...
    def findLengthFromParam(self, param: float) -> float: ...
    def findParamFromLength(self, partLength: float) -> float: ...
    def form(self) -> NurbsCurve.Form: ...
    def getCV(self, index: int, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def getCVs(self, space: datatypes.Space.Space=...) -> List[datatypes.Point]: ...
    def getDerivativesAtParm(self, param: float, space: datatypes.Space.Space) -> Tuple[datatypes.Point, datatypes.Vector, datatypes.Vector]: ...
    def getKnot(self, index: int) -> float: ...
    def getKnotDomain(self) -> Tuple[float, float]: ...
    def getKnots(self) -> List[float]: ...
    def getParamAtPoint(self, atThisPoint: datatypes.Point, space: datatypes.Space.Space=...) -> float: ...
    def getPointAtParam(self, param: float, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def hasHistoryOnCreate(self) -> bool: ...
    def isParamOnCurve(self, param: float) -> bool: ...
    def isPlanar(self, planeNormal: datatypes.Vector=...) -> bool: ...
    def isPointOnCurve(self, point: datatypes.Point, tolerance: float=..., space: datatypes.Space.Space=...) -> bool: ...
    def length(self, tolerance: float=...) -> float: ...
    def makeMultipleEndKnots(self) -> None: ...
    def normal(self, param: float, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def numKnots(self) -> int: ...
    def numSpans(self) -> int: ...
    def rebuild(self, endKnots: int=..., keepEndPoints: bool=..., keepTangents: bool=..., keepControlPoints: bool=..., tolerance: float=...) -> Tuple[general.PyNode, int, int, int]: ...
    def removeKnot(self, atThisParam: float, removeAll: bool=...) -> None: ...
    def reverse(self, constructionHistory: bool=...) -> None: ...
    def setCV(self, index: int, pt: datatypes.Point, space: datatypes.Space.Space=...) -> None: ...
    def setCVs(self, array: List[datatypes.Point], space: datatypes.Space.Space=...) -> None: ...
    def setKnot(self, index: int, param: float) -> None: ...
    def setKnots(self, array: List[float], startIndex: int, endIndex: int) -> None: ...
    def tangent(self, param: float, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def updateCurve(self) -> None: ...

class SurfaceShape(ControlPoint):
    __melnode__: str = ...

class NurbsSurface(SurfaceShape):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    BoundaryType: Any = ...
    Form: Any = ...
    def area(self, tolerance: float=...) -> float: ...
    def assignUV(self, patchId: int, cornerIndex: int, uvId: int) -> None: ...
    def assignUVs(self, uvCounts: List[int], uvIds: List[int]) -> None: ...
    def boundaryType(self, region: int, boundary: int) -> NurbsSurface.BoundaryType: ...
    def clearUVs(self) -> None: ...
    def closestPoint(self, toThisPoint: datatypes.Point, ignoreTrimBoundaries: bool=..., tolerance: float=..., space: datatypes.Space.Space=...) -> Tuple[datatypes.Point, float, float]: ...
    def copy(self, source: general.PyNode, parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def cvsInU(self, startIndex: int, endIndex: int, rowIndex: int) -> general.PyNode: ...
    def cvsInV(self, startIndex: int, endIndex: int, rowIndex: int) -> general.PyNode: ...
    def degreeU(self) -> int: ...
    def degreeV(self) -> int: ...
    def distanceToPoint(self, pt: datatypes.Point, space: datatypes.Space.Space=...) -> float: ...
    def edge(self, region: int, boundary: int, edge: int, paramEdge: bool=...) -> List[general.PyNode]: ...
    def formInU(self) -> NurbsSurface.Form: ...
    def formInV(self) -> NurbsSurface.Form: ...
    def getAssignedUVs(self) -> Tuple[List[int], List[int]]: ...
    def getCV(self, indexU: int, indexV: int, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def getCVs(self, space: datatypes.Space.Space=...) -> List[datatypes.Point]: ...
    def getConnectedShaders(self, instanceNumber: int) -> Tuple[List[general.PyNode], List[int]]: ...
    def getDataObject(self) -> general.PyNode: ...
    def getDerivativesAtParm(self, paramInU: float, paramInV: float, space: datatypes.Space.Space) -> Tuple[datatypes.Point, datatypes.Vector, datatypes.Vector, datatypes.Vector, datatypes.Vector, datatypes.Vector]: ...
    def getKnotDomain(self) -> Tuple[float, float, float, float]: ...
    def getKnotInU(self, index: int) -> float: ...
    def getKnotInV(self, index: int) -> float: ...
    def getKnotsInU(self) -> List[float]: ...
    def getKnotsInV(self) -> List[float]: ...
    def getParamAtPoint(self, atThisPoint: datatypes.Point, space: datatypes.Space.Space=...) -> Tuple[float, float]: ...
    def getPatchUV(self, patchId: int, cornerIndex: int) -> Tuple[float, float]: ...
    def getPatchUVid(self, patchId: int, cornerIndex: int) -> int: ...
    def getPatchUVs(self, patchId: int) -> Tuple[List[float], List[float]]: ...
    def getPointAtParam(self, paramU: float, paramV: float, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def getTangents(self, paramInU: float, paramInV: float, space: datatypes.Space.Space=...) -> Tuple[datatypes.Vector, datatypes.Vector]: ...
    def hasHistoryOnCreate(self) -> bool: ...
    def intersect(self, rayStartingPoint: datatypes.Point, alongThisDirection: datatypes.Vector, tolerance: float=..., space: datatypes.Space.Space=..., calculateDistance: bool=..., calculateExactHit: bool=...) -> Tuple[bool, float, float, datatypes.Point, float, bool]: ...
    def isBezier(self) -> bool: ...
    def isFlipNorm(self, region: int) -> bool: ...
    def isFoldedOnBispan(self) -> bool: ...
    def isKnotU(self, param: float) -> bool: ...
    def isKnotV(self, param: float) -> bool: ...
    def isParamOnSurface(self, paramU: float, paramV: float) -> bool: ...
    def isPointInTrimmedRegion(self, u: float, v: float) -> bool: ...
    def isPointOnSurface(self, point: datatypes.Point, tolerance: float=..., space: datatypes.Space.Space=...) -> bool: ...
    def isTrimmedSurface(self) -> bool: ...
    def isUniform(self) -> bool: ...
    def normal(self, paramInU: float, paramInV: float, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def numBoundaries(self, region: int) -> int: ...
    def numEdges(self, region: int, boundary: int) -> int: ...
    def numKnotsInU(self) -> int: ...
    def numKnotsInV(self) -> int: ...
    def numNonZeroSpansInU(self) -> int: ...
    def numNonZeroSpansInV(self) -> int: ...
    def numPatches(self) -> int: ...
    def numPatchesInU(self) -> int: ...
    def numPatchesInV(self) -> int: ...
    def numRegions(self) -> int: ...
    def numSpansInU(self) -> int: ...
    def numSpansInV(self) -> int: ...
    def numUVs(self) -> int: ...
    def projectCurve(self, curve: general.PyNode, direction: datatypes.Vector=..., constructionHistory: bool=...) -> None: ...
    def removeKnotInU(self, atThisParam: float, removeAll: bool=...) -> None: ...
    def removeKnotInV(self, atThisParam: float, removeAll: bool=...) -> None: ...
    def removeOneKnotInU(self, atThisParam: float) -> None: ...
    def removeOneKnotInV(self, atThisParam: float) -> None: ...
    def setCV(self, indexU: int, indexV: int, pt: datatypes.Point, space: datatypes.Space.Space=...) -> None: ...
    def setCVs(self, array: List[datatypes.Point], space: datatypes.Space.Space=...) -> None: ...
    def setKnotInU(self, index: int, param: float) -> None: ...
    def setKnotInV(self, index: int, param: float) -> None: ...
    def setKnotsInU(self, array: List[float], startIndex: int, endIndex: int) -> None: ...
    def setKnotsInV(self, array: List[float], startIndex: int, endIndex: int) -> None: ...
    def tesselate(self, parms: datatypes.TesselationParams=..., parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def trim(self, locatorU: List[float], locatorV: List[float], constructionHistory: bool=...) -> None: ...
    def updateSurface(self) -> None: ...

class Mesh(SurfaceShape):
    numVertices: Any = ...
    numEdges: Any = ...
    numFaces: Any = ...
    numTriangles: Any = ...
    numSelectedTriangles: Any = ...
    numSelectedFaces: Any = ...
    numSelectedEdges: Any = ...
    numSelectedVertices: Any = ...
    area: Any = ...
    worldArea: Any = ...
    def getUVAtPoint(self, uvPoint: Any, space: Any = ..., uvSet: Optional[Any] = ..., returnClosestPolygon: bool = ...): ...
    def getCurrentUVSetName(self): ...
    def getCurrentColorSetName(self): ...
    def getVertexColors(self, colorSet: Optional[Any] = ..., defaultUnsetColor: Optional[Any] = ...): ...
    def numColors(self, colorSet: Optional[Any] = ...): ...
    __apicls__: Any = ...
    __melnode__: str = ...
    BoolOperation: Any = ...
    MColorRepresentation: Any = ...
    SplitPlacement: Any = ...
    def addHoles(self, faceIndex: int, vertexArray: List[datatypes.Point], loopCounts: List[int], mergeVertices: bool=..., pointTolerance: float=...) -> None: ...
    def assignColor(self, polygonId: int, vertexIndex: int, colorId: int, colorSet: str=...) -> None: ...
    def assignColors(self, colorIds: List[int], colorSet: str=...) -> None: ...
    def assignUV(self, polygonId: int, vertexIndex: int, uvId: int, uvSet: str=...) -> None: ...
    def assignUVs(self, uvCounts: List[int], uvIds: List[int], uvSet: str=...) -> None: ...
    def booleanOps(self, op: Mesh.BoolOperation, meshes: List[general.PyNode]) -> bool: ...
    def cleanupEdgeSmoothing(self) -> None: ...
    def clearColors(self, colorSet: str=...) -> None: ...
    def clearUVs(self, uvSet: str=...) -> None: ...
    @classmethod
    def componentTypeFromName(self, assocName: str) -> datatypes.Fn.Type: ...
    @classmethod
    def componentTypeName(self, compType: datatypes.Fn.Type) -> str: ...
    def createColorSetDataMesh(self, colorSetName: str, clamped: bool=..., rep: Mesh.MColorRepresentation=...) -> None: ...
    def createColorSetWithName(self, colorSetName: str, modifier: datatypes.DGModifier=..., instances: datatypes.UintArray=...) -> str: ...
    createColorSet: Any = ...
    def createColorSetWithNameDataMesh(self, colorSetName: str, clamped: bool, rep: Mesh.MColorRepresentation) -> str: ...
    def createUVSetDataMeshWithName(self, uvSetName: str) -> str: ...
    def createUVSetWithName(self, uvSetName: str, modifier: datatypes.DGModifier=..., instances: datatypes.UintArray=...) -> str: ...
    createUVSet: Any = ...
    def deleteColorSet(self, colorSetName: str, modifier: datatypes.DGModifier=..., currentSelection: SelectionSet=...) -> None: ...
    def deleteUVSet(self, setName: str, modifier: datatypes.DGModifier=..., currentSelection: SelectionSet=...) -> None: ...
    def getAssignedUVs(self, uvSet: str=...) -> Tuple[List[int], List[int]]: ...
    def getAssociatedColorSetInstances(self, colorSetName: str) -> List[int]: ...
    def getAssociatedUVSetInstances(self, uvSetName: str) -> List[int]: ...
    def getAssociatedUVSetTextures(self, uvSetName: str) -> List[general.PyNode]: ...
    def getAxisAtPoint(self, pt: datatypes.Point, space: datatypes.Space.Space=..., uvSet: str=...) -> Tuple[datatypes.Vector, datatypes.Vector, datatypes.Vector, int]: ...
    def getBinormals(self, space: datatypes.Space.Space=..., uvSet: str=...) -> List[datatypes.FloatVector]: ...
    def getCheckSamePointTwice(self) -> bool: ...
    def getClosestNormal(self, toThisPoint: datatypes.Point, space: datatypes.Space.Space=..., accelParams: datatypes.MeshIsectAccelParams=...) -> Tuple[datatypes.Vector, int]: ...
    def getClosestPoint(self, toThisPoint: datatypes.Point, space: datatypes.Space.Space=..., accelParams: datatypes.MeshIsectAccelParams=...) -> Tuple[datatypes.Point, int]: ...
    def getClosestPointAndNormal(self, toThisPoint: datatypes.Point, space: datatypes.Space.Space=..., accelParams: datatypes.MeshIsectAccelParams=...) -> Tuple[datatypes.Point, datatypes.Vector, int]: ...
    def getClosestUVs(self, toThisUVPoint: Tuple[float, float], uvSet: str=...) -> List[int]: ...
    def getColor(self, colorId: int, colorSet: str=..., defaultUnsetColor: datatypes.Color=...) -> datatypes.Color: ...
    def getColorRepresentation(self, colorSet: str) -> Mesh.MColorRepresentation: ...
    def getColorSetFamilyNames(self) -> List[str]: ...
    def getColorSetNames(self) -> List[str]: ...
    def getColors(self, colorSet: str=..., defaultUnsetColor: datatypes.Color=...) -> List[datatypes.Color]: ...
    def getDisplayColors(self) -> bool: ...
    def getEdgeVertices(self, edgeId: int) -> Tuple[int, int]: ...
    def getFaceNormalIds(self, faceIndex: int) -> List[int]: ...
    def getFaceUVSetNames(self, polygonId: int) -> List[str]: ...
    def getFaceVertexBinormal(self, faceIndex: int, vertexIndex: int, space: datatypes.Space.Space=..., uvSet: str=...) -> datatypes.Vector: ...
    def getFaceVertexBinormals(self, faceIndex: int, space: datatypes.Space.Space=..., uvSet: str=...) -> List[datatypes.FloatVector]: ...
    def getFaceVertexColorIndex(self, faceIndex: int, localVertexIndex: int, colorSet: str=...) -> int: ...
    def getFaceVertexColors(self, colorSet: str=..., defaultUnsetColor: datatypes.Color=...) -> List[datatypes.Color]: ...
    def getFaceVertexNormal(self, faceIndex: int, vertexIndex: int, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def getFaceVertexNormals(self, faceIndex: int, space: datatypes.Space.Space=...) -> List[datatypes.FloatVector]: ...
    def getFaceVertexTangent(self, faceIndex: int, vertexIndex: int, space: datatypes.Space.Space=..., uvSet: str=...) -> datatypes.Vector: ...
    def getFaceVertexTangents(self, faceIndex: int, space: datatypes.Space.Space=..., uvSet: str=...) -> List[datatypes.FloatVector]: ...
    def getHoles(self) -> Tuple[int, List[int], List[int]]: ...
    def getNormalIds(self) -> Tuple[List[int], List[int]]: ...
    def getNormals(self, space: datatypes.Space.Space=...) -> List[datatypes.FloatVector]: ...
    def getPoint(self, vertexId: int, space: datatypes.Space.Space=...) -> datatypes.Point: ...
    def getPointAtUV(self, polygonId: int, uvPoint: Tuple[float, float], space: datatypes.Space.Space=..., uvSet: str=..., tolerance: float=...) -> datatypes.Point: ...
    def getPoints(self, space: datatypes.Space.Space=...) -> List[datatypes.Point]: ...
    def getPointsAtUV(self, uvPoint: Tuple[float, float], space: datatypes.Space.Space=..., uvSet: str=..., tolerance: float=...) -> Tuple[List[int], List[datatypes.Point]]: ...
    def getPolygonNormal(self, polygonId: int, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def getPolygonTriangleVertices(self, polygonId: int, triangleId: int) -> Tuple[int, int, int]: ...
    def getPolygonUV(self, polygonId: int, vertexIndex: int, uvSet: str=...) -> Tuple[float, float]: ...
    def getPolygonUVid(self, polygonId: int, vertexIndex: int, uvSet: str=...) -> int: ...
    def getPolygonVertices(self, polygonId: int) -> List[int]: ...
    def getTangentId(self, faceIndex: int, vertexIndex: int) -> int: ...
    def getTangents(self, space: datatypes.Space.Space=..., uvSet: str=...) -> List[datatypes.FloatVector]: ...
    def getTriangleOffsets(self) -> Tuple[List[int], List[int]]: ...
    def getTriangles(self) -> Tuple[List[int], List[int]]: ...
    def getUV(self, uvId: int, uvSet: str=...) -> Tuple[float, float]: ...
    def getUVSetFamilyNames(self) -> List[str]: ...
    def getUVSetNames(self) -> List[str]: ...
    def getUVSetsInFamily(self, familyName: str) -> List[str]: ...
    def getUVs(self, uvSet: str=...) -> Tuple[List[float], List[float]]: ...
    def getUvShellsIds(self, uvSet: str=...) -> Tuple[List[int], int]: ...
    def getVertexNormal(self, vertexId: int, angleWeighted: bool, space: datatypes.Space.Space=...) -> datatypes.Vector: ...
    def getVertexNormals(self, angleWeighted: bool, space: datatypes.Space.Space=...) -> List[datatypes.FloatVector]: ...
    def getVertices(self) -> Tuple[List[int], List[int]]: ...
    def hasAlphaChannels(self, colorSet: str) -> bool: ...
    def hasColorChannels(self, colorSet: str) -> bool: ...
    def intersect(self, raySource: datatypes.Point, rayDirection: datatypes.Vector, tolerance: float=..., space: datatypes.Space.Space=...) -> Tuple[bool, List[datatypes.Point], List[int]]: ...
    def intersectFaceAtUV(self, toThisUVPoint: Tuple[float, float], uvSet: str=...) -> int: ...
    def isColorClamped(self, colorSet: str) -> bool: ...
    def isColorSetPerInstance(self, name: str) -> bool: ...
    def isEdgeSmooth(self, edgeId: int) -> bool: ...
    def isNormalLocked(self, normalId: int) -> bool: ...
    def isPolygonConvex(self, faceIndex: int) -> bool: ...
    def isPolygonUVReversed(self, polygonId: int, uvSet: str=...) -> bool: ...
    def isRightHandedTangent(self, tangentId: int, uvSetName: str=...) -> bool: ...
    def isUVSetPerInstance(self, name: str) -> bool: ...
    def lockFaceVertexNormals(self, faceList: List[int], vertexList: List[int]) -> None: ...
    def lockVertexNormals(self, vertexList: List[int]) -> None: ...
    def numPolygons(self) -> int: ...
    def onBoundary(self, polygonId: int) -> bool: ...
    @classmethod
    def polyTriangulate(self, pointsAndHoles: float, pointsCount: int, outerPointsCount: int, holesCount: int, considerNormal: bool, normals: float) -> Tuple[int, int]: ...
    def polygonVertexCount(self, polygonId: int) -> int: ...
    numPolygonVertices: Any = ...
    def removeFaceColors(self, faceList: List[int]) -> None: ...
    def removeFaceVertexColors(self, faceList: List[int], vertexList: List[int]) -> None: ...
    def removeVertexColors(self, vertexList: List[int]) -> None: ...
    def renameUVSet(self, origName: str, newName: str, modifier: datatypes.DGModifier=...) -> None: ...
    def setCheckSamePointTwice(self, check: bool=...) -> None: ...
    def setColor(self, colorId: int, color: datatypes.Color, colorSet: str=...) -> None: ...
    def setColorClamped(self, colorSet: str, clamped: bool) -> None: ...
    def setColors(self, colorArray: List[datatypes.Color], colorSet: str=...) -> None: ...
    def setCurrentColorSetName(self, setName: str, modifier: datatypes.DGModifier=..., currentSelection: SelectionSet=...) -> None: ...
    def setCurrentUVSetName(self, setName: str, modifier: datatypes.DGModifier=..., currentSelection: SelectionSet=...) -> None: ...
    def setDisplayColors(self, enable: bool) -> None: ...
    def setEdgeSmoothing(self, edgeId: int, smooth: bool=...) -> None: ...
    def setEdgeSmoothings(self, edgeIds: List[int], smooths: List[int]) -> None: ...
    def setFaceColor(self, color: datatypes.Color, faceIndex: int) -> None: ...
    def setFaceColors(self, colors: List[datatypes.Color], faceList: List[int]) -> None: ...
    def setFaceVertexColor(self, color: datatypes.Color, faceIndex: int, vertexIndex: int, modifier: datatypes.DGModifier=...) -> None: ...
    def setFaceVertexNormal(self, normalIn: datatypes.Vector, faceId: int, vertexId: int, space: datatypes.Space.Space=..., modifier: datatypes.DGModifier=...) -> None: ...
    def setNormals(self, normals: List[datatypes.FloatVector], space: datatypes.Space.Space=...) -> None: ...
    def setPoint(self, vertexId: int, pos: datatypes.Point, space: datatypes.Space.Space=...) -> None: ...
    def setPoints(self, vertexArray: List[datatypes.Point], space: datatypes.Space.Space=...) -> None: ...
    def setSomeColors(self, colorIds: List[int], colorArray: List[datatypes.Color], colorSet: str=...) -> None: ...
    def setSomeUVs(self, uvIds: List[int], uArray: List[float], vArray: List[float], uvSet: str=...) -> None: ...
    def setUV(self, uvId: int, u: float, v: float, uvSet: str=...) -> None: ...
    def setUVs(self, uArray: List[float], vArray: List[float], uvSet: str=...) -> None: ...
    def setVertexColor(self, color: datatypes.Color, vertexIndex: int, modifier: datatypes.DGModifier=...) -> None: ...
    def setVertexNormal(self, normalIn: datatypes.Vector, vertexId: int, space: datatypes.Space.Space=..., modifier: datatypes.DGModifier=...) -> None: ...
    def syncObject(self) -> None: ...
    def unlockFaceVertexNormals(self, faceList: List[int], vertexList: List[int]) -> None: ...
    def unlockVertexNormals(self, vertexList: List[int]) -> None: ...
    def updateSurface(self) -> None: ...

class Subdiv(SurfaceShape):
    def getTweakedVerts(self, **kwargs: Any): ...
    def getSharpenedVerts(self, **kwargs: Any): ...
    def getSharpenedEdges(self, **kwargs: Any): ...
    def getEdges(self, **kwargs: Any): ...
    def cleanTopology(self) -> None: ...
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def collapse(self, level: int, makeNewNodeInvisible: bool) -> general.PyNode: ...
    def convertToNurbs(self) -> List[general.PyNode]: ...
    def copy(self, source: general.PyNode, parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def creasesClearAll(self) -> None: ...
    def createBaseMesh(self, reverseNormal: bool, numVertices: int, numPolygons: int, vertexArray: List[datatypes.Point], polygonCounts: List[int], polygonConnects: List[int], parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def editsPending(self) -> int: ...
    def editsUpdateAll(self) -> None: ...
    def getCurrentLevel(self, **kwargs: Any): ...
    def getCurrentSubdLevel(self, **kwargs: Any): ...
    def getDeepestLevel(self, **kwargs: Any): ...
    def getDisplayLoad(self, **kwargs: Any): ...
    def getEdgeStats(self, **kwargs: Any): ...
    def getFaceStats(self, **kwargs: Any): ...
    def getMaxPossibleLevel(self, **kwargs: Any): ...
    def getProxyMode(self, **kwargs: Any): ...
    def getSmallOffsets(self, **kwargs: Any): ...
    def levelFullySubdivideTo(self, level: int) -> None: ...
    def levelMaxAllowed(self) -> int: ...
    def levelMaxCurrent(self) -> int: ...
    def numEdges(self, level: int=...) -> int: ...
    def numFaces(self, level: int=...) -> int: ...
    def numVertices(self, level: int=...) -> int: ...
    def polygonCountMaxWithGivenBaseMesh(self, level: int=...) -> int: ...
    def tesselate(self, uniform: bool, depth: int, sample: int, parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def tessellateViaNurbs(self, parentOrOwner: general.PyNode=...) -> general.PyNode: ...
    def updateAllEditsAndCreases(self) -> None: ...
    def updateSubdSurface(self) -> None: ...
    def vertexBaseMeshAdd(self, x: float, y: float, z: float) -> int: ...
    def vertexBaseMeshAddWithIndex(self, x: float, y: float, z: float, index: int) -> None: ...
    def vertexBaseMeshGet(self, space: datatypes.Space.Space=...) -> List[datatypes.Point]: ...
    def vertexBaseMeshSet(self, space: datatypes.Space.Space=...) -> List[datatypes.Point]: ...
    def vertexEditsClearAllNonBase(self) -> None: ...

class Lattice(ControlPoint):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getDivisions(self) -> Tuple[int, int, int]: ...
    def getExclusive(self, **kwargs: Any): ...
    def getFreezeMapping(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getLdivisions(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def latticeReset(self, val: bool = ..., **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def point(self, s: int, t: int, u: int) -> datatypes.Point: ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def removeTweaks(self, val: bool = ..., **kwargs: Any): ...
    def reset(self, sSize: float=..., tSize: float=..., uSize: float=...) -> None: ...
    def setDivisions(self, s: int, t: int, u: int) -> None: ...
    def setFreezeMapping(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setLdivisions(self, val: bool = ..., **kwargs: Any): ...

class Particle(DeformableShape):
    __apicls__: Any = ...
    Point: Any = ...
    def pointCount(self): ...
    num: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    RenderType: Any = ...
    def acceleration(self) -> List[datatypes.Vector]: ...
    def age(self, ages: List[float]) -> None: ...
    def betterIllum(self) -> bool: ...
    def castsShadows(self) -> bool: ...
    def deformedParticleShape(self) -> general.PyNode: ...
    def disableCloudAxis(self) -> bool: ...
    def emission(self, emissions: List[datatypes.Vector]) -> None: ...
    def emit(self, v: datatypes.Point) -> None: ...
    def evaluateDynamics(self, to: datatypes.Time, runupFromStart: bool) -> None: ...
    def flatShaded(self) -> bool: ...
    def floatValue(self, val: bool = ..., **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getCache(self, **kwargs: Any): ...
    def getConserve(self, **kwargs: Any): ...
    def getCount(self) -> int: ...
    def getDynamicAttrList(self, **kwargs: Any): ...
    def getGridSpacing(self, **kwargs: Any): ...
    def getInherit(self, **kwargs: Any): ...
    def getJitterBasePoint(self, **kwargs: Any): ...
    def getJitterRadius(self, **kwargs: Any): ...
    def getLowerLeft(self, **kwargs: Any): ...
    def getNumJitters(self, **kwargs: Any): ...
    def getOrder(self, **kwargs: Any): ...
    def getParticleId(self, **kwargs: Any): ...
    def getPerParticleAttribute(self, attrName: str) -> Tuple[int, List[int]]: ...
    def getPerParticleDouble(self, **kwargs: Any): ...
    def getPerParticleVector(self, **kwargs: Any): ...
    def getShapeName(self, **kwargs: Any): ...
    def getUpperRight(self, **kwargs: Any): ...
    def hasEmission(self) -> bool: ...
    def hasLifespan(self) -> bool: ...
    def hasOpacity(self) -> bool: ...
    def hasRgb(self) -> bool: ...
    def isDeformedParticleShape(self) -> bool: ...
    def isPerParticleDoubleAttribute(self, attrName: str) -> bool: ...
    def isPerParticleIntAttribute(self, attrName: str) -> bool: ...
    def isPerParticleVectorAttribute(self, attrName: str) -> bool: ...
    def isValid(self) -> bool: ...
    def lifespan(self, lifespans: List[float]) -> None: ...
    def mass(self) -> List[float]: ...
    def opacity(self, opacities: List[float]) -> None: ...
    def originalParticleShape(self) -> general.PyNode: ...
    def particleIds(self) -> List[int]: ...
    def particleName(self) -> str: ...
    def position(self, positions: List[datatypes.Vector]) -> None: ...
    def position0(self, positions: List[datatypes.Vector]) -> None: ...
    def position1(self, positions: List[datatypes.Vector]) -> None: ...
    def primaryVisibility(self) -> bool: ...
    def radius(self, radii: List[float]) -> None: ...
    def radius0(self, radii: List[float]) -> None: ...
    def radius1(self, radii: List[float]) -> None: ...
    def receiveShadows(self) -> bool: ...
    def renderType(self) -> ParticleSystem.RenderType: ...
    def rgb(self, colors: List[datatypes.Vector]) -> None: ...
    def saveInitialState(self) -> None: ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setCache(self, val: bool = ..., **kwargs: Any): ...
    def setConserve(self, val: bool = ..., **kwargs: Any): ...
    def setCount(self, count: int) -> None: ...
    def setInherit(self, val: bool = ..., **kwargs: Any): ...
    def setOrder(self, val: bool = ..., **kwargs: Any): ...
    def setParticleId(self, val: bool = ..., **kwargs: Any): ...
    def setPerParticleAttribute(self, attrName: str, array: List[datatypes.Vector]) -> None: ...
    def setShapeName(self, val: bool = ..., **kwargs: Any): ...
    def surfaceShading(self) -> float: ...
    def tailSize(self) -> float: ...
    def threshold(self) -> float: ...
    def vectorValue(self, val: bool = ..., **kwargs: Any): ...
    def velocity(self) -> List[datatypes.Vector]: ...
    def visibleInReflections(self) -> bool: ...
    def visibleInRefractions(self) -> bool: ...

class SelectionSet:
    apicls: Any = ...
    def __init__(self, objs: Any) -> None: ...
    def __melobject__(self): ...
    def __len__(self) -> int: ...
    def __contains__(self, item: Any) -> bool: ...
    def __getitem__(self, index: Any) -> general.PyNode: ...
    def __setitem__(self, index: Any, item: Any): ...
    def __and__(self, s: Any): ...
    def __iand__(self, s: Any): ...
    def __or__(self, s: Any): ...
    def __ior__(self, s: Any): ...
    def __lt__(self, s: Any) -> Any: ...
    def __gt__(self, s: Any) -> Any: ...
    def __sub__(self, s: Any): ...
    def __isub__(self, s: Any): ...
    def __xor__(self, s: Any): ...
    def __ixor__(self, s: Any): ...
    def add(self, item: Any): ...
    def pop(self, index: int) -> general.PyNode: ...
    def isSubSet(self, other: Any) -> bool: ...
    def isSuperSet(self, other: Any, flatten: Any=...) -> bool: ...
    def getIntersection(self, other: Any) -> SelectionSet: ...
    def intersection(self, other: Any) -> None: ...
    def getDifference(self, other: Any) -> SelectionSet: ...
    def difference(self, other: Any) -> None: ...
    def getUnion(self, other: Any) -> SelectionSet: ...
    def union(self, other: Any) -> None: ...
    def getSymmetricDifference(self, other: Any) -> SelectionSet: ...
    def symmetricDifference(self, other: Any) -> None: ...
    def asObjectSet(self): ...
    MergeStrategy: Any = ...
    def clear(self) -> None: ...
    def getSelectionStrings(self) -> List[str]: ...
    def intersect(self, other: SelectionSet, expandToLeaves: bool=...) -> None: ...
    def isEmpty(self) -> bool: ...
    def removeAtIndex(self, index: int) -> None: ...

class ObjectSet(Entity):
    def __contains__(self, item: Any) -> bool: ...
    def __getitem__(self, index: Any): ...
    def __len__(self) -> int: ...
    def __and__(self, s: Any): ...
    def __iand__(self, s: Any): ...
    def __or__(self, s: Any): ...
    def __ior__(self, s: Any): ...
    def __sub__(self, s: Any): ...
    def __isub__(self, s: Any): ...
    def __xor__(self, s: Any): ...
    def __ixor__(self, s: Any): ...
    def forceElement(self, member: Any) -> None: ...
    def members(self, flatten: Any=...) -> List[general.PyNode]: ...
    def elements(self, flatten: Any=...) -> List[general.PyNode]: ...
    def flattened(self) -> List[general.PyNode]: ...
    def resetTo(self, newContents: Any) -> None: ...
    def add(self, item: Any): ...
    addMember: Any = ...
    def remove(self, item: Any): ...
    removeMember: Any = ...
    def isSubSet(self, other: Union[str, ObjectSet]) -> bool: ...
    def isSuperSet(self, other: Union[str, ObjectSet]) -> bool: ...
    def isEqual(self, other: Union[str, ObjectSet]) -> bool: ...
    def getDifference(self, other: Union[str, ObjectSet]) -> SelectionSet: ...
    def difference(self, other: Any) -> None: ...
    def getSymmetricDifference(self, other: Union[str, ObjectSet]) -> SelectionSet: ...
    def symmetricDifference(self, other: Any) -> None: ...
    def getIntersection(self, other: Union[str, ObjectSet]) -> SelectionSet: ...
    def intersection(self, other: Any) -> None: ...
    def getUnion(self, other: Union[str, ObjectSet]) -> SelectionSet: ...
    def union(self, other: Any) -> None: ...
    def isRenderable(self): ...
    __apicls__: Any = ...
    __melnode__: str = ...
    Restriction: Any = ...
    def addMembers(self, list: SelectionSet) -> None: ...
    def asSelectionSet(self, flatten: bool=...) -> SelectionSet: ...
    def clear(self) -> None: ...
    def getAnnotation(self) -> str: ...
    def hasRestrictions(self) -> bool: ...
    def intersectsWith(self, otherSet: general.PyNode) -> bool: ...
    def isMember(self, object: general.PyNode) -> bool: ...
    def removeMembers(self, list: SelectionSet) -> None: ...
    def restriction(self) -> Set.Restriction: ...
    def setAnnotation(self, annotation: str) -> None: ...

class ShadingEngine(ObjectSet):
    __melnode__: str = ...

class AnimLayer(ObjectSet):
    def getAttribute(self): ...
    getAttributes: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def copyAnimation(self, val: bool = ..., **kwargs: Any): ...
    def copyNoAnimation(self, val: bool = ..., **kwargs: Any): ...
    def extractAnimation(self, val: bool = ..., **kwargs: Any): ...
    def getAddRelatedKG(self, **kwargs: Any): ...
    def getAddSelectedObjects(self, **kwargs: Any): ...
    def getAffectedLayers(self, **kwargs: Any): ...
    def getAnimCurves(self, **kwargs: Any): ...
    def getBaseAnimCurves(self, **kwargs: Any): ...
    def getBestAnimLayer(self, **kwargs: Any): ...
    def getBestLayer(self, **kwargs: Any): ...
    def getBlendNodes(self, **kwargs: Any): ...
    def getChildren(self, **kwargs: Any): ...
    def getCollapse(self, **kwargs: Any): ...
    def getExcludeBoolean(self, **kwargs: Any): ...
    def getExcludeDynamic(self, **kwargs: Any): ...
    def getExcludeEnum(self, **kwargs: Any): ...
    def getExcludeRotate(self, **kwargs: Any): ...
    def getExcludeScale(self, **kwargs: Any): ...
    def getExcludeTranslate(self, **kwargs: Any): ...
    def getExcludeVisibility(self, **kwargs: Any): ...
    def getExists(self, **kwargs: Any): ...
    def getFindCurveForPlug(self, **kwargs: Any): ...
    def getLayeredPlug(self, **kwargs: Any): ...
    def getLock(self, **kwargs: Any): ...
    def getMaxLayers(self, **kwargs: Any): ...
    def getMute(self, **kwargs: Any): ...
    def getOverride(self, **kwargs: Any): ...
    def getParent(self, **kwargs: Any): ...
    def getPassthrough(self, **kwargs: Any): ...
    def getPreferred(self, **kwargs: Any): ...
    def getRoot(self, **kwargs: Any): ...
    def getSelected(self, **kwargs: Any): ...
    def getSolo(self, **kwargs: Any): ...
    def getWeight(self, **kwargs: Any): ...
    def moveLayerAfter(self, val: bool = ..., **kwargs: Any): ...
    def moveLayerBefore(self, val: bool = ..., **kwargs: Any): ...
    def removeAllAttributes(self, val: bool = ..., **kwargs: Any): ...
    def setAddRelatedKG(self, val: bool = ..., **kwargs: Any): ...
    def setAddSelectedObjects(self, val: bool = ..., **kwargs: Any): ...
    def setAnimCurves(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setBaseAnimCurves(self, val: bool = ..., **kwargs: Any): ...
    def setBestAnimLayer(self, val: bool = ..., **kwargs: Any): ...
    def setBlendNodes(self, val: bool = ..., **kwargs: Any): ...
    def setCollapse(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeBoolean(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeDynamic(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeEnum(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeRotate(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeScale(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setExcludeVisibility(self, val: bool = ..., **kwargs: Any): ...
    def setFindCurveForPlug(self, val: bool = ..., **kwargs: Any): ...
    def setLock(self, val: bool = ..., **kwargs: Any): ...
    def setMute(self, val: bool = ..., **kwargs: Any): ...
    def setOverride(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setPassthrough(self, val: bool = ..., **kwargs: Any): ...
    def setPreferred(self, val: bool = ..., **kwargs: Any): ...
    def setSelected(self, val: bool = ..., **kwargs: Any): ...
    def setSolo(self, val: bool = ..., **kwargs: Any): ...
    def setWeight(self, val: bool = ..., **kwargs: Any): ...
    def writeBlendnodeDestinations(self, val: bool = ..., **kwargs: Any): ...

class AnimCurve(DependNode):
    def addKeys(self, time: Any, values: Any, tangentInType: str = ..., tangentOutType: str = ..., unit: Optional[Any] = ..., keepExistingKeys: bool = ...): ...
    def addKeyTU(self, time: Union[datatypes.Time, float], value: float, tangentInType: AnimCurve.TangentType=..., tangentOutType: AnimCurve.TangentType=...) -> int: ...
    def addKeyTT(self, timeInput: Union[datatypes.Time, float], timeValue: Union[datatypes.Time, float], tangentInType: AnimCurve.TangentType=..., tangentOutType: AnimCurve.TangentType=...) -> int: ...
    def addKeyUU(self, unitlessInput: float, value: float, tangentInType: AnimCurve.TangentType=..., tangentOutType: AnimCurve.TangentType=...) -> int: ...
    def addKeyUT(self, unitlessInput: float, timeValue: Union[datatypes.Time, float], tangentInType: AnimCurve.TangentType=..., tangentOutType: AnimCurve.TangentType=...) -> int: ...
    def addKeyframe(self, *args: Any, **kwargs: Any): ...
    def evaluateTU(self, atTime: datatypes.Time) -> float: ...
    def evaluateTT(self, atTime: datatypes.Time) -> datatypes.Time: ...
    def evaluateUU(self, atUnitlessInput: float) -> float: ...
    def evaluateUT(self, atUnitlessInput: float) -> datatypes.Time: ...
    def findClosestT(self, time: datatypes.Time) -> int: ...
    def findClosestU(self, unitlessInput: float) -> int: ...
    def numKeyframes(self): ...
    @classmethod
    def timedAnimCurveTypeForPlug(cls, plug: general.Attribute) -> AnimCurve.AnimCurveType: ...
    @classmethod
    def unitlessAnimCurveTypeForPlug(cls, plug: general.Attribute) -> AnimCurve.AnimCurveType: ...
    __apicls__: Any = ...
    __melnode__: str = ...
    AnimCurveType: Any = ...
    InfinityType: Any = ...
    TangentType: Any = ...
    def addKeysWithTangents(self, timeArray: List[datatypes.Time], valueArray: List[float], tangentInType: AnimCurve.TangentType=..., tangentOutType: AnimCurve.TangentType=..., tangentInTypeArray: List[int]=..., tangentOutTypeArray: List[int]=..., tangentInXArray: List[float]=..., tangentInYArray: List[float]=..., tangentOutXArray: List[float]=..., tangentOutYArray: List[float]=..., tangentsLockedArray: List[int]=..., weightsLockedArray: List[int]=..., convertUnits: bool=..., keepExistingKeys: bool=...) -> None: ...
    def animCurveType(self) -> AnimCurve.AnimCurveType: ...
    def getInTangentType(self, index: int) -> AnimCurve.TangentType: ...
    def getOutTangentType(self, index: int) -> AnimCurve.TangentType: ...
    def getPostInfinityType(self) -> AnimCurve.InfinityType: ...
    def getPreInfinityType(self) -> AnimCurve.InfinityType: ...
    def getTangentsLocked(self, index: int) -> bool: ...
    def getTime(self, index: int) -> datatypes.Time: ...
    def getUnitlessInput(self, index: int) -> float: ...
    def getValue(self, index: int) -> float: ...
    def getWeightsLocked(self, index: int) -> bool: ...
    def insertKey(self, time: datatypes.Time, breakdown: bool=...) -> int: ...
    def isBreakdown(self, index: int) -> bool: ...
    def isStatic(self) -> bool: ...
    def isTimeInput(self) -> bool: ...
    def isUnitlessInput(self) -> bool: ...
    def isWeighted(self) -> bool: ...
    def numKeys(self) -> int: ...
    def remove(self, index: int) -> None: ...
    def setAngle(self, index: int, angle: datatypes.Angle, inTangent: bool) -> None: ...
    def setBreakdown(self, index: int, isBreakdown: bool) -> None: ...
    def setInTangentType(self, index: int, tangentType: AnimCurve.TangentType) -> None: ...
    def setOutTangentType(self, index: int, tangentType: AnimCurve.TangentType) -> None: ...
    def setPostInfinityType(self, infinityType: AnimCurve.InfinityType) -> None: ...
    def setPreInfinityType(self, infinityType: AnimCurve.InfinityType) -> None: ...
    def setTangentTypes(self, indexArray: List[int], inTangentType: AnimCurve.TangentType=..., outTangentType: AnimCurve.TangentType=...) -> None: ...
    def setTangentsLocked(self, index: int, locked: bool) -> None: ...
    def setTime(self, index: int, time: datatypes.Time) -> None: ...
    def setUnitlessInput(self, index: int, unitlessInput: float) -> None: ...
    def setValue(self, index: int, value: float) -> None: ...
    def setWeight(self, index: int, weight: float, inTangent: bool) -> None: ...
    def setWeighted(self, isWeighted: bool) -> None: ...
    def setWeightsLocked(self, index: int, locked: bool) -> None: ...

class AnimCurveTA(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveTL(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveTT(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveTU(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveUA(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveUL(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveUT(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class AnimCurveUU(AnimCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class ResultCurve(AnimCurve):
    __melnode__: str = ...

class ResultCurveTimeToAngular(ResultCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class ResultCurveTimeToLinear(ResultCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class ResultCurveTimeToTime(ResultCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class ResultCurveTimeToUnitless(ResultCurve):
    addKey: Any = ...
    evaluate: Any = ...
    findClosest: Any = ...
    __melnode__: str = ...

class GeometryFilter(DependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def deformerSet(self) -> general.PyNode: ...
    def getEnvelope(self) -> float: ...
    def getInputGeometry(self) -> List[general.PyNode]: ...
    def getOutputGeometry(self) -> List[general.PyNode]: ...
    def getPathAtIndex(self, index: int) -> general.PyNode: ...
    def groupIdAtIndex(self, index: int) -> int: ...
    def indexForGroupId(self, groupId: int) -> int: ...
    def indexForOutputConnection(self, connectionIndex: int) -> int: ...
    def indexForOutputShape(self, shape: general.PyNode) -> int: ...
    def inputShapeAtIndex(self, index: int) -> general.PyNode: ...
    def numOutputConnections(self) -> int: ...
    def outputShapeAtIndex(self, index: int) -> general.PyNode: ...
    def setEnvelope(self, envelope: float) -> None: ...

class SkinCluster(GeometryFilter):
    def getWeights(self, geometry: Any, influenceIndex: Optional[Any] = ...): ...
    def setWeights(self, geometry: Any, influnces: Any, weights: Any, normalize: bool = ...): ...
    def influenceObjects(self): ...
    def numInfluenceObjects(self): ...
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addInfluence(self, val: bool = ..., **kwargs: Any): ...
    def addToSelection(self, val: bool = ..., **kwargs: Any): ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def baseShape(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def forceNormalizeWeights(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getBindMethod(self, **kwargs: Any): ...
    def getBlendWeights(self, path: general.PyNode, components: general.PyNode) -> List[float]: ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getDropoffRate(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getIgnoreHierarchy(self, **kwargs: Any): ...
    def getInfluence(self, **kwargs: Any): ...
    def getLockWeights(self, **kwargs: Any): ...
    def getMaximumInfluences(self, **kwargs: Any): ...
    def getNormalizeWeights(self, **kwargs: Any): ...
    def getObeyMaxInfluences(self, **kwargs: Any): ...
    def getPointsAffectedByInfluence(self, path: general.PyNode) -> Tuple[SelectionSet, List[float]]: ...
    def getSkinMethod(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWeightDistribution(self, **kwargs: Any): ...
    def getWeightedInfluence(self, **kwargs: Any): ...
    def ignoreBindPose(self, val: bool = ..., **kwargs: Any): ...
    def indexForInfluenceObject(self, mpath: general.PyNode) -> int: ...
    def moveJointsMode(self, val: bool = ..., **kwargs: Any): ...
    def nurbsSamples(self, val: bool = ..., **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def polySmoothness(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def recacheBindMatrices(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def removeFromSelection(self, val: bool = ..., **kwargs: Any): ...
    def removeInfluence(self, val: bool = ..., **kwargs: Any): ...
    def selectInfluenceVerts(self, val: bool = ..., **kwargs: Any): ...
    def setBlendWeights(self, path: general.PyNode, components: general.PyNode, weights: List[float]) -> None: ...
    def setDropoffRate(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setInfluence(self, val: bool = ..., **kwargs: Any): ...
    def setLockWeights(self, val: bool = ..., **kwargs: Any): ...
    def setMaximumInfluences(self, val: bool = ..., **kwargs: Any): ...
    def setNormalizeWeights(self, val: bool = ..., **kwargs: Any): ...
    def setObeyMaxInfluences(self, val: bool = ..., **kwargs: Any): ...
    def setSkinMethod(self, val: bool = ..., **kwargs: Any): ...
    def setWeightDistribution(self, val: bool = ..., **kwargs: Any): ...
    def smoothWeights(self, val: bool = ..., **kwargs: Any): ...
    def smoothWeightsMaxIterations(self, val: bool = ..., **kwargs: Any): ...
    def unbind(self, val: bool = ..., **kwargs: Any): ...
    def unbindKeepHistory(self, val: bool = ..., **kwargs: Any): ...
    def useGeometry(self, val: bool = ..., **kwargs: Any): ...
    def weight(self, val: bool = ..., **kwargs: Any): ...

class HikHandle(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class JointFfd(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class AngleBetween(DependNode):
    @staticmethod
    def __melcmd__(*args: Any, **kwargs: Any): ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class THdependNode(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TadskAssetInstanceNode_TdependNode(DependNode):
    __melnode__: str = ...

class AdskMaterial(TadskAssetInstanceNode_TdependNode):
    __melnode__: str = ...

class AboutToSetValueTestNode(DependNode):
    __melnode__: str = ...

class AbstractBaseCreate(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class AbstractBaseNurbsConversion(AbstractBaseCreate):
    __melnode__: str = ...

class NurbsToSubdiv(AbstractBaseNurbsConversion):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAddUnderTransform(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getCollapsePoles(self, **kwargs: Any): ...
    def getMatchPeriodic(self, **kwargs: Any): ...
    def getMaxPolyCount(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getReverseNormal(self, **kwargs: Any): ...
    def setAddUnderTransform(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCollapsePoles(self, val: bool = ..., **kwargs: Any): ...
    def setMatchPeriodic(self, val: bool = ..., **kwargs: Any): ...
    def setMaxPolyCount(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setReverseNormal(self, val: bool = ..., **kwargs: Any): ...

class NurbsToSubdivProc(NurbsToSubdiv):
    __melnode__: str = ...

class ParentTessellate(AbstractBaseNurbsConversion):
    __melnode__: str = ...

class NurbsTessellate(ParentTessellate):
    __melnode__: str = ...

class ShellTessellate(ParentTessellate):
    __melnode__: str = ...

class RebuildSurface(AbstractBaseNurbsConversion):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDegreeU(self, **kwargs: Any): ...
    def getDegreeV(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getEndKnots(self, **kwargs: Any): ...
    def getFitRebuild(self, **kwargs: Any): ...
    def getKeepControlPoints(self, **kwargs: Any): ...
    def getKeepCorners(self, **kwargs: Any): ...
    def getKeepRange(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRebuildType(self, **kwargs: Any): ...
    def getSpansU(self, **kwargs: Any): ...
    def getSpansV(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegreeU(self, val: bool = ..., **kwargs: Any): ...
    def setDegreeV(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setEndKnots(self, val: bool = ..., **kwargs: Any): ...
    def setFitRebuild(self, val: bool = ..., **kwargs: Any): ...
    def setKeepControlPoints(self, val: bool = ..., **kwargs: Any): ...
    def setKeepCorners(self, val: bool = ..., **kwargs: Any): ...
    def setKeepRange(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRebuildType(self, val: bool = ..., **kwargs: Any): ...
    def setSpansU(self, val: bool = ..., **kwargs: Any): ...
    def setSpansV(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...

class AlignCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCurvatureContinuity(self, **kwargs: Any): ...
    def getCurvatureScale1(self, **kwargs: Any): ...
    def getCurvatureScale2(self, **kwargs: Any): ...
    def getJoinParameter(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPositionalContinuity(self, **kwargs: Any): ...
    def getPositionalContinuityType(self, **kwargs: Any): ...
    def getReverse1(self, **kwargs: Any): ...
    def getReverse2(self, **kwargs: Any): ...
    def getTangentContinuity(self, **kwargs: Any): ...
    def getTangentContinuityType(self, **kwargs: Any): ...
    def getTangentScale1(self, **kwargs: Any): ...
    def getTangentScale2(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureScale1(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureScale2(self, val: bool = ..., **kwargs: Any): ...
    def setJoinParameter(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPositionalContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setPositionalContinuityType(self, val: bool = ..., **kwargs: Any): ...
    def setReverse1(self, val: bool = ..., **kwargs: Any): ...
    def setReverse2(self, val: bool = ..., **kwargs: Any): ...
    def setTangentContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setTangentContinuityType(self, val: bool = ..., **kwargs: Any): ...
    def setTangentScale1(self, val: bool = ..., **kwargs: Any): ...
    def setTangentScale2(self, val: bool = ..., **kwargs: Any): ...

class AlignSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCurvatureContinuity(self, **kwargs: Any): ...
    def getCurvatureScale1(self, **kwargs: Any): ...
    def getCurvatureScale2(self, **kwargs: Any): ...
    def getDirectionU(self, **kwargs: Any): ...
    def getJoinParameter(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPositionalContinuity(self, **kwargs: Any): ...
    def getPositionalContinuityType(self, **kwargs: Any): ...
    def getReverse1(self, **kwargs: Any): ...
    def getReverse2(self, **kwargs: Any): ...
    def getSwap1(self, **kwargs: Any): ...
    def getSwap2(self, **kwargs: Any): ...
    def getTangentContinuity(self, **kwargs: Any): ...
    def getTangentContinuityType(self, **kwargs: Any): ...
    def getTangentScale1(self, **kwargs: Any): ...
    def getTangentScale2(self, **kwargs: Any): ...
    def getTwist(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureScale1(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureScale2(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionU(self, val: bool = ..., **kwargs: Any): ...
    def setJoinParameter(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPositionalContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setPositionalContinuityType(self, val: bool = ..., **kwargs: Any): ...
    def setReverse1(self, val: bool = ..., **kwargs: Any): ...
    def setReverse2(self, val: bool = ..., **kwargs: Any): ...
    def setSwap1(self, val: bool = ..., **kwargs: Any): ...
    def setSwap2(self, val: bool = ..., **kwargs: Any): ...
    def setTangentContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setTangentContinuityType(self, val: bool = ..., **kwargs: Any): ...
    def setTangentScale1(self, val: bool = ..., **kwargs: Any): ...
    def setTangentScale2(self, val: bool = ..., **kwargs: Any): ...
    def setTwist(self, val: bool = ..., **kwargs: Any): ...

class ArubaTessellate(AbstractBaseCreate):
    __melnode__: str = ...

class AttachCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBlendBias(self, **kwargs: Any): ...
    def getBlendKnotInsertion(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getKeepMultipleKnots(self, **kwargs: Any): ...
    def getMethod(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def getReverse1(self, **kwargs: Any): ...
    def getReverse2(self, **kwargs: Any): ...
    def setBlendBias(self, val: bool = ..., **kwargs: Any): ...
    def setBlendKnotInsertion(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setKeepMultipleKnots(self, val: bool = ..., **kwargs: Any): ...
    def setMethod(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...
    def setReverse1(self, val: bool = ..., **kwargs: Any): ...
    def setReverse2(self, val: bool = ..., **kwargs: Any): ...

class AttachSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBlendBias(self, **kwargs: Any): ...
    def getBlendKnotInsertion(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDirectionU(self, **kwargs: Any): ...
    def getKeepMultipleKnots(self, **kwargs: Any): ...
    def getMethod(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def getReverse1(self, **kwargs: Any): ...
    def getReverse2(self, **kwargs: Any): ...
    def getSwap1(self, **kwargs: Any): ...
    def getSwap2(self, **kwargs: Any): ...
    def getTwist(self, **kwargs: Any): ...
    def setBlendBias(self, val: bool = ..., **kwargs: Any): ...
    def setBlendKnotInsertion(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionU(self, val: bool = ..., **kwargs: Any): ...
    def setKeepMultipleKnots(self, val: bool = ..., **kwargs: Any): ...
    def setMethod(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...
    def setReverse1(self, val: bool = ..., **kwargs: Any): ...
    def setReverse2(self, val: bool = ..., **kwargs: Any): ...
    def setSwap1(self, val: bool = ..., **kwargs: Any): ...
    def setSwap2(self, val: bool = ..., **kwargs: Any): ...
    def setTwist(self, val: bool = ..., **kwargs: Any): ...

class AvgCurves(AbstractBaseCreate):
    __melnode__: str = ...

class AvgNurbsSurfacePoints(AbstractBaseCreate):
    __melnode__: str = ...

class AvgSurfacePoints(AbstractBaseCreate):
    __melnode__: str = ...

class Bevel(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBevelShapeType(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getCornerType(self, **kwargs: Any): ...
    def getDepth(self, **kwargs: Any): ...
    def getExtrudeDepth(self, **kwargs: Any): ...
    def getJoinSurfaces(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberOfSides(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setBevelShapeType(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCornerType(self, val: bool = ..., **kwargs: Any): ...
    def setDepth(self, val: bool = ..., **kwargs: Any): ...
    def setExtrudeDepth(self, val: bool = ..., **kwargs: Any): ...
    def setJoinSurfaces(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfSides(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class BevelPlus(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBevelInside(self, **kwargs: Any): ...
    def getCapSides(self, **kwargs: Any): ...
    def getInnerStyle(self, **kwargs: Any): ...
    def getJoinSurfaces(self, **kwargs: Any): ...
    def getNormalsOutwards(self, **kwargs: Any): ...
    def getNumberOfSides(self, **kwargs: Any): ...
    def getOuterStyle(self, **kwargs: Any): ...
    def setBevelInside(self, val: bool = ..., **kwargs: Any): ...
    def setInnerStyle(self, val: bool = ..., **kwargs: Any): ...
    def setJoinSurfaces(self, val: bool = ..., **kwargs: Any): ...
    def setNormalsOutwards(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfSides(self, val: bool = ..., **kwargs: Any): ...
    def setOuterStyle(self, val: bool = ..., **kwargs: Any): ...

class BezierCurveToNurbs(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class BirailSrf(AbstractBaseCreate):
    __melnode__: str = ...

class DpBirailSrf(BirailSrf):
    __melnode__: str = ...

class MpBirailSrf(BirailSrf):
    __melnode__: str = ...

class SpBirailSrf(BirailSrf):
    __melnode__: str = ...

class Boolean(AbstractBaseCreate):
    __melnode__: str = ...

class BoundaryBase(AbstractBaseCreate):
    __melnode__: str = ...

class Boundary(BoundaryBase):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getEndPoint(self, **kwargs: Any): ...
    def getEndPointTolerance(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOrder(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setEndPoint(self, val: bool = ..., **kwargs: Any): ...
    def setEndPointTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOrder(self, val: bool = ..., **kwargs: Any): ...

class SquareSrf(BoundaryBase):
    __melnode__: str = ...

class CloseCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBlendBias(self, **kwargs: Any): ...
    def getBlendKnotInsertion(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def getPreserveShape(self, **kwargs: Any): ...
    def setBlendBias(self, val: bool = ..., **kwargs: Any): ...
    def setBlendKnotInsertion(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveShape(self, val: bool = ..., **kwargs: Any): ...

class CloseSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBlendBias(self, **kwargs: Any): ...
    def getBlendKnotInsertion(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def getPreserveShape(self, **kwargs: Any): ...
    def setBlendBias(self, val: bool = ..., **kwargs: Any): ...
    def setBlendKnotInsertion(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveShape(self, val: bool = ..., **kwargs: Any): ...

class ClosestPointOnSurface(AbstractBaseCreate):
    __melnode__: str = ...

class CurveInfo(AbstractBaseCreate):
    __melnode__: str = ...

class CurveIntersect(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseDirection(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseDirection(self, val: bool = ..., **kwargs: Any): ...

class CurveRange(AbstractBaseCreate):
    __melnode__: str = ...

class CurveFromSubdiv(CurveRange):
    __melnode__: str = ...

class CurveFromSubdivEdge(CurveFromSubdiv):
    __melnode__: str = ...

class CurveFromSubdivFace(CurveFromSubdiv):
    __melnode__: str = ...

class CurveFromSurface(CurveRange):
    __melnode__: str = ...

class CurveFromSurfaceBnd(CurveFromSurface):
    __melnode__: str = ...

class CurveFromSurfaceCoS(CurveFromSurface):
    __melnode__: str = ...

class CurveFromSurfaceIso(CurveFromSurface):
    __melnode__: str = ...

class SubCurve(CurveRange):
    __melnode__: str = ...

class DetachCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getKeep(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setKeep(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...

class DetachSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getKeep(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setKeep(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...

class ExplodeNurbsShell(AbstractBaseCreate):
    __melnode__: str = ...

class ExtendCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDistance(self, **kwargs: Any): ...
    def getExtendMethod(self, **kwargs: Any): ...
    def getExtensionType(self, **kwargs: Any): ...
    def getInputPoint(self, **kwargs: Any): ...
    def getJoin(self, **kwargs: Any): ...
    def getNoChanges(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPointX(self, **kwargs: Any): ...
    def getPointY(self, **kwargs: Any): ...
    def getPointZ(self, **kwargs: Any): ...
    def getRemoveMultipleKnots(self, **kwargs: Any): ...
    def getStart(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDistance(self, val: bool = ..., **kwargs: Any): ...
    def setExtendMethod(self, val: bool = ..., **kwargs: Any): ...
    def setExtensionType(self, val: bool = ..., **kwargs: Any): ...
    def setInputPoint(self, val: bool = ..., **kwargs: Any): ...
    def setJoin(self, val: bool = ..., **kwargs: Any): ...
    def setNoChanges(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPointX(self, val: bool = ..., **kwargs: Any): ...
    def setPointY(self, val: bool = ..., **kwargs: Any): ...
    def setPointZ(self, val: bool = ..., **kwargs: Any): ...
    def setRemoveMultipleKnots(self, val: bool = ..., **kwargs: Any): ...
    def setStart(self, val: bool = ..., **kwargs: Any): ...

class ExtendSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDistance(self, **kwargs: Any): ...
    def getExtendDirection(self, **kwargs: Any): ...
    def getExtendMethod(self, **kwargs: Any): ...
    def getExtendSide(self, **kwargs: Any): ...
    def getExtensionType(self, **kwargs: Any): ...
    def getJoin(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDistance(self, val: bool = ..., **kwargs: Any): ...
    def setExtendDirection(self, val: bool = ..., **kwargs: Any): ...
    def setExtendMethod(self, val: bool = ..., **kwargs: Any): ...
    def setExtendSide(self, val: bool = ..., **kwargs: Any): ...
    def setExtensionType(self, val: bool = ..., **kwargs: Any): ...
    def setJoin(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class Extrude(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDegreeAlongLength(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getExtrudeType(self, **kwargs: Any): ...
    def getFixedPath(self, **kwargs: Any): ...
    def getLength(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getReverseSurfaceIfPathReversed(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getSubCurveSubSurface(self, **kwargs: Any): ...
    def getUseComponentPivot(self, **kwargs: Any): ...
    def getUseProfileNormal(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegreeAlongLength(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setExtrudeType(self, val: bool = ..., **kwargs: Any): ...
    def setFixedPath(self, val: bool = ..., **kwargs: Any): ...
    def setLength(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setReverseSurfaceIfPathReversed(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setSubCurveSubSurface(self, val: bool = ..., **kwargs: Any): ...
    def setUseComponentPivot(self, val: bool = ..., **kwargs: Any): ...
    def setUseProfileNormal(self, val: bool = ..., **kwargs: Any): ...

class FfBlendSrf(AbstractBaseCreate):
    __melnode__: str = ...

class FfBlendSrfObsolete(AbstractBaseCreate):
    __melnode__: str = ...

class FfFilletSrf(AbstractBaseCreate):
    __melnode__: str = ...

class FilletCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBias(self, **kwargs: Any): ...
    def getBlendControl(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getCircular(self, **kwargs: Any): ...
    def getCurveParameter1(self, **kwargs: Any): ...
    def getCurveParameter2(self, **kwargs: Any): ...
    def getDepth(self, **kwargs: Any): ...
    def getFreeformBlend(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def setBias(self, val: bool = ..., **kwargs: Any): ...
    def setBlendControl(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCircular(self, val: bool = ..., **kwargs: Any): ...
    def setCurveParameter1(self, val: bool = ..., **kwargs: Any): ...
    def setCurveParameter2(self, val: bool = ..., **kwargs: Any): ...
    def setDepth(self, val: bool = ..., **kwargs: Any): ...
    def setFreeformBlend(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...

class FitBspline(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...

class GlobalStitch(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getLockSurface(self, **kwargs: Any): ...
    def getMaxSeparation(self, **kwargs: Any): ...
    def getModificationResistance(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSampling(self, **kwargs: Any): ...
    def getStitchCorners(self, **kwargs: Any): ...
    def getStitchEdges(self, **kwargs: Any): ...
    def getStitchPartialEdges(self, **kwargs: Any): ...
    def getStitchSmoothness(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setLockSurface(self, val: bool = ..., **kwargs: Any): ...
    def setMaxSeparation(self, val: bool = ..., **kwargs: Any): ...
    def setModificationResistance(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSampling(self, val: bool = ..., **kwargs: Any): ...
    def setStitchCorners(self, val: bool = ..., **kwargs: Any): ...
    def setStitchEdges(self, val: bool = ..., **kwargs: Any): ...
    def setStitchPartialEdges(self, val: bool = ..., **kwargs: Any): ...
    def setStitchSmoothness(self, val: bool = ..., **kwargs: Any): ...

class HardenPoint(AbstractBaseCreate):
    __melnode__: str = ...

class InsertKnotCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAddKnots(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getInsertBetween(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberOfKnots(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def setAddKnots(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setInsertBetween(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfKnots(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...

class InsertKnotSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAddKnots(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getInsertBetween(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberOfKnots(self, **kwargs: Any): ...
    def getParameter(self, **kwargs: Any): ...
    def setAddKnots(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setInsertBetween(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfKnots(self, val: bool = ..., **kwargs: Any): ...
    def setParameter(self, val: bool = ..., **kwargs: Any): ...

class IntersectSurface(AbstractBaseCreate):
    __melnode__: str = ...

class LeastSquaresModifier(AbstractBaseCreate):
    __melnode__: str = ...

class Loft(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAutoReverse(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getClose(self, **kwargs: Any): ...
    def getCreateCusp(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getReverse(self, **kwargs: Any): ...
    def getReverseSurfaceNormals(self, **kwargs: Any): ...
    def getSectionSpans(self, **kwargs: Any): ...
    def getUniform(self, **kwargs: Any): ...
    def setAutoReverse(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setClose(self, val: bool = ..., **kwargs: Any): ...
    def setCreateCusp(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setReverse(self, val: bool = ..., **kwargs: Any): ...
    def setReverseSurfaceNormals(self, val: bool = ..., **kwargs: Any): ...
    def setSectionSpans(self, val: bool = ..., **kwargs: Any): ...
    def setUniform(self, val: bool = ..., **kwargs: Any): ...

class MakeCircularArc(AbstractBaseCreate):
    __melnode__: str = ...

class MakeThreePointCircularArc(MakeCircularArc):
    __melnode__: str = ...

class MakeTwoPointCircularArc(MakeCircularArc):
    __melnode__: str = ...

class MakeIllustratorCurves(AbstractBaseCreate):
    __melnode__: str = ...

class MakeNurbCircle(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCenter(self, **kwargs: Any): ...
    def getCenterX(self, **kwargs: Any): ...
    def getCenterY(self, **kwargs: Any): ...
    def getCenterZ(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getFirst(self, **kwargs: Any): ...
    def getFirstPointX(self, **kwargs: Any): ...
    def getFirstPointY(self, **kwargs: Any): ...
    def getFirstPointZ(self, **kwargs: Any): ...
    def getFixCenter(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNormal(self, **kwargs: Any): ...
    def getNormalX(self, **kwargs: Any): ...
    def getNormalY(self, **kwargs: Any): ...
    def getNormalZ(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSections(self, **kwargs: Any): ...
    def getSweep(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseTolerance(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCenter(self, val: bool = ..., **kwargs: Any): ...
    def setCenterX(self, val: bool = ..., **kwargs: Any): ...
    def setCenterY(self, val: bool = ..., **kwargs: Any): ...
    def setCenterZ(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setFirst(self, val: bool = ..., **kwargs: Any): ...
    def setFirstPointX(self, val: bool = ..., **kwargs: Any): ...
    def setFirstPointY(self, val: bool = ..., **kwargs: Any): ...
    def setFirstPointZ(self, val: bool = ..., **kwargs: Any): ...
    def setFixCenter(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNormal(self, val: bool = ..., **kwargs: Any): ...
    def setNormalX(self, val: bool = ..., **kwargs: Any): ...
    def setNormalY(self, val: bool = ..., **kwargs: Any): ...
    def setNormalZ(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSections(self, val: bool = ..., **kwargs: Any): ...
    def setSweep(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseTolerance(self, val: bool = ..., **kwargs: Any): ...

class MakeNurbsSquare(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCenter(self, **kwargs: Any): ...
    def getCenterX(self, **kwargs: Any): ...
    def getCenterY(self, **kwargs: Any): ...
    def getCenterZ(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNormal(self, **kwargs: Any): ...
    def getNormalX(self, **kwargs: Any): ...
    def getNormalY(self, **kwargs: Any): ...
    def getNormalZ(self, **kwargs: Any): ...
    def getSideLength1(self, **kwargs: Any): ...
    def getSideLength2(self, **kwargs: Any): ...
    def getSpansPerSide(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCenter(self, val: bool = ..., **kwargs: Any): ...
    def setCenterX(self, val: bool = ..., **kwargs: Any): ...
    def setCenterY(self, val: bool = ..., **kwargs: Any): ...
    def setCenterZ(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNormal(self, val: bool = ..., **kwargs: Any): ...
    def setNormalX(self, val: bool = ..., **kwargs: Any): ...
    def setNormalY(self, val: bool = ..., **kwargs: Any): ...
    def setNormalZ(self, val: bool = ..., **kwargs: Any): ...
    def setSideLength1(self, val: bool = ..., **kwargs: Any): ...
    def setSideLength2(self, val: bool = ..., **kwargs: Any): ...
    def setSpansPerSide(self, val: bool = ..., **kwargs: Any): ...

class MakeTextCurves(AbstractBaseCreate):
    __melnode__: str = ...

class NearestPointOnCurve(AbstractBaseCreate):
    __melnode__: str = ...

class NurbsCurveToBezier(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class OffsetCos(AbstractBaseCreate):
    __melnode__: str = ...

class OffsetCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConnectBreaks(self, **kwargs: Any): ...
    def getCutLoop(self, **kwargs: Any): ...
    def getCutRadius(self, **kwargs: Any): ...
    def getDistance(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNormal(self, **kwargs: Any): ...
    def getReparameterize(self, **kwargs: Any): ...
    def getStitch(self, **kwargs: Any): ...
    def getSubdivisionDensity(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseGivenNormal(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setConnectBreaks(self, val: bool = ..., **kwargs: Any): ...
    def setCutLoop(self, val: bool = ..., **kwargs: Any): ...
    def setCutRadius(self, val: bool = ..., **kwargs: Any): ...
    def setDistance(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNormal(self, val: bool = ..., **kwargs: Any): ...
    def setReparameterize(self, val: bool = ..., **kwargs: Any): ...
    def setStitch(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionDensity(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseGivenNormal(self, val: bool = ..., **kwargs: Any): ...

class OffsetSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDistance(self, **kwargs: Any): ...
    def getMethod(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDistance(self, val: bool = ..., **kwargs: Any): ...
    def setMethod(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PlanarTrimSurface(AbstractBaseCreate):
    __melnode__: str = ...

class PointOnCurveInfo(AbstractBaseCreate):
    __melnode__: str = ...

class PointOnSurfaceInfo(AbstractBaseCreate):
    __melnode__: str = ...

class PolyEdgeToCurve(AbstractBaseCreate):
    __melnode__: str = ...

class PolyProjectCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...

class Primitive(AbstractBaseCreate):
    __melnode__: str = ...

class MakeNurbCube(Primitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeightRatio(self, **kwargs: Any): ...
    def getLengthRatio(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPatchesU(self, **kwargs: Any): ...
    def getPatchesV(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeightRatio(self, val: bool = ..., **kwargs: Any): ...
    def setLengthRatio(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPatchesU(self, val: bool = ..., **kwargs: Any): ...
    def setPatchesV(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class MakeNurbPlane(Primitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getLengthRatio(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPatchesU(self, **kwargs: Any): ...
    def getPatchesV(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setLengthRatio(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPatchesU(self, val: bool = ..., **kwargs: Any): ...
    def setPatchesV(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class RevolvedPrimitive(Primitive):
    __melnode__: str = ...

class MakeNurbCone(RevolvedPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getEndSweep(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeightRatio(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSections(self, **kwargs: Any): ...
    def getSpans(self, **kwargs: Any): ...
    def getStartSweep(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseOldInitBehaviour(self, **kwargs: Any): ...
    def getUseTolerance(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setEndSweep(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeightRatio(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSections(self, val: bool = ..., **kwargs: Any): ...
    def setSpans(self, val: bool = ..., **kwargs: Any): ...
    def setStartSweep(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseOldInitBehaviour(self, val: bool = ..., **kwargs: Any): ...
    def setUseTolerance(self, val: bool = ..., **kwargs: Any): ...

class MakeNurbCylinder(RevolvedPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getEndSweep(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeightRatio(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSections(self, **kwargs: Any): ...
    def getSpans(self, **kwargs: Any): ...
    def getStartSweep(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseTolerance(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setEndSweep(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeightRatio(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSections(self, val: bool = ..., **kwargs: Any): ...
    def setSpans(self, val: bool = ..., **kwargs: Any): ...
    def setStartSweep(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseTolerance(self, val: bool = ..., **kwargs: Any): ...

class MakeNurbSphere(RevolvedPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getEndSweep(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeightRatio(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSections(self, **kwargs: Any): ...
    def getSpans(self, **kwargs: Any): ...
    def getStartSweep(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseTolerance(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setEndSweep(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeightRatio(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSections(self, val: bool = ..., **kwargs: Any): ...
    def setSpans(self, val: bool = ..., **kwargs: Any): ...
    def setStartSweep(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseTolerance(self, val: bool = ..., **kwargs: Any): ...

class MakeNurbTorus(RevolvedPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getEndSweep(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeightRatio(self, **kwargs: Any): ...
    def getMinorSweep(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSections(self, **kwargs: Any): ...
    def getSpans(self, **kwargs: Any): ...
    def getStartSweep(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseTolerance(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setEndSweep(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeightRatio(self, val: bool = ..., **kwargs: Any): ...
    def setMinorSweep(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSections(self, val: bool = ..., **kwargs: Any): ...
    def setSpans(self, val: bool = ..., **kwargs: Any): ...
    def setStartSweep(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseTolerance(self, val: bool = ..., **kwargs: Any): ...

class ProjectCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseNormal(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseNormal(self, val: bool = ..., **kwargs: Any): ...

class ProjectTangent(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCurvature(self, **kwargs: Any): ...
    def getCurvatureScale(self, **kwargs: Any): ...
    def getIgnoreEdges(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getReverseTangent(self, **kwargs: Any): ...
    def getRotate(self, **kwargs: Any): ...
    def getTangentDirection(self, **kwargs: Any): ...
    def getTangentScale(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCurvature(self, val: bool = ..., **kwargs: Any): ...
    def setCurvatureScale(self, val: bool = ..., **kwargs: Any): ...
    def setIgnoreEdges(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setReverseTangent(self, val: bool = ..., **kwargs: Any): ...
    def setRotate(self, val: bool = ..., **kwargs: Any): ...
    def setTangentDirection(self, val: bool = ..., **kwargs: Any): ...
    def setTangentScale(self, val: bool = ..., **kwargs: Any): ...

class RbfSrf(AbstractBaseCreate):
    __melnode__: str = ...

class RebuildCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getEndKnots(self, **kwargs: Any): ...
    def getFitRebuild(self, **kwargs: Any): ...
    def getKeepControlPoints(self, **kwargs: Any): ...
    def getKeepEndPoints(self, **kwargs: Any): ...
    def getKeepRange(self, **kwargs: Any): ...
    def getKeepTangents(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRebuildType(self, **kwargs: Any): ...
    def getSmartSurfaceCurveRebuild(self, **kwargs: Any): ...
    def getSpans(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setEndKnots(self, val: bool = ..., **kwargs: Any): ...
    def setFitRebuild(self, val: bool = ..., **kwargs: Any): ...
    def setKeepControlPoints(self, val: bool = ..., **kwargs: Any): ...
    def setKeepEndPoints(self, val: bool = ..., **kwargs: Any): ...
    def setKeepRange(self, val: bool = ..., **kwargs: Any): ...
    def setKeepTangents(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRebuildType(self, val: bool = ..., **kwargs: Any): ...
    def setSmartSurfaceCurveRebuild(self, val: bool = ..., **kwargs: Any): ...
    def setSpans(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...

class ReverseCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class ReverseSurface(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class Revolve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAutoCorrectNormal(self, **kwargs: Any): ...
    def getAxis(self, **kwargs: Any): ...
    def getAxisChoice(self, **kwargs: Any): ...
    def getAxisX(self, **kwargs: Any): ...
    def getAxisY(self, **kwargs: Any): ...
    def getAxisZ(self, **kwargs: Any): ...
    def getBridge(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComputePivotAndAxis(self, **kwargs: Any): ...
    def getDegree(self, **kwargs: Any): ...
    def getEndSweep(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotX(self, **kwargs: Any): ...
    def getPivotY(self, **kwargs: Any): ...
    def getPivotZ(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getRadiusAnchor(self, **kwargs: Any): ...
    def getSections(self, **kwargs: Any): ...
    def getStartSweep(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getUseLocalPivot(self, **kwargs: Any): ...
    def getUseTolerance(self, **kwargs: Any): ...
    def setAutoCorrectNormal(self, val: bool = ..., **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setAxisChoice(self, val: bool = ..., **kwargs: Any): ...
    def setAxisX(self, val: bool = ..., **kwargs: Any): ...
    def setAxisY(self, val: bool = ..., **kwargs: Any): ...
    def setAxisZ(self, val: bool = ..., **kwargs: Any): ...
    def setBridge(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComputePivotAndAxis(self, val: bool = ..., **kwargs: Any): ...
    def setDegree(self, val: bool = ..., **kwargs: Any): ...
    def setEndSweep(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotX(self, val: bool = ..., **kwargs: Any): ...
    def setPivotY(self, val: bool = ..., **kwargs: Any): ...
    def setPivotZ(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setRadiusAnchor(self, val: bool = ..., **kwargs: Any): ...
    def setSections(self, val: bool = ..., **kwargs: Any): ...
    def setStartSweep(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setUseLocalPivot(self, val: bool = ..., **kwargs: Any): ...
    def setUseTolerance(self, val: bool = ..., **kwargs: Any): ...

class RoundConstantRadius(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class SmoothCurve(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSmoothness(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothness(self, val: bool = ..., **kwargs: Any): ...

class SmoothTangentSrf(AbstractBaseCreate):
    __melnode__: str = ...

class StitchAsNurbsShell(AbstractBaseCreate):
    __melnode__: str = ...

class StitchSrf(AbstractBaseCreate):
    __melnode__: str = ...

class StyleCurve(AbstractBaseCreate):
    __melnode__: str = ...

class SubSurface(AbstractBaseCreate):
    __melnode__: str = ...

class SubdivToNurbs(AbstractBaseCreate):
    __melnode__: str = ...

class SurfaceInfo(AbstractBaseCreate):
    __melnode__: str = ...

class TransformGeometry(AbstractBaseCreate):
    __melnode__: str = ...

class Trim(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getLocatorU(self, **kwargs: Any): ...
    def getLocatorV(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSelected(self, **kwargs: Any): ...
    def getShrink(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setLocatorU(self, val: bool = ..., **kwargs: Any): ...
    def setLocatorV(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSelected(self, val: bool = ..., **kwargs: Any): ...
    def setShrink(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...

class TrimWithBoundaries(AbstractBaseCreate):
    __melnode__: str = ...

class Untrim(AbstractBaseCreate):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getNoChanges(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getUntrimAll(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNoChanges(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setUntrimAll(self, val: bool = ..., **kwargs: Any): ...

class AddDoubleLinear(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class AddMatrix(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class AimMatrix(DependNode):
    __melnode__: str = ...

class AnimBlend(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class AnimBlendInOut(AnimBlend):
    __melnode__: str = ...

class AnimBlendNodeBase(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class AnimBlendNodeAdditive(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveDA(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveDL(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveF(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveFA(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveFL(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveI16(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveI32(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveRotation(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeAdditiveScale(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeBoolean(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeEnum(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimBlendNodeTime(AnimBlendNodeBase):
    __melnode__: str = ...

class AnimClip(DependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getAbsoluteChannelSettings(self) -> List[int]: ...
    def getEnabled(self) -> bool: ...
    def getMemberAnimCurves(self) -> Tuple[List[general.PyNode], List[general.Attribute]]: ...
    def getPostCycle(self) -> float: ...
    def getPreCycle(self) -> float: ...
    def getScale(self) -> float: ...
    def getSourceDuration(self) -> datatypes.Time: ...
    def getSourceStart(self) -> datatypes.Time: ...
    def getStartFrame(self) -> datatypes.Time: ...
    def getWeight(self) -> float: ...
    def isInstancedClip(self) -> bool: ...
    def isPose(self) -> bool: ...
    def setAbsoluteChannelSettings(self, absoluteChannels: List[int], mod: datatypes.DGModifier=...) -> None: ...
    def setEnabled(self, val: bool, mod: datatypes.DGModifier=...) -> None: ...
    def setPoseClip(self, state: bool, mod: datatypes.DGModifier=...) -> None: ...
    def setPostCycle(self, cycle: float, mod: datatypes.DGModifier=...) -> None: ...
    def setPreCycle(self, cycle: float, mod: datatypes.DGModifier=...) -> None: ...
    def setScale(self, scale: float, mod: datatypes.DGModifier=...) -> None: ...
    def setSourceData(self, start: datatypes.Time, duration: datatypes.Time, mod: datatypes.DGModifier=...) -> None: ...
    def setStartFrame(self, start: datatypes.Time, mod: datatypes.DGModifier=...) -> None: ...
    def setWeight(self, wt: float, mod: datatypes.DGModifier=...) -> None: ...
    def sourceClip(self) -> general.PyNode: ...

class ArrayMapper(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class THarrayMapper(ArrayMapper):
    __melnode__: str = ...

class AttrHierarchyTest(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Audio(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Blend(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class BlendDevice(Blend):
    __melnode__: str = ...

class BlendTwoAttr(Blend):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAttribute0(self, **kwargs: Any): ...
    def getAttribute1(self, **kwargs: Any): ...
    def getBlender(self, **kwargs: Any): ...
    def getDriver(self, **kwargs: Any): ...
    def setAttribute0(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute1(self, val: bool = ..., **kwargs: Any): ...
    def setBlender(self, val: bool = ..., **kwargs: Any): ...
    def setDriver(self, val: bool = ..., **kwargs: Any): ...

class BlendWeighted(Blend):
    __melnode__: str = ...

class BlendColors(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class BlendFalloff(DependNode):
    __melnode__: str = ...

class BlendMatrix(DependNode):
    __melnode__: str = ...

class BlindDataTemplate(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SubdHierBlind(BlindDataTemplate):
    __melnode__: str = ...

class Brush(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Bump3d(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CacheBase(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CacheBlend(CacheBase):
    __melnode__: str = ...

class CacheFile(CacheBase):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCacheFormat(self, **kwargs: Any): ...
    def getCacheInfo(self, **kwargs: Any): ...
    def getCacheableAttrs(self, **kwargs: Any): ...
    def getChannelIndex(self, **kwargs: Any): ...
    def getChannelName(self, **kwargs: Any): ...
    def getDataSize(self, **kwargs: Any): ...
    def getDescriptionFileName(self, **kwargs: Any): ...
    def getDirectory(self, **kwargs: Any): ...
    def getFileName(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getPointCount(self, **kwargs: Any): ...
    def getRunupFrames(self, **kwargs: Any): ...
    def getSampleMultiplier(self, **kwargs: Any): ...
    def getSimulationRate(self, **kwargs: Any): ...
    def getStaticCache(self, **kwargs: Any): ...
    def replaceWithoutSimulating(self, val: bool = ..., **kwargs: Any): ...
    def setRunupFrames(self, val: bool = ..., **kwargs: Any): ...
    def setSampleMultiplier(self, val: bool = ..., **kwargs: Any): ...
    def setSimulationRate(self, val: bool = ..., **kwargs: Any): ...

class CameraSet(DependNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def appendLayer(self, camera: general.PyNode, set: general.PyNode) -> None: ...
    def appendTo(self, val: bool = ..., **kwargs: Any): ...
    def clear(self) -> None: ...
    def deleteAll(self, val: bool = ..., **kwargs: Any): ...
    def deleteLayer(self, index: int) -> None: ...
    def getActive(self, **kwargs: Any): ...
    def getCamera(self, **kwargs: Any): ...
    def getClearDepth(self, **kwargs: Any): ...
    def getLayer(self, **kwargs: Any): ...
    def getLayerCamera(self, index: int) -> general.PyNode: ...
    def getLayerClearDepthValue(self, index: int) -> bool: ...
    def getLayerOrder(self, index: int) -> int: ...
    def getLayerSceneData(self, index: int) -> general.PyNode: ...
    def getNumLayers(self) -> int: ...
    def getObjectSet(self, **kwargs: Any): ...
    def getOrder(self, **kwargs: Any): ...
    def insertAt(self, val: bool = ..., **kwargs: Any): ...
    def insertLayer(self, index: int, camera: general.PyNode, set: general.PyNode) -> None: ...
    def isLayerActive(self, index: int) -> bool: ...
    def setActive(self, val: bool = ..., **kwargs: Any): ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setClearDepth(self, val: bool = ..., **kwargs: Any): ...
    def setLayer(self, val: bool = ..., **kwargs: Any): ...
    def setLayerActive(self, index: int, isActive: bool) -> None: ...
    def setLayerCamera(self, index: int, camera: general.PyNode) -> None: ...
    def setLayerClearDepthValue(self, index: int, depth: bool) -> None: ...
    def setLayerOrder(self, index: int, order: int) -> None: ...
    def setLayerSceneData(self, index: int, set: general.PyNode) -> None: ...
    def setObjectSet(self, val: bool = ..., **kwargs: Any): ...
    def setOrder(self, val: bool = ..., **kwargs: Any): ...

class THcameraSet(CameraSet):
    __melnode__: str = ...

class CameraView(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addBookmark(self, val: bool = ..., **kwargs: Any): ...
    def animate(self, val: bool = ..., **kwargs: Any): ...
    def camera(self, val: bool = ..., **kwargs: Any): ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def removeBookmark(self, val: bool = ..., **kwargs: Any): ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setView(self, val: bool = ..., **kwargs: Any): ...

class CharacterMap(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getMapAttr(self, **kwargs: Any): ...
    def getMapNode(self, **kwargs: Any): ...
    def getMapping(self, **kwargs: Any): ...
    def getProposedMapping(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setMapAttr(self, val: bool = ..., **kwargs: Any): ...
    def unmapAttr(self, val: bool = ..., **kwargs: Any): ...

class CharacterOffset(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Choice(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getIndex(self, **kwargs: Any): ...
    def getSelector(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Chooser(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Clamp(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ClipLibrary(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ClipScheduler(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ClipToGhostData(DependNode):
    __melnode__: str = ...

class ClosestPointOnMesh(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ColorManagementGlobals(DependNode):
    __melnode__: str = ...

class ColorProfile(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CombinationShape(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAllDrivers(self, **kwargs: Any): ...
    def getCombineMethod(self, **kwargs: Any): ...
    def getExist(self, **kwargs: Any): ...
    def setCombineMethod(self, val: bool = ..., **kwargs: Any): ...

class CompactPlugArrayTest(DependNode):
    __melnode__: str = ...

class ComponentFalloff(DependNode):
    __melnode__: str = ...

class ComposeMatrix(DependNode):
    __melnode__: str = ...

class Condition(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Container(ContainerBase):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    MPublishNodeType: Any = ...
    def addNode(self, val: bool = ..., **kwargs: Any): ...
    def clear(self) -> None: ...
    def force(self, val: bool = ..., **kwargs: Any): ...
    def getAsset(self, **kwargs: Any): ...
    def getAssetMember(self, **kwargs: Any): ...
    def getBindAttr(self, **kwargs: Any): ...
    def getConnectionList(self, **kwargs: Any): ...
    @classmethod
    def getCurrent(self) -> general.PyNode: ...
    def getFileName(self, **kwargs: Any): ...
    def getFindContainer(self, **kwargs: Any): ...
    def getIsContainer(self, **kwargs: Any): ...
    def getMembers(self) -> List[general.PyNode]: ...
    def getNodeList(self, **kwargs: Any): ...
    def getParentContainer(self) -> general.PyNode: ...
    def getPublishAsChild(self, **kwargs: Any): ...
    def getPublishAsParent(self, **kwargs: Any): ...
    def getPublishAsRoot(self, **kwargs: Any): ...
    def getPublishAttr(self, **kwargs: Any): ...
    def getPublishName(self, **kwargs: Any): ...
    def getPublishedNames(self, unboundOnly: bool) -> List[str]: ...
    def getPublishedNodes(self, type: ContainerNode.MPublishNodeType) -> Tuple[List[str], List[general.PyNode]]: ...
    def getPublishedPlugs(self) -> Tuple[List[general.Attribute], List[str]]: ...
    def getRootTransform(self) -> general.PyNode: ...
    def getSubcontainers(self) -> List[general.PyNode]: ...
    def getType(self, **kwargs: Any): ...
    def getUnbindAttr(self, **kwargs: Any): ...
    def getUnsortedOrder(self, **kwargs: Any): ...
    def includeHierarchyAbove(self, val: bool = ..., **kwargs: Any): ...
    def includeHierarchyBelow(self, val: bool = ..., **kwargs: Any): ...
    def includeNetwork(self, val: bool = ..., **kwargs: Any): ...
    def includeNetworkDetails(self, val: bool = ..., **kwargs: Any): ...
    def includeShaders(self, val: bool = ..., **kwargs: Any): ...
    def includeShapes(self, val: bool = ..., **kwargs: Any): ...
    def includeTransform(self, val: bool = ..., **kwargs: Any): ...
    def isCurrent(self) -> bool: ...
    def makeCurrent(self, isCurrent: bool=...) -> None: ...
    def nodeNamePrefix(self, val: bool = ..., **kwargs: Any): ...
    def publishAndBind(self, val: bool = ..., **kwargs: Any): ...
    def publishConnections(self, val: bool = ..., **kwargs: Any): ...
    def removeContainer(self, val: bool = ..., **kwargs: Any): ...
    def removeNode(self, val: bool = ..., **kwargs: Any): ...
    def setBindAttr(self, val: bool = ..., **kwargs: Any): ...
    def setCurrent(self, val: bool = ..., **kwargs: Any): ...
    def setPublishAsChild(self, val: bool = ..., **kwargs: Any): ...
    def setPublishAsParent(self, val: bool = ..., **kwargs: Any): ...
    def setPublishAsRoot(self, val: bool = ..., **kwargs: Any): ...
    def setPublishName(self, val: bool = ..., **kwargs: Any): ...
    def setUnbindAttr(self, val: bool = ..., **kwargs: Any): ...
    def unbindAndUnpublish(self, val: bool = ..., **kwargs: Any): ...
    def unbindChild(self, val: bool = ..., **kwargs: Any): ...
    def unbindParent(self, val: bool = ..., **kwargs: Any): ...
    def unpublishChild(self, val: bool = ..., **kwargs: Any): ...
    def unpublishName(self, val: bool = ..., **kwargs: Any): ...
    def unpublishParent(self, val: bool = ..., **kwargs: Any): ...

class BaseLattice(Shape):
    __melnode__: str = ...

class StereoRigCamera(Camera):
    __melnode__: str = ...

class ClusterHandle(Shape):
    __melnode__: str = ...

class DeformFunc(Shape):
    __melnode__: str = ...

class DeformBend(DeformFunc):
    __melnode__: str = ...

class DeformFlare(DeformFunc):
    __melnode__: str = ...

class DeformSine(DeformFunc):
    __melnode__: str = ...

class DeformSquash(DeformFunc):
    __melnode__: str = ...

class DeformTwist(DeformFunc):
    __melnode__: str = ...

class DeformWave(DeformFunc):
    __melnode__: str = ...

class DimensionShape(Shape):
    __melnode__: str = ...

class AngleDimension(DimensionShape):
    __melnode__: str = ...

class AnnotationShape(DimensionShape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class DistanceDimShape(DimensionShape):
    __melnode__: str = ...

class NurbsDimShape(DimensionShape):
    __melnode__: str = ...

class ArcLengthDimension(NurbsDimShape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class ParamDimension(NurbsDimShape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class DynHolder(Shape):
    __melnode__: str = ...

class DynamicConstraint(Shape):
    __melnode__: str = ...

class FlexorShape(Shape):
    __melnode__: str = ...

class ClusterFlexorShape(FlexorShape):
    __melnode__: str = ...

class Follicle(Shape):
    __melnode__: str = ...

class GeoConnectable(Shape):
    __melnode__: str = ...

class BezierCurve(NurbsCurve):
    __melnode__: str = ...

class SnapshotShape(ControlPoint):
    __melnode__: str = ...

class MotionTrailShape(SnapshotShape):
    __melnode__: str = ...

class THsurfaceShape(SurfaceShape):
    __melnode__: str = ...

class FluidShape(SurfaceShape):
    __apicls__: Any = ...
    __melnode__: str = ...
    ColorMethod: Any = ...
    CoordinateMethod: Any = ...
    FalloffMethod: Any = ...
    FluidGradient: Any = ...
    FluidMethod: Any = ...
    def create2D(self, Xres: int, Yres: int, Xdim: float, Ydim: float, parent: general.PyNode=...) -> general.PyNode: ...
    def create3D(self, Xres: int, Yres: int, Zres: int, Xdim: float, Ydim: float, Zdim: float, parent: general.PyNode=...) -> general.PyNode: ...
    def density(self) -> float: ...
    def emitIntoArrays(self, val: float, x: int, y: int, z: int, density: float, heat: float, fuel: float, doColor: bool, emitColor: datatypes.Color) -> None: ...
    def expandToInclude(self, min: datatypes.Point, max: datatypes.Point) -> None: ...
    def falloff(self) -> float: ...
    def fuel(self) -> float: ...
    def getColorMode(self) -> Fluid.ColorMethod: ...
    def getColors(self) -> Tuple[float, float, float]: ...
    def getCoordinateMode(self) -> Fluid.CoordinateMethod: ...
    def getCoordinates(self) -> Tuple[float, float, float]: ...
    def getDensityMode(self) -> Tuple[Fluid.FluidMethod, Fluid.FluidGradient]: ...
    def getDimensions(self) -> Tuple[float, float, float]: ...
    def getFalloffMode(self) -> Fluid.FalloffMethod: ...
    def getForceAtPoint(self, point: List[datatypes.Point], velocity: List[datatypes.Vector], mass: List[float], deltaTime: float=...) -> List[datatypes.Vector]: ...
    def getFuelMode(self) -> Tuple[Fluid.FluidMethod, Fluid.FluidGradient]: ...
    def getResolution(self) -> Tuple[int, int, int]: ...
    def getTemperatureMode(self) -> Tuple[Fluid.FluidMethod, Fluid.FluidGradient]: ...
    def getVelocity(self) -> Tuple[float, float, float]: ...
    def getVelocityMode(self) -> Tuple[Fluid.FluidMethod, Fluid.FluidGradient]: ...
    def gridSize(self) -> int: ...
    def isAutoResize(self) -> bool: ...
    def isResizeToEmitter(self) -> bool: ...
    def pressure(self) -> float: ...
    def setColorMode(self, method: Fluid.ColorMethod) -> None: ...
    def setCoordinateMode(self, method: Fluid.CoordinateMethod) -> None: ...
    def setDensityMode(self, method: Fluid.FluidMethod, gradient: Fluid.FluidGradient) -> None: ...
    def setFalloffMode(self, method: Fluid.FalloffMethod) -> None: ...
    def setFuelMode(self, method: Fluid.FluidMethod, gradient: Fluid.FluidGradient) -> None: ...
    def setSize(self, Xres: int, Yres: int, Zres: int, Xdim: float, Ydim: float, Zdim: float, resample: bool) -> None: ...
    def setTemperatureMode(self, method: Fluid.FluidMethod, gradient: Fluid.FluidGradient) -> None: ...
    def setVelocityMode(self, method: Fluid.FluidMethod, gradient: Fluid.FluidGradient) -> None: ...
    def temperature(self) -> float: ...
    def toGridIndex(self, objectSpacePoint: datatypes.Point) -> Tuple[bool, Tuple[int, int, int]]: ...
    def updateGrid(self) -> None: ...
    def velocityGridSizes(self) -> Tuple[int, int, int]: ...
    def voxelCenterPosition(self, xi: int, yi: int, zi: int) -> datatypes.Point: ...

class FluidTexture2D(FluidShape):
    __melnode__: str = ...

class FluidTexture3D(FluidShape):
    __melnode__: str = ...

class HeightField(SurfaceShape):
    __melnode__: str = ...

class GreasePlaneRenderShape(Mesh):
    __melnode__: str = ...

class NBase(Particle):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def clearCachedTextureMap(self, val: bool = ..., **kwargs: Any): ...
    def clearStart(self, val: bool = ..., **kwargs: Any): ...
    def stuffStart(self, val: bool = ..., **kwargs: Any): ...
    def textureToVertex(self, val: bool = ..., **kwargs: Any): ...

class NCloth(NBase):
    __melnode__: str = ...

class NParticle(NBase):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def floatValue(self, val: bool = ..., **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getCache(self, **kwargs: Any): ...
    def getConserve(self, **kwargs: Any): ...
    def getDynamicAttrList(self, **kwargs: Any): ...
    def getGridSpacing(self, **kwargs: Any): ...
    def getInherit(self, **kwargs: Any): ...
    def getJitterBasePoint(self, **kwargs: Any): ...
    def getJitterRadius(self, **kwargs: Any): ...
    def getLowerLeft(self, **kwargs: Any): ...
    def getNumJitters(self, **kwargs: Any): ...
    def getOrder(self, **kwargs: Any): ...
    def getParticleId(self, **kwargs: Any): ...
    def getPerParticleDouble(self, **kwargs: Any): ...
    def getPerParticleVector(self, **kwargs: Any): ...
    def getShapeName(self, **kwargs: Any): ...
    def getUpperRight(self, **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setCache(self, val: bool = ..., **kwargs: Any): ...
    def setConserve(self, val: bool = ..., **kwargs: Any): ...
    def setInherit(self, val: bool = ..., **kwargs: Any): ...
    def setOrder(self, val: bool = ..., **kwargs: Any): ...
    def setParticleId(self, val: bool = ..., **kwargs: Any): ...
    def setShapeName(self, val: bool = ..., **kwargs: Any): ...
    def vectorValue(self, val: bool = ..., **kwargs: Any): ...

class NRigid(NBase):
    __melnode__: str = ...

class DirectedDisc(GeometryShape):
    __melnode__: str = ...

class EnvironmentFog(GeometryShape):
    __melnode__: str = ...

class ImplicitBox(GeometryShape):
    __melnode__: str = ...

class RenderBox(ImplicitBox):
    __melnode__: str = ...

class ImplicitCone(GeometryShape):
    __melnode__: str = ...

class RenderCone(ImplicitCone):
    __melnode__: str = ...

class ImplicitSphere(GeometryShape):
    __melnode__: str = ...

class RenderSphere(ImplicitSphere):
    __melnode__: str = ...

class Locator(GeometryShape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def absolute(self, val: bool = ..., **kwargs: Any): ...
    def getPosition(self, **kwargs: Any): ...
    def relative(self, val: bool = ..., **kwargs: Any): ...
    def setPosition(self, val: bool = ..., **kwargs: Any): ...

class THlocatorShape(Locator):
    __melnode__: str = ...

class DropoffLocator(Locator):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class HikFloorContactMarker(Locator):
    __melnode__: str = ...

class PositionMarker(Locator):
    __melnode__: str = ...

class OrientationMarker(PositionMarker):
    __melnode__: str = ...

class Plane(GeometryShape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class SketchPlane(Plane):
    __melnode__: str = ...

class GroundPlane(SketchPlane):
    __melnode__: str = ...

class OrthoGrid(SketchPlane):
    __melnode__: str = ...

class RenderRect(GeometryShape):
    __melnode__: str = ...

class HairConstraint(Shape):
    __melnode__: str = ...

class HairSystem(Shape):
    __melnode__: str = ...

class ImagePlane(Shape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def detach(self, val: bool = ..., **kwargs: Any): ...
    def fileName(self, val: bool = ..., **kwargs: Any): ...
    def getCamera(self, **kwargs: Any): ...
    def getDropFrame(self, **kwargs: Any): ...
    def getFrameDuration(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getImageSize(self, **kwargs: Any): ...
    def getLookThrough(self, **kwargs: Any): ...
    def getMaintainRatio(self, **kwargs: Any): ...
    def getNegTimesOK(self, **kwargs: Any): ...
    def getNumFrames(self, **kwargs: Any): ...
    def getQuickTime(self, **kwargs: Any): ...
    def getShowInAllViews(self, **kwargs: Any): ...
    def getTimeCode(self, **kwargs: Any): ...
    def getTimeCodeTrack(self, **kwargs: Any): ...
    def getTimeScale(self, **kwargs: Any): ...
    def getTwentyFourHourMax(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setLookThrough(self, val: bool = ..., **kwargs: Any): ...
    def setMaintainRatio(self, val: bool = ..., **kwargs: Any): ...
    def setShowInAllViews(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class THimagePlane(ImagePlane):
    __melnode__: str = ...

class GreasePlane(ImagePlane):
    __melnode__: str = ...

class Light(Shape):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getCenterOfIllumination(self) -> float: ...
    def getColor(self) -> datatypes.Color: ...
    def getIntensity(self) -> float: ...
    def getNumShadowSamples(self) -> int: ...
    def getOpticalFXvisibility(self) -> datatypes.Color: ...
    def getRayDepthLimit(self) -> int: ...
    def getShadowColor(self) -> datatypes.Color: ...
    def getUseRayTraceShadows(self) -> bool: ...
    def lightAmbient(self) -> bool: ...
    def lightDiffuse(self) -> bool: ...
    def lightDirection(self, instance: int, space: datatypes.Space.Space=...) -> datatypes.FloatVector: ...
    def lightIntensity(self) -> datatypes.Color: ...
    def lightSpecular(self) -> bool: ...
    def setCenterOfIllumination(self, dist: float) -> None: ...
    def setColor(self, col: datatypes.Color) -> None: ...
    def setIntensity(self, intens: float) -> None: ...
    def setNumShadowSamples(self, num_shadow_samples: int) -> None: ...
    def setOpticalFXvisibility(self, visibility: datatypes.Color) -> None: ...
    def setRayDepthLimit(self, ray_depth_limit: int) -> None: ...
    def setShadowColor(self, shadow_color: datatypes.Color) -> None: ...
    def setUseRayTraceShadows(self, useRayTraceShadows: bool) -> None: ...

class TadskAssetInstanceNode_TlightShape(Light):
    __melnode__: str = ...

class RenderLight(Light):
    __melnode__: str = ...

class AmbientLight(RenderLight):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAmbientShade(self) -> float: ...
    def getCastSoftShadows(self) -> bool: ...
    def getDiscRadius(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getPosition(self, **kwargs: Any): ...
    def getRgb(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getShadowDither(self, **kwargs: Any): ...
    def getShadowRadius(self) -> float: ...
    def getShadowSamples(self, **kwargs: Any): ...
    def getSoftShadow(self, **kwargs: Any): ...
    def setAmbientShade(self, ambient_shade: float) -> None: ...
    def setCastSoftShadows(self, cast_soft_shadows: bool) -> None: ...
    def setDiscRadius(self, val: bool = ..., **kwargs: Any): ...
    def setShadowDither(self, val: bool = ..., **kwargs: Any): ...
    def setShadowRadius(self, shadow_radius: float) -> None: ...
    def setShadowSamples(self, val: bool = ..., **kwargs: Any): ...
    def setSoftShadow(self, val: bool = ..., **kwargs: Any): ...

class NonAmbientLightShapeNode(RenderLight):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getDecayRate(self) -> int: ...
    def setDecayRate(self, decay_rate: int) -> None: ...

class NonExtendedLightShapeNode(NonAmbientLightShapeNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getCastSoftShadows(self) -> bool: ...
    def getDepthMapBias(self) -> float: ...
    def getDepthMapFilterSize(self) -> int: ...
    def getDepthMapFocus(self) -> float: ...
    def getDepthMapResolution(self) -> int: ...
    def getDepthMapWidthFocus(self) -> float: ...
    def getShadowRadius(self) -> float: ...
    def getUseDepthMapAutoFocus(self) -> bool: ...
    def getUseDepthMapShadows(self) -> bool: ...
    def setCastSoftShadows(self, cast_soft_shadows: bool) -> None: ...
    def setDepthMapBias(self, depth_map_bias: float) -> None: ...
    def setDepthMapFilterSize(self, depth_map_filter_size: int) -> None: ...
    def setDepthMapFocus(self, depth_map_focus: float) -> None: ...
    def setDepthMapResolution(self, depth_map_resolution: int) -> None: ...
    def setDepthMapWidthFocus(self, depth_map_width_focus: float) -> None: ...
    def setShadowRadius(self, shadow_radius: float) -> None: ...
    def setUseDepthMapAutoFocus(self, use_depth_map_auto_focus: bool) -> None: ...
    def setUseDepthMapShadows(self, use_depth_map: bool) -> None: ...

class AreaLight(NonExtendedLightShapeNode):
    __apicls__: Any = ...
    __melnode__: str = ...

class DirectionalLight(NonExtendedLightShapeNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getDiscRadius(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getRgb(self, **kwargs: Any): ...
    def getShadowAngle(self) -> float: ...
    def getShadowDither(self, **kwargs: Any): ...
    def getShadowSamples(self, **kwargs: Any): ...
    def getSoftShadow(self, **kwargs: Any): ...
    def getUseLightPosition(self) -> bool: ...
    def setShadowAngle(self, shadow_angle: float) -> None: ...
    def setUseLightPosition(self, use_light_position: bool) -> None: ...

class PointLight(NonExtendedLightShapeNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getDiscRadius(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getRgb(self, **kwargs: Any): ...
    def getShadowDither(self, **kwargs: Any): ...
    def getShadowSamples(self, **kwargs: Any): ...
    def getSoftShadow(self, **kwargs: Any): ...
    def setDiscRadius(self, val: bool = ..., **kwargs: Any): ...
    def setExclusive(self, val: bool = ..., **kwargs: Any): ...
    def setRgb(self, val: bool = ..., **kwargs: Any): ...
    def setShadowDither(self, val: bool = ..., **kwargs: Any): ...
    def setShadowSamples(self, val: bool = ..., **kwargs: Any): ...
    def setSoftShadow(self, val: bool = ..., **kwargs: Any): ...

class VolumeLight(PointLight):
    __apicls__: Any = ...
    __melnode__: str = ...
    MLightDirection: Any = ...
    MLightShape: Any = ...
    def getArc(self) -> float: ...
    def getConeEndRadius(self) -> float: ...
    def getEmitAmbient(self) -> bool: ...
    def getLightShape(self) -> VolumeLight.MLightShape: ...
    def getShadowAngle(self) -> float: ...
    def getVolumeLightDirection(self) -> VolumeLight.MLightDirection: ...
    def setArc(self, arc: float) -> None: ...
    def setConeEndRadius(self, cone_end_radius: float) -> None: ...
    def setEmitAmbient(self, emit_ambient: bool) -> None: ...
    def setLightShape(self, light_shape: VolumeLight.MLightShape) -> None: ...
    def setShadowAngle(self, shadow_angle: float) -> None: ...
    def setVolumeLightDirection(self, volume_light_direction: VolumeLight.MLightDirection) -> None: ...

class SpotLight(NonExtendedLightShapeNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    MBarnDoor: Any = ...
    MDecayRegion: Any = ...
    def getBarnDoorAngle(self, which_door: SpotLight.MBarnDoor) -> float: ...
    def getBarnDoors(self) -> bool: ...
    def getBottomBarnDoorAngle(self, **kwargs: Any): ...
    def getConeAngle(self) -> float: ...
    def getDiscRadius(self, **kwargs: Any): ...
    def getDropOff(self) -> float: ...
    def getEndDistance(self, which_region: SpotLight.MDecayRegion) -> float: ...
    def getExclusive(self, **kwargs: Any): ...
    def getLeftBarnDoorAngle(self, **kwargs: Any): ...
    def getPenumbra(self) -> float: ...
    def getRgb(self, **kwargs: Any): ...
    def getRightBarnDoorAngle(self, **kwargs: Any): ...
    def getShadowDither(self, **kwargs: Any): ...
    def getShadowSamples(self, **kwargs: Any): ...
    def getSoftShadow(self, **kwargs: Any): ...
    def getStartDistance(self, which_region: SpotLight.MDecayRegion) -> float: ...
    def getTopBarnDoorAngle(self, **kwargs: Any): ...
    def getUseDecayRegions(self) -> bool: ...
    def setBarnDoorAngle(self, which_door: SpotLight.MBarnDoor, barn_door_angle: float) -> None: ...
    def setBarnDoors(self, barn_doors: bool) -> None: ...
    def setBottomBarnDoorAngle(self, val: bool = ..., **kwargs: Any): ...
    def setConeAngle(self, cone_angle: float) -> None: ...
    def setDropOff(self, drop_off: float) -> None: ...
    def setEndDistance(self, which_region: SpotLight.MDecayRegion, end_distance: float) -> None: ...
    def setLeftBarnDoorAngle(self, val: bool = ..., **kwargs: Any): ...
    def setPenumbra(self, penumbra_angle: float) -> None: ...
    def setRightBarnDoorAngle(self, val: bool = ..., **kwargs: Any): ...
    def setStartDistance(self, which_region: SpotLight.MDecayRegion, start_distance: float) -> None: ...
    def setTopBarnDoorAngle(self, val: bool = ..., **kwargs: Any): ...
    def setUseDecayRegions(self, use_decay_regions: bool) -> None: ...

class LineModifier(Shape):
    __melnode__: str = ...

class PfxGeometry(Shape):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getBoundingBox(self) -> Tuple[float, float]: ...

class PfxHair(PfxGeometry):
    __melnode__: str = ...

class PfxToon(PfxGeometry):
    __melnode__: str = ...

class Stroke(PfxGeometry):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class RigidBody(Shape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def deleteCache(self, val: bool = ..., **kwargs: Any): ...
    def getActive(self, **kwargs: Any): ...
    def getAngularVelocity(self, **kwargs: Any): ...
    def getApplyForceAt(self, **kwargs: Any): ...
    def getBounciness(self, **kwargs: Any): ...
    def getCache(self, **kwargs: Any): ...
    def getCenterOfMass(self, **kwargs: Any): ...
    def getCollisions(self, **kwargs: Any): ...
    def getContactCount(self, **kwargs: Any): ...
    def getContactName(self, **kwargs: Any): ...
    def getContactPosition(self, **kwargs: Any): ...
    def getDamping(self, **kwargs: Any): ...
    def getDynamicFriction(self, **kwargs: Any): ...
    def getForce(self, **kwargs: Any): ...
    def getIgnore(self, **kwargs: Any): ...
    def getInitialAngularVelocity(self, **kwargs: Any): ...
    def getInitialVelocity(self, **kwargs: Any): ...
    def getLayer(self, **kwargs: Any): ...
    def getLockCenterOfMass(self, **kwargs: Any): ...
    def getMass(self, **kwargs: Any): ...
    def getOrientation(self, **kwargs: Any): ...
    def getParticleCollision(self, **kwargs: Any): ...
    def getPassive(self, **kwargs: Any): ...
    def getPosition(self, **kwargs: Any): ...
    def getRemoveShape(self, **kwargs: Any): ...
    def getSolver(self, **kwargs: Any): ...
    def getStandInObject(self, **kwargs: Any): ...
    def getStaticFriction(self, **kwargs: Any): ...
    def getTesselationFactor(self, **kwargs: Any): ...
    def getVelocity(self, **kwargs: Any): ...
    def impulse(self, val: bool = ..., **kwargs: Any): ...
    def impulsePosition(self, val: bool = ..., **kwargs: Any): ...
    def setActive(self, val: bool = ..., **kwargs: Any): ...
    def setApplyForceAt(self, val: bool = ..., **kwargs: Any): ...
    def setBounciness(self, val: bool = ..., **kwargs: Any): ...
    def setCache(self, val: bool = ..., **kwargs: Any): ...
    def setCenterOfMass(self, val: bool = ..., **kwargs: Any): ...
    def setCollisions(self, val: bool = ..., **kwargs: Any): ...
    def setDamping(self, val: bool = ..., **kwargs: Any): ...
    def setDynamicFriction(self, val: bool = ..., **kwargs: Any): ...
    def setIgnore(self, val: bool = ..., **kwargs: Any): ...
    def setInitialAngularVelocity(self, val: bool = ..., **kwargs: Any): ...
    def setInitialVelocity(self, val: bool = ..., **kwargs: Any): ...
    def setLayer(self, val: bool = ..., **kwargs: Any): ...
    def setLockCenterOfMass(self, val: bool = ..., **kwargs: Any): ...
    def setMass(self, val: bool = ..., **kwargs: Any): ...
    def setOrientation(self, val: bool = ..., **kwargs: Any): ...
    def setParticleCollision(self, val: bool = ..., **kwargs: Any): ...
    def setPassive(self, val: bool = ..., **kwargs: Any): ...
    def setPosition(self, val: bool = ..., **kwargs: Any): ...
    def setRemoveShape(self, val: bool = ..., **kwargs: Any): ...
    def setSolver(self, val: bool = ..., **kwargs: Any): ...
    def setStandInObject(self, val: bool = ..., **kwargs: Any): ...
    def setStaticFriction(self, val: bool = ..., **kwargs: Any): ...
    def spinImpulse(self, val: bool = ..., **kwargs: Any): ...

class SoftModHandle(Shape):
    __melnode__: str = ...

class Spring(Shape):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def allPoints(self, val: bool = ..., **kwargs: Any): ...
    def getCount(self, **kwargs: Any): ...
    def getDamping(self, **kwargs: Any): ...
    def getDampingPS(self, **kwargs: Any): ...
    def getEndForceWeight(self, **kwargs: Any): ...
    def getLength(self, **kwargs: Any): ...
    def getRestLength(self, **kwargs: Any): ...
    def getRestLengthPS(self, **kwargs: Any): ...
    def getStartForceWeight(self, **kwargs: Any): ...
    def getStiffness(self, **kwargs: Any): ...
    def getStiffnessPS(self, **kwargs: Any): ...
    def getUseDampingPS(self, **kwargs: Any): ...
    def getUseRestLengthPS(self, **kwargs: Any): ...
    def getUseStiffnessPS(self, **kwargs: Any): ...
    def maxDistance(self, val: bool = ..., **kwargs: Any): ...
    def setDamping(self, val: bool = ..., **kwargs: Any): ...
    def setDampingPS(self, val: bool = ..., **kwargs: Any): ...
    def setEndForceWeight(self, val: bool = ..., **kwargs: Any): ...
    def setLength(self, val: bool = ..., **kwargs: Any): ...
    def setRestLength(self, val: bool = ..., **kwargs: Any): ...
    def setRestLengthPS(self, val: bool = ..., **kwargs: Any): ...
    def setStartForceWeight(self, val: bool = ..., **kwargs: Any): ...
    def setStiffness(self, val: bool = ..., **kwargs: Any): ...
    def setStiffnessPS(self, val: bool = ..., **kwargs: Any): ...
    def setUseDampingPS(self, val: bool = ..., **kwargs: Any): ...
    def setUseRestLengthPS(self, val: bool = ..., **kwargs: Any): ...
    def setUseStiffnessPS(self, val: bool = ..., **kwargs: Any): ...

class THdynSpring(Spring):
    __melnode__: str = ...

class THcustomTransform(Transform):
    __melnode__: str = ...

class BaseGeometryVarGroup(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class CurveVarGroup(BaseGeometryVarGroup):
    __melnode__: str = ...

class GeometryVarGroup(BaseGeometryVarGroup):
    __melnode__: str = ...

class MeshVarGroup(BaseGeometryVarGroup):
    __melnode__: str = ...

class SubdivSurfaceVarGroup(BaseGeometryVarGroup):
    __melnode__: str = ...

class SurfaceVarGroup(BaseGeometryVarGroup):
    __melnode__: str = ...

class ClipGhostShape(Transform):
    __melnode__: str = ...

class THconstraint(Constraint):
    __melnode__: str = ...

class AimConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAimVector(self, **kwargs: Any): ...
    def getOffset(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getUpVector(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def getWorldUpObject(self, **kwargs: Any): ...
    def getWorldUpType(self, **kwargs: Any): ...
    def getWorldUpVector(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setAimVector(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def setUpVector(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpObject(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpType(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpVector(self, val: bool = ..., **kwargs: Any): ...
    def skip(self, val: bool = ..., **kwargs: Any): ...

class LookAt(AimConstraint):
    __melnode__: str = ...

class GeometryConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...

class NormalConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAimVector(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getUpVector(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def getWorldUpObject(self, **kwargs: Any): ...
    def getWorldUpType(self, **kwargs: Any): ...
    def getWorldUpVector(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setAimVector(self, val: bool = ..., **kwargs: Any): ...
    def setUpVector(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpObject(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpType(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpVector(self, val: bool = ..., **kwargs: Any): ...

class OldNormalConstraint(Constraint):
    __melnode__: str = ...

class OldTangentConstraint(Constraint):
    __melnode__: str = ...

class OrientConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def createCache(self, val: bool = ..., **kwargs: Any): ...
    def deleteCache(self, val: bool = ..., **kwargs: Any): ...
    def getOffset(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def skip(self, val: bool = ..., **kwargs: Any): ...

class ParentConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def createCache(self, val: bool = ..., **kwargs: Any): ...
    def deleteCache(self, val: bool = ..., **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...

class PointConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getOffset(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def skip(self, val: bool = ..., **kwargs: Any): ...

class PoleVectorConstraint(PointConstraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...

class PointOnPolyConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getOffset(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def skip(self, val: bool = ..., **kwargs: Any): ...

class ScaleConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getOffset(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def scaleCompensate(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def skip(self, val: bool = ..., **kwargs: Any): ...

class SymmetryConstraint(Constraint):
    __melnode__: str = ...

class TangentConstraint(Constraint):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAimVector(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getUpVector(self, **kwargs: Any): ...
    def getWeightAliasList(self, **kwargs: Any): ...
    def getWorldUpObject(self, **kwargs: Any): ...
    def getWorldUpType(self, **kwargs: Any): ...
    def getWorldUpVector(self, **kwargs: Any): ...
    def layer(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setAimVector(self, val: bool = ..., **kwargs: Any): ...
    def setUpVector(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpObject(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpType(self, val: bool = ..., **kwargs: Any): ...
    def setWorldUpVector(self, val: bool = ..., **kwargs: Any): ...

class DagContainer(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class Assembly(DagContainer):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def activate(self, representation: str) -> None: ...
    def activateNonRecursive(self, representation: str) -> None: ...
    def canActivate(self) -> bool: ...
    def canRepApplyEdits(self, representation: str) -> bool: ...
    def createRepresentation(self, val: bool = ..., **kwargs: Any): ...
    def deleteAllRepresentations(self) -> None: ...
    def deleteRepresentation(self, representation: str) -> None: ...
    def deregister(self, val: bool = ..., **kwargs: Any): ...
    def getAbsoluteRepNamespace(self) -> str: ...
    def getActive(self) -> str: ...
    def getActiveLabel(self, **kwargs: Any): ...
    def getCanCreate(self, **kwargs: Any): ...
    def getCreateOptionBoxProc(self, **kwargs: Any): ...
    def getDefaultType(self, **kwargs: Any): ...
    def getInitialRep(self) -> str: ...
    def getIsAType(self, **kwargs: Any): ...
    def getIsTrackingMemberEdits(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getListRepTypes(self, **kwargs: Any): ...
    def getListRepTypesProc(self, **kwargs: Any): ...
    def getListRepresentations(self, **kwargs: Any): ...
    def getListTypes(self, **kwargs: Any): ...
    def getParentAssembly(self) -> general.PyNode: ...
    def getPostCreateUIProc(self, **kwargs: Any): ...
    def getRepLabel(self, representation: str) -> str: ...
    def getRepNamespace(self) -> str: ...
    def getRepPostCreateUIProc(self, **kwargs: Any): ...
    def getRepPreCreateUIProc(self, **kwargs: Any): ...
    def getRepType(self, representation: str) -> str: ...
    def getRepTypeLabel(self, **kwargs: Any): ...
    def getRepTypeLabelProc(self, **kwargs: Any): ...
    def getRepresentations(self) -> List[str]: ...
    def getSubAssemblies(self) -> List[general.PyNode]: ...
    @classmethod
    def getTopLevelAssemblies(self) -> List[general.PyNode]: ...
    def getType(self, **kwargs: Any): ...
    def handlesAddEdits(self) -> bool: ...
    def importFile(self, fileName: str, type: str=..., preserveReferences: bool=..., nameSpace: str=..., ignoreVersion: bool=...) -> None: ...
    def input(self, val: bool = ..., **kwargs: Any): ...
    def isActive(self, representation: str) -> bool: ...
    def isTopLevel(self) -> bool: ...
    def newRepLabel(self, val: bool = ..., **kwargs: Any): ...
    def postLoad(self) -> None: ...
    def proc(self, val: bool = ..., **kwargs: Any): ...
    def renameRepresentation(self, val: bool = ..., **kwargs: Any): ...
    def repName(self, val: bool = ..., **kwargs: Any): ...
    def repTypes(self) -> List[str]: ...
    def setActive(self, val: bool = ..., **kwargs: Any): ...
    def setActiveLabel(self, val: bool = ..., **kwargs: Any): ...
    def setCreateOptionBoxProc(self, val: bool = ..., **kwargs: Any): ...
    def setDefaultType(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setListRepTypesProc(self, val: bool = ..., **kwargs: Any): ...
    def setPostCreateUIProc(self, val: bool = ..., **kwargs: Any): ...
    def setRepLabel(self, representation: str, label: str) -> None: ...
    def setRepName(self, representation: str, newName: str) -> str: ...
    def setRepPostCreateUIProc(self, val: bool = ..., **kwargs: Any): ...
    def setRepPreCreateUIProc(self, val: bool = ..., **kwargs: Any): ...
    def setRepTypeLabelProc(self, val: bool = ..., **kwargs: Any): ...
    def setType(self, val: bool = ..., **kwargs: Any): ...
    def supportsEdits(self) -> bool: ...
    def supportsMemberChanges(self) -> bool: ...

class THassembly(Assembly):
    __melnode__: str = ...

class CollisionModel(DynBase):
    __melnode__: str = ...

class Field(DynBase):
    __apicls__: Any = ...
    __melnode__: str = ...
    def falloffCurve(self, param: float) -> float: ...
    def getAttenuation(self) -> float: ...
    def getForceAtPoint(self, point: List[datatypes.Point], velocity: List[datatypes.Vector], mass: List[float], deltaTime: float=...) -> List[datatypes.Vector]: ...
    def getMagnitude(self) -> float: ...
    def getMaxDistance(self) -> float: ...
    def getPerVertex(self) -> bool: ...
    def getUseMaxDistance(self) -> bool: ...
    def isFalloffCurveConstantOne(self) -> bool: ...
    def setAttenuation(self, atten: float) -> None: ...
    def setMagnitude(self, mag: float) -> None: ...
    def setMaxDistance(self, dist: float) -> None: ...
    def setPerVertex(self, enable: bool) -> None: ...
    def setUseMaxDistance(self, enable: bool) -> None: ...

class THdynField(Field):
    __melnode__: str = ...

class AirField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def fanSetup(self, val: bool = ..., **kwargs: Any): ...
    def getComponentOnly(self) -> bool: ...
    def getDirection(self) -> datatypes.Vector: ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getEnableSpread(self) -> bool: ...
    def getInheritRotation(self) -> bool: ...
    def getInheritVelocity(self) -> float: ...
    def getPosition(self, **kwargs: Any): ...
    def getSpeed(self) -> float: ...
    def getSpread(self) -> float: ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getVelocityComponentOnly(self, **kwargs: Any): ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setComponentOnly(self, enable: bool) -> None: ...
    def setDirection(self, airDirection: datatypes.Vector) -> None: ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setEnableSpread(self, enable: bool) -> None: ...
    def setInheritRotation(self, enable: bool) -> None: ...
    def setInheritVelocity(self, velocity: float) -> None: ...
    def setPosition(self, val: bool = ..., **kwargs: Any): ...
    def setSpeed(self, value: float) -> None: ...
    def setSpread(self, value: float) -> None: ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setVelocityComponentOnly(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...
    def wakeSetup(self, val: bool = ..., **kwargs: Any): ...
    def windSetup(self, val: bool = ..., **kwargs: Any): ...

class DragField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getDirection(self) -> datatypes.Vector: ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getUseDirection(self) -> bool: ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setDirection(self, dragDirection: datatypes.Vector) -> None: ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setUseDirection(self, enable: bool) -> None: ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class GravityField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getDirection(self) -> datatypes.Vector: ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setDirection(self, gravityDirection: datatypes.Vector) -> None: ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class NewtonField(Field):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getMinDistance(self) -> float: ...
    def setMinDistance(self, distance: float) -> None: ...

class RadialField(Field):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getRadialType(self) -> float: ...
    def setRadialType(self, value: float) -> None: ...

class TurbulenceField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getFrequency(self) -> float: ...
    def getNoiseLevel(self, **kwargs: Any): ...
    def getNoiseRatio(self, **kwargs: Any): ...
    def getPhase(self) -> float: ...
    def getPhaseX(self, **kwargs: Any): ...
    def getPhaseY(self, **kwargs: Any): ...
    def getPhaseZ(self, **kwargs: Any): ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setFrequency(self, value: float) -> None: ...
    def setNoiseLevel(self, val: bool = ..., **kwargs: Any): ...
    def setNoiseRatio(self, val: bool = ..., **kwargs: Any): ...
    def setPhase(self, value: float) -> None: ...
    def setPhaseX(self, val: bool = ..., **kwargs: Any): ...
    def setPhaseY(self, val: bool = ..., **kwargs: Any): ...
    def setPhaseZ(self, val: bool = ..., **kwargs: Any): ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class UniformField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getDirection(self) -> datatypes.Vector: ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setDirection(self, uniformDirection: datatypes.Vector) -> None: ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class VolumeAxisField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def detailTurbulence(self) -> float: ...
    def getDetailTurbulence(self, **kwargs: Any): ...
    def getDirection(self) -> datatypes.Vector: ...
    def getDirectionX(self, **kwargs: Any): ...
    def getDirectionY(self, **kwargs: Any): ...
    def getDirectionZ(self, **kwargs: Any): ...
    def getDirectionalSpeed(self) -> float: ...
    def getInvertAttenuation(self) -> bool: ...
    def getSpeedAlongAxis(self) -> float: ...
    def getSpeedAroundAxis(self) -> float: ...
    def getSpeedAwayFromAxis(self) -> float: ...
    def getSpeedAwayFromCenter(self) -> float: ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getTurbulence(self) -> float: ...
    def getTurbulenceFrequency(self) -> datatypes.Vector: ...
    def getTurbulenceFrequencyX(self, **kwargs: Any): ...
    def getTurbulenceFrequencyY(self, **kwargs: Any): ...
    def getTurbulenceFrequencyZ(self, **kwargs: Any): ...
    def getTurbulenceOffset(self) -> datatypes.Vector: ...
    def getTurbulenceOffsetX(self, **kwargs: Any): ...
    def getTurbulenceOffsetY(self, **kwargs: Any): ...
    def getTurbulenceOffsetZ(self, **kwargs: Any): ...
    def getTurbulenceSpeed(self) -> float: ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setDetailTurbulence(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, direction: datatypes.Vector) -> None: ...
    def setDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setDirectionalSpeed(self, speed: float) -> None: ...
    def setInvertAttenuation(self, enable: bool) -> None: ...
    def setSpeedAlongAxis(self, speed: float) -> None: ...
    def setSpeedAroundAxis(self, speed: float) -> None: ...
    def setSpeedAwayFromAxis(self, speed: float) -> None: ...
    def setSpeedAwayFromCenter(self, speed: float) -> None: ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulence(self, value: float) -> None: ...
    def setTurbulenceFrequency(self, value: datatypes.Vector) -> None: ...
    def setTurbulenceFrequencyX(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulenceFrequencyY(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulenceFrequencyZ(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulenceOffset(self, value: datatypes.Vector) -> None: ...
    def setTurbulenceOffsetX(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulenceOffsetY(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulenceOffsetZ(self, val: bool = ..., **kwargs: Any): ...
    def setTurbulenceSpeed(self, value: float) -> None: ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class VortexField(Field):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self) -> datatypes.Vector: ...
    def getAxisX(self, **kwargs: Any): ...
    def getAxisY(self, **kwargs: Any): ...
    def getAxisZ(self, **kwargs: Any): ...
    def getTorusSectionRadius(self, **kwargs: Any): ...
    def getVolumeExclusion(self, **kwargs: Any): ...
    def getVolumeOffset(self, **kwargs: Any): ...
    def getVolumeShape(self, **kwargs: Any): ...
    def getVolumeSweep(self, **kwargs: Any): ...
    def setAxis(self, axisVector: datatypes.Vector) -> None: ...
    def setAxisX(self, val: bool = ..., **kwargs: Any): ...
    def setAxisY(self, val: bool = ..., **kwargs: Any): ...
    def setAxisZ(self, val: bool = ..., **kwargs: Any): ...
    def setTorusSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeExclusion(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeShape(self, val: bool = ..., **kwargs: Any): ...
    def setVolumeSweep(self, val: bool = ..., **kwargs: Any): ...

class THdynEmitter(PointEmitter):
    __melnode__: str = ...

class THfluidEmitter(FluidEmitter):
    __melnode__: str = ...

class FosterParent(Transform):
    __melnode__: str = ...

class HikEffector(Transform):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getAuxiliaryEffectors(self) -> List[general.PyNode]: ...
    def getEffColor(self) -> datatypes.Color: ...
    def getPivotOffset(self) -> datatypes.Vector: ...
    def setEffColor(self, color: datatypes.Color) -> None: ...
    def setPivotOffset(self, vector: datatypes.Vector) -> None: ...

class HikGroundPlane(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class HikIKEffector(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class IkEffector(Transform):
    __apicls__: Any = ...
    __melnode__: str = ...

class IkHandle(Transform):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    Stickiness: Any = ...
    def autoPriority(self, val: bool = ..., **kwargs: Any): ...
    def connectEffector(self, val: bool = ..., **kwargs: Any): ...
    def disableHandles(self, val: bool = ..., **kwargs: Any): ...
    def enableHandles(self, val: bool = ..., **kwargs: Any): ...
    def freezeJoints(self, val: bool = ..., **kwargs: Any): ...
    def getCurve(self, **kwargs: Any): ...
    def getEffector(self) -> general.PyNode: ...
    def getEndEffector(self, **kwargs: Any): ...
    def getForceSolver(self, **kwargs: Any): ...
    def getJointList(self, **kwargs: Any): ...
    def getPositionWeight(self, **kwargs: Any): ...
    def getPriority(self) -> int: ...
    def getRootOnCurve(self, **kwargs: Any): ...
    def getRootTwistMode(self, **kwargs: Any): ...
    def getSnapHandleFlagToggle(self, **kwargs: Any): ...
    def getSolver(self) -> general.PyNode: ...
    def getStartJoint(self) -> general.PyNode: ...
    def getStickiness(self) -> IkHandle.Stickiness: ...
    def getSticky(self, **kwargs: Any): ...
    def getTwistType(self, **kwargs: Any): ...
    def getWeight(self) -> float: ...
    def poWeight(self) -> float: ...
    def setCurve(self, val: bool = ..., **kwargs: Any): ...
    def setEffector(self, effectorPath: general.PyNode) -> None: ...
    def setEndEffector(self, val: bool = ..., **kwargs: Any): ...
    def setForceSolver(self, val: bool = ..., **kwargs: Any): ...
    def setPOWeight(self, poWeight: float) -> None: ...
    def setPositionWeight(self, val: bool = ..., **kwargs: Any): ...
    def setPriority(self, priority: int) -> None: ...
    def setRootOnCurve(self, val: bool = ..., **kwargs: Any): ...
    def setRootTwistMode(self, val: bool = ..., **kwargs: Any): ...
    def setSnapHandleFlagToggle(self, val: bool = ..., **kwargs: Any): ...
    def setSolver(self, solver: general.PyNode) -> None: ...
    def setStartJoint(self, jointPath: general.PyNode) -> None: ...
    def setStartJointAndEffector(self, jointPath: general.PyNode, effectorPath: general.PyNode) -> None: ...
    def setStickiness(self, stickiness: IkHandle.Stickiness) -> None: ...
    def setSticky(self, val: bool = ..., **kwargs: Any): ...
    def setTwistType(self, val: bool = ..., **kwargs: Any): ...
    def setWeight(self, weight: float) -> None: ...
    def setupForRPsolver(self, val: bool = ..., **kwargs: Any): ...
    def snapHandleToEffector(self, val: bool = ..., **kwargs: Any): ...

class Instancer(Transform):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addObject(self, val: bool = ..., **kwargs: Any): ...
    def allInstances(self) -> Tuple[List[general.PyNode], List[datatypes.Matrix], List[int], List[int]]: ...
    def getCycle(self, **kwargs: Any): ...
    def getCycleStep(self, **kwargs: Any): ...
    def getCycleStepUnits(self, **kwargs: Any): ...
    def getIndex(self, **kwargs: Any): ...
    def getLevelOfDetail(self, **kwargs: Any): ...
    def getObject(self, **kwargs: Any): ...
    def getObjectPosition(self, **kwargs: Any): ...
    def getObjectRotation(self, **kwargs: Any): ...
    def getObjectScale(self, **kwargs: Any): ...
    def getPointDataSource(self, **kwargs: Any): ...
    def getRotationUnits(self, **kwargs: Any): ...
    def getValueName(self, **kwargs: Any): ...
    def instancesForParticle(self, p: int) -> Tuple[int, List[general.PyNode], datatypes.Matrix]: ...
    def particleCount(self) -> int: ...
    def removeObject(self, val: bool = ..., **kwargs: Any): ...
    def setCycle(self, val: bool = ..., **kwargs: Any): ...
    def setCycleStep(self, val: bool = ..., **kwargs: Any): ...
    def setCycleStepUnits(self, val: bool = ..., **kwargs: Any): ...
    def setLevelOfDetail(self, val: bool = ..., **kwargs: Any): ...
    def setObject(self, val: bool = ..., **kwargs: Any): ...
    def setRotationUnits(self, val: bool = ..., **kwargs: Any): ...

class HikFKJoint(Joint):
    __melnode__: str = ...

class LodGroup(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class Nucleus(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class Place3dTexture(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class PrimitiveFalloff(Transform):
    __melnode__: str = ...

class RigidConstraint(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class TextureDeformerHandle(Transform):
    __melnode__: str = ...

class UfeProxyTransform(Transform):
    __melnode__: str = ...

class UnknownTransform(Transform):
    __melnode__: str = ...
    def getRotationQuaternion(self, space: datatypes.Space.Space=...) -> Tuple[float, float, float, float]: ...
    def setRotationQuaternion(self, x: float, y: float, z: float, w: float, space: datatypes.Space.Space=...) -> None: ...

class UnknownDag(DagNode):
    __melnode__: str = ...

class THobjectSet(ObjectSet):
    __melnode__: str = ...

class BakeSet(ObjectSet):
    __melnode__: str = ...

class TextureBakeSet(BakeSet):
    __melnode__: str = ...

class VertexBakeSet(BakeSet):
    __melnode__: str = ...

class Character(ObjectSet):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addElement(self, val: bool = ..., **kwargs: Any): ...
    def blendExists(self, instancedClip1: general.PyNode, instancedClip2: general.PyNode, blendResult: general.PyNode) -> bool: ...
    def flatten(self, val: bool = ..., **kwargs: Any): ...
    def getAddOffsetObject(self, **kwargs: Any): ...
    def getBlend(self, index: int) -> general.PyNode: ...
    def getBlendClips(self, index: int) -> Tuple[general.PyNode, general.PyNode]: ...
    def getBlendCount(self) -> int: ...
    def getCharacterPlug(self, **kwargs: Any): ...
    def getCharacterThatOwnsPlug(self, plug: general.Attribute, result: general.PyNode) -> bool: ...
    def getClipScheduler(self) -> general.PyNode: ...
    def getIsIntersecting(self, **kwargs: Any): ...
    def getIsMember(self, **kwargs: Any): ...
    def getLibrary(self, **kwargs: Any): ...
    def getMemberIndex(self, **kwargs: Any): ...
    def getMemberPlugs(self) -> List[general.Attribute]: ...
    def getNodesOnly(self, **kwargs: Any): ...
    def getOffsetNode(self, **kwargs: Any): ...
    def getScheduledClip(self, index: int) -> general.PyNode: ...
    def getScheduledClipCount(self) -> int: ...
    def getScheduler(self, **kwargs: Any): ...
    def getSourceClip(self, index: int) -> general.PyNode: ...
    def getSourceClipCount(self) -> int: ...
    def getSubCharacters(self) -> SelectionSet: ...
    def getSubtract(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getUserAlias(self, **kwargs: Any): ...
    def include(self, val: bool = ..., **kwargs: Any): ...
    def removeOffsetObject(self, val: bool = ..., **kwargs: Any): ...
    def setAddOffsetObject(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...

class CreaseSet(ObjectSet):
    __melnode__: str = ...

class KeyingGroup(ObjectSet):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addElement(self, val: bool = ..., **kwargs: Any): ...
    def afterFilters(self, val: bool = ..., **kwargs: Any): ...
    def flatten(self, val: bool = ..., **kwargs: Any): ...
    def getActivator(self, **kwargs: Any): ...
    def getCategory(self, **kwargs: Any): ...
    def getColor(self, **kwargs: Any): ...
    def getEdges(self, **kwargs: Any): ...
    def getEditPoints(self, **kwargs: Any): ...
    def getFacets(self, **kwargs: Any): ...
    def getMinimizeRotation(self, **kwargs: Any): ...
    def getNoIntermediate(self, **kwargs: Any): ...
    def getNodesOnly(self, **kwargs: Any): ...
    def getRenderable(self, **kwargs: Any): ...
    def getSetActiveFilter(self, **kwargs: Any): ...
    def getSize(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getVertices(self, **kwargs: Any): ...
    def include(self, val: bool = ..., **kwargs: Any): ...
    def removeActivator(self, val: bool = ..., **kwargs: Any): ...
    def setActivator(self, val: bool = ..., **kwargs: Any): ...
    def setCategory(self, val: bool = ..., **kwargs: Any): ...
    def setColor(self, val: bool = ..., **kwargs: Any): ...
    def setMinimizeRotation(self, val: bool = ..., **kwargs: Any): ...
    def setSetActiveFilter(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...

class Partition(Entity):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    Restriction: Any = ...
    def addMember(self, set: general.PyNode) -> None: ...
    def getRender(self, **kwargs: Any): ...
    def isRenderPartition(self) -> bool: ...
    def removeMember(self, set: general.PyNode) -> None: ...

class Contrast(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Controller(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAllControllers(self, **kwargs: Any): ...
    def getChildren(self, **kwargs: Any): ...
    def getGroup(self, **kwargs: Any): ...
    def getIndex(self, **kwargs: Any): ...
    def getIsController(self, **kwargs: Any): ...
    def getParent(self, **kwargs: Any): ...
    def getPickWalkDown(self, **kwargs: Any): ...
    def getPickWalkLeft(self, **kwargs: Any): ...
    def getPickWalkRight(self, **kwargs: Any): ...
    def getPickWalkUp(self, **kwargs: Any): ...
    def setIndex(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def unparent(self, val: bool = ..., **kwargs: Any): ...

class CopyColorSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CopyUVSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CreateColorSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CreateUVSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CurveFromMesh(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CurveFromMeshCoM(CurveFromMesh):
    __melnode__: str = ...

class CurveFromMeshEdge(CurveFromMesh):
    __melnode__: str = ...

class CurveNormalizer(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class CurveNormalizerAngle(CurveNormalizer):
    __melnode__: str = ...

class CurveNormalizerLinear(CurveNormalizer):
    __melnode__: str = ...

class DagPose(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getAtPose(self, **kwargs: Any): ...
    def getBindPose(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getMembers(self, **kwargs: Any): ...
    def getSelection(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DataBlockTest(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DecomposeMatrix(DependNode):
    __melnode__: str = ...

class DefaultLightList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DefaultRenderUtilityList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DefaultRenderingList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DefaultShaderList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DefaultTextureList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DeleteColorSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DeleteComponent(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DeleteUVSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DiskCache(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getAppend(self, **kwargs: Any): ...
    def getCacheType(self, **kwargs: Any): ...
    def getClose(self, **kwargs: Any): ...
    def getCloseAll(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getDelete(self, **kwargs: Any): ...
    def getDeleteAll(self, **kwargs: Any): ...
    def getEmpty(self, **kwargs: Any): ...
    def getEmptyAll(self, **kwargs: Any): ...
    def getEnabledCachesOnly(self, **kwargs: Any): ...
    def getEndTime(self, **kwargs: Any): ...
    def getFrameRangeType(self, **kwargs: Any): ...
    def getOverSample(self, **kwargs: Any): ...
    def getSamplingRate(self, **kwargs: Any): ...
    def getStartTime(self, **kwargs: Any): ...
    def getTempDir(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DisplacementShader(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DisplayLayerManager(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DistanceBetween(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Dof(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DynController(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class DynGlobals(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getActive(self, **kwargs: Any): ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getListAll(self, **kwargs: Any): ...
    def getOverSampling(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setOverSampling(self, val: bool = ..., **kwargs: Any): ...

class EditMetadata(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getChannelName(self, **kwargs: Any): ...
    def getChannelType(self, **kwargs: Any): ...
    def getIndex(self, **kwargs: Any): ...
    def getIndexType(self, **kwargs: Any): ...
    def getScene(self, **kwargs: Any): ...
    def getStreamName(self, **kwargs: Any): ...

class EditsManager(DependNode):
    __melnode__: str = ...

class Expression(DependNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    UnitConversion: Any = ...
    def evaluate(self) -> List[float]: ...
    def getAlwaysEvaluate(self, **kwargs: Any): ...
    def getAnimated(self, **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getDefaultObject(self) -> general.PyNode: ...
    def getExpression(self) -> str: ...
    def getObject(self, **kwargs: Any): ...
    def getSafe(self, **kwargs: Any): ...
    def getShortNames(self, **kwargs: Any): ...
    def getString(self, **kwargs: Any): ...
    def getTimeDependent(self, **kwargs: Any): ...
    def getUnitConversion(self) -> Expression.UnitConversion: ...
    def isAnimated(self) -> bool: ...
    def setAlwaysEvaluate(self, val: bool = ..., **kwargs: Any): ...
    def setAnimated(self, value: bool=...) -> None: ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setDefaultObject(self, object: general.PyNode) -> None: ...
    def setExpression(self, expression: str) -> None: ...
    def setObject(self, val: bool = ..., **kwargs: Any): ...
    def setShortNames(self, val: bool = ..., **kwargs: Any): ...
    def setString(self, val: bool = ..., **kwargs: Any): ...
    def setUnitConversion(self, conversion: Expression.UnitConversion) -> None: ...

class Facade(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class EnvFacade(Facade):
    __melnode__: str = ...

class AISEnvFacade(EnvFacade):
    __melnode__: str = ...

class MaterialFacade(Facade):
    __melnode__: str = ...

class Flow(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getDivisions(self, **kwargs: Any): ...
    def getLocalCompute(self, **kwargs: Any): ...
    def getLocalDivisions(self, **kwargs: Any): ...
    def getObjectCentered(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class FourByFourMatrix(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class FrameCache(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class GammaCorrect(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class GeoConnector(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class GeomBind(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getFalloff(self, **kwargs: Any): ...
    def getGeodesicVoxelParams(self, **kwargs: Any): ...
    def getMaxInfluences(self, **kwargs: Any): ...
    def setFalloff(self, val: bool = ..., **kwargs: Any): ...
    def setGeodesicVoxelParams(self, val: bool = ..., **kwargs: Any): ...
    def setMaxInfluences(self, val: bool = ..., **kwargs: Any): ...

class THgeometryFilter(GeometryFilter):
    __melnode__: str = ...

class BlendShape(GeometryFilter):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    HistoryLocation: Any = ...
    Origin: Any = ...
    TargetType: Any = ...
    def addBaseObject(self, object: general.PyNode) -> None: ...
    def addTarget(self, baseObject: general.PyNode, weightIndex: int, newTarget: general.PyNode, fullWeight: float, targetType: BlendShapeDeformer.TargetType=...) -> None: ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def automatic(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def copyDelta(self, val: bool = ..., **kwargs: Any): ...
    def copyInBetweenDelta(self, val: bool = ..., **kwargs: Any): ...
    def export(self, val: bool = ..., **kwargs: Any): ...
    def exportTarget(self, val: bool = ..., **kwargs: Any): ...
    def flipTarget(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getBaseObjects(self) -> List[general.PyNode]: ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getEnvelope(self) -> float: ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getNormalizationGroups(self, **kwargs: Any): ...
    def getOrigin(self) -> BlendShapeDeformer.Origin: ...
    def getSymmetryAxis(self, **kwargs: Any): ...
    def getSymmetryEdge(self, **kwargs: Any): ...
    def getSymmetrySpace(self, **kwargs: Any): ...
    def getTarget(self, **kwargs: Any): ...
    def getTargets(self, baseObject: general.PyNode, weightIndex: int) -> List[general.PyNode]: ...
    def getTransform(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWeight(self, index: int) -> float: ...
    def getWeightCount(self, **kwargs: Any): ...
    def historyLocation(self) -> BlendShapeDeformer.HistoryLocation: ...
    def inBetween(self, val: bool = ..., **kwargs: Any): ...
    def inBetweenIndex(self, val: bool = ..., **kwargs: Any): ...
    def inBetweenType(self, val: bool = ..., **kwargs: Any): ...
    def ip(self, val: bool = ..., **kwargs: Any): ...
    def mergeSource(self, val: bool = ..., **kwargs: Any): ...
    def mergeTarget(self, val: bool = ..., **kwargs: Any): ...
    def mirrorDirection(self, val: bool = ..., **kwargs: Any): ...
    def mirrorTarget(self, val: bool = ..., **kwargs: Any): ...
    def numWeights(self) -> int: ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def removeTarget(self, baseObject: general.PyNode, weightIndex: int, target: general.PyNode, fullWeight: float) -> None: ...
    def resetTargetDelta(self, val: bool = ..., **kwargs: Any): ...
    def setEnvelope(self, envelope: float) -> None: ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setOrigin(self, space: BlendShapeDeformer.Origin) -> None: ...
    def setSymmetryAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetryEdge(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetrySpace(self, val: bool = ..., **kwargs: Any): ...
    def setTarget(self, val: bool = ..., **kwargs: Any): ...
    def setTransform(self, val: bool = ..., **kwargs: Any): ...
    def setWeight(self, index: int, weight: float) -> None: ...
    def setWeightCount(self, val: bool = ..., **kwargs: Any): ...
    def suppressDialog(self, val: bool = ..., **kwargs: Any): ...
    def tangentSpace(self, val: bool = ..., **kwargs: Any): ...
    def targetItemIndexList(self, weightIndex: int, baseObject: general.PyNode) -> List[int]: ...
    def weightIndexList(self) -> List[int]: ...

class THblendShape(BlendShape):
    __melnode__: str = ...

class BoneLattice(GeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getBicep(self, **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getJoint(self, **kwargs: Any): ...
    def getLengthIn(self, **kwargs: Any): ...
    def getLengthOut(self, **kwargs: Any): ...
    def getTricep(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWidthLeft(self, **kwargs: Any): ...
    def getWidthRight(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setBicep(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setJoint(self, val: bool = ..., **kwargs: Any): ...
    def setLengthIn(self, val: bool = ..., **kwargs: Any): ...
    def setLengthOut(self, val: bool = ..., **kwargs: Any): ...
    def setTricep(self, val: bool = ..., **kwargs: Any): ...
    def setWidthLeft(self, val: bool = ..., **kwargs: Any): ...
    def setWidthRight(self, val: bool = ..., **kwargs: Any): ...

class HistorySwitch(GeometryFilter):
    __melnode__: str = ...

class JointLattice(GeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getCreasing(self, **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getLengthIn(self, **kwargs: Any): ...
    def getLengthOut(self, **kwargs: Any): ...
    def getRounding(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWidthLeft(self, **kwargs: Any): ...
    def getWidthRight(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setCreasing(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setLengthIn(self, val: bool = ..., **kwargs: Any): ...
    def setLengthOut(self, val: bool = ..., **kwargs: Any): ...
    def setRounding(self, val: bool = ..., **kwargs: Any): ...
    def setWidthLeft(self, val: bool = ..., **kwargs: Any): ...
    def setWidthRight(self, val: bool = ..., **kwargs: Any): ...

class Sculpt(GeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getDropoffDistance(self, **kwargs: Any): ...
    def getDropoffType(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getInsideMode(self, **kwargs: Any): ...
    def getMaxDisplacement(self, **kwargs: Any): ...
    def getMode(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setDropoffDistance(self, val: bool = ..., **kwargs: Any): ...
    def setDropoffType(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setInsideMode(self, val: bool = ..., **kwargs: Any): ...
    def setMaxDisplacement(self, val: bool = ..., **kwargs: Any): ...
    def setMode(self, val: bool = ..., **kwargs: Any): ...

class THskinCluster(SkinCluster):
    __melnode__: str = ...

class Tweak(GeometryFilter):
    __melnode__: str = ...

class WeightGeometryFilter(GeometryFilter):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getWeightPlugStrings(self, list: SelectionSet) -> List[str]: ...
    def getWeights(self, index: int) -> Tuple[general.PyNode, List[float]]: ...
    def setWeight(self, path: general.PyNode, index: int, components: general.PyNode, weight: float, oldValues: List[float]=...) -> None: ...
    def weightPlugStrings(self, list: SelectionSet) -> str: ...

class THdeformer(WeightGeometryFilter):
    __melnode__: str = ...

class Cluster(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWeightedNode(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def resetGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setWeightedNode(self, val: bool = ..., **kwargs: Any): ...

class JointCluster(Cluster):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAboveBound(self, **kwargs: Any): ...
    def getAboveCluster(self, **kwargs: Any): ...
    def getAboveDropoffType(self, **kwargs: Any): ...
    def getAboveValue(self, **kwargs: Any): ...
    def getBelowBound(self, **kwargs: Any): ...
    def getBelowCluster(self, **kwargs: Any): ...
    def getBelowDropoffType(self, **kwargs: Any): ...
    def getBelowValue(self, **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def setAboveBound(self, val: bool = ..., **kwargs: Any): ...
    def setAboveDropoffType(self, val: bool = ..., **kwargs: Any): ...
    def setAboveValue(self, val: bool = ..., **kwargs: Any): ...
    def setBelowBound(self, val: bool = ..., **kwargs: Any): ...
    def setBelowDropoffType(self, val: bool = ..., **kwargs: Any): ...
    def setBelowValue(self, val: bool = ..., **kwargs: Any): ...

class DeltaMush(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getInwardConstraint(self, **kwargs: Any): ...
    def getOutwardConstraint(self, **kwargs: Any): ...
    def getPinBorderVertices(self, **kwargs: Any): ...
    def getSmoothingIterations(self, **kwargs: Any): ...
    def getSmoothingStep(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setInwardConstraint(self, val: bool = ..., **kwargs: Any): ...
    def setOutwardConstraint(self, val: bool = ..., **kwargs: Any): ...
    def setPinBorderVertices(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingIterations(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingStep(self, val: bool = ..., **kwargs: Any): ...

class Ffd(WeightGeometryFilter):
    __apicls__: Any = ...
    __melnode__: str = ...
    def addGeometry(self, object: general.PyNode) -> None: ...
    def baseLattice(self) -> general.PyNode: ...
    def deformLattice(self) -> general.PyNode: ...
    def getAffectedGeometry(self) -> List[general.PyNode]: ...
    def getDivisions(self) -> Tuple[int, int, int]: ...
    def removeGeometry(self, object: general.PyNode) -> None: ...
    def resetLattice(self, centerLattice: bool=...) -> None: ...
    def setDivisions(self, x: int, y: int, z: int) -> None: ...

class Jiggle(WeightGeometryFilter):
    __melnode__: str = ...

class NonLinear(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...

class ProximityWrap(WeightGeometryFilter):
    __melnode__: str = ...

class ShrinkWrap(WeightGeometryFilter):
    __melnode__: str = ...

class SoftMod(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWeightedNode(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def resetGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setWeightedNode(self, val: bool = ..., **kwargs: Any): ...

class Solidify(WeightGeometryFilter):
    __melnode__: str = ...

class Tension(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getInwardConstraint(self, **kwargs: Any): ...
    def getOutwardConstraint(self, **kwargs: Any): ...
    def getPinBorderVertices(self, **kwargs: Any): ...
    def getSmoothingIterations(self, **kwargs: Any): ...
    def getSmoothingStep(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setInwardConstraint(self, val: bool = ..., **kwargs: Any): ...
    def setOutwardConstraint(self, val: bool = ..., **kwargs: Any): ...
    def setPinBorderVertices(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingIterations(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingStep(self, val: bool = ..., **kwargs: Any): ...

class TextureDeformer(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...

class TransferAttributes(WeightGeometryFilter):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def colorBorders(self, val: bool = ..., **kwargs: Any): ...
    def flipUVs(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def matchChoice(self, val: bool = ..., **kwargs: Any): ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def sampleSpace(self, val: bool = ..., **kwargs: Any): ...
    def searchMethod(self, val: bool = ..., **kwargs: Any): ...
    def searchScaleX(self, val: bool = ..., **kwargs: Any): ...
    def searchScaleY(self, val: bool = ..., **kwargs: Any): ...
    def searchScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def transferColors(self, val: bool = ..., **kwargs: Any): ...
    def transferNormals(self, val: bool = ..., **kwargs: Any): ...
    def transferPositions(self, val: bool = ..., **kwargs: Any): ...
    def transferUVs(self, val: bool = ..., **kwargs: Any): ...

class Wire(WeightGeometryFilter):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addGeometry(self, object: general.PyNode) -> None: ...
    def addWire(self, object: general.PyNode) -> None: ...
    def after(self, val: bool = ..., **kwargs: Any): ...
    def afterReference(self, val: bool = ..., **kwargs: Any): ...
    def before(self, val: bool = ..., **kwargs: Any): ...
    def frontOfChain(self, val: bool = ..., **kwargs: Any): ...
    def getAffectedGeometry(self) -> List[general.PyNode]: ...
    def getCrossingEffect(self) -> float: ...
    def getDeformerTools(self, **kwargs: Any): ...
    def getDropoffDistance(self, **kwargs: Any): ...
    def getEnvelope(self) -> float: ...
    def getExclusive(self, **kwargs: Any): ...
    def getGeometry(self, **kwargs: Any): ...
    def getGeometryIndices(self, **kwargs: Any): ...
    def getHolder(self, **kwargs: Any): ...
    def getHoldingShape(self, wireIndex: int) -> general.PyNode: ...
    def getLocalInfluence(self, **kwargs: Any): ...
    def getLocalIntensity(self) -> float: ...
    def getRotation(self) -> float: ...
    def getUseComponentTags(self, **kwargs: Any): ...
    def getWire(self, **kwargs: Any): ...
    def getWireCount(self, **kwargs: Any): ...
    def getWireDropOffDistance(self, wireIndex: int) -> float: ...
    def getWireScale(self, wireIndex: int) -> float: ...
    def numDropoffLocators(self, wireIndex: int) -> int: ...
    def numWires(self) -> int: ...
    def parallel(self, val: bool = ..., **kwargs: Any): ...
    def prune(self, val: bool = ..., **kwargs: Any): ...
    def remove(self, val: bool = ..., **kwargs: Any): ...
    def removeGeometry(self, object: general.PyNode) -> None: ...
    def setCrossingEffect(self, crossingEffect: float) -> None: ...
    def setDropoffDistance(self, val: bool = ..., **kwargs: Any): ...
    def setEnvelope(self, envelope: float) -> None: ...
    def setGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setHolder(self, val: bool = ..., **kwargs: Any): ...
    def setHoldingShape(self, wireIndex: int, holdingShape: general.PyNode) -> None: ...
    def setLocalInfluence(self, val: bool = ..., **kwargs: Any): ...
    def setLocalIntensity(self, localIntensity: float) -> None: ...
    def setRotation(self, rotation: float) -> None: ...
    def setWire(self, val: bool = ..., **kwargs: Any): ...
    def setWireCount(self, val: bool = ..., **kwargs: Any): ...
    def setWireDropOffDistance(self, wireIndex: int, dropOff: float) -> None: ...
    def setWireScale(self, wireIndex: int, scale: float) -> None: ...
    def wire(self, wireIndex: int) -> general.PyNode: ...

class Wrap(GeometryFilter):
    __melnode__: str = ...

class GlobalCacheControl(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class GreasePencilSequence(DependNode):
    __melnode__: str = ...

class GroupId(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class GroupParts(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Guide(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HardwareRenderGlobals(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HardwareRenderingGlobals(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HierarchyTestNode1(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HierarchyTestNode2(HierarchyTestNode1):
    __melnode__: str = ...

class HierarchyTestNode3(HierarchyTestNode2):
    __melnode__: str = ...

class HoldMatrix(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HsvToRgb(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HwReflectionMap(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getBackTextureName(self, **kwargs: Any): ...
    def getBottomTextureName(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getCubeMap(self, **kwargs: Any): ...
    def getDecalMode(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getFrontTextureName(self, **kwargs: Any): ...
    def getLeftTextureName(self, **kwargs: Any): ...
    def getRightTextureName(self, **kwargs: Any): ...
    def getSphereMapTextureName(self, **kwargs: Any): ...
    def getTopTextureName(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HwRenderGlobals(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HyperGraphInfo(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HyperLayout(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class HyperView(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class IkSolver(DependNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getEpsilon(self, **kwargs: Any): ...
    def getMaxIterations(self) -> int: ...
    def getSolverType(self, **kwargs: Any): ...
    def getTolerance(self) -> float: ...
    def setEpsilon(self, val: bool = ..., **kwargs: Any): ...
    def setMaxIterations(self, maxIters: int) -> None: ...
    def setSolverType(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, tolerance: float) -> None: ...

class THikSolverNode(IkSolver):
    __melnode__: str = ...

class HikSolver(IkSolver):
    __melnode__: str = ...

class IkMCsolver(IkSolver):
    __melnode__: str = ...

class IkPASolver(IkSolver):
    __melnode__: str = ...

class IkSCsolver(IkSolver):
    __melnode__: str = ...

class IkRPsolver(IkSCsolver):
    __melnode__: str = ...

class IkSplineSolver(IkSolver):
    __melnode__: str = ...

class IkSystem(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def autoPriority(self, val: bool = ..., **kwargs: Any): ...
    def autoPriorityMC(self, val: bool = ..., **kwargs: Any): ...
    def autoPrioritySC(self, val: bool = ..., **kwargs: Any): ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getAllowRotation(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getList(self, **kwargs: Any): ...
    def getSnap(self, **kwargs: Any): ...
    def getSolve(self, **kwargs: Any): ...
    def getSolverTypes(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setAllowRotation(self, val: bool = ..., **kwargs: Any): ...
    def setList(self, val: bool = ..., **kwargs: Any): ...
    def setSnap(self, val: bool = ..., **kwargs: Any): ...
    def setSolve(self, val: bool = ..., **kwargs: Any): ...

class ImageSource(DependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def sourceCamera(self, currentCamera: general.PyNode) -> general.PyNode: ...
    def sourceLayer(self, currentLayer: general.PyNode) -> general.PyNode: ...

class RenderPass(ImageSource):
    __apicls__: Any = ...
    __melnode__: str = ...
    def customTokenString(self) -> str: ...
    def frameBufferChannels(self) -> int: ...
    def passID(self) -> str: ...
    def usesFiltering(self) -> bool: ...

class RenderTarget(ImageSource):
    __melnode__: str = ...

class RenderedImageSource(ImageSource):
    __melnode__: str = ...

class LightInfo(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class LightLinker(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class LightList(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class LodThresholds(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Luminance(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class MakeGroup(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class MaterialInfo(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class MaterialTemplate(DependNode):
    __melnode__: str = ...

class Membrane(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class MotionPath(DependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    Axis: Any = ...
    def addAnimatedObject(self, objectToAnimate: general.PyNode, modifier: datatypes.DGModifier=...) -> None: ...
    def getAnimatedObjects(self) -> List[general.PyNode]: ...
    def getBank(self) -> bool: ...
    def getBankScale(self) -> float: ...
    def getBankThreshold(self) -> float: ...
    def getFollow(self) -> bool: ...
    def getFollowAxis(self) -> MotionPath.Axis: ...
    def getInverseNormal(self) -> bool: ...
    def getOrientationMarker(self, markerNum: int) -> general.PyNode: ...
    def getPathObject(self) -> general.PyNode: ...
    def getPositionMarker(self, markerNum: int) -> general.PyNode: ...
    def getUEnd(self) -> float: ...
    def getUStart(self) -> float: ...
    def getUTimeEnd(self) -> datatypes.Time: ...
    def getUTimeStart(self) -> datatypes.Time: ...
    def getUpAxis(self) -> MotionPath.Axis: ...
    def getUseNormal(self) -> bool: ...
    def numOrientationMarkers(self) -> int: ...
    def numPositionMarkers(self) -> int: ...
    def setBank(self, bank: bool) -> None: ...
    def setBankScale(self, bankScale: float) -> None: ...
    def setBankThreshold(self, bankThreshold: float) -> None: ...
    def setFollow(self, on: bool, modifier: datatypes.DGModifier=...) -> None: ...
    def setFollowAxis(self, axis: MotionPath.Axis) -> None: ...
    def setInverseNormal(self, invert: bool) -> None: ...
    def setPathObject(self, pathObject: general.PyNode, modifier: datatypes.DGModifier=...) -> None: ...
    def setUEnd(self, end: float) -> None: ...
    def setUStart(self, start: float) -> None: ...
    def setUTimeEnd(self, end: datatypes.Time) -> None: ...
    def setUTimeStart(self, start: datatypes.Time) -> None: ...
    def setUpAxis(self, axis: MotionPath.Axis) -> None: ...
    def setUseNormal(self, use: bool) -> None: ...

class THmotionPath(MotionPath):
    __melnode__: str = ...

class MultDoubleLinear(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class MultMatrix(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class MultilisterLight(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Mute(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class NComponent(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Network(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class NodeGraphEditorBookmarkInfo(DependNode):
    __melnode__: str = ...

class NodeGraphEditorBookmarks(DependNode):
    __melnode__: str = ...

class NodeGraphEditorInfo(DependNode):
    __melnode__: str = ...

class ObjectFilter(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ObjectAttrFilter(ObjectFilter):
    __melnode__: str = ...

class ObjectBinFilter(ObjectFilter):
    __melnode__: str = ...

class ObjectMultiFilter(ObjectFilter):
    __melnode__: str = ...

class ObjectNameFilter(ObjectFilter):
    __melnode__: str = ...

class ObjectRenderFilter(ObjectFilter):
    __melnode__: str = ...

class ObjectScriptFilter(ObjectFilter):
    __melnode__: str = ...

class ObjectTypeFilter(ObjectFilter):
    __melnode__: str = ...

class OldBlindDataBase(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class OldGeometryConstraint(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class OpticalFX(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PairBlend(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getInput1(self, **kwargs: Any): ...
    def getInput2(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ParticleAgeMapper(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ParticleColorMapper(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ParticleIncandMapper(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ParticleTranspMapper(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PassContributionMap(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PassMatrix(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PickMatrix(DependNode):
    __melnode__: str = ...

class PointMatrixMult(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PolyBase(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PolyCreator(PolyBase):
    __melnode__: str = ...

class PolyCreateFace(PolyCreator):
    __melnode__: str = ...

class PolyPrimitive(PolyCreator):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSideLength(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSideLength(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...

class PolyCone(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getRoundCap(self, **kwargs: Any): ...
    def getSubdivisionsAxis(self, **kwargs: Any): ...
    def getSubdivisionsCap(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getSubdivisionsX(self, **kwargs: Any): ...
    def getSubdivisionsY(self, **kwargs: Any): ...
    def getSubdivisionsZ(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setRoundCap(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCap(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsX(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsY(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsZ(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...

class PolyCube(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getDepth(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSubdivisionsDepth(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getSubdivisionsWidth(self, **kwargs: Any): ...
    def getSubdivisionsX(self, **kwargs: Any): ...
    def getSubdivisionsY(self, **kwargs: Any): ...
    def getSubdivisionsZ(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setDepth(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsDepth(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsWidth(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsX(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsY(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsZ(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class PolyCylinder(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getRoundCap(self, **kwargs: Any): ...
    def getSubdivisionsAxis(self, **kwargs: Any): ...
    def getSubdivisionsCaps(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getSubdivisionsX(self, **kwargs: Any): ...
    def getSubdivisionsY(self, **kwargs: Any): ...
    def getSubdivisionsZ(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setRoundCap(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCaps(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsX(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsY(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsZ(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...

class PolyHelix(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getCoils(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getRoundCap(self, **kwargs: Any): ...
    def getSubdivisionsAxis(self, **kwargs: Any): ...
    def getSubdivisionsCaps(self, **kwargs: Any): ...
    def getSubdivisionsCoil(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def getUseOldInitBehaviour(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCoils(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setRoundCap(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCaps(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCoil(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...
    def setUseOldInitBehaviour(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class PolyPipe(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getRoundCap(self, **kwargs: Any): ...
    def getSubdivisionsAxis(self, **kwargs: Any): ...
    def getSubdivisionsCaps(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def getThickness(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setRoundCap(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCaps(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...
    def setThickness(self, val: bool = ..., **kwargs: Any): ...

class PolyPlane(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getSubdivisionsWidth(self, **kwargs: Any): ...
    def getSubdivisionsX(self, **kwargs: Any): ...
    def getSubdivisionsY(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsWidth(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsX(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsY(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...

class PolyPlatonicSolid(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSideLength(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSideLength(self, val: bool = ..., **kwargs: Any): ...

class PolyPrimitiveMisc(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class PolyPrism(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getLength(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberOfSides(self, **kwargs: Any): ...
    def getNumderOfSides(self, **kwargs: Any): ...
    def getSideLength(self, **kwargs: Any): ...
    def getSubdivisionsCaps(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setLength(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfSides(self, val: bool = ..., **kwargs: Any): ...
    def setNumderOfSides(self, val: bool = ..., **kwargs: Any): ...
    def setSideLength(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCaps(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...

class PolyPyramid(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberOfSides(self, **kwargs: Any): ...
    def getNumderOfSides(self, **kwargs: Any): ...
    def getSideLength(self, **kwargs: Any): ...
    def getSubdivisionsCaps(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfSides(self, val: bool = ..., **kwargs: Any): ...
    def setNumderOfSides(self, val: bool = ..., **kwargs: Any): ...
    def setSideLength(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsCaps(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...

class PolySphere(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSubdivisionsAxis(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getSubdivisionsX(self, **kwargs: Any): ...
    def getSubdivisionsY(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsX(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsY(self, val: bool = ..., **kwargs: Any): ...

class PolyTorus(PolyPrimitive):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxis(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getComponentTagCreate(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCreateUVs(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRadius(self, **kwargs: Any): ...
    def getSectionRadius(self, **kwargs: Any): ...
    def getSubdivisionsAxis(self, **kwargs: Any): ...
    def getSubdivisionsHeight(self, **kwargs: Any): ...
    def getSubdivisionsX(self, **kwargs: Any): ...
    def getSubdivisionsY(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def getTwist(self, **kwargs: Any): ...
    def setAxis(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setComponentTagCreate(self, val: bool = ..., **kwargs: Any): ...
    def setCreateUVs(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSectionRadius(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsAxis(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsHeight(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsX(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionsY(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...
    def setTwist(self, val: bool = ..., **kwargs: Any): ...

class PolyUnite(PolyCreator):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyBoolOp(PolyUnite):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getFaceAreaThreshold(self, **kwargs: Any): ...
    def getMergeUVSets(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOperation(self, **kwargs: Any): ...
    def getPreserveColor(self, **kwargs: Any): ...
    def getUseThresholds(self, **kwargs: Any): ...
    def getVertexDistanceThreshold(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setFaceAreaThreshold(self, val: bool = ..., **kwargs: Any): ...
    def setMergeUVSets(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOperation(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveColor(self, val: bool = ..., **kwargs: Any): ...
    def setUseThresholds(self, val: bool = ..., **kwargs: Any): ...
    def setVertexDistanceThreshold(self, val: bool = ..., **kwargs: Any): ...

class PolyCBoolOp(PolyBoolOp):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getClassification(self, **kwargs: Any): ...
    def getFaceAreaThreshold(self, **kwargs: Any): ...
    def getMergeUVSets(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOperation(self, **kwargs: Any): ...
    def getPreserveColor(self, **kwargs: Any): ...
    def getUseCarveBooleans(self, **kwargs: Any): ...
    def getUseThresholds(self, **kwargs: Any): ...
    def getVertexDistanceThreshold(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setClassification(self, val: bool = ..., **kwargs: Any): ...
    def setFaceAreaThreshold(self, val: bool = ..., **kwargs: Any): ...
    def setMergeUVSets(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOperation(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveColor(self, val: bool = ..., **kwargs: Any): ...
    def setUseCarveBooleans(self, val: bool = ..., **kwargs: Any): ...
    def setUseThresholds(self, val: bool = ..., **kwargs: Any): ...
    def setVertexDistanceThreshold(self, val: bool = ..., **kwargs: Any): ...

class PolyModifier(PolyBase):
    __melnode__: str = ...

class BlendColorSets(PolyModifier):
    __melnode__: str = ...

class PolyAppend(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getSubdivision(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def setSubdivision(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...

class PolyAppendVertex(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...

class PolyClean(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCleanEdges(self, **kwargs: Any): ...
    def getCleanPartialUVMapping(self, **kwargs: Any): ...
    def getCleanUVs(self, **kwargs: Any): ...
    def getCleanVertices(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getFrozen(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCleanEdges(self, val: bool = ..., **kwargs: Any): ...
    def setCleanPartialUVMapping(self, val: bool = ..., **kwargs: Any): ...
    def setCleanUVs(self, val: bool = ..., **kwargs: Any): ...
    def setCleanVertices(self, val: bool = ..., **kwargs: Any): ...
    def setFrozen(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyCloseBorder(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyCollapseEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyCollapseF(PolyModifier):
    __melnode__: str = ...

class PolyColorDel(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getColorSetName(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setColorSetName(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyColorMod(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAlphaScale_FloatValue(self, **kwargs: Any): ...
    def getAlphaScale_Interp(self, **kwargs: Any): ...
    def getAlphaScale_Position(self, **kwargs: Any): ...
    def getBlueScale_FloatValue(self, **kwargs: Any): ...
    def getBlueScale_Interp(self, **kwargs: Any): ...
    def getBlueScale_Position(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getGreenScale_FloatValue(self, **kwargs: Any): ...
    def getGreenScale_Interp(self, **kwargs: Any): ...
    def getGreenScale_Position(self, **kwargs: Any): ...
    def getHuev(self, **kwargs: Any): ...
    def getIntensityScale_FloatValue(self, **kwargs: Any): ...
    def getIntensityScale_Interp(self, **kwargs: Any): ...
    def getIntensityScale_Position(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getRedScale_FloatValue(self, **kwargs: Any): ...
    def getRedScale_Interp(self, **kwargs: Any): ...
    def getRedScale_Position(self, **kwargs: Any): ...
    def getSatv(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def setAlphaScale_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setAlphaScale_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setAlphaScale_Position(self, val: bool = ..., **kwargs: Any): ...
    def setBlueScale_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setBlueScale_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setBlueScale_Position(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setGreenScale_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setGreenScale_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setGreenScale_Position(self, val: bool = ..., **kwargs: Any): ...
    def setHuev(self, val: bool = ..., **kwargs: Any): ...
    def setIntensityScale_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setIntensityScale_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setIntensityScale_Position(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setRedScale_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setRedScale_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setRedScale_Position(self, val: bool = ..., **kwargs: Any): ...
    def setSatv(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...

class PolyColorPerVertex(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAlpha(self, **kwargs: Any): ...
    def getClamped(self, **kwargs: Any): ...
    def getColorB(self, **kwargs: Any): ...
    def getColorDisplayOption(self, **kwargs: Any): ...
    def getColorG(self, **kwargs: Any): ...
    def getColorR(self, **kwargs: Any): ...
    def getColorRGB(self, **kwargs: Any): ...
    def getNotUndoable(self, **kwargs: Any): ...
    def getRelative(self, **kwargs: Any): ...
    def getRemove(self, **kwargs: Any): ...
    def getRepresentation(self, **kwargs: Any): ...
    def setAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setClamped(self, val: bool = ..., **kwargs: Any): ...
    def setColorB(self, val: bool = ..., **kwargs: Any): ...
    def setColorDisplayOption(self, val: bool = ..., **kwargs: Any): ...
    def setColorG(self, val: bool = ..., **kwargs: Any): ...
    def setColorR(self, val: bool = ..., **kwargs: Any): ...
    def setColorRGB(self, val: bool = ..., **kwargs: Any): ...
    def setNotUndoable(self, val: bool = ..., **kwargs: Any): ...
    def setRelative(self, val: bool = ..., **kwargs: Any): ...
    def setRemove(self, val: bool = ..., **kwargs: Any): ...
    def setRepresentation(self, val: bool = ..., **kwargs: Any): ...

class PolyConnectComponents(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAdjustEdgeFlow(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getInsertWithEdgeFlow(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setAdjustEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setInsertWithEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyDelEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCleanVertices(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCleanVertices(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyDelFacet(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyDelVertex(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyDuplicateEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAdjustEdgeFlow(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDeleteEdge(self, **kwargs: Any): ...
    def getEndVertexOffset(self, **kwargs: Any): ...
    def getInsertWithEdgeFlow(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getSplitType(self, **kwargs: Any): ...
    def getStartVertexOffset(self, **kwargs: Any): ...
    def setAdjustEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDeleteEdge(self, val: bool = ..., **kwargs: Any): ...
    def setEndVertexOffset(self, val: bool = ..., **kwargs: Any): ...
    def setInsertWithEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setSplitType(self, val: bool = ..., **kwargs: Any): ...
    def setStartVertexOffset(self, val: bool = ..., **kwargs: Any): ...

class PolyEditEdgeFlow(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyFlipEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class PolyMapCut(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getMoveratio(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setMoveratio(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyMapDel(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyMapSew(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyMergeEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getFirstEdge(self, **kwargs: Any): ...
    def getMergeMode(self, **kwargs: Any): ...
    def getMergeTexture(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSecondEdge(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setFirstEdge(self, val: bool = ..., **kwargs: Any): ...
    def setMergeMode(self, val: bool = ..., **kwargs: Any): ...
    def setMergeTexture(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSecondEdge(self, val: bool = ..., **kwargs: Any): ...

class PolyMergeFace(PolyModifier):
    __melnode__: str = ...

class PolyModifierWorld(PolyModifier):
    __melnode__: str = ...

class PolyAverageVertex(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getIterations(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setIterations(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyBevel(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAngleTolerance(self, **kwargs: Any): ...
    def getAutoFit(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getMergeVertexTolerance(self, **kwargs: Any): ...
    def getMergeVertices(self, **kwargs: Any): ...
    def getMiteringAngle(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOffset(self, **kwargs: Any): ...
    def getOffsetAsFraction(self, **kwargs: Any): ...
    def getRoundness(self, **kwargs: Any): ...
    def getSegments(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getSubdivideNgons(self, **kwargs: Any): ...
    def getUseLegacyBevelAlgorithm(self, **kwargs: Any): ...
    def getUvAssignment(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAngleTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setAutoFit(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setMergeVertexTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setMergeVertices(self, val: bool = ..., **kwargs: Any): ...
    def setMiteringAngle(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def setOffsetAsFraction(self, val: bool = ..., **kwargs: Any): ...
    def setRoundness(self, val: bool = ..., **kwargs: Any): ...
    def setSegments(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivideNgons(self, val: bool = ..., **kwargs: Any): ...
    def setUseLegacyBevelAlgorithm(self, val: bool = ..., **kwargs: Any): ...
    def setUvAssignment(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyBevel2(PolyBevel):
    __melnode__: str = ...

class PolyBevel3(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAngleTolerance(self, **kwargs: Any): ...
    def getAutoFit(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getChamfer(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDepth(self, **kwargs: Any): ...
    def getFillNgons(self, **kwargs: Any): ...
    def getMergeVertexTolerance(self, **kwargs: Any): ...
    def getMergeVertices(self, **kwargs: Any): ...
    def getMiterAlong(self, **kwargs: Any): ...
    def getMitering(self, **kwargs: Any): ...
    def getMiteringAngle(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOffset(self, **kwargs: Any): ...
    def getOffsetAsFraction(self, **kwargs: Any): ...
    def getRoundness(self, **kwargs: Any): ...
    def getSegments(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getUvAssignment(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAngleTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setAutoFit(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setChamfer(self, val: bool = ..., **kwargs: Any): ...
    def setDepth(self, val: bool = ..., **kwargs: Any): ...
    def setFillNgons(self, val: bool = ..., **kwargs: Any): ...
    def setMergeVertexTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setMergeVertices(self, val: bool = ..., **kwargs: Any): ...
    def setMiterAlong(self, val: bool = ..., **kwargs: Any): ...
    def setMitering(self, val: bool = ..., **kwargs: Any): ...
    def setMiteringAngle(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def setOffsetAsFraction(self, val: bool = ..., **kwargs: Any): ...
    def setRoundness(self, val: bool = ..., **kwargs: Any): ...
    def setSegments(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setUvAssignment(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyBridgeEdge(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBridgeOffset(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCurveType(self, **kwargs: Any): ...
    def getDivisions(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getStartVert1(self, **kwargs: Any): ...
    def getStartVert2(self, **kwargs: Any): ...
    def getTaper(self, **kwargs: Any): ...
    def getTaperCurve_FloatValue(self, **kwargs: Any): ...
    def getTaperCurve_Interp(self, **kwargs: Any): ...
    def getTaperCurve_Position(self, **kwargs: Any): ...
    def getTwist(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setBridgeOffset(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCurveType(self, val: bool = ..., **kwargs: Any): ...
    def setDivisions(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setStartVert1(self, val: bool = ..., **kwargs: Any): ...
    def setStartVert2(self, val: bool = ..., **kwargs: Any): ...
    def setTaper(self, val: bool = ..., **kwargs: Any): ...
    def setTaperCurve_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setTaperCurve_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setTaperCurve_Position(self, val: bool = ..., **kwargs: Any): ...
    def setTwist(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyCircularize(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAlignment(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getEvenlyDistribute(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNormalOrientation(self, **kwargs: Any): ...
    def getRadialOffset(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAlignment(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setEvenlyDistribute(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNormalOrientation(self, val: bool = ..., **kwargs: Any): ...
    def setRadialOffset(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyCrease(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCreateHistory(self, **kwargs: Any): ...
    def getOperation(self, **kwargs: Any): ...
    def getRelativeValue(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVertexValue(self, **kwargs: Any): ...
    def setCreateHistory(self, val: bool = ..., **kwargs: Any): ...
    def setOperation(self, val: bool = ..., **kwargs: Any): ...
    def setRelativeValue(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVertexValue(self, val: bool = ..., **kwargs: Any): ...

class PolyCreaseEdge(PolyCrease):
    __melnode__: str = ...

class PolyCut(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCutPlaneCenter(self, **kwargs: Any): ...
    def getCutPlaneCenterX(self, **kwargs: Any): ...
    def getCutPlaneCenterY(self, **kwargs: Any): ...
    def getCutPlaneCenterZ(self, **kwargs: Any): ...
    def getCutPlaneHeight(self, **kwargs: Any): ...
    def getCutPlaneRotate(self, **kwargs: Any): ...
    def getCutPlaneRotateX(self, **kwargs: Any): ...
    def getCutPlaneRotateY(self, **kwargs: Any): ...
    def getCutPlaneRotateZ(self, **kwargs: Any): ...
    def getCutPlaneSize(self, **kwargs: Any): ...
    def getCutPlaneWidth(self, **kwargs: Any): ...
    def getDeleteFaces(self, **kwargs: Any): ...
    def getExtractFaces(self, **kwargs: Any): ...
    def getExtractOffset(self, **kwargs: Any): ...
    def getExtractOffsetX(self, **kwargs: Any): ...
    def getExtractOffsetY(self, **kwargs: Any): ...
    def getExtractOffsetZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOnObject(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneCenter(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneCenterX(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneCenterY(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneCenterZ(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneHeight(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneRotate(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneSize(self, val: bool = ..., **kwargs: Any): ...
    def setCutPlaneWidth(self, val: bool = ..., **kwargs: Any): ...
    def setDeleteFaces(self, val: bool = ..., **kwargs: Any): ...
    def setExtractFaces(self, val: bool = ..., **kwargs: Any): ...
    def setExtractOffset(self, val: bool = ..., **kwargs: Any): ...
    def setExtractOffsetX(self, val: bool = ..., **kwargs: Any): ...
    def setExtractOffsetY(self, val: bool = ..., **kwargs: Any): ...
    def setExtractOffsetZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOnObject(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyCylProj(PolyModifierWorld):
    __melnode__: str = ...

class PolyExtrudeVertex(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDivisions(self, **kwargs: Any): ...
    def getLength(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDivisions(self, val: bool = ..., **kwargs: Any): ...
    def setLength(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyHoleFace(PolyModifierWorld):
    __melnode__: str = ...

class PolyMergeVert(PolyModifierWorld):
    __melnode__: str = ...

class PolyMirror(PolyModifierWorld):
    __melnode__: str = ...

class PolyModifierUV(PolyModifierWorld):
    __melnode__: str = ...

class PolyAutoProj(PolyModifierUV):
    __melnode__: str = ...

class PolyContourProj(PolyModifierUV):
    __melnode__: str = ...

class PolyCopyUV(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getUvSetNameInput(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setUvSetNameInput(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyFlipUV(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCutUV(self, **kwargs: Any): ...
    def getFlipType(self, **kwargs: Any): ...
    def getLocal(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivotU(self, **kwargs: Any): ...
    def getPivotV(self, **kwargs: Any): ...
    def getUsePivot(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCutUV(self, val: bool = ..., **kwargs: Any): ...
    def setFlipType(self, val: bool = ..., **kwargs: Any): ...
    def setLocal(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivotU(self, val: bool = ..., **kwargs: Any): ...
    def setPivotV(self, val: bool = ..., **kwargs: Any): ...
    def setUsePivot(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyLayoutUV(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getFlipReversed(self, **kwargs: Any): ...
    def getLayout(self, **kwargs: Any): ...
    def getLayoutMethod(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPercentageSpace(self, **kwargs: Any): ...
    def getRotateForBestFit(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getSeparate(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setFlipReversed(self, val: bool = ..., **kwargs: Any): ...
    def setLayout(self, val: bool = ..., **kwargs: Any): ...
    def setLayoutMethod(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPercentageSpace(self, val: bool = ..., **kwargs: Any): ...
    def setRotateForBestFit(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setSeparate(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyMapSewMove(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getLimitPieceSize(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberFaces(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setLimitPieceSize(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberFaces(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyMergeUV(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDistance(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDistance(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyNormalizeUV(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCenterOnTile(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNormalizeDirection(self, **kwargs: Any): ...
    def getNormalizeType(self, **kwargs: Any): ...
    def getPreserveAspectRatio(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCenterOnTile(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNormalizeDirection(self, val: bool = ..., **kwargs: Any): ...
    def setNormalizeType(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveAspectRatio(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyOptUvs(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyPinUV(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCreateHistory(self, **kwargs: Any): ...
    def getOperation(self, **kwargs: Any): ...
    def getUnpinned(self, **kwargs: Any): ...
    def getUvSetName(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def setCreateHistory(self, val: bool = ..., **kwargs: Any): ...
    def setOperation(self, val: bool = ..., **kwargs: Any): ...
    def setUnpinned(self, val: bool = ..., **kwargs: Any): ...
    def setUvSetName(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...

class PolyStraightenUVBorder(PolyModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getBlendOriginal(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getCurvature(self, **kwargs: Any): ...
    def getGapTolerance(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPreserveLength(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyMoveVertex(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getGain(self, **kwargs: Any): ...
    def getLocalDirection(self, **kwargs: Any): ...
    def getLocalDirectionX(self, **kwargs: Any): ...
    def getLocalDirectionY(self, **kwargs: Any): ...
    def getLocalDirectionZ(self, **kwargs: Any): ...
    def getLocalTranslate(self, **kwargs: Any): ...
    def getLocalTranslateX(self, **kwargs: Any): ...
    def getLocalTranslateY(self, **kwargs: Any): ...
    def getLocalTranslateZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotX(self, **kwargs: Any): ...
    def getPivotY(self, **kwargs: Any): ...
    def getPivotZ(self, **kwargs: Any): ...
    def getRandom(self, **kwargs: Any): ...
    def getRotate(self, **kwargs: Any): ...
    def getRotateX(self, **kwargs: Any): ...
    def getRotateY(self, **kwargs: Any): ...
    def getRotateZ(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getScaleX(self, **kwargs: Any): ...
    def getScaleY(self, **kwargs: Any): ...
    def getScaleZ(self, **kwargs: Any): ...
    def getTranslate(self, **kwargs: Any): ...
    def getTranslateX(self, **kwargs: Any): ...
    def getTranslateY(self, **kwargs: Any): ...
    def getTranslateZ(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setGain(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirection(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotX(self, val: bool = ..., **kwargs: Any): ...
    def setPivotY(self, val: bool = ..., **kwargs: Any): ...
    def setPivotZ(self, val: bool = ..., **kwargs: Any): ...
    def setRandom(self, val: bool = ..., **kwargs: Any): ...
    def setRotate(self, val: bool = ..., **kwargs: Any): ...
    def setRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyMoveEdge(PolyMoveVertex):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getGain(self, **kwargs: Any): ...
    def getLocalCenter(self, **kwargs: Any): ...
    def getLocalDirection(self, **kwargs: Any): ...
    def getLocalDirectionX(self, **kwargs: Any): ...
    def getLocalDirectionY(self, **kwargs: Any): ...
    def getLocalDirectionZ(self, **kwargs: Any): ...
    def getLocalRotate(self, **kwargs: Any): ...
    def getLocalRotateX(self, **kwargs: Any): ...
    def getLocalRotateY(self, **kwargs: Any): ...
    def getLocalRotateZ(self, **kwargs: Any): ...
    def getLocalScale(self, **kwargs: Any): ...
    def getLocalScaleX(self, **kwargs: Any): ...
    def getLocalScaleY(self, **kwargs: Any): ...
    def getLocalScaleZ(self, **kwargs: Any): ...
    def getLocalTranslate(self, **kwargs: Any): ...
    def getLocalTranslateX(self, **kwargs: Any): ...
    def getLocalTranslateY(self, **kwargs: Any): ...
    def getLocalTranslateZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotX(self, **kwargs: Any): ...
    def getPivotY(self, **kwargs: Any): ...
    def getPivotZ(self, **kwargs: Any): ...
    def getRandom(self, **kwargs: Any): ...
    def getRotate(self, **kwargs: Any): ...
    def getRotateX(self, **kwargs: Any): ...
    def getRotateY(self, **kwargs: Any): ...
    def getRotateZ(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getScaleX(self, **kwargs: Any): ...
    def getScaleY(self, **kwargs: Any): ...
    def getScaleZ(self, **kwargs: Any): ...
    def getTranslate(self, **kwargs: Any): ...
    def getTranslateX(self, **kwargs: Any): ...
    def getTranslateY(self, **kwargs: Any): ...
    def getTranslateZ(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setGain(self, val: bool = ..., **kwargs: Any): ...
    def setLocalCenter(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirection(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScale(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotX(self, val: bool = ..., **kwargs: Any): ...
    def setPivotY(self, val: bool = ..., **kwargs: Any): ...
    def setPivotZ(self, val: bool = ..., **kwargs: Any): ...
    def setRandom(self, val: bool = ..., **kwargs: Any): ...
    def setRotate(self, val: bool = ..., **kwargs: Any): ...
    def setRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyExtrudeEdge(PolyMoveEdge):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDivisions(self, **kwargs: Any): ...
    def getGain(self, **kwargs: Any): ...
    def getKeepFacesTogether(self, **kwargs: Any): ...
    def getLocalCenter(self, **kwargs: Any): ...
    def getLocalDirection(self, **kwargs: Any): ...
    def getLocalDirectionX(self, **kwargs: Any): ...
    def getLocalDirectionY(self, **kwargs: Any): ...
    def getLocalDirectionZ(self, **kwargs: Any): ...
    def getLocalRotate(self, **kwargs: Any): ...
    def getLocalRotateX(self, **kwargs: Any): ...
    def getLocalRotateY(self, **kwargs: Any): ...
    def getLocalRotateZ(self, **kwargs: Any): ...
    def getLocalScale(self, **kwargs: Any): ...
    def getLocalScaleX(self, **kwargs: Any): ...
    def getLocalScaleY(self, **kwargs: Any): ...
    def getLocalScaleZ(self, **kwargs: Any): ...
    def getLocalTranslate(self, **kwargs: Any): ...
    def getLocalTranslateX(self, **kwargs: Any): ...
    def getLocalTranslateY(self, **kwargs: Any): ...
    def getLocalTranslateZ(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOffset(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotX(self, **kwargs: Any): ...
    def getPivotY(self, **kwargs: Any): ...
    def getPivotZ(self, **kwargs: Any): ...
    def getRandom(self, **kwargs: Any): ...
    def getRotate(self, **kwargs: Any): ...
    def getRotateX(self, **kwargs: Any): ...
    def getRotateY(self, **kwargs: Any): ...
    def getRotateZ(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getScaleX(self, **kwargs: Any): ...
    def getScaleY(self, **kwargs: Any): ...
    def getScaleZ(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getTaper(self, **kwargs: Any): ...
    def getTaperCurve_FloatValue(self, **kwargs: Any): ...
    def getTaperCurve_Interp(self, **kwargs: Any): ...
    def getTaperCurve_Position(self, **kwargs: Any): ...
    def getThickness(self, **kwargs: Any): ...
    def getTranslate(self, **kwargs: Any): ...
    def getTranslateX(self, **kwargs: Any): ...
    def getTranslateY(self, **kwargs: Any): ...
    def getTranslateZ(self, **kwargs: Any): ...
    def getTwist(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDivisions(self, val: bool = ..., **kwargs: Any): ...
    def setGain(self, val: bool = ..., **kwargs: Any): ...
    def setKeepFacesTogether(self, val: bool = ..., **kwargs: Any): ...
    def setLocalCenter(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirection(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScale(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotX(self, val: bool = ..., **kwargs: Any): ...
    def setPivotY(self, val: bool = ..., **kwargs: Any): ...
    def setPivotZ(self, val: bool = ..., **kwargs: Any): ...
    def setRandom(self, val: bool = ..., **kwargs: Any): ...
    def setRotate(self, val: bool = ..., **kwargs: Any): ...
    def setRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setTaper(self, val: bool = ..., **kwargs: Any): ...
    def setTaperCurve_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setTaperCurve_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setTaperCurve_Position(self, val: bool = ..., **kwargs: Any): ...
    def setThickness(self, val: bool = ..., **kwargs: Any): ...
    def setTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setTwist(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyMoveFace(PolyMoveEdge):
    __melnode__: str = ...

class PolyChipOff(PolyMoveFace):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAttraction(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDuplicate(self, **kwargs: Any): ...
    def getGain(self, **kwargs: Any): ...
    def getGravity(self, **kwargs: Any): ...
    def getGravityX(self, **kwargs: Any): ...
    def getGravityY(self, **kwargs: Any): ...
    def getGravityZ(self, **kwargs: Any): ...
    def getKeepFacesTogether(self, **kwargs: Any): ...
    def getKeepFacetTogether(self, **kwargs: Any): ...
    def getLocalCenter(self, **kwargs: Any): ...
    def getLocalDirection(self, **kwargs: Any): ...
    def getLocalDirectionX(self, **kwargs: Any): ...
    def getLocalDirectionY(self, **kwargs: Any): ...
    def getLocalDirectionZ(self, **kwargs: Any): ...
    def getLocalRotate(self, **kwargs: Any): ...
    def getLocalRotateX(self, **kwargs: Any): ...
    def getLocalRotateY(self, **kwargs: Any): ...
    def getLocalRotateZ(self, **kwargs: Any): ...
    def getLocalScale(self, **kwargs: Any): ...
    def getLocalScaleX(self, **kwargs: Any): ...
    def getLocalScaleY(self, **kwargs: Any): ...
    def getLocalScaleZ(self, **kwargs: Any): ...
    def getLocalTranslate(self, **kwargs: Any): ...
    def getLocalTranslateX(self, **kwargs: Any): ...
    def getLocalTranslateY(self, **kwargs: Any): ...
    def getLocalTranslateZ(self, **kwargs: Any): ...
    def getMagnX(self, **kwargs: Any): ...
    def getMagnY(self, **kwargs: Any): ...
    def getMagnZ(self, **kwargs: Any): ...
    def getMagnet(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOffset(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotX(self, **kwargs: Any): ...
    def getPivotY(self, **kwargs: Any): ...
    def getPivotZ(self, **kwargs: Any): ...
    def getRandom(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getScaleX(self, **kwargs: Any): ...
    def getScaleY(self, **kwargs: Any): ...
    def getScaleZ(self, **kwargs: Any): ...
    def getTranslate(self, **kwargs: Any): ...
    def getTranslateX(self, **kwargs: Any): ...
    def getTranslateY(self, **kwargs: Any): ...
    def getTranslateZ(self, **kwargs: Any): ...
    def getWeight(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAttraction(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDuplicate(self, val: bool = ..., **kwargs: Any): ...
    def setGain(self, val: bool = ..., **kwargs: Any): ...
    def setGravity(self, val: bool = ..., **kwargs: Any): ...
    def setGravityX(self, val: bool = ..., **kwargs: Any): ...
    def setGravityY(self, val: bool = ..., **kwargs: Any): ...
    def setGravityZ(self, val: bool = ..., **kwargs: Any): ...
    def setKeepFacesTogether(self, val: bool = ..., **kwargs: Any): ...
    def setKeepFacetTogether(self, val: bool = ..., **kwargs: Any): ...
    def setLocalCenter(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirection(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalDirectionZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalRotateZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScale(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setLocalTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setMagnX(self, val: bool = ..., **kwargs: Any): ...
    def setMagnY(self, val: bool = ..., **kwargs: Any): ...
    def setMagnZ(self, val: bool = ..., **kwargs: Any): ...
    def setMagnet(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOffset(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotX(self, val: bool = ..., **kwargs: Any): ...
    def setPivotY(self, val: bool = ..., **kwargs: Any): ...
    def setPivotZ(self, val: bool = ..., **kwargs: Any): ...
    def setRandom(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setScaleX(self, val: bool = ..., **kwargs: Any): ...
    def setScaleY(self, val: bool = ..., **kwargs: Any): ...
    def setScaleZ(self, val: bool = ..., **kwargs: Any): ...
    def setTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateX(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateY(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateZ(self, val: bool = ..., **kwargs: Any): ...
    def setWeight(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyExtrudeFace(PolyMoveFace):
    __melnode__: str = ...

class PolyPassThru(PolyModifierWorld):
    __melnode__: str = ...

class PolyPlanarProj(PolyModifierWorld):
    __melnode__: str = ...

class PolyPoke(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyProj(PolyModifierWorld):
    __melnode__: str = ...

class PolyQuad(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAngle(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getKeepGroupBorder(self, **kwargs: Any): ...
    def getKeepHardEdges(self, **kwargs: Any): ...
    def getKeepTextureBorders(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAngle(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setKeepGroupBorder(self, val: bool = ..., **kwargs: Any): ...
    def setKeepHardEdges(self, val: bool = ..., **kwargs: Any): ...
    def setKeepTextureBorders(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyRemesh(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCollapseThreshold(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getInterpolationType(self, **kwargs: Any): ...
    def getMaxEdgeLength(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getSmoothStrength(self, **kwargs: Any): ...
    def getTessellateBorders(self, **kwargs: Any): ...
    def getUseRelativeValues(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCollapseThreshold(self, val: bool = ..., **kwargs: Any): ...
    def setInterpolationType(self, val: bool = ..., **kwargs: Any): ...
    def setMaxEdgeLength(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothStrength(self, val: bool = ..., **kwargs: Any): ...
    def setTessellateBorders(self, val: bool = ..., **kwargs: Any): ...
    def setUseRelativeValues(self, val: bool = ..., **kwargs: Any): ...

class PolySewEdge(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getTexture(self, **kwargs: Any): ...
    def getTolerance(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setTexture(self, val: bool = ..., **kwargs: Any): ...
    def setTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolySoftEdge(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAngle(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAngle(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolySphProj(PolyModifierWorld):
    __melnode__: str = ...

class PolySplitRing(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAdjustEdgeFlow(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getDirection(self, **kwargs: Any): ...
    def getDivisions(self, **kwargs: Any): ...
    def getEnableProfileCurve(self, **kwargs: Any): ...
    def getFixQuads(self, **kwargs: Any): ...
    def getInsertWithEdgeFlow(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getProfileCurve_FloatValue(self, **kwargs: Any): ...
    def getProfileCurve_Interp(self, **kwargs: Any): ...
    def getProfileCurve_Position(self, **kwargs: Any): ...
    def getProfileCurveInputOffset(self, **kwargs: Any): ...
    def getProfileCurveInputScale(self, **kwargs: Any): ...
    def getRootEdge(self, **kwargs: Any): ...
    def getSmoothingAngle(self, **kwargs: Any): ...
    def getSplitType(self, **kwargs: Any): ...
    def getUseEqualMultiplier(self, **kwargs: Any): ...
    def getUseFaceNormalsAtEnds(self, **kwargs: Any): ...
    def getWeight(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setAdjustEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setDirection(self, val: bool = ..., **kwargs: Any): ...
    def setDivisions(self, val: bool = ..., **kwargs: Any): ...
    def setEnableProfileCurve(self, val: bool = ..., **kwargs: Any): ...
    def setFixQuads(self, val: bool = ..., **kwargs: Any): ...
    def setInsertWithEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setProfileCurve_FloatValue(self, val: bool = ..., **kwargs: Any): ...
    def setProfileCurve_Interp(self, val: bool = ..., **kwargs: Any): ...
    def setProfileCurve_Position(self, val: bool = ..., **kwargs: Any): ...
    def setProfileCurveInputOffset(self, val: bool = ..., **kwargs: Any): ...
    def setProfileCurveInputScale(self, val: bool = ..., **kwargs: Any): ...
    def setRootEdge(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothingAngle(self, val: bool = ..., **kwargs: Any): ...
    def setSplitType(self, val: bool = ..., **kwargs: Any): ...
    def setUseEqualMultiplier(self, val: bool = ..., **kwargs: Any): ...
    def setUseFaceNormalsAtEnds(self, val: bool = ..., **kwargs: Any): ...
    def setWeight(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolySplitVert(PolyModifierWorld):
    __melnode__: str = ...

class PolySubdEdge(PolyModifierWorld):
    __melnode__: str = ...

class PolyWedgeFace(PolyModifierWorld):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class PolyMoveUV(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxisLen(self, **kwargs: Any): ...
    def getAxisLenX(self, **kwargs: Any): ...
    def getAxisLenY(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotU(self, **kwargs: Any): ...
    def getPivotV(self, **kwargs: Any): ...
    def getRandom(self, **kwargs: Any): ...
    def getRotationAngle(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getScaleU(self, **kwargs: Any): ...
    def getScaleV(self, **kwargs: Any): ...
    def getTranslate(self, **kwargs: Any): ...
    def getTranslateU(self, **kwargs: Any): ...
    def getTranslateV(self, **kwargs: Any): ...
    def setAxisLen(self, val: bool = ..., **kwargs: Any): ...
    def setAxisLenX(self, val: bool = ..., **kwargs: Any): ...
    def setAxisLenY(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotU(self, val: bool = ..., **kwargs: Any): ...
    def setPivotV(self, val: bool = ..., **kwargs: Any): ...
    def setRandom(self, val: bool = ..., **kwargs: Any): ...
    def setRotationAngle(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setScaleU(self, val: bool = ..., **kwargs: Any): ...
    def setScaleV(self, val: bool = ..., **kwargs: Any): ...
    def setTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateU(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateV(self, val: bool = ..., **kwargs: Any): ...

class PolyMoveFacetUV(PolyMoveUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAxisLen(self, **kwargs: Any): ...
    def getAxisLenX(self, **kwargs: Any): ...
    def getAxisLenY(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPivot(self, **kwargs: Any): ...
    def getPivotU(self, **kwargs: Any): ...
    def getPivotV(self, **kwargs: Any): ...
    def getRandom(self, **kwargs: Any): ...
    def getRotationAngle(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getScaleU(self, **kwargs: Any): ...
    def getScaleV(self, **kwargs: Any): ...
    def getTranslate(self, **kwargs: Any): ...
    def getTranslateU(self, **kwargs: Any): ...
    def getTranslateV(self, **kwargs: Any): ...
    def setAxisLen(self, val: bool = ..., **kwargs: Any): ...
    def setAxisLenX(self, val: bool = ..., **kwargs: Any): ...
    def setAxisLenY(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPivot(self, val: bool = ..., **kwargs: Any): ...
    def setPivotU(self, val: bool = ..., **kwargs: Any): ...
    def setPivotV(self, val: bool = ..., **kwargs: Any): ...
    def setRandom(self, val: bool = ..., **kwargs: Any): ...
    def setRotationAngle(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setScaleU(self, val: bool = ..., **kwargs: Any): ...
    def setScaleV(self, val: bool = ..., **kwargs: Any): ...
    def setTranslate(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateU(self, val: bool = ..., **kwargs: Any): ...
    def setTranslateV(self, val: bool = ..., **kwargs: Any): ...

class PolyNormal(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNormalMode(self, **kwargs: Any): ...
    def getUserNormalMode(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNormalMode(self, val: bool = ..., **kwargs: Any): ...
    def setUserNormalMode(self, val: bool = ..., **kwargs: Any): ...

class PolyNormalPerVertex(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAllLocked(self, **kwargs: Any): ...
    def getDeformable(self, **kwargs: Any): ...
    def getFreezeNormal(self, **kwargs: Any): ...
    def getNormalX(self, **kwargs: Any): ...
    def getNormalXYZ(self, **kwargs: Any): ...
    def getNormalY(self, **kwargs: Any): ...
    def getNormalZ(self, **kwargs: Any): ...
    def getRelative(self, **kwargs: Any): ...
    def getUnFreezeNormal(self, **kwargs: Any): ...
    def setAllLocked(self, val: bool = ..., **kwargs: Any): ...
    def setDeformable(self, val: bool = ..., **kwargs: Any): ...
    def setFreezeNormal(self, val: bool = ..., **kwargs: Any): ...
    def setNormalX(self, val: bool = ..., **kwargs: Any): ...
    def setNormalXYZ(self, val: bool = ..., **kwargs: Any): ...
    def setNormalY(self, val: bool = ..., **kwargs: Any): ...
    def setNormalZ(self, val: bool = ..., **kwargs: Any): ...
    def setRelative(self, val: bool = ..., **kwargs: Any): ...
    def setUnFreezeNormal(self, val: bool = ..., **kwargs: Any): ...

class PolyReduce(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getCachingReduce(self, **kwargs: Any): ...
    def getColorWeights(self, **kwargs: Any): ...
    def getCompactness(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getGeomWeights(self, **kwargs: Any): ...
    def getInvertVertexWeights(self, **kwargs: Any): ...
    def getKeepBorder(self, **kwargs: Any): ...
    def getKeepBorderWeight(self, **kwargs: Any): ...
    def getKeepColorBorder(self, **kwargs: Any): ...
    def getKeepColorBorderWeight(self, **kwargs: Any): ...
    def getKeepCreaseEdge(self, **kwargs: Any): ...
    def getKeepCreaseEdgeWeight(self, **kwargs: Any): ...
    def getKeepFaceGroupBorder(self, **kwargs: Any): ...
    def getKeepFaceGroupBorderWeight(self, **kwargs: Any): ...
    def getKeepHardEdge(self, **kwargs: Any): ...
    def getKeepHardEdgeWeight(self, **kwargs: Any): ...
    def getKeepMapBorder(self, **kwargs: Any): ...
    def getKeepMapBorderWeight(self, **kwargs: Any): ...
    def getKeepOriginalVertices(self, **kwargs: Any): ...
    def getKeepQuadsWeight(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPercentage(self, **kwargs: Any): ...
    def getPreserveTopology(self, **kwargs: Any): ...
    def getSharpness(self, **kwargs: Any): ...
    def getSymmetryPlaneW(self, **kwargs: Any): ...
    def getSymmetryPlaneX(self, **kwargs: Any): ...
    def getSymmetryPlaneY(self, **kwargs: Any): ...
    def getSymmetryPlaneZ(self, **kwargs: Any): ...
    def getSymmetryTolerance(self, **kwargs: Any): ...
    def getTermination(self, **kwargs: Any): ...
    def getTriangleCount(self, **kwargs: Any): ...
    def getTriangulate(self, **kwargs: Any): ...
    def getUseVirtualSymmetry(self, **kwargs: Any): ...
    def getUvWeights(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVertexCount(self, **kwargs: Any): ...
    def getVertexMapName(self, **kwargs: Any): ...
    def getVertexWeightCoefficient(self, **kwargs: Any): ...
    def getWeightCoefficient(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setCachingReduce(self, val: bool = ..., **kwargs: Any): ...
    def setColorWeights(self, val: bool = ..., **kwargs: Any): ...
    def setCompactness(self, val: bool = ..., **kwargs: Any): ...
    def setGeomWeights(self, val: bool = ..., **kwargs: Any): ...
    def setInvertVertexWeights(self, val: bool = ..., **kwargs: Any): ...
    def setKeepBorder(self, val: bool = ..., **kwargs: Any): ...
    def setKeepBorderWeight(self, val: bool = ..., **kwargs: Any): ...
    def setKeepColorBorder(self, val: bool = ..., **kwargs: Any): ...
    def setKeepColorBorderWeight(self, val: bool = ..., **kwargs: Any): ...
    def setKeepCreaseEdge(self, val: bool = ..., **kwargs: Any): ...
    def setKeepCreaseEdgeWeight(self, val: bool = ..., **kwargs: Any): ...
    def setKeepFaceGroupBorder(self, val: bool = ..., **kwargs: Any): ...
    def setKeepFaceGroupBorderWeight(self, val: bool = ..., **kwargs: Any): ...
    def setKeepHardEdge(self, val: bool = ..., **kwargs: Any): ...
    def setKeepHardEdgeWeight(self, val: bool = ..., **kwargs: Any): ...
    def setKeepMapBorder(self, val: bool = ..., **kwargs: Any): ...
    def setKeepMapBorderWeight(self, val: bool = ..., **kwargs: Any): ...
    def setKeepOriginalVertices(self, val: bool = ..., **kwargs: Any): ...
    def setKeepQuadsWeight(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPercentage(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveTopology(self, val: bool = ..., **kwargs: Any): ...
    def setSharpness(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetryPlaneW(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetryPlaneX(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetryPlaneY(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetryPlaneZ(self, val: bool = ..., **kwargs: Any): ...
    def setSymmetryTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setTermination(self, val: bool = ..., **kwargs: Any): ...
    def setTriangleCount(self, val: bool = ..., **kwargs: Any): ...
    def setTriangulate(self, val: bool = ..., **kwargs: Any): ...
    def setUseVirtualSymmetry(self, val: bool = ..., **kwargs: Any): ...
    def setUvWeights(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVertexCount(self, val: bool = ..., **kwargs: Any): ...
    def setVertexWeightCoefficient(self, val: bool = ..., **kwargs: Any): ...
    def setWeightCoefficient(self, val: bool = ..., **kwargs: Any): ...

class PolyRetopo(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class PolySmooth(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getContinuity(self, **kwargs: Any): ...
    def getDivisions(self, **kwargs: Any): ...
    def getKeepBorder(self, **kwargs: Any): ...
    def getKeepHardEdge(self, **kwargs: Any): ...
    def getKeepSelectionBorder(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOsdCreaseMethod(self, **kwargs: Any): ...
    def getOsdFvarBoundary(self, **kwargs: Any): ...
    def getOsdFvarPropagateCorners(self, **kwargs: Any): ...
    def getOsdSmoothTriangles(self, **kwargs: Any): ...
    def getOsdVertBoundary(self, **kwargs: Any): ...
    def getPropagateEdgeHardness(self, **kwargs: Any): ...
    def getSubdivisionType(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setContinuity(self, val: bool = ..., **kwargs: Any): ...
    def setDivisions(self, val: bool = ..., **kwargs: Any): ...
    def setKeepBorder(self, val: bool = ..., **kwargs: Any): ...
    def setKeepHardEdge(self, val: bool = ..., **kwargs: Any): ...
    def setKeepSelectionBorder(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOsdCreaseMethod(self, val: bool = ..., **kwargs: Any): ...
    def setOsdFvarBoundary(self, val: bool = ..., **kwargs: Any): ...
    def setOsdFvarPropagateCorners(self, val: bool = ..., **kwargs: Any): ...
    def setOsdSmoothTriangles(self, val: bool = ..., **kwargs: Any): ...
    def setOsdVertBoundary(self, val: bool = ..., **kwargs: Any): ...
    def setPropagateEdgeHardness(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivisionType(self, val: bool = ..., **kwargs: Any): ...

class PolySmoothFace(PolyModifier):
    __melnode__: str = ...

class PolySmoothProxy(PolyModifier):
    __melnode__: str = ...

class PolySpinEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class PolySplit(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAdjustEdgeFlow(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getInsertWithEdgeFlow(self, **kwargs: Any): ...
    def getSubdivision(self, **kwargs: Any): ...
    def setAdjustEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setInsertWithEdgeFlow(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivision(self, val: bool = ..., **kwargs: Any): ...

class PolySplitEdge(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getOperation(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setOperation(self, val: bool = ..., **kwargs: Any): ...

class PolySubdFace(PolyModifier):
    __melnode__: str = ...

class PolyTransfer(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getAlternateObject(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getUvSets(self, **kwargs: Any): ...
    def getVertexColor(self, **kwargs: Any): ...
    def getVertices(self, **kwargs: Any): ...
    def setAlternateObject(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setUvSets(self, val: bool = ..., **kwargs: Any): ...
    def setVertexColor(self, val: bool = ..., **kwargs: Any): ...
    def setVertices(self, val: bool = ..., **kwargs: Any): ...

class PolyTriangulate(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyTweak(PolyModifier):
    __melnode__: str = ...

class PolyTweakUV(PolyModifier):
    __melnode__: str = ...

class PolyUVRectangle(PolyModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyBlindData(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def associationType(self, val: bool = ..., **kwargs: Any): ...
    def binaryData(self, val: bool = ..., **kwargs: Any): ...
    def booleanData(self, val: bool = ..., **kwargs: Any): ...
    def delete(self, val: bool = ..., **kwargs: Any): ...
    def doubleData(self, val: bool = ..., **kwargs: Any): ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def int64Data(self, val: bool = ..., **kwargs: Any): ...
    def intData(self, val: bool = ..., **kwargs: Any): ...
    def longDataName(self, val: bool = ..., **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def rescan(self, val: bool = ..., **kwargs: Any): ...
    def reset(self, val: bool = ..., **kwargs: Any): ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setTypeId(self, val: bool = ..., **kwargs: Any): ...
    def shape(self, val: bool = ..., **kwargs: Any): ...
    def shortDataName(self, val: bool = ..., **kwargs: Any): ...
    def stringData(self, val: bool = ..., **kwargs: Any): ...

class SubdBlindData(PolyBlindData):
    __melnode__: str = ...

class PolySeparate(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getCaching(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getNodeState(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class PolyToSubdiv(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAbsolutePosition(self, **kwargs: Any): ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getApplyMatrixToResult(self, **kwargs: Any): ...
    def getCaching(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getMaxEdgesPerVert(self, **kwargs: Any): ...
    def getMaxPolyCount(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPreserveVertexOrdering(self, **kwargs: Any): ...
    def getQuickConvert(self, **kwargs: Any): ...
    def getUvPoints(self, **kwargs: Any): ...
    def getUvPointsU(self, **kwargs: Any): ...
    def getUvPointsV(self, **kwargs: Any): ...
    def getUvTreatment(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAbsolutePosition(self, val: bool = ..., **kwargs: Any): ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setApplyMatrixToResult(self, val: bool = ..., **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setMaxEdgesPerVert(self, val: bool = ..., **kwargs: Any): ...
    def setMaxPolyCount(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPreserveVertexOrdering(self, val: bool = ..., **kwargs: Any): ...
    def setQuickConvert(self, val: bool = ..., **kwargs: Any): ...
    def setUvPoints(self, val: bool = ..., **kwargs: Any): ...
    def setUvPointsU(self, val: bool = ..., **kwargs: Any): ...
    def setUvPointsV(self, val: bool = ..., **kwargs: Any): ...
    def setUvTreatment(self, val: bool = ..., **kwargs: Any): ...

class PoseInterpolatorManager(DependNode):
    __melnode__: str = ...

class PostProcessList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class PrecompExport(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ProximityPin(DependNode):
    __melnode__: str = ...

class ProxyManager(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Record(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Reference(DependNode):
    __apicls__: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def associatedNamespace(self, baseName: bool) -> str: ...
    def containsNode(self, node: general.PyNode) -> bool: ...
    def containsNodeExactly(self, node: general.PyNode) -> bool: ...
    def fileName(self, resolvedName: bool, includePath: bool, includeCopyNumber: bool) -> str: ...
    @classmethod
    def getIgnoreReferenceEdits(self) -> bool: ...
    def isExportEditsFile(self) -> bool: ...
    def isLoaded(self) -> bool: ...
    def isReferenceLocked(self) -> bool: ...
    def nodes(self) -> List[general.PyNode]: ...
    def parentAssembly(self) -> general.PyNode: ...
    def parentFileName(self, resolveName: bool, includePath: bool, includeCopyNumber: bool) -> str: ...
    def parentReference(self) -> general.PyNode: ...
    @classmethod
    def setIgnoreReferenceEdits(self, ignoreEdits: bool) -> None: ...

class RemapColor(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RemapHsv(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RemapValue(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RenderGlobals(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RenderGlobalsList(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RenderLayerManager(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RenderPassSet(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RenderQuality(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ReorderUVSet(DependNode):
    __melnode__: str = ...

class Resolution(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Reverse(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RgbToHsv(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class RigidSolver(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getAutoTolerances(self, **kwargs: Any): ...
    def getBounciness(self, **kwargs: Any): ...
    def getCacheData(self, **kwargs: Any): ...
    def getCollide(self, **kwargs: Any): ...
    def getCollisionTolerance(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getContactData(self, **kwargs: Any): ...
    def getDeleteCache(self, **kwargs: Any): ...
    def getDisplayCenterOfMass(self, **kwargs: Any): ...
    def getDisplayConstraint(self, **kwargs: Any): ...
    def getDisplayVelocity(self, **kwargs: Any): ...
    def getDynamics(self, **kwargs: Any): ...
    def getFriction(self, **kwargs: Any): ...
    def getInterpenetrate(self, **kwargs: Any): ...
    def getRigidBodies(self, **kwargs: Any): ...
    def getRigidBodyCount(self, **kwargs: Any): ...
    def getShowCollision(self, **kwargs: Any): ...
    def getShowInterpenetration(self, **kwargs: Any): ...
    def getSolverMethod(self, **kwargs: Any): ...
    def getStartTime(self, **kwargs: Any): ...
    def getState(self, **kwargs: Any): ...
    def getStatistics(self, **kwargs: Any): ...
    def getStepSize(self, **kwargs: Any): ...
    def getVelocityVectorScale(self, **kwargs: Any): ...
    def interpenetrationCheck(self, val: bool = ..., **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setAutoTolerances(self, val: bool = ..., **kwargs: Any): ...
    def setBounciness(self, val: bool = ..., **kwargs: Any): ...
    def setCacheData(self, val: bool = ..., **kwargs: Any): ...
    def setCollide(self, val: bool = ..., **kwargs: Any): ...
    def setCollisionTolerance(self, val: bool = ..., **kwargs: Any): ...
    def setContactData(self, val: bool = ..., **kwargs: Any): ...
    def setDeleteCache(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayCenterOfMass(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayConstraint(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayVelocity(self, val: bool = ..., **kwargs: Any): ...
    def setDynamics(self, val: bool = ..., **kwargs: Any): ...
    def setFriction(self, val: bool = ..., **kwargs: Any): ...
    def setInterpenetrate(self, val: bool = ..., **kwargs: Any): ...
    def setShowCollision(self, val: bool = ..., **kwargs: Any): ...
    def setShowInterpenetration(self, val: bool = ..., **kwargs: Any): ...
    def setSolverMethod(self, val: bool = ..., **kwargs: Any): ...
    def setStartTime(self, val: bool = ..., **kwargs: Any): ...
    def setState(self, val: bool = ..., **kwargs: Any): ...
    def setStatistics(self, val: bool = ..., **kwargs: Any): ...
    def setStepSize(self, val: bool = ..., **kwargs: Any): ...
    def setVelocityVectorScale(self, val: bool = ..., **kwargs: Any): ...

class Sampler(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Script(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SelectionListOperator(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SequenceManager(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getCurrentShot(self, **kwargs: Any): ...
    def getCurrentTime(self, **kwargs: Any): ...
    def getModelPanel(self, **kwargs: Any): ...
    def getNode(self, **kwargs: Any): ...
    def getWritableSequencer(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Sequencer(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SetRange(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ShaderGlow(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ShadingDependNode(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class BaseShadingSwitch(ShadingDependNode):
    __melnode__: str = ...

class DoubleShadingSwitch(BaseShadingSwitch):
    __melnode__: str = ...

class QuadShadingSwitch(BaseShadingSwitch):
    __melnode__: str = ...

class SingleShadingSwitch(BaseShadingSwitch):
    __melnode__: str = ...

class TripleShadingSwitch(BaseShadingSwitch):
    __melnode__: str = ...

class Bump2d(ShadingDependNode):
    __melnode__: str = ...

class HwShader(ShadingDependNode):
    __melnode__: str = ...

class THhardwareShader(HwShader):
    __melnode__: str = ...

class THhwShader(HwShader):
    __melnode__: str = ...

class Lambert(ShadingDependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getAmbientColor(self) -> datatypes.Color: ...
    def getColor(self) -> datatypes.Color: ...
    def getDiffuseCoeff(self) -> float: ...
    def getGlowIntensity(self) -> float: ...
    def getHideSource(self) -> bool: ...
    def getIncandescence(self) -> datatypes.Color: ...
    def getRefractedRayDepthLimit(self) -> int: ...
    def getRefractiveIndex(self) -> float: ...
    def getRtRefractedColor(self) -> bool: ...
    def getTranslucenceCoeff(self) -> float: ...
    def getTransparency(self) -> datatypes.Color: ...
    def setAmbientColor(self, ambient_color: datatypes.Color) -> None: ...
    def setColor(self, col: datatypes.Color) -> None: ...
    def setDiffuseCoeff(self, diffuse_coeff: float) -> None: ...
    def setGlowIntensity(self, glow_intensity: float) -> None: ...
    def setHideSource(self, hide_source: bool) -> None: ...
    def setIncandescence(self, incand: datatypes.Color) -> None: ...
    def setRefractedRayDepthLimit(self, refracted_ray_depth_limit: int) -> None: ...
    def setRefractiveIndex(self, refractive_index: float) -> None: ...
    def setRtRefractedColor(self, rt_refracted_color: bool) -> None: ...
    def setTranslucenceCoeff(self, translucence_coeff: float) -> None: ...
    def setTransparency(self, transp: datatypes.Color) -> None: ...

class Reflect(Lambert):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getReflectedColor(self) -> datatypes.Color: ...
    def getReflectedRayDepthLimit(self) -> int: ...
    def getReflectivity(self) -> float: ...
    def getSpecularColor(self) -> datatypes.Color: ...
    def setReflectedColor(self, reflected_color: datatypes.Color) -> None: ...
    def setReflectedRayDepthLimit(self, reflected_ray_depth_limit: int) -> None: ...
    def setReflectivity(self, reflect: float) -> None: ...
    def setSpecularColor(self, specular_color: datatypes.Color) -> None: ...

class Anisotropic(Reflect):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getAnisotropicReflectivity(self) -> bool: ...
    def getCorrelationX(self) -> float: ...
    def getCorrelationY(self) -> float: ...
    def getFresnelRefractiveIndex(self) -> float: ...
    def getRotateAngle(self) -> float: ...
    def getRoughness(self) -> float: ...
    def getTangentUCamera(self) -> datatypes.Color: ...
    def getTangentVCamera(self) -> datatypes.Color: ...
    def setAnisotropicReflectivity(self, anisotropic_reflectivity: bool) -> None: ...
    def setCorrelationX(self, correl_x: float) -> None: ...
    def setCorrelationY(self, correl_y: float) -> None: ...
    def setFresnelRefractiveIndex(self, refractive_index: float) -> None: ...
    def setRotateAngle(self, rotate_angle: float) -> None: ...
    def setRoughness(self, roughness: float) -> None: ...
    def setTangentUCamera(self, tangu_camera: datatypes.Color) -> None: ...
    def setTangentVCamera(self, tangv_camera: datatypes.Color) -> None: ...

class Blinn(Reflect):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getEccentricity(self) -> float: ...
    def getSpecularRollOff(self) -> float: ...
    def setEccentricity(self, eccentr: float) -> None: ...
    def setSpecularRollOff(self, specular_rolloff: float) -> None: ...

class HairTubeShader(Reflect):
    __melnode__: str = ...

class Phong(Reflect):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getCosPower(self) -> float: ...
    def setCosPower(self, cos_power: float) -> None: ...

class PhongE(Reflect):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getHighlightSize(self) -> float: ...
    def getRoughness(self) -> float: ...
    def getWhiteness(self) -> datatypes.Color: ...
    def setHighlightSize(self, highlight_size: float) -> None: ...
    def setRoughness(self, roughness: float) -> None: ...
    def setWhiteness(self, whiteness: datatypes.Color) -> None: ...

class LayeredShader(ShadingDependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getColor(self, lIndex: int=...) -> datatypes.Color: ...
    def getCompositingFlag(self) -> int: ...
    def getGlowColor(self, lIndex: int=...) -> datatypes.Color: ...
    def getHardwareColor(self) -> datatypes.Color: ...
    def getHardwareShader(self) -> datatypes.Color: ...
    def getTransparency(self, lIndex: int=...) -> datatypes.Color: ...
    def setColor(self, col: datatypes.Color, lIndex: int=...) -> None: ...
    def setCompositingFlag(self, cflag: int) -> None: ...
    def setGlowColor(self, glow_color: datatypes.Color, lIndex: int=...) -> None: ...
    def setHardwareColor(self, hardware_color: datatypes.Color) -> None: ...
    def setHardwareShader(self, hardware_shader: datatypes.Color) -> None: ...
    def setTransparency(self, transp: datatypes.Color, lIndex: int=...) -> None: ...

class LayeredTexture(ShadingDependNode):
    __melnode__: str = ...

class LightFog(ShadingDependNode):
    __melnode__: str = ...

class EnvFog(LightFog):
    __melnode__: str = ...

class MultiplyDivide(ShadingDependNode):
    __melnode__: str = ...

class OceanShader(ShadingDependNode):
    __melnode__: str = ...

class ParticleCloud(ShadingDependNode):
    __melnode__: str = ...

class ParticleSamplerInfo(ShadingDependNode):
    __melnode__: str = ...

class Place2dTexture(ShadingDependNode):
    __melnode__: str = ...

class PlusMinusAverage(ShadingDependNode):
    __melnode__: str = ...

class RampShader(ShadingDependNode):
    __melnode__: str = ...

class SamplerInfo(ShadingDependNode):
    __melnode__: str = ...

class ShadingMap(ShadingDependNode):
    __melnode__: str = ...

class StandardSurface(ShadingDependNode):
    __apicls__: Any = ...
    __melnode__: str = ...
    def getBase(self) -> float: ...
    def getBaseColor(self) -> datatypes.Color: ...
    def getCoat(self) -> float: ...
    def getCoatAffectColor(self) -> float: ...
    def getCoatAffectRoughness(self) -> float: ...
    def getCoatAnisotropy(self) -> float: ...
    def getCoatColor(self) -> datatypes.Color: ...
    def getCoatIOR(self) -> float: ...
    def getCoatRotation(self) -> float: ...
    def getCoatRoughness(self) -> float: ...
    def getDiffuseRoughness(self) -> float: ...
    def getEmission(self) -> float: ...
    def getEmissionColor(self) -> datatypes.Color: ...
    def getMetalness(self) -> float: ...
    def getOpacity(self) -> datatypes.Color: ...
    def getSheen(self) -> float: ...
    def getSheenColor(self) -> datatypes.Color: ...
    def getSheenRoughness(self) -> float: ...
    def getSpecular(self) -> float: ...
    def getSpecularAnisotropy(self) -> float: ...
    def getSpecularColor(self) -> datatypes.Color: ...
    def getSpecularIOR(self) -> float: ...
    def getSpecularRotation(self) -> float: ...
    def getSpecularRoughness(self) -> float: ...
    def getSubsurface(self) -> float: ...
    def getSubsurfaceAnisotropy(self) -> float: ...
    def getSubsurfaceColor(self) -> datatypes.Color: ...
    def getSubsurfaceRadius(self) -> datatypes.Color: ...
    def getSubsurfaceScale(self) -> float: ...
    def getThinFilmIOR(self) -> float: ...
    def getThinFilmThickness(self) -> float: ...
    def getThinWalled(self) -> bool: ...
    def getTransmission(self) -> float: ...
    def getTransmissionColor(self) -> datatypes.Color: ...
    def getTransmissionDepth(self) -> float: ...
    def getTransmissionDispersion(self) -> float: ...
    def getTransmissionExtraRoughness(self) -> float: ...
    def getTransmissionScatter(self) -> datatypes.Color: ...
    def getTransmissionScatterAnisotropy(self) -> float: ...
    def setBase(self, base: float) -> None: ...
    def setBaseColor(self, base_color: datatypes.Color) -> None: ...
    def setCoat(self, coat: float) -> None: ...
    def setCoatAffectColor(self, coat_affect_color: float) -> None: ...
    def setCoatAffectRoughness(self, coat_affect_roughness: float) -> None: ...
    def setCoatAnisotropy(self, coat_anisotropy: float) -> None: ...
    def setCoatColor(self, coat_color: datatypes.Color) -> None: ...
    def setCoatIOR(self, coat_i_o_r: float) -> None: ...
    def setCoatRotation(self, coat_rotation: float) -> None: ...
    def setCoatRoughness(self, coat_roughness: float) -> None: ...
    def setDiffuseRoughness(self, diffuse_roughness: float) -> None: ...
    def setEmission(self, emission: float) -> None: ...
    def setEmissionColor(self, emission_color: datatypes.Color) -> None: ...
    def setMetalness(self, metalness: float) -> None: ...
    def setOpacity(self, opacity: datatypes.Color) -> None: ...
    def setSheen(self, sheen: float) -> None: ...
    def setSheenColor(self, sheen_color: datatypes.Color) -> None: ...
    def setSheenRoughness(self, sheen_roughness: float) -> None: ...
    def setSpecular(self, specular: float) -> None: ...
    def setSpecularAnisotropy(self, specular_anisotropy: float) -> None: ...
    def setSpecularColor(self, specular_color: datatypes.Color) -> None: ...
    def setSpecularIOR(self, specular_i_o_r: float) -> None: ...
    def setSpecularRotation(self, specular_rotation: float) -> None: ...
    def setSpecularRoughness(self, specular_roughness: float) -> None: ...
    def setSubsurface(self, subsurface: float) -> None: ...
    def setSubsurfaceAnisotropy(self, subsurface_anisotropy: float) -> None: ...
    def setSubsurfaceColor(self, subsurface_color: datatypes.Color) -> None: ...
    def setSubsurfaceRadius(self, subsurface_radius: datatypes.Color) -> None: ...
    def setSubsurfaceScale(self, subsurface_scale: float) -> None: ...
    def setThinFilmIOR(self, thin_film_i_o_r: float) -> None: ...
    def setThinFilmThickness(self, thin_film_thickness: float) -> None: ...
    def setThinWalled(self, thin_walled: bool) -> None: ...
    def setTransmission(self, transmission: float) -> None: ...
    def setTransmissionColor(self, transmission_color: datatypes.Color) -> None: ...
    def setTransmissionDepth(self, transmission_depth: float) -> None: ...
    def setTransmissionDispersion(self, transmission_dispersion: float) -> None: ...
    def setTransmissionExtraRoughness(self, transmission_extra_roughness: float) -> None: ...
    def setTransmissionScatter(self, transmission_scatter: datatypes.Color) -> None: ...
    def setTransmissionScatterAnisotropy(self, transmission_scatter_anisotropy: float) -> None: ...

class Texture2d(ShadingDependNode):
    __melnode__: str = ...

class TadskAssetInstanceNode_TdnTx2D(Texture2d):
    __melnode__: str = ...

class Bulge(Texture2d):
    __melnode__: str = ...

class Checker(Texture2d):
    __melnode__: str = ...

class Cloth(Texture2d):
    __melnode__: str = ...

class File(Texture2d):
    __melnode__: str = ...

class Movie(File):
    __melnode__: str = ...

class PsdFileTex(File):
    __melnode__: str = ...

class Fractal(Texture2d):
    __melnode__: str = ...

class Grid(Texture2d):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getDefault(self, **kwargs: Any): ...
    def getDisplayAxes(self, **kwargs: Any): ...
    def getDisplayAxesBold(self, **kwargs: Any): ...
    def getDisplayDivisionLines(self, **kwargs: Any): ...
    def getDisplayGridLines(self, **kwargs: Any): ...
    def getDisplayOrthographicLabels(self, **kwargs: Any): ...
    def getDisplayPerspectiveLabels(self, **kwargs: Any): ...
    def getDivisions(self, **kwargs: Any): ...
    def getOrthographicLabelPosition(self, **kwargs: Any): ...
    def getPerspectiveLabelPosition(self, **kwargs: Any): ...
    def getSize(self, **kwargs: Any): ...
    def getSpacing(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getToggle(self, **kwargs: Any): ...

class Mandelbrot(Texture2d):
    __melnode__: str = ...

class Mountain(Texture2d):
    __melnode__: str = ...

class Noise(Texture2d):
    __melnode__: str = ...

class Ocean(Texture2d):
    __melnode__: str = ...

class Ramp(Texture2d):
    __melnode__: str = ...

class Stencil(Texture2d):
    __melnode__: str = ...

class Water(Texture2d):
    __melnode__: str = ...

class Texture3d(ShadingDependNode):
    __melnode__: str = ...

class Brownian(Texture3d):
    __melnode__: str = ...

class Cloud(Texture3d):
    __melnode__: str = ...

class Crater(Texture3d):
    __melnode__: str = ...

class Granite(Texture3d):
    __melnode__: str = ...

class Leather(Texture3d):
    __melnode__: str = ...

class Mandelbrot3D(Texture3d):
    __melnode__: str = ...

class Marble(Texture3d):
    __melnode__: str = ...

class Projection(Texture3d):
    __melnode__: str = ...

class Rock(Texture3d):
    __melnode__: str = ...

class Snow(Texture3d):
    __melnode__: str = ...

class SolidFractal(Texture3d):
    __melnode__: str = ...

class Stucco(Texture3d):
    __melnode__: str = ...

class VolumeNoise(Texture3d):
    __melnode__: str = ...

class Wood(Texture3d):
    __melnode__: str = ...

class TextureEnv(ShadingDependNode):
    __melnode__: str = ...

class EnvBall(TextureEnv):
    __melnode__: str = ...

class EnvChrome(TextureEnv):
    __melnode__: str = ...

class EnvCube(TextureEnv):
    __melnode__: str = ...

class EnvSky(TextureEnv):
    __melnode__: str = ...

class EnvSphere(TextureEnv):
    __melnode__: str = ...

class UseBackground(ShadingDependNode):
    __melnode__: str = ...

class VectorProduct(ShadingDependNode):
    __melnode__: str = ...

class VolumeFog(ShadingDependNode):
    __melnode__: str = ...

class ShapeEditorManager(DependNode):
    __melnode__: str = ...

class Shot(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def createCustomAnim(self, val: bool = ..., **kwargs: Any): ...
    def deleteCustomAnim(self, val: bool = ..., **kwargs: Any): ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getAudio(self, **kwargs: Any): ...
    def getClip(self, **kwargs: Any): ...
    def getClipDuration(self, **kwargs: Any): ...
    def getClipOpacity(self, **kwargs: Any): ...
    def getClipSyncState(self, **kwargs: Any): ...
    def getClipZeroOffset(self, **kwargs: Any): ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getCopy(self, **kwargs: Any): ...
    def getCurrentCamera(self, **kwargs: Any): ...
    def getCustomAnim(self, **kwargs: Any): ...
    def getDetermineTrack(self, **kwargs: Any): ...
    def getEndTime(self, **kwargs: Any): ...
    def getFavorite(self, **kwargs: Any): ...
    def getFlag1(self, **kwargs: Any): ...
    def getFlag10(self, **kwargs: Any): ...
    def getFlag11(self, **kwargs: Any): ...
    def getFlag12(self, **kwargs: Any): ...
    def getFlag2(self, **kwargs: Any): ...
    def getFlag3(self, **kwargs: Any): ...
    def getFlag4(self, **kwargs: Any): ...
    def getFlag5(self, **kwargs: Any): ...
    def getFlag6(self, **kwargs: Any): ...
    def getFlag7(self, **kwargs: Any): ...
    def getFlag8(self, **kwargs: Any): ...
    def getFlag9(self, **kwargs: Any): ...
    def getHasCameraSet(self, **kwargs: Any): ...
    def getHasStereoCamera(self, **kwargs: Any): ...
    def getImagePlaneVisibility(self, **kwargs: Any): ...
    def getLinkAudio(self, **kwargs: Any): ...
    def getLock(self, **kwargs: Any): ...
    def getMute(self, **kwargs: Any): ...
    def getPaste(self, **kwargs: Any): ...
    def getPasteInstance(self, **kwargs: Any): ...
    def getPostHoldTime(self, **kwargs: Any): ...
    def getPreHoldTime(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getSelfmute(self, **kwargs: Any): ...
    def getSequenceDuration(self, **kwargs: Any): ...
    def getSequenceEndTime(self, **kwargs: Any): ...
    def getSequenceStartTime(self, **kwargs: Any): ...
    def getShotName(self, **kwargs: Any): ...
    def getSourceDuration(self, **kwargs: Any): ...
    def getStartTime(self, **kwargs: Any): ...
    def getTrack(self, **kwargs: Any): ...
    def getTransitionInLength(self, **kwargs: Any): ...
    def getTransitionInType(self, **kwargs: Any): ...
    def getTransitionOutLength(self, **kwargs: Any): ...
    def getTransitionOutType(self, **kwargs: Any): ...
    def getUnlinkAudio(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setAudio(self, val: bool = ..., **kwargs: Any): ...
    def setClip(self, val: bool = ..., **kwargs: Any): ...
    def setClipDuration(self, val: bool = ..., **kwargs: Any): ...
    def setClipOpacity(self, val: bool = ..., **kwargs: Any): ...
    def setClipSyncState(self, val: bool = ..., **kwargs: Any): ...
    def setClipZeroOffset(self, val: bool = ..., **kwargs: Any): ...
    def setCopy(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentCamera(self, val: bool = ..., **kwargs: Any): ...
    def setDetermineTrack(self, val: bool = ..., **kwargs: Any): ...
    def setEndTime(self, val: bool = ..., **kwargs: Any): ...
    def setFavorite(self, val: bool = ..., **kwargs: Any): ...
    def setFlag1(self, val: bool = ..., **kwargs: Any): ...
    def setFlag10(self, val: bool = ..., **kwargs: Any): ...
    def setFlag11(self, val: bool = ..., **kwargs: Any): ...
    def setFlag12(self, val: bool = ..., **kwargs: Any): ...
    def setFlag2(self, val: bool = ..., **kwargs: Any): ...
    def setFlag3(self, val: bool = ..., **kwargs: Any): ...
    def setFlag4(self, val: bool = ..., **kwargs: Any): ...
    def setFlag5(self, val: bool = ..., **kwargs: Any): ...
    def setFlag6(self, val: bool = ..., **kwargs: Any): ...
    def setFlag7(self, val: bool = ..., **kwargs: Any): ...
    def setFlag8(self, val: bool = ..., **kwargs: Any): ...
    def setFlag9(self, val: bool = ..., **kwargs: Any): ...
    def setHasCameraSet(self, val: bool = ..., **kwargs: Any): ...
    def setHasStereoCamera(self, val: bool = ..., **kwargs: Any): ...
    def setImagePlaneVisibility(self, val: bool = ..., **kwargs: Any): ...
    def setLinkAudio(self, val: bool = ..., **kwargs: Any): ...
    def setLock(self, val: bool = ..., **kwargs: Any): ...
    def setMute(self, val: bool = ..., **kwargs: Any): ...
    def setPaste(self, val: bool = ..., **kwargs: Any): ...
    def setPasteInstance(self, val: bool = ..., **kwargs: Any): ...
    def setPostHoldTime(self, val: bool = ..., **kwargs: Any): ...
    def setPreHoldTime(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setSelfmute(self, val: bool = ..., **kwargs: Any): ...
    def setSequenceDuration(self, val: bool = ..., **kwargs: Any): ...
    def setSequenceEndTime(self, val: bool = ..., **kwargs: Any): ...
    def setSequenceStartTime(self, val: bool = ..., **kwargs: Any): ...
    def setShotName(self, val: bool = ..., **kwargs: Any): ...
    def setSourceDuration(self, val: bool = ..., **kwargs: Any): ...
    def setStartTime(self, val: bool = ..., **kwargs: Any): ...
    def setTrack(self, val: bool = ..., **kwargs: Any): ...
    def setTransitionInLength(self, val: bool = ..., **kwargs: Any): ...
    def setTransitionInType(self, val: bool = ..., **kwargs: Any): ...
    def setTransitionOutLength(self, val: bool = ..., **kwargs: Any): ...
    def setTransitionOutType(self, val: bool = ..., **kwargs: Any): ...
    def setUnlinkAudio(self, val: bool = ..., **kwargs: Any): ...

class SimpleTestNode(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SimpleVolumeShader(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SkinBinding(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Snapshot(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def getConstructionHistory(self, **kwargs: Any): ...
    def getEndTime(self, **kwargs: Any): ...
    def getIncrement(self, **kwargs: Any): ...
    def getStartTime(self, **kwargs: Any): ...
    def getUpdate(self, **kwargs: Any): ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...
    def setEndTime(self, val: bool = ..., **kwargs: Any): ...
    def setIncrement(self, val: bool = ..., **kwargs: Any): ...
    def setStartTime(self, val: bool = ..., **kwargs: Any): ...
    def setUpdate(self, val: bool = ..., **kwargs: Any): ...

class MotionTrail(Snapshot):
    __melnode__: str = ...

class StrokeGlobals(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SubdBase(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SubdModifier(SubdBase):
    __melnode__: str = ...

class SubdAddTopology(SubdModifier):
    __melnode__: str = ...

class SubdCleanTopology(SubdModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...

class SubdMapCut(SubdModifier):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...

class SubdModifierWorld(SubdModifier):
    __melnode__: str = ...

class SubdModifierUV(SubdModifierWorld):
    __melnode__: str = ...

class SubdAutoProj(SubdModifierUV):
    __melnode__: str = ...

class SubdLayoutUV(SubdModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getFlipReversed(self, **kwargs: Any): ...
    def getLayout(self, **kwargs: Any): ...
    def getLayoutMethod(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getPercentageSpace(self, **kwargs: Any): ...
    def getRotateForBestFit(self, **kwargs: Any): ...
    def getScale(self, **kwargs: Any): ...
    def getSeparate(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setFlipReversed(self, val: bool = ..., **kwargs: Any): ...
    def setLayout(self, val: bool = ..., **kwargs: Any): ...
    def setLayoutMethod(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setPercentageSpace(self, val: bool = ..., **kwargs: Any): ...
    def setRotateForBestFit(self, val: bool = ..., **kwargs: Any): ...
    def setScale(self, val: bool = ..., **kwargs: Any): ...
    def setSeparate(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class SubdMapSewMove(SubdModifierUV):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getCaching(self, **kwargs: Any): ...
    def getLimitPieceSize(self, **kwargs: Any): ...
    def getNodeState(self, **kwargs: Any): ...
    def getNumberFaces(self, **kwargs: Any): ...
    def getWorldSpace(self, **kwargs: Any): ...
    def setCaching(self, val: bool = ..., **kwargs: Any): ...
    def setLimitPieceSize(self, val: bool = ..., **kwargs: Any): ...
    def setNodeState(self, val: bool = ..., **kwargs: Any): ...
    def setNumberFaces(self, val: bool = ..., **kwargs: Any): ...
    def setWorldSpace(self, val: bool = ..., **kwargs: Any): ...

class SubdPlanarProj(SubdModifierWorld):
    __melnode__: str = ...

class SubdTweak(SubdModifier):
    __melnode__: str = ...

class SubdTweakUV(SubdModifier):
    __melnode__: str = ...

class SubdivCollapse(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SubdivComponentId(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SubdivReverseFaces(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SubdivToPoly(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SurfaceLuminance(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class SurfaceShader(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TexLattice(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TextureToGeom(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class ThreadedDevice(DependNode):
    __melnode__: str = ...

class ClientDevice(ThreadedDevice):
    __melnode__: str = ...

class Time(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TimeEditor(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def getMute(self, **kwargs: Any): ...

class TimeEditorAnimSource(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addSource(self, val: bool = ..., **kwargs: Any): ...
    def apply(self, val: bool = ..., **kwargs: Any): ...
    def bakeToAnimSource(self, val: bool = ..., **kwargs: Any): ...
    def copyAnimation(self, val: bool = ..., **kwargs: Any): ...
    def exclusive(self, val: bool = ..., **kwargs: Any): ...
    def export(self, val: bool = ..., **kwargs: Any): ...
    def getAddObjects(self, **kwargs: Any): ...
    def getAddRelatedKG(self, **kwargs: Any): ...
    def getAddSelectedObjects(self, **kwargs: Any): ...
    def getCalculateTiming(self, **kwargs: Any): ...
    def getDrivenClips(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getTargetIndex(self, **kwargs: Any): ...
    def getTargets(self, **kwargs: Any): ...
    def getType(self, **kwargs: Any): ...
    def importOption(self, val: bool = ..., **kwargs: Any): ...
    def importPopulateOption(self, val: bool = ..., **kwargs: Any): ...
    def includeRoot(self, val: bool = ..., **kwargs: Any): ...
    def populateAttribute(self, val: bool = ..., **kwargs: Any): ...
    def recursively(self, val: bool = ..., **kwargs: Any): ...
    def removeSceneAnimation(self, val: bool = ..., **kwargs: Any): ...
    def removeSource(self, val: bool = ..., **kwargs: Any): ...
    def setAddObjects(self, val: bool = ..., **kwargs: Any): ...
    def setAddRelatedKG(self, val: bool = ..., **kwargs: Any): ...
    def setAddSelectedObjects(self, val: bool = ..., **kwargs: Any): ...
    def setCalculateTiming(self, val: bool = ..., **kwargs: Any): ...
    def setType(self, val: bool = ..., **kwargs: Any): ...

class TimeEditorClipBase(DependNode):
    __melnode__: str = ...

class TimeEditorClip(TimeEditorClipBase):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addClipAttribute(self, val: bool = ..., **kwargs: Any): ...
    def allowShrinking(self, val: bool = ..., **kwargs: Any): ...
    def clipId(self, val: bool = ..., **kwargs: Any): ...
    def copyClip(self, val: bool = ..., **kwargs: Any): ...
    def duplicateClip(self, val: bool = ..., **kwargs: Any): ...
    def exclusive(self, val: bool = ..., **kwargs: Any): ...
    def existingOnly(self, val: bool = ..., **kwargs: Any): ...
    def explode(self, val: bool = ..., **kwargs: Any): ...
    def exportAllClips(self, val: bool = ..., **kwargs: Any): ...
    def exportFbx(self, val: bool = ..., **kwargs: Any): ...
    def extend(self, val: bool = ..., **kwargs: Any): ...
    def extendParent(self, val: bool = ..., **kwargs: Any): ...
    def getAbsolute(self, **kwargs: Any): ...
    def getAddObjects(self, **kwargs: Any): ...
    def getAddRelatedKG(self, **kwargs: Any): ...
    def getAddSelectedObjects(self, **kwargs: Any): ...
    def getAnimSource(self, **kwargs: Any): ...
    def getChildren(self, **kwargs: Any): ...
    def getClipAfter(self, **kwargs: Any): ...
    def getClipBefore(self, **kwargs: Any): ...
    def getClipDataType(self, **kwargs: Any): ...
    def getClipIdFromNodeName(self, **kwargs: Any): ...
    def getClipIdFromPath(self, **kwargs: Any): ...
    def getClipNode(self, **kwargs: Any): ...
    def getClipPath(self, **kwargs: Any): ...
    def getCrossfadeMode(self, **kwargs: Any): ...
    def getCrossfadePlug(self, **kwargs: Any): ...
    def getCurveTime(self, **kwargs: Any): ...
    def getDefaultGhostRoot(self, **kwargs: Any): ...
    def getDrivenAttributes(self, **kwargs: Any): ...
    def getDrivenClipsBySource(self, **kwargs: Any): ...
    def getDrivenObjects(self, **kwargs: Any): ...
    def getDrivenRootObjects(self, **kwargs: Any): ...
    def getDrivingSources(self, **kwargs: Any): ...
    def getDuration(self, **kwargs: Any): ...
    def getEndTime(self, **kwargs: Any): ...
    def getExists(self, **kwargs: Any): ...
    def getGhost(self, **kwargs: Any): ...
    def getHoldEnd(self, **kwargs: Any): ...
    def getHoldStart(self, **kwargs: Any): ...
    def getIsContainer(self, **kwargs: Any): ...
    def getListUserGhostRoot(self, **kwargs: Any): ...
    def getLoopEnd(self, **kwargs: Any): ...
    def getLoopStart(self, **kwargs: Any): ...
    def getMinClipDuration(self, **kwargs: Any): ...
    def getMute(self, **kwargs: Any): ...
    def getParentClipId(self, **kwargs: Any): ...
    def getParentGroupId(self, **kwargs: Any): ...
    def getRemappedSourceAttrs(self, **kwargs: Any): ...
    def getRemappedTargetAttrs(self, **kwargs: Any): ...
    def getRemoveWeightCurve(self, **kwargs: Any): ...
    def getSpeedRamping(self, **kwargs: Any): ...
    def getStartTime(self, **kwargs: Any): ...
    def getTimeWarp(self, **kwargs: Any): ...
    def getTimeWarpCurve(self, **kwargs: Any): ...
    def getTimeWarpType(self, **kwargs: Any): ...
    def getTrack(self, **kwargs: Any): ...
    def getTracksNode(self, **kwargs: Any): ...
    def getTruncated(self, **kwargs: Any): ...
    def getType(self, **kwargs: Any): ...
    def getUserGhostRoot(self, **kwargs: Any): ...
    def getWeightCurve(self, **kwargs: Any): ...
    def ghostRootAdd(self, val: bool = ..., **kwargs: Any): ...
    def ghostRootRemove(self, val: bool = ..., **kwargs: Any): ...
    def importOption(self, val: bool = ..., **kwargs: Any): ...
    def importPopulateOption(self, val: bool = ..., **kwargs: Any): ...
    def includeRoot(self, val: bool = ..., **kwargs: Any): ...
    def modifyAnimSource(self, val: bool = ..., **kwargs: Any): ...
    def moveClip(self, val: bool = ..., **kwargs: Any): ...
    def parent(self, val: bool = ..., **kwargs: Any): ...
    def pasteClip(self, val: bool = ..., **kwargs: Any): ...
    def path(self, val: bool = ..., **kwargs: Any): ...
    def populateAttribute(self, val: bool = ..., **kwargs: Any): ...
    def razorClip(self, val: bool = ..., **kwargs: Any): ...
    def recursively(self, val: bool = ..., **kwargs: Any): ...
    def remap(self, val: bool = ..., **kwargs: Any): ...
    def remapSource(self, val: bool = ..., **kwargs: Any): ...
    def removeClip(self, val: bool = ..., **kwargs: Any): ...
    def removeClipAttribute(self, val: bool = ..., **kwargs: Any): ...
    def removeCrossfade(self, val: bool = ..., **kwargs: Any): ...
    def removeSceneAnimation(self, val: bool = ..., **kwargs: Any): ...
    def resetTiming(self, val: bool = ..., **kwargs: Any): ...
    def resetTransition(self, val: bool = ..., **kwargs: Any): ...
    def ripple(self, val: bool = ..., **kwargs: Any): ...
    def rootClipId(self, val: bool = ..., **kwargs: Any): ...
    def rootPath(self, val: bool = ..., **kwargs: Any): ...
    def scaleEnd(self, val: bool = ..., **kwargs: Any): ...
    def scalePivot(self, val: bool = ..., **kwargs: Any): ...
    def scaleStart(self, val: bool = ..., **kwargs: Any): ...
    def setAddObjects(self, val: bool = ..., **kwargs: Any): ...
    def setAddRelatedKG(self, val: bool = ..., **kwargs: Any): ...
    def setAddSelectedObjects(self, val: bool = ..., **kwargs: Any): ...
    def setAnimSource(self, val: bool = ..., **kwargs: Any): ...
    def setCrossfadeMode(self, val: bool = ..., **kwargs: Any): ...
    def setDefaultGhostRoot(self, val: bool = ..., **kwargs: Any): ...
    def setGhost(self, val: bool = ..., **kwargs: Any): ...
    def setHoldEnd(self, val: bool = ..., **kwargs: Any): ...
    def setHoldStart(self, val: bool = ..., **kwargs: Any): ...
    def setKeyframe(self, val: bool = ..., **kwargs: Any): ...
    def setLoopEnd(self, val: bool = ..., **kwargs: Any): ...
    def setLoopStart(self, val: bool = ..., **kwargs: Any): ...
    def setMute(self, val: bool = ..., **kwargs: Any): ...
    def setRemoveWeightCurve(self, val: bool = ..., **kwargs: Any): ...
    def setSpeedRamping(self, val: bool = ..., **kwargs: Any): ...
    def setTimeWarpType(self, val: bool = ..., **kwargs: Any): ...
    def setTrack(self, val: bool = ..., **kwargs: Any): ...
    def setType(self, val: bool = ..., **kwargs: Any): ...
    def setUserGhostRoot(self, val: bool = ..., **kwargs: Any): ...
    def setWeightCurve(self, val: bool = ..., **kwargs: Any): ...
    def transition(self, val: bool = ..., **kwargs: Any): ...
    def trimEnd(self, val: bool = ..., **kwargs: Any): ...
    def trimStart(self, val: bool = ..., **kwargs: Any): ...
    def uniqueAnimSource(self, val: bool = ..., **kwargs: Any): ...
    def zeroKeying(self, val: bool = ..., **kwargs: Any): ...

class TimeEditorClipEvaluator(DependNode):
    __melnode__: str = ...

class TimeEditorInterpolator(DependNode):
    __melnode__: str = ...

class TimeEditorTracks(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def addTrack(self, val: bool = ..., **kwargs: Any): ...
    def getActiveClipWeight(self, **kwargs: Any): ...
    def getActiveClipWeightId(self, **kwargs: Any): ...
    def getAllClips(self, **kwargs: Any): ...
    def getAllTracks(self, **kwargs: Any): ...
    def getAllTracksRecursive(self, **kwargs: Any): ...
    def getComposition(self, **kwargs: Any): ...
    def getPlugIndex(self, **kwargs: Any): ...
    def getSelectedTracks(self, **kwargs: Any): ...
    def getTrackGhost(self, **kwargs: Any): ...
    def getTrackIndex(self, **kwargs: Any): ...
    def getTrackMuted(self, **kwargs: Any): ...
    def getTrackName(self, **kwargs: Any): ...
    def getTrackSolo(self, **kwargs: Any): ...
    def getTrackType(self, **kwargs: Any): ...
    def path(self, val: bool = ..., **kwargs: Any): ...
    def removeTrack(self, val: bool = ..., **kwargs: Any): ...
    def removeTrackByPath(self, val: bool = ..., **kwargs: Any): ...
    def reorderTrack(self, val: bool = ..., **kwargs: Any): ...
    def setPlugIndex(self, val: bool = ..., **kwargs: Any): ...
    def setTrackGhost(self, val: bool = ..., **kwargs: Any): ...
    def setTrackIndex(self, val: bool = ..., **kwargs: Any): ...
    def setTrackMuted(self, val: bool = ..., **kwargs: Any): ...
    def setTrackName(self, val: bool = ..., **kwargs: Any): ...
    def setTrackSolo(self, val: bool = ..., **kwargs: Any): ...
    def setTrackType(self, val: bool = ..., **kwargs: Any): ...

class TimeFunction(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TimeToUnitConversion(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TimeWarp(DependNode):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melnode__: str = ...
    def deleteFrame(self, val: bool = ..., **kwargs: Any): ...
    def getFrame(self, **kwargs: Any): ...
    def getG(self, **kwargs: Any): ...
    def getInterpType(self, **kwargs: Any): ...
    def getMoveFrame(self, **kwargs: Any): ...
    def setFrame(self, val: bool = ..., **kwargs: Any): ...
    def setG(self, val: bool = ..., **kwargs: Any): ...
    def setInterpType(self, val: bool = ..., **kwargs: Any): ...
    def setMoveFrame(self, val: bool = ..., **kwargs: Any): ...

class ToonLineAttributes(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class TrackInfoManager(DependNode):
    __melnode__: str = ...

class TransferFalloff(DependNode):
    __melnode__: str = ...

class UniformFalloff(DependNode):
    __melnode__: str = ...

class UnitConversion(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class UnitToTimeConversion(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class Unknown(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class UvChooser(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class UvPin(DependNode):
    __melnode__: str = ...

class ViewColorManager(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class VolumeShader(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

class WtAddMatrix(DependNode):
    __melnode__: str = ...
    def findAlias(self, alias: str) -> Tuple[bool, general.PyNode]: ...
    def getAffectedAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAffectedByAttributes(self, attr: general.PyNode) -> List[general.PyNode]: ...
    def getAliasList(self) -> Tuple[bool, List[str]]: ...
    def getConnections(self) -> List[general.Attribute]: ...
    def plugsAlias(self, plug: general.Attribute) -> str: ...
    def setAlias(self, alias: str, name: str, plug: general.Attribute, add: bool=...) -> bool: ...

dynModule: Any
