from typing import *
from builtins import str
from pymel.core import animation as animation, effects as effects, general as general, modeling as modeling, other as other, rendering as rendering, system as system, windows as windows
from typing import Any, Optional

mayaTypeNameToPymelTypeName: Any
pymelTypeNameToMayaTypeName: Any

def toPyQtObject(mayaName: Any): ...
def toPyQtControl(mayaName: Any): ...
def toPyQtLayout(mayaName: Any): ...
def toPyQtWindow(mayaName: Any): ...
def toPyQtMenuItem(mayaName: Any): ...
def pysideWrapInstance(ptr: Any, base: Optional[Any] = ...): ...
def toPySideObject(mayaName: Any): ...
def toPySideControl(mayaName: Any): ...
def toPySideLayout(mayaName: Any): ...
def toPySideWindow(mayaName: Any): ...
def toPySideMenuItem(mayaName: Any): ...

pyQtAvailable: bool
pySideAvailable: bool
qtBinding: str
toQtObject = toPyQtObject
toQtControl = toPyQtControl
toQtLayout = toPyQtLayout
toQtWindow = toPyQtWindow
toQtMenuItem = toPyQtMenuItem
toQtObject = toPySideObject
toQtControl = toPySideControl
toQtLayout = toPySideLayout
toQtWindow = toPySideWindow
toQtMenuItem = toPySideMenuItem

def objectTypeUI(name: Any, **kwargs: Any): ...

class PyUI(str):
    __melui__: Any = ...
    def __new__(cls, name: Optional[Any] = ..., create: bool = ..., **kwargs: Any): ...
    def parent(self) -> PyUI: ...
    getParent: Any = ...
    def shortName(self) -> str: ...
    def name(self) -> str: ...
    def window(self) -> Window: ...
    delete: Any = ...
    rename: Any = ...
    type: Any = ...
    @classmethod
    def exists(cls, name: Any): ...
    asQtObject: Any = ...

class Panel(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class PyUIContainer(PyUI):
    def __enter__(self): ...
    def __exit__(self, type: Any, value: Any, traceback: Any) -> None: ...
    def walkChildren(self) -> Iterator[PyUI]: ...
    def findChild(self, shortName: str, recurse: bool=...) -> Optional[PyUI]: ...
    def addChild(self, uiType: Any, name: Optional[Any] = ..., **kwargs: Any): ...
    def makeDefault(self) -> None: ...
    def pop(self): ...

class Layout(PyUIContainer):
    def children(self) -> List[PyUI]: ...
    getChildren: Any = ...
    def clear(self) -> None: ...
    asQtObject: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class Window(PyUIContainer):
    def __exit__(self, type: Any, value: Any, traceback: Any) -> None: ...
    def show(self) -> None: ...
    def delete(self) -> None: ...
    def layout(self): ...
    def children(self): ...
    getChildren: Any = ...
    def window(self): ...
    def parent(self) -> None: ...
    getParent: Any = ...
    asQtObject: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def backgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def closeCommand(self, val: bool = ..., **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDockingLayout(self, **kwargs: Any): ...
    def getFrontWindow(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getIconName(self, **kwargs: Any): ...
    def getIconify(self, **kwargs: Any): ...
    def getLeftEdge(self, **kwargs: Any): ...
    def getMainMenuBar(self, **kwargs: Any): ...
    def getMainWindow(self, **kwargs: Any): ...
    def getMaximizeButton(self, **kwargs: Any): ...
    def getMenuArray(self, **kwargs: Any): ...
    def getMenuBar(self, **kwargs: Any): ...
    def getMenuBarCornerWidget(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getMinimizeButton(self, **kwargs: Any): ...
    def getNumberOfMenus(self, **kwargs: Any): ...
    def getResizeToFitChildren(self, **kwargs: Any): ...
    def getSizeable(self, **kwargs: Any): ...
    def getState(self, **kwargs: Any): ...
    def getTitle(self, **kwargs: Any): ...
    def getTitleBar(self, **kwargs: Any): ...
    def getTitleBarMenu(self, **kwargs: Any): ...
    def getToolbox(self, **kwargs: Any): ...
    def getTopEdge(self, **kwargs: Any): ...
    def getTopLeftCorner(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def getWidthHeight(self, **kwargs: Any): ...
    def menuBarResize(self, val: bool = ..., **kwargs: Any): ...
    def menuIndex(self, val: bool = ..., **kwargs: Any): ...
    def minimizeCommand(self, val: bool = ..., **kwargs: Any): ...
    def restoreCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDockingLayout(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setIconName(self, val: bool = ..., **kwargs: Any): ...
    def setIconify(self, val: bool = ..., **kwargs: Any): ...
    def setLeftEdge(self, val: bool = ..., **kwargs: Any): ...
    def setMainMenuBar(self, val: bool = ..., **kwargs: Any): ...
    def setMainWindow(self, val: bool = ..., **kwargs: Any): ...
    def setMaximizeButton(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarCornerWidget(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setMinimizeButton(self, val: bool = ..., **kwargs: Any): ...
    def setResizeToFitChildren(self, val: bool = ..., **kwargs: Any): ...
    def setSizeable(self, val: bool = ..., **kwargs: Any): ...
    def setState(self, val: bool = ..., **kwargs: Any): ...
    def setTitle(self, val: bool = ..., **kwargs: Any): ...
    def setTitleBar(self, val: bool = ..., **kwargs: Any): ...
    def setTitleBarMenu(self, val: bool = ..., **kwargs: Any): ...
    def setToolbox(self, val: bool = ..., **kwargs: Any): ...
    def setTopEdge(self, val: bool = ..., **kwargs: Any): ...
    def setTopLeftCorner(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def setWidthHeight(self, val: bool = ..., **kwargs: Any): ...

class FormLayout(Layout):
    def __new__(cls, name: Optional[Any] = ..., **kwargs: Any): ...
    def __init__(self, name: Optional[Any] = ..., orientation: str = ..., spacing: int = ..., reversed: bool = ..., ratios: Optional[Any] = ..., **kwargs: Any) -> None: ...
    def attachForm(self, *args: Any) -> None: ...
    def attachControl(self, *args: Any) -> None: ...
    def attachNone(self, *args: Any) -> None: ...
    def attachPosition(self, *args: Any) -> None: ...
    HORIZONTAL: int = ...
    VERTICAL: int = ...
    Orientation: Any = ...
    def flip(self) -> None: ...
    def reverse(self) -> None: ...
    def reset(self) -> None: ...
    def redistribute(self, *ratios: Any) -> None: ...
    def vDistribute(self, *ratios: Any) -> None: ...
    def hDistribute(self, *ratios: Any) -> None: ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def attachOppositeControl(self, val: bool = ..., **kwargs: Any): ...
    def attachOppositeForm(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfDivisions(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfDivisions(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class AutoLayout(FormLayout):
    def __exit__(self, type: Any, value: Any, traceback: Any) -> None: ...

class RowLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfColumns(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class TextScrollList(PyUI):
    def extend(self, appendList: Any) -> None: ...
    def selectIndexedItems(self, selectList: Any) -> None: ...
    def removeIndexedItems(self, removeList: Any) -> None: ...
    def selectAll(self) -> None: ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def append(self, val: bool = ..., **kwargs: Any): ...
    def appendPosition(self, val: bool = ..., **kwargs: Any): ...
    def deleteKeyCommand(self, val: bool = ..., **kwargs: Any): ...
    def deselectAll(self, val: bool = ..., **kwargs: Any): ...
    def deselectIndexedItem(self, val: bool = ..., **kwargs: Any): ...
    def deselectItem(self, val: bool = ..., **kwargs: Any): ...
    def doubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAllItems(self, **kwargs: Any): ...
    def getAllowAutomaticSelection(self, **kwargs: Any): ...
    def getAllowMultiSelection(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfItems(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getNumberOfRows(self, **kwargs: Any): ...
    def getNumberOfSelectedItems(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelectIndexedItem(self, **kwargs: Any): ...
    def getSelectItem(self, **kwargs: Any): ...
    def getSelectUniqueTagItem(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def lineFont(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def removeAll(self, val: bool = ..., **kwargs: Any): ...
    def removeIndexedItem(self, val: bool = ..., **kwargs: Any): ...
    def removeItem(self, val: bool = ..., **kwargs: Any): ...
    def selectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAllowAutomaticSelection(self, val: bool = ..., **kwargs: Any): ...
    def setAllowMultiSelection(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfRows(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSelectIndexedItem(self, val: bool = ..., **kwargs: Any): ...
    def setSelectItem(self, val: bool = ..., **kwargs: Any): ...
    def setSelectUniqueTagItem(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def showIndexedItem(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def uniqueTag(self, val: bool = ..., **kwargs: Any): ...

class Menu(PyUI):
    def __enter__(self): ...
    def __exit__(self, type: Any, value: Any, traceback: Any) -> None: ...
    def getItemArray(self): ...
    def makeDefault(self) -> None: ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def deleteAllItems(self, val: bool = ..., **kwargs: Any): ...
    def getAllowOptionBoxes(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getFamilyImage(self, **kwargs: Any): ...
    def getHelpMenu(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getMnemonic(self, **kwargs: Any): ...
    def getNumberOfItems(self, **kwargs: Any): ...
    def getPostMenuCommandOnce(self, **kwargs: Any): ...
    def getScrollable(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def postMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setFamilyImage(self, val: bool = ..., **kwargs: Any): ...
    def setHelpMenu(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setMnemonic(self, val: bool = ..., **kwargs: Any): ...
    def setPostMenuCommandOnce(self, val: bool = ..., **kwargs: Any): ...
    def setScrollable(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...

class PopupMenu(Menu):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def deleteAllItems(self, val: bool = ..., **kwargs: Any): ...
    def getAllowOptionBoxes(self, **kwargs: Any): ...
    def getAltModifier(self, **kwargs: Any): ...
    def getButton(self, **kwargs: Any): ...
    def getCtrlModifier(self, **kwargs: Any): ...
    def getMarkingMenu(self, **kwargs: Any): ...
    def getNumberOfItems(self, **kwargs: Any): ...
    def getPostMenuCommandOnce(self, **kwargs: Any): ...
    def getShiftModifier(self, **kwargs: Any): ...
    def postMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAltModifier(self, val: bool = ..., **kwargs: Any): ...
    def setButton(self, val: bool = ..., **kwargs: Any): ...
    def setCtrlModifier(self, val: bool = ..., **kwargs: Any): ...
    def setMarkingMenu(self, val: bool = ..., **kwargs: Any): ...
    def setPostMenuCommandOnce(self, val: bool = ..., **kwargs: Any): ...
    def setShiftModifier(self, val: bool = ..., **kwargs: Any): ...

class OptionMenu(PopupMenu):
    def addMenuItems(self, items: Any, title: Optional[Any] = ...) -> None: ...
    def clear(self) -> None: ...
    addItems: Any = ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def beforeShowPopup(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def deleteAllItems(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlwaysCallChangeCommand(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getItemListLong(self, **kwargs: Any): ...
    def getItemListShort(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxVisibleItems(self, **kwargs: Any): ...
    def getNumberOfItems(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPostMenuCommandOnce(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def postMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxVisibleItems(self, val: bool = ..., **kwargs: Any): ...
    def setPostMenuCommandOnce(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class OptionMenuGrp(RowLayout):
    def menu(self): ...
    def __enter__(self): ...
    def __exit__(self, type: Any, value: Any, traceback: Any): ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def deleteAllItems(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getItemListLong(self, **kwargs: Any): ...
    def getItemListShort(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfItems(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPostMenuCommandOnce(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def postMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPostMenuCommandOnce(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class SubMenuItem(Menu):
    def getBoldFont(self): ...
    def getItalicized(self): ...
    asQtObject: Any = ...

class CommandMenuItem(PyUI):
    __melui__: str = ...
    def __enter__(self): ...
    def __exit__(self, type: Any, value: Any, traceback: Any): ...
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    def getAllowOptionBoxes(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBoldFont(self, **kwargs: Any): ...
    def getCheckBox(self, **kwargs: Any): ...
    def getCollection(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getData(self, **kwargs: Any): ...
    def getDivider(self, **kwargs: Any): ...
    def getDividerLabel(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDragDoubleClickCommand(self, **kwargs: Any): ...
    def getDragMenuCommand(self, **kwargs: Any): ...
    def getEchoCommand(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableCommandRepeat(self, **kwargs: Any): ...
    def getFamilyImage(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsCheckBox(self, **kwargs: Any): ...
    def getIsOptionBox(self, **kwargs: Any): ...
    def getIsRadioButton(self, **kwargs: Any): ...
    def getItalicized(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLongDivider(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getOptionBox(self, **kwargs: Any): ...
    def getOptionBoxIcon(self, **kwargs: Any): ...
    def getPostMenuCommand(self, **kwargs: Any): ...
    def getPostMenuCommandOnce(self, **kwargs: Any): ...
    def getRadialPosition(self, **kwargs: Any): ...
    def getRadioButton(self, **kwargs: Any): ...
    def getSourceType(self, **kwargs: Any): ...
    def getSubMenu(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def runTimeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setCheckBox(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setData(self, val: bool = ..., **kwargs: Any): ...
    def setDividerLabel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDragDoubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDragMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def setEchoCommand(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableCommandRepeat(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLongDivider(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setOptionBoxIcon(self, val: bool = ..., **kwargs: Any): ...
    def setPostMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def setPostMenuCommandOnce(self, val: bool = ..., **kwargs: Any): ...
    def setRadialPosition(self, val: bool = ..., **kwargs: Any): ...
    def setRadioButton(self, val: bool = ..., **kwargs: Any): ...
    def setSourceType(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...

def MenuItem(name: Optional[Any] = ..., create: bool = ..., **kwargs: Any): ...

class UITemplate:
    def __init__(self, name: Optional[Any] = ..., force: bool = ...) -> None: ...
    def __enter__(self): ...
    def __exit__(self, type: Any, value: Any, traceback: Any) -> None: ...
    def name(self): ...
    def push(self) -> None: ...
    def pop(self) -> None: ...
    def define(self, uiType: Any, **kwargs: Any) -> None: ...
    @staticmethod
    def exists(name: Any): ...

class AELoader(type):
    def __new__(cls, classname: Any, bases: Any, classdict: Any): ...
    @staticmethod
    def makeAEProc(modname: Any, classname: Any, procname: Any) -> None: ...
    @staticmethod
    def load(modname: Any, classname: Any, nodename: Any) -> None: ...
    @classmethod
    def loadedTemplates(cls): ...

class AETemplate:
    def __init__(self, nodeName: Any) -> None: ...
    @property
    def nodeName(self): ...
    @classmethod
    def nodeType(cls): ...
    @classmethod
    def controlValue(cls, nodeName: Any, control: Any): ...
    @classmethod
    def controlLabel(cls, nodeName: Any, control: Any): ...
    @classmethod
    def reload(cls) -> None: ...
    def addControl(self, control: Any, label: Optional[Any] = ..., changeCommand: Optional[Any] = ..., annotation: Optional[Any] = ..., preventOverride: bool = ..., dynamic: bool = ...) -> None: ...
    def callCustom(self, newFunc: Any, replaceFunc: Any, *attrs: Any) -> None: ...
    def suppress(self, control: Any) -> None: ...
    def dimControl(self, nodeName: Any, control: Any, state: Any) -> None: ...
    def beginLayout(self, name: Any, collapse: bool = ...) -> None: ...
    def endLayout(self) -> None: ...
    def beginScrollLayout(self) -> None: ...
    def endScrollLayout(self) -> None: ...
    def beginNoOptimize(self) -> None: ...
    def endNoOptimize(self) -> None: ...
    def interruptOptimize(self) -> None: ...
    def addSeparator(self) -> None: ...
    def addComponents(self) -> None: ...
    def addExtraControls(self, label: Optional[Any] = ...) -> None: ...

class FloatFieldGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnable1(self, **kwargs: Any): ...
    def getEnable2(self, **kwargs: Any): ...
    def getEnable3(self, **kwargs: Any): ...
    def getEnable4(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getValue1(self, **kwargs: Any): ...
    def getValue2(self, **kwargs: Any): ...
    def getValue3(self, **kwargs: Any): ...
    def getValue4(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def precision(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable1(self, val: bool = ..., **kwargs: Any): ...
    def setEnable2(self, val: bool = ..., **kwargs: Any): ...
    def setEnable3(self, val: bool = ..., **kwargs: Any): ...
    def setEnable4(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setValue1(self, val: bool = ..., **kwargs: Any): ...
    def setValue2(self, val: bool = ..., **kwargs: Any): ...
    def setValue3(self, val: bool = ..., **kwargs: Any): ...
    def setValue4(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def showTrailingZeros(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class TextFieldButtonGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def buttonCommand(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def forceChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getButtonLabel(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableButton(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFileName(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getInsertionPosition(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPlaceholderText(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def insertText(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setButtonLabel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableButton(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFileName(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setInsertionPosition(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPlaceholderText(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def textChangedCommand(self, val: bool = ..., **kwargs: Any): ...

class ProgressBar(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def beginProgress(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def endProgress(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsCancelled(self, **kwargs: Any): ...
    def getIsInterruptable(self, **kwargs: Any): ...
    def getIsMainProgressBar(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getProgress(self, **kwargs: Any): ...
    def getStatus(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setIsInterruptable(self, val: bool = ..., **kwargs: Any): ...
    def setIsMainProgressBar(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setProgress(self, val: bool = ..., **kwargs: Any): ...
    def setStatus(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def step(self, val: bool = ..., **kwargs: Any): ...

class MainProgressBar(ProgressBar):
    def __new__(cls, minValue: int=..., maxValue: int=..., interruptable: bool=...) -> MainProgressBar: ...
    def __enter__(self): ...
    def __exit__(self, *args: Any) -> None: ...

class VectorFieldGrp(FloatFieldGrp):
    def __new__(cls, name: Optional[Any] = ..., create: bool = ..., *args: Any, **kwargs: Any): ...
    def getVector(self): ...
    def setVector(self, vec: Any) -> None: ...

class PathButtonGrp(TextFieldButtonGrp):
    PROMPT_FUNCTION: str = ...
    def __new__(cls, name: Optional[Any] = ..., create: bool = ..., *args: Any, **kwargs: Any): ...
    def setPath(self, path: Any, **kwargs: Any) -> None: ...
    def getPath(self): ...

class FolderButtonGrp(PathButtonGrp):
    PROMPT_FUNCTION: str = ...

class AnimCurveEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def denormalizeCurvesCommand(self, val: bool = ..., **kwargs: Any): ...
    def displayActiveKeyTangents(self, val: bool = ..., **kwargs: Any): ...
    def displayActiveKeys(self, val: bool = ..., **kwargs: Any): ...
    def displayInfinities(self, val: bool = ..., **kwargs: Any): ...
    def displayKeys(self, val: bool = ..., **kwargs: Any): ...
    def displayTangents(self, val: bool = ..., **kwargs: Any): ...
    def displayValues(self, val: bool = ..., **kwargs: Any): ...
    def getAreCurvesSelected(self, **kwargs: Any): ...
    def getAutoFit(self, **kwargs: Any): ...
    def getAutoFitTime(self, **kwargs: Any): ...
    def getClassicMode(self, **kwargs: Any): ...
    def getClipTime(self, **kwargs: Any): ...
    def getConstrainDrag(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getCurvesShown(self, **kwargs: Any): ...
    def getCurvesShownForceUpdate(self, **kwargs: Any): ...
    def getDisplayNormalized(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getHighlightAffectedCurves(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getKeyingTime(self, **kwargs: Any): ...
    def getLockPlayRangeShades(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getOutliner(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getPreSelectionHighlight(self, **kwargs: Any): ...
    def getResultSamples(self, **kwargs: Any): ...
    def getResultScreenSamples(self, **kwargs: Any): ...
    def getResultUpdate(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getShowActiveCurveNames(self, **kwargs: Any): ...
    def getShowBufferCurves(self, **kwargs: Any): ...
    def getShowCurveNames(self, **kwargs: Any): ...
    def getShowPlayRangeShades(self, **kwargs: Any): ...
    def getShowResults(self, **kwargs: Any): ...
    def getShowUpstreamCurves(self, **kwargs: Any): ...
    def getSimpleKeyView(self, **kwargs: Any): ...
    def getSmoothness(self, **kwargs: Any): ...
    def getSnapTime(self, **kwargs: Any): ...
    def getSnapValue(self, **kwargs: Any): ...
    def getStackedCurves(self, **kwargs: Any): ...
    def getStackedCurvesMax(self, **kwargs: Any): ...
    def getStackedCurvesMin(self, **kwargs: Any): ...
    def getStackedCurvesSpace(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getTimelinePositionTop(self, **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def lookAt(self, val: bool = ..., **kwargs: Any): ...
    def normalizeCurvesCommand(self, val: bool = ..., **kwargs: Any): ...
    def renormalizeCurves(self, val: bool = ..., **kwargs: Any): ...
    def setAutoFit(self, val: bool = ..., **kwargs: Any): ...
    def setAutoFitTime(self, val: bool = ..., **kwargs: Any): ...
    def setClassicMode(self, val: bool = ..., **kwargs: Any): ...
    def setClipTime(self, val: bool = ..., **kwargs: Any): ...
    def setConstrainDrag(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayNormalized(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightAffectedCurves(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setLockPlayRangeShades(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setOutliner(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setPreSelectionHighlight(self, val: bool = ..., **kwargs: Any): ...
    def setResultSamples(self, val: bool = ..., **kwargs: Any): ...
    def setResultScreenSamples(self, val: bool = ..., **kwargs: Any): ...
    def setResultUpdate(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setShowActiveCurveNames(self, val: bool = ..., **kwargs: Any): ...
    def setShowBufferCurves(self, val: bool = ..., **kwargs: Any): ...
    def setShowCurveNames(self, val: bool = ..., **kwargs: Any): ...
    def setShowPlayRangeShades(self, val: bool = ..., **kwargs: Any): ...
    def setShowResults(self, val: bool = ..., **kwargs: Any): ...
    def setShowUpstreamCurves(self, val: bool = ..., **kwargs: Any): ...
    def setSimpleKeyView(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothness(self, val: bool = ..., **kwargs: Any): ...
    def setSnapTime(self, val: bool = ..., **kwargs: Any): ...
    def setSnapValue(self, val: bool = ..., **kwargs: Any): ...
    def setStackedCurves(self, val: bool = ..., **kwargs: Any): ...
    def setStackedCurvesMax(self, val: bool = ..., **kwargs: Any): ...
    def setStackedCurvesMin(self, val: bool = ..., **kwargs: Any): ...
    def setStackedCurvesSpace(self, val: bool = ..., **kwargs: Any): ...
    def setTimelinePositionTop(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def valueLinesToggle(self, val: bool = ..., **kwargs: Any): ...

class AnimDisplay(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getModelUpdate(self, **kwargs: Any): ...
    def getRefAnimCurvesEditable(self, **kwargs: Any): ...
    def getTimeCode(self, **kwargs: Any): ...
    def getTimeCodeOffset(self, **kwargs: Any): ...
    def setModelUpdate(self, val: bool = ..., **kwargs: Any): ...
    def setRefAnimCurvesEditable(self, val: bool = ..., **kwargs: Any): ...
    def setTimeCode(self, val: bool = ..., **kwargs: Any): ...
    def setTimeCodeOffset(self, val: bool = ..., **kwargs: Any): ...

class AttrEnumOptionMenu(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def attribute(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class AttributeMenu(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...

class BlendShapeEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getTargetControlList(self, **kwargs: Any): ...
    def getTargetList(self, **kwargs: Any): ...
    def getVerticalSliders(self, **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setVerticalSliders(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...

class Button(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getActOnPress(self, **kwargs: Any): ...
    def getActionIsSubstitute(self, **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRecomputeSize(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setActOnPress(self, val: bool = ..., **kwargs: Any): ...
    def setActionIsSubstitute(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRecomputeSize(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class Canvas(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHsvValue(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRgbValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def pressCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHsvValue(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRgbValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ChannelBox(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def execute(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAttrBgColor(self, **kwargs: Any): ...
    def getAttrColor(self, **kwargs: Any): ...
    def getAttrFilter(self, **kwargs: Any): ...
    def getAttrRegex(self, **kwargs: Any): ...
    def getAttributeEditorMode(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getContainerAtTop(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getEnableLabelSelection(self, **kwargs: Any): ...
    def getFieldWidth(self, **kwargs: Any): ...
    def getFixedAttrList(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHistoryObjectList(self, **kwargs: Any): ...
    def getHyperbolic(self, **kwargs: Any): ...
    def getInputs(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabelWidth(self, **kwargs: Any): ...
    def getLongNames(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getMainObjectList(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxHeight(self, **kwargs: Any): ...
    def getMaxWidth(self, **kwargs: Any): ...
    def getNiceNames(self, **kwargs: Any): ...
    def getNodeRegex(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOutputObjectList(self, **kwargs: Any): ...
    def getOutputs(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPrecision(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelectedHistoryAttributes(self, **kwargs: Any): ...
    def getSelectedMainAttributes(self, **kwargs: Any): ...
    def getSelectedOutputAttributes(self, **kwargs: Any): ...
    def getSelectedShapeAttributes(self, **kwargs: Any): ...
    def getShapeObjectList(self, **kwargs: Any): ...
    def getShapes(self, **kwargs: Any): ...
    def getShowNamespace(self, **kwargs: Any): ...
    def getShowTransforms(self, **kwargs: Any): ...
    def getSpeed(self, **kwargs: Any): ...
    def getUseManips(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def select(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAttrBgColor(self, val: bool = ..., **kwargs: Any): ...
    def setAttrColor(self, val: bool = ..., **kwargs: Any): ...
    def setAttrFilter(self, val: bool = ..., **kwargs: Any): ...
    def setAttrRegex(self, val: bool = ..., **kwargs: Any): ...
    def setAttributeEditorMode(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setContainerAtTop(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setEnableLabelSelection(self, val: bool = ..., **kwargs: Any): ...
    def setFieldWidth(self, val: bool = ..., **kwargs: Any): ...
    def setFixedAttrList(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHyperbolic(self, val: bool = ..., **kwargs: Any): ...
    def setLabelWidth(self, val: bool = ..., **kwargs: Any): ...
    def setLongNames(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMaxWidth(self, val: bool = ..., **kwargs: Any): ...
    def setNiceNames(self, val: bool = ..., **kwargs: Any): ...
    def setNodeRegex(self, val: bool = ..., **kwargs: Any): ...
    def setPrecision(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setShowNamespace(self, val: bool = ..., **kwargs: Any): ...
    def setShowTransforms(self, val: bool = ..., **kwargs: Any): ...
    def setSpeed(self, val: bool = ..., **kwargs: Any): ...
    def setUseManips(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def takeFocus(self, val: bool = ..., **kwargs: Any): ...
    def update(self, val: bool = ..., **kwargs: Any): ...

class CheckBox(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOffCommand(self, **kwargs: Any): ...
    def getOnCommand(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRecomputeSize(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setOffCommand(self, val: bool = ..., **kwargs: Any): ...
    def setOnCommand(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRecomputeSize(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ClipEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def clipDropCmd(self, val: bool = ..., **kwargs: Any): ...
    def deleteCmd(self, val: bool = ..., **kwargs: Any): ...
    def deselectAll(self, val: bool = ..., **kwargs: Any): ...
    def displayActiveKeyTangents(self, val: bool = ..., **kwargs: Any): ...
    def displayActiveKeys(self, val: bool = ..., **kwargs: Any): ...
    def displayInfinities(self, val: bool = ..., **kwargs: Any): ...
    def displayKeys(self, val: bool = ..., **kwargs: Any): ...
    def displayTangents(self, val: bool = ..., **kwargs: Any): ...
    def displayValues(self, val: bool = ..., **kwargs: Any): ...
    def frameAll(self, val: bool = ..., **kwargs: Any): ...
    def getAutoFit(self, **kwargs: Any): ...
    def getAutoFitTime(self, **kwargs: Any): ...
    def getClipStyle(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getFrameRange(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getHighlightedBlend(self, **kwargs: Any): ...
    def getHighlightedClip(self, **kwargs: Any): ...
    def getInitialized(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getManageSequencer(self, **kwargs: Any): ...
    def getMenuContext(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getSelectBlend(self, **kwargs: Any): ...
    def getSelectClip(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getSnapTime(self, **kwargs: Any): ...
    def getSnapValue(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def listAllCharacters(self, val: bool = ..., **kwargs: Any): ...
    def listCurrentCharacters(self, val: bool = ..., **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def lookAt(self, val: bool = ..., **kwargs: Any): ...
    def setAutoFit(self, val: bool = ..., **kwargs: Any): ...
    def setAutoFitTime(self, val: bool = ..., **kwargs: Any): ...
    def setClipStyle(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setFrameRange(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setManageSequencer(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setSelectBlend(self, val: bool = ..., **kwargs: Any): ...
    def setSelectClip(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setSnapTime(self, val: bool = ..., **kwargs: Any): ...
    def setSnapValue(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...

class ClipSchedulerOutliner(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def clipScheduler(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class CmdScrollFieldExecuter(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def appendText(self, val: bool = ..., **kwargs: Any): ...
    def clear(self, val: bool = ..., **kwargs: Any): ...
    def copySelection(self, val: bool = ..., **kwargs: Any): ...
    def cutSelection(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def execute(self, val: bool = ..., **kwargs: Any): ...
    def executeAll(self, val: bool = ..., **kwargs: Any): ...
    def fileChangedCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAutoCloseBraces(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommandCompletion(self, **kwargs: Any): ...
    def getCurrentLine(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFilename(self, **kwargs: Any): ...
    def getFilterKeyPress(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHasFocus(self, **kwargs: Any): ...
    def getHasSelection(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getModified(self, **kwargs: Any): ...
    def getNumberOfLines(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getObjectPathCompletion(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSearchAndSelect(self, **kwargs: Any): ...
    def getSearchDown(self, **kwargs: Any): ...
    def getSearchMatchCase(self, **kwargs: Any): ...
    def getSearchString(self, **kwargs: Any): ...
    def getSearchWraps(self, **kwargs: Any): ...
    def getSelectedText(self, **kwargs: Any): ...
    def getShowLineNumbers(self, **kwargs: Any): ...
    def getShowTooltipHelp(self, **kwargs: Any): ...
    def getSourceType(self, **kwargs: Any): ...
    def getSpacesPerTab(self, **kwargs: Any): ...
    def getTabsForIndent(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getTextLength(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def insertText(self, val: bool = ..., **kwargs: Any): ...
    def load(self, val: bool = ..., **kwargs: Any): ...
    def loadContents(self, val: bool = ..., **kwargs: Any): ...
    def loadFile(self, val: bool = ..., **kwargs: Any): ...
    def modificationChangedCommand(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def pasteSelection(self, val: bool = ..., **kwargs: Any): ...
    def redo(self, val: bool = ..., **kwargs: Any): ...
    def removeStoredContents(self, val: bool = ..., **kwargs: Any): ...
    def replaceAll(self, val: bool = ..., **kwargs: Any): ...
    def saveFile(self, val: bool = ..., **kwargs: Any): ...
    def saveSelection(self, val: bool = ..., **kwargs: Any): ...
    def saveSelectionToShelf(self, val: bool = ..., **kwargs: Any): ...
    def select(self, val: bool = ..., **kwargs: Any): ...
    def selectAll(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAutoCloseBraces(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommandCompletion(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentLine(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFilterKeyPress(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setModified(self, val: bool = ..., **kwargs: Any): ...
    def setObjectPathCompletion(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSearchDown(self, val: bool = ..., **kwargs: Any): ...
    def setSearchMatchCase(self, val: bool = ..., **kwargs: Any): ...
    def setSearchString(self, val: bool = ..., **kwargs: Any): ...
    def setSearchWraps(self, val: bool = ..., **kwargs: Any): ...
    def setShowLineNumbers(self, val: bool = ..., **kwargs: Any): ...
    def setShowTooltipHelp(self, val: bool = ..., **kwargs: Any): ...
    def setSpacesPerTab(self, val: bool = ..., **kwargs: Any): ...
    def setTabsForIndent(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def source(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def storeContents(self, val: bool = ..., **kwargs: Any): ...
    def undo(self, val: bool = ..., **kwargs: Any): ...

class CmdScrollFieldReporter(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def clear(self, val: bool = ..., **kwargs: Any): ...
    def copySelection(self, val: bool = ..., **kwargs: Any): ...
    def cutSelection(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEchoAllCommands(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFilterSourceType(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHasFocus(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLineNumbers(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStackTrace(self, **kwargs: Any): ...
    def getSuppressErrors(self, **kwargs: Any): ...
    def getSuppressInfo(self, **kwargs: Any): ...
    def getSuppressResults(self, **kwargs: Any): ...
    def getSuppressStackTrace(self, **kwargs: Any): ...
    def getSuppressWarnings(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getTextLength(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def pasteSelection(self, val: bool = ..., **kwargs: Any): ...
    def receiveFocusCommand(self, val: bool = ..., **kwargs: Any): ...
    def saveSelection(self, val: bool = ..., **kwargs: Any): ...
    def saveSelectionToShelf(self, val: bool = ..., **kwargs: Any): ...
    def select(self, val: bool = ..., **kwargs: Any): ...
    def selectAll(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEchoAllCommands(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFilterSourceType(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLineNumbers(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStackTrace(self, val: bool = ..., **kwargs: Any): ...
    def setSuppressErrors(self, val: bool = ..., **kwargs: Any): ...
    def setSuppressInfo(self, val: bool = ..., **kwargs: Any): ...
    def setSuppressResults(self, val: bool = ..., **kwargs: Any): ...
    def setSuppressStackTrace(self, val: bool = ..., **kwargs: Any): ...
    def setSuppressWarnings(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class CmdShell(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfHistoryLines(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getNumberOfSavedLines(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getPrompt(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfHistoryLines(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfSavedLines(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setPrompt(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ColorEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getAlpha(self, **kwargs: Any): ...
    def getHsvValue(self, **kwargs: Any): ...
    def getResult(self, **kwargs: Any): ...
    def getRgbValue(self, **kwargs: Any): ...

class CommandLine(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def command(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def enterCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHoldFocus(self, **kwargs: Any): ...
    def getInputAnnotation(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfHistoryLines(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOutputAnnotation(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSourceType(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHoldFocus(self, val: bool = ..., **kwargs: Any): ...
    def setInputAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfHistoryLines(self, val: bool = ..., **kwargs: Any): ...
    def setOutputAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSourceType(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ConfirmDialog(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...

class DefaultLightListCheckBox(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def label(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def shadingGroup(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class DeviceEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getTakePath(self, **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setTakePath(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...

class DynPaintEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def canvasUndo(self, val: bool = ..., **kwargs: Any): ...
    def clear(self, val: bool = ..., **kwargs: Any): ...
    def getActiveOnly(self, **kwargs: Any): ...
    def getAutoSave(self, **kwargs: Any): ...
    def getCamera(self, **kwargs: Any): ...
    def getCanvasMode(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getCurrentCanvasSize(self, **kwargs: Any): ...
    def getDisplayAppearance(self, **kwargs: Any): ...
    def getDisplayFog(self, **kwargs: Any): ...
    def getDisplayImage(self, **kwargs: Any): ...
    def getDisplayLights(self, **kwargs: Any): ...
    def getDisplayStyle(self, **kwargs: Any): ...
    def getDisplayTextures(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDoubleBuffer(self, **kwargs: Any): ...
    def getDrawAxis(self, **kwargs: Any): ...
    def getDrawContext(self, **kwargs: Any): ...
    def getFileName(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getNbImages(self, **kwargs: Any): ...
    def getNewImage(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getRefreshMode(self, **kwargs: Any): ...
    def getSaveAlpha(self, **kwargs: Any): ...
    def getSaveBumpmap(self, **kwargs: Any): ...
    def getScaleBlue(self, **kwargs: Any): ...
    def getScaleGreen(self, **kwargs: Any): ...
    def getScaleRed(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getSingleBuffer(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getWrap(self, **kwargs: Any): ...
    def getZoom(self, **kwargs: Any): ...
    def iconGrab(self, val: bool = ..., **kwargs: Any): ...
    def loadImage(self, val: bool = ..., **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def paintAll(self, val: bool = ..., **kwargs: Any): ...
    def redrawLast(self, val: bool = ..., **kwargs: Any): ...
    def refresh(self, val: bool = ..., **kwargs: Any): ...
    def removeAllImages(self, val: bool = ..., **kwargs: Any): ...
    def removeImage(self, val: bool = ..., **kwargs: Any): ...
    def rollImage(self, val: bool = ..., **kwargs: Any): ...
    def saveImage(self, val: bool = ..., **kwargs: Any): ...
    def setActiveOnly(self, val: bool = ..., **kwargs: Any): ...
    def setAutoSave(self, val: bool = ..., **kwargs: Any): ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setCanvasMode(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayAppearance(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayFog(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayImage(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayLights(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayStyle(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayTextures(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDoubleBuffer(self, val: bool = ..., **kwargs: Any): ...
    def setDrawAxis(self, val: bool = ..., **kwargs: Any): ...
    def setFileName(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setNewImage(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setRefreshMode(self, val: bool = ..., **kwargs: Any): ...
    def setSaveAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setSaveBumpmap(self, val: bool = ..., **kwargs: Any): ...
    def setScaleBlue(self, val: bool = ..., **kwargs: Any): ...
    def setScaleGreen(self, val: bool = ..., **kwargs: Any): ...
    def setScaleRed(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setSingleBuffer(self, val: bool = ..., **kwargs: Any): ...
    def setWrap(self, val: bool = ..., **kwargs: Any): ...
    def setZoom(self, val: bool = ..., **kwargs: Any): ...
    def snapShot(self, val: bool = ..., **kwargs: Any): ...
    def tileSize(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def undoCache(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def writeImage(self, val: bool = ..., **kwargs: Any): ...

class DynRelEditor(PyUI):
    __melui__: str = ...

class ExclusiveLightCheckBox(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def label(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class FloatField(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def enterCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPrecision(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getShowTrailingZeros(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def receiveFocusCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPrecision(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setShowTrailingZeros(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class FloatScrollBar(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHorizontal(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLargeStep(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLargeStep(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class FloatSlider(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHorizontal(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class FloatSlider2(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand1(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand2(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaximum(self, **kwargs: Any): ...
    def getMinimum(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPolarity(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getValue1(self, **kwargs: Any): ...
    def getValue2(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def positionControl1(self, val: bool = ..., **kwargs: Any): ...
    def positionControl2(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaximum(self, val: bool = ..., **kwargs: Any): ...
    def setMinimum(self, val: bool = ..., **kwargs: Any): ...
    def setPolarity(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setValue1(self, val: bool = ..., **kwargs: Any): ...
    def setValue2(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def values(self, val: bool = ..., **kwargs: Any): ...

class FontDialog(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...

class GlRenderEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getLookThru(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getViewCameraName(self, **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setLookThru(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...

class GradientControl(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAdaptiveScaling(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfControls(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRefreshOnRelease(self, **kwargs: Any): ...
    def getStaticNumberOfControls(self, **kwargs: Any): ...
    def getStaticPositions(self, **kwargs: Any): ...
    def getUpperLimitControl(self, **kwargs: Any): ...
    def getVerticalLayout(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def selectedColorControl(self, val: bool = ..., **kwargs: Any): ...
    def selectedInterpControl(self, val: bool = ..., **kwargs: Any): ...
    def selectedPositionControl(self, val: bool = ..., **kwargs: Any): ...
    def setAdaptiveScaling(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRefreshOnRelease(self, val: bool = ..., **kwargs: Any): ...
    def setStaticNumberOfControls(self, val: bool = ..., **kwargs: Any): ...
    def setStaticPositions(self, val: bool = ..., **kwargs: Any): ...
    def setUpperLimitControl(self, val: bool = ..., **kwargs: Any): ...
    def setVerticalLayout(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class GradientControlNoAttr(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def currentKeyChanged(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAsString(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCurrentKey(self, **kwargs: Any): ...
    def getCurrentKeyColorValue(self, **kwargs: Any): ...
    def getCurrentKeyCurveValue(self, **kwargs: Any): ...
    def getCurrentKeyInterpValue(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOptionVar(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRampAsColor(self, **kwargs: Any): ...
    def getValueAtPoint(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAsString(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentKey(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentKeyColorValue(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentKeyCurveValue(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentKeyInterpValue(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setOptionVar(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRampAsColor(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class HelpLine(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class HyperGraph(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def addBookmark(self, val: bool = ..., **kwargs: Any): ...
    def addDependGraph(self, val: bool = ..., **kwargs: Any): ...
    def addDependNode(self, val: bool = ..., **kwargs: Any): ...
    def attributeEditor(self, val: bool = ..., **kwargs: Any): ...
    def backward(self, val: bool = ..., **kwargs: Any): ...
    def clear(self, val: bool = ..., **kwargs: Any): ...
    def collapseContainer(self, val: bool = ..., **kwargs: Any): ...
    def connectionDrawStyle(self, val: bool = ..., **kwargs: Any): ...
    def debug(self, val: bool = ..., **kwargs: Any): ...
    def deleteBookmark(self, val: bool = ..., **kwargs: Any): ...
    def dependGraph(self, val: bool = ..., **kwargs: Any): ...
    def dependNode(self, val: bool = ..., **kwargs: Any): ...
    def directoryPressCommand(self, val: bool = ..., **kwargs: Any): ...
    def down(self, val: bool = ..., **kwargs: Any): ...
    def downstream(self, val: bool = ..., **kwargs: Any): ...
    def dragAndDropBehaviorCommand(self, val: bool = ..., **kwargs: Any): ...
    def edgeDblClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def edgeDimmedDblClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def edgeDropCommand(self, val: bool = ..., **kwargs: Any): ...
    def edgePressCommand(self, val: bool = ..., **kwargs: Any): ...
    def edgeReleaseCommand(self, val: bool = ..., **kwargs: Any): ...
    def enableAutomaticLayout(self, val: bool = ..., **kwargs: Any): ...
    def expandContainer(self, val: bool = ..., **kwargs: Any): ...
    def filterDetail(self, val: bool = ..., **kwargs: Any): ...
    def focusCommand(self, val: bool = ..., **kwargs: Any): ...
    def fold(self, val: bool = ..., **kwargs: Any): ...
    def forceRefresh(self, val: bool = ..., **kwargs: Any): ...
    def forward(self, val: bool = ..., **kwargs: Any): ...
    def frame(self, val: bool = ..., **kwargs: Any): ...
    def frameBranch(self, val: bool = ..., **kwargs: Any): ...
    def frameGraph(self, val: bool = ..., **kwargs: Any): ...
    def frameGraphNoRebuild(self, val: bool = ..., **kwargs: Any): ...
    def frameHierarchy(self, val: bool = ..., **kwargs: Any): ...
    def getAnimateTransition(self, **kwargs: Any): ...
    def getBookmarkName(self, **kwargs: Any): ...
    def getBreakConnectionCommand(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getCurrentEdge(self, **kwargs: Any): ...
    def getCurrentNode(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDropNode(self, **kwargs: Any): ...
    def getDropTargetNode(self, **kwargs: Any): ...
    def getFeedbackGadget(self, **kwargs: Any): ...
    def getFeedbackNode(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getFreeform(self, **kwargs: Any): ...
    def getFromAttr(self, **kwargs: Any): ...
    def getFromNode(self, **kwargs: Any): ...
    def getGetNodeList(self, **kwargs: Any): ...
    def getGetNodePosition(self, **kwargs: Any): ...
    def getGraphLayoutStyle(self, **kwargs: Any): ...
    def getGraphType(self, **kwargs: Any): ...
    def getHeatMapDisplay(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getIconSize(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImageEnabled(self, **kwargs: Any): ...
    def getImageForContainer(self, **kwargs: Any): ...
    def getImagePosition(self, **kwargs: Any): ...
    def getImageScale(self, **kwargs: Any): ...
    def getIsHotkeyTarget(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getMergeConnections(self, **kwargs: Any): ...
    def getOpaqueContainers(self, **kwargs: Any): ...
    def getOrientation(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getRange(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getShowConnectionFromSelected(self, **kwargs: Any): ...
    def getShowConnectionToSelected(self, **kwargs: Any): ...
    def getShowConstraints(self, **kwargs: Any): ...
    def getShowDeformers(self, **kwargs: Any): ...
    def getShowExpressions(self, **kwargs: Any): ...
    def getShowInvisible(self, **kwargs: Any): ...
    def getShowRelationships(self, **kwargs: Any): ...
    def getShowShapes(self, **kwargs: Any): ...
    def getShowUnderworld(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getToAttr(self, **kwargs: Any): ...
    def getToNode(self, **kwargs: Any): ...
    def getTransitionFrames(self, **kwargs: Any): ...
    def getUpdateNodeAdded(self, **kwargs: Any): ...
    def getUpdateSelection(self, **kwargs: Any): ...
    def getUseFeedbackList(self, **kwargs: Any): ...
    def getViewOption(self, **kwargs: Any): ...
    def graphDescription(self, val: bool = ..., **kwargs: Any): ...
    def initializeScript(self, val: bool = ..., **kwargs: Any): ...
    def layout(self, val: bool = ..., **kwargs: Any): ...
    def layoutSelected(self, val: bool = ..., **kwargs: Any): ...
    def limitGraphTraversal(self, val: bool = ..., **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def look(self, val: bool = ..., **kwargs: Any): ...
    def navigateHome(self, val: bool = ..., **kwargs: Any): ...
    def navup(self, val: bool = ..., **kwargs: Any): ...
    def newInputConnection(self, val: bool = ..., **kwargs: Any): ...
    def newOutputConnection(self, val: bool = ..., **kwargs: Any): ...
    def nextView(self, val: bool = ..., **kwargs: Any): ...
    def nodeConnectCommand(self, val: bool = ..., **kwargs: Any): ...
    def nodeDblClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def nodeDropCommand(self, val: bool = ..., **kwargs: Any): ...
    def nodeMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def nodePressCommand(self, val: bool = ..., **kwargs: Any): ...
    def nodeReleaseCommand(self, val: bool = ..., **kwargs: Any): ...
    def panView(self, val: bool = ..., **kwargs: Any): ...
    def popupMenuScript(self, val: bool = ..., **kwargs: Any): ...
    def previousView(self, val: bool = ..., **kwargs: Any): ...
    def rebuild(self, val: bool = ..., **kwargs: Any): ...
    def removeNode(self, val: bool = ..., **kwargs: Any): ...
    def resetFreeform(self, val: bool = ..., **kwargs: Any): ...
    def restoreBookmark(self, val: bool = ..., **kwargs: Any): ...
    def scrollUpDownNoZoom(self, val: bool = ..., **kwargs: Any): ...
    def setAnimateTransition(self, val: bool = ..., **kwargs: Any): ...
    def setBreakConnectionCommand(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentEdge(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentNode(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setFreeform(self, val: bool = ..., **kwargs: Any): ...
    def setGraphLayoutStyle(self, val: bool = ..., **kwargs: Any): ...
    def setHeatMapDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setIconSize(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImageEnabled(self, val: bool = ..., **kwargs: Any): ...
    def setImageForContainer(self, val: bool = ..., **kwargs: Any): ...
    def setImagePosition(self, val: bool = ..., **kwargs: Any): ...
    def setImageScale(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMergeConnections(self, val: bool = ..., **kwargs: Any): ...
    def setNodePosition(self, val: bool = ..., **kwargs: Any): ...
    def setOpaqueContainers(self, val: bool = ..., **kwargs: Any): ...
    def setOrientation(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setRange(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setShowConnectionFromSelected(self, val: bool = ..., **kwargs: Any): ...
    def setShowConnectionToSelected(self, val: bool = ..., **kwargs: Any): ...
    def setShowConstraints(self, val: bool = ..., **kwargs: Any): ...
    def setShowDeformers(self, val: bool = ..., **kwargs: Any): ...
    def setShowExpressions(self, val: bool = ..., **kwargs: Any): ...
    def setShowInvisible(self, val: bool = ..., **kwargs: Any): ...
    def setShowRelationships(self, val: bool = ..., **kwargs: Any): ...
    def setShowShapes(self, val: bool = ..., **kwargs: Any): ...
    def setShowUnderworld(self, val: bool = ..., **kwargs: Any): ...
    def setTransitionFrames(self, val: bool = ..., **kwargs: Any): ...
    def setUpdateNodeAdded(self, val: bool = ..., **kwargs: Any): ...
    def setUpdateSelection(self, val: bool = ..., **kwargs: Any): ...
    def setUseFeedbackList(self, val: bool = ..., **kwargs: Any): ...
    def setViewOption(self, val: bool = ..., **kwargs: Any): ...
    def showCachedConnections(self, val: bool = ..., **kwargs: Any): ...
    def showConstraintLabels(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unfold(self, val: bool = ..., **kwargs: Any): ...
    def unfoldAll(self, val: bool = ..., **kwargs: Any): ...
    def unfoldAllShapes(self, val: bool = ..., **kwargs: Any): ...
    def unfoldHidden(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def upstream(self, val: bool = ..., **kwargs: Any): ...
    def useDrawOverrideColor(self, val: bool = ..., **kwargs: Any): ...
    def visibility(self, val: bool = ..., **kwargs: Any): ...
    def zoom(self, val: bool = ..., **kwargs: Any): ...

class HyperShade(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...

class IconTextButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getCommandRepeatable(self, **kwargs: Any): ...
    def getDisabledImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDoubleClickCommand(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFlat(self, **kwargs: Any): ...
    def getFlipX(self, **kwargs: Any): ...
    def getFlipY(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHighlightImage(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelOffset(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOverlayLabelBackColor(self, **kwargs: Any): ...
    def getOverlayLabelColor(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getSelectionImage(self, **kwargs: Any): ...
    def getSourceType(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getUseAlpha(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def handleNodeDropCallback(self, val: bool = ..., **kwargs: Any): ...
    def labelEditingCallback(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def scaleIcon(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setCommandRepeatable(self, val: bool = ..., **kwargs: Any): ...
    def setDisabledImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDoubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFlat(self, val: bool = ..., **kwargs: Any): ...
    def setFlipX(self, val: bool = ..., **kwargs: Any): ...
    def setFlipY(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelOffset(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelBackColor(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelColor(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionImage(self, val: bool = ..., **kwargs: Any): ...
    def setSourceType(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setUseAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IconTextCheckBox(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getDisabledImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFlat(self, **kwargs: Any): ...
    def getFlipX(self, **kwargs: Any): ...
    def getFlipY(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHighlightImage(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelOffset(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOffCommand(self, **kwargs: Any): ...
    def getOnCommand(self, **kwargs: Any): ...
    def getOverlayLabelBackColor(self, **kwargs: Any): ...
    def getOverlayLabelColor(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getSelectionHighlightImage(self, **kwargs: Any): ...
    def getSelectionImage(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getUseAlpha(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDisabledImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFlat(self, val: bool = ..., **kwargs: Any): ...
    def setFlipX(self, val: bool = ..., **kwargs: Any): ...
    def setFlipY(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelOffset(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setOffCommand(self, val: bool = ..., **kwargs: Any): ...
    def setOnCommand(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelBackColor(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelColor(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionHighlightImage(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionImage(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setUseAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IconTextRadioButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getDisabledImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFlat(self, **kwargs: Any): ...
    def getFlipX(self, **kwargs: Any): ...
    def getFlipY(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHighlightImage(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelOffset(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOffCommand(self, **kwargs: Any): ...
    def getOnCommand(self, **kwargs: Any): ...
    def getOverlayLabelBackColor(self, **kwargs: Any): ...
    def getOverlayLabelColor(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def getSelectionHighlightImage(self, **kwargs: Any): ...
    def getSelectionImage(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getUseAlpha(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDisabledImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFlat(self, val: bool = ..., **kwargs: Any): ...
    def setFlipX(self, val: bool = ..., **kwargs: Any): ...
    def setFlipY(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelOffset(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setOffCommand(self, val: bool = ..., **kwargs: Any): ...
    def setOnCommand(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelBackColor(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelColor(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionHighlightImage(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionImage(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setUseAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IconTextRadioCollection(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def disableCommands(self, val: bool = ..., **kwargs: Any): ...
    def getCollectionItemArray(self, **kwargs: Any): ...
    def getGl(self, **kwargs: Any): ...
    def getNumberOfCollectionItems(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...

class IconTextScrollList(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def append(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def deselectAll(self, val: bool = ..., **kwargs: Any): ...
    def doubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragFeedbackVisible(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropRectCallback(self, val: bool = ..., **kwargs: Any): ...
    def editIndexed(self, val: bool = ..., **kwargs: Any): ...
    def editable(self, val: bool = ..., **kwargs: Any): ...
    def getAllowMultiSelection(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getItemAt(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfIcons(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getNumberOfRows(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelectIndexedItem(self, **kwargs: Any): ...
    def getSelectItem(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getVisualRectAt(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def itemTextColor(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def removeAll(self, val: bool = ..., **kwargs: Any): ...
    def selectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAllowMultiSelection(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSelectIndexedItem(self, val: bool = ..., **kwargs: Any): ...
    def setSelectItem(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IconTextStaticLabel(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDisabledImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFlipX(self, **kwargs: Any): ...
    def getFlipY(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelOffset(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOverlayLabelBackColor(self, **kwargs: Any): ...
    def getOverlayLabelColor(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getUseAlpha(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDisabledImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFlipX(self, val: bool = ..., **kwargs: Any): ...
    def setFlipY(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelOffset(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelBackColor(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelColor(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setUseAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class Image(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IntField(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def enterCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def receiveFocusCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IntScrollBar(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHorizontal(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLargeStep(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLargeStep(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IntSlider(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHorizontal(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class KeyframeOutliner(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def animCurve(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDisplay(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class KeyframeStats(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnimEditor(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getClassicMode(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPrecision(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getTimeAnnotation(self, **kwargs: Any): ...
    def getValueAnnotation(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnimEditor(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setClassicMode(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPrecision(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setTimeAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setValueAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class LayerButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def color(self, val: bool = ..., **kwargs: Any): ...
    def command(self, val: bool = ..., **kwargs: Any): ...
    def current(self, val: bool = ..., **kwargs: Any): ...
    def doubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIdentification(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelWidth(self, **kwargs: Any): ...
    def getLayerHideOnPlayback(self, **kwargs: Any): ...
    def getLayerState(self, **kwargs: Any): ...
    def getLayerVisible(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def getTransparent(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def hideOnPlaybackCommand(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def renameCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setIdentification(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLayerHideOnPlayback(self, val: bool = ..., **kwargs: Any): ...
    def setLayerState(self, val: bool = ..., **kwargs: Any): ...
    def setLayerVisible(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...
    def setTransparent(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def typeCommand(self, val: bool = ..., **kwargs: Any): ...
    def visibleCommand(self, val: bool = ..., **kwargs: Any): ...

class AttrColorSliderGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAttrNavDecision(self, **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHsvValue(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRgbValue(self, **kwargs: Any): ...
    def getShowButton(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAttrNavDecision(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHsvValue(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRgbValue(self, val: bool = ..., **kwargs: Any): ...
    def setShowButton(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class AttrControlGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getExists(self, **kwargs: Any): ...
    def getHandlesAttribute(self, **kwargs: Any): ...
    def getHideMapButton(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setExists(self, val: bool = ..., **kwargs: Any): ...
    def setHandlesAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setHideMapButton(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...

class AttrEnumOptionMenuGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def attribute(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class AttrFieldGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def extraButtonCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraButtonIcon(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def precision(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraButtonIcon(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class AttrFieldSliderGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def extraButtonCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraButtonIcon(self, **kwargs: Any): ...
    def getFieldMaxValue(self, **kwargs: Any): ...
    def getFieldMinValue(self, **kwargs: Any): ...
    def getFieldStep(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSliderMaxValue(self, **kwargs: Any): ...
    def getSliderMinValue(self, **kwargs: Any): ...
    def getSliderStep(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getVertical(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def precision(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraButtonIcon(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldStep(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSliderMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setSliderMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setSliderStep(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class AttrNavigationControlGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def extraButtonCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAttrNavDecision(self, **kwargs: Any): ...
    def getAttribute(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getConnectAttrToDropped(self, **kwargs: Any): ...
    def getConnectNodeToDropped(self, **kwargs: Any): ...
    def getConnectToExisting(self, **kwargs: Any): ...
    def getCreateNew(self, **kwargs: Any): ...
    def getDefaultTraversal(self, **kwargs: Any): ...
    def getDelete(self, **kwargs: Any): ...
    def getDisconnect(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraButtonIcon(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIgnore(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRelatedNodes(self, **kwargs: Any): ...
    def getUnignore(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def noIgnorableMenu(self, val: bool = ..., **kwargs: Any): ...
    def noKeyableMenu(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAttrNavDecision(self, val: bool = ..., **kwargs: Any): ...
    def setAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setConnectAttrToDropped(self, val: bool = ..., **kwargs: Any): ...
    def setConnectNodeToDropped(self, val: bool = ..., **kwargs: Any): ...
    def setConnectToExisting(self, val: bool = ..., **kwargs: Any): ...
    def setCreateNew(self, val: bool = ..., **kwargs: Any): ...
    def setDefaultTraversal(self, val: bool = ..., **kwargs: Any): ...
    def setDelete(self, val: bool = ..., **kwargs: Any): ...
    def setDisconnect(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraButtonIcon(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setIgnore(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRelatedNodes(self, val: bool = ..., **kwargs: Any): ...
    def setUnignore(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class CheckBoxGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand1(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand2(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand3(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnable1(self, **kwargs: Any): ...
    def getEnable2(self, **kwargs: Any): ...
    def getEnable3(self, **kwargs: Any): ...
    def getEnable4(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabel1(self, **kwargs: Any): ...
    def getLabel2(self, **kwargs: Any): ...
    def getLabel3(self, **kwargs: Any): ...
    def getLabel4(self, **kwargs: Any): ...
    def getLabelArray2(self, **kwargs: Any): ...
    def getLabelArray3(self, **kwargs: Any): ...
    def getLabelArray4(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getValue1(self, **kwargs: Any): ...
    def getValue2(self, **kwargs: Any): ...
    def getValue3(self, **kwargs: Any): ...
    def getValue4(self, **kwargs: Any): ...
    def getValueArray2(self, **kwargs: Any): ...
    def getValueArray3(self, **kwargs: Any): ...
    def getValueArray4(self, **kwargs: Any): ...
    def getVertical(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def offCommand(self, val: bool = ..., **kwargs: Any): ...
    def offCommand1(self, val: bool = ..., **kwargs: Any): ...
    def offCommand2(self, val: bool = ..., **kwargs: Any): ...
    def offCommand3(self, val: bool = ..., **kwargs: Any): ...
    def offCommand4(self, val: bool = ..., **kwargs: Any): ...
    def onCommand(self, val: bool = ..., **kwargs: Any): ...
    def onCommand1(self, val: bool = ..., **kwargs: Any): ...
    def onCommand2(self, val: bool = ..., **kwargs: Any): ...
    def onCommand3(self, val: bool = ..., **kwargs: Any): ...
    def onCommand4(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable1(self, val: bool = ..., **kwargs: Any): ...
    def setEnable2(self, val: bool = ..., **kwargs: Any): ...
    def setEnable3(self, val: bool = ..., **kwargs: Any): ...
    def setEnable4(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel1(self, val: bool = ..., **kwargs: Any): ...
    def setLabel2(self, val: bool = ..., **kwargs: Any): ...
    def setLabel3(self, val: bool = ..., **kwargs: Any): ...
    def setLabel4(self, val: bool = ..., **kwargs: Any): ...
    def setLabelArray2(self, val: bool = ..., **kwargs: Any): ...
    def setLabelArray3(self, val: bool = ..., **kwargs: Any): ...
    def setLabelArray4(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setValue1(self, val: bool = ..., **kwargs: Any): ...
    def setValue2(self, val: bool = ..., **kwargs: Any): ...
    def setValue3(self, val: bool = ..., **kwargs: Any): ...
    def setValue4(self, val: bool = ..., **kwargs: Any): ...
    def setValueArray2(self, val: bool = ..., **kwargs: Any): ...
    def setValueArray3(self, val: bool = ..., **kwargs: Any): ...
    def setValueArray4(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ColorIndexSliderGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getForceDragRefresh(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getInvisible(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setForceDragRefresh(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setInvisible(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ColorSliderButtonGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def buttonCommand(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getButtonLabel(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getForceDragRefresh(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHsvValue(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRgbValue(self, **kwargs: Any): ...
    def getSymbolButtonDisplay(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setButtonLabel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setForceDragRefresh(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHsvValue(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRgbValue(self, val: bool = ..., **kwargs: Any): ...
    def setSymbolButtonDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def symbolButtonCommand(self, val: bool = ..., **kwargs: Any): ...

class ColorSliderGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getForceDragRefresh(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHsvValue(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRgbValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setForceDragRefresh(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHsvValue(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRgbValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ColumnLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getColumnWidth(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRowSpacing(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setColumnWidth(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRowSpacing(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class FloatSliderButtonGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def buttonCommand(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getButtonLabel(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFieldMaxValue(self, **kwargs: Any): ...
    def getFieldMinValue(self, **kwargs: Any): ...
    def getFieldStep(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSliderStep(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getSymbolButtonDisplay(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def precision(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setButtonLabel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldStep(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSliderStep(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setSymbolButtonDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def symbolButtonCommand(self, val: bool = ..., **kwargs: Any): ...

class FloatSliderGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFieldMaxValue(self, **kwargs: Any): ...
    def getFieldMinValue(self, **kwargs: Any): ...
    def getFieldStep(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSliderStep(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def precision(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldStep(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSliderStep(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class FrameLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def collapseCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def expandCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getBackgroundShade(self, **kwargs: Any): ...
    def getBorderStyle(self, **kwargs: Any): ...
    def getBorderVisible(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getCollapsable(self, **kwargs: Any): ...
    def getCollapse(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelAlign(self, **kwargs: Any): ...
    def getLabelIndent(self, **kwargs: Any): ...
    def getLabelVisible(self, **kwargs: Any): ...
    def getLabelWidth(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def preCollapseCommand(self, val: bool = ..., **kwargs: Any): ...
    def preExpandCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundShade(self, val: bool = ..., **kwargs: Any): ...
    def setBorderStyle(self, val: bool = ..., **kwargs: Any): ...
    def setBorderVisible(self, val: bool = ..., **kwargs: Any): ...
    def setCollapsable(self, val: bool = ..., **kwargs: Any): ...
    def setCollapse(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelAlign(self, val: bool = ..., **kwargs: Any): ...
    def setLabelIndent(self, val: bool = ..., **kwargs: Any): ...
    def setLabelVisible(self, val: bool = ..., **kwargs: Any): ...
    def setLabelWidth(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class GridLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def cellWidthHeight(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAllowEmptyCells(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAutoGrow(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCellHeight(self, **kwargs: Any): ...
    def getCellWidth(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getColumnsResizable(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getGridOrder(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfColumns(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getNumberOfRows(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def numberOfRowsColumns(self, val: bool = ..., **kwargs: Any): ...
    def position(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCellHeight(self, val: bool = ..., **kwargs: Any): ...
    def setCellWidth(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfColumns(self, val: bool = ..., **kwargs: Any): ...
    def setNumberOfRows(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IntFieldGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnable1(self, **kwargs: Any): ...
    def getEnable2(self, **kwargs: Any): ...
    def getEnable3(self, **kwargs: Any): ...
    def getEnable4(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getValue1(self, **kwargs: Any): ...
    def getValue2(self, **kwargs: Any): ...
    def getValue3(self, **kwargs: Any): ...
    def getValue4(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable1(self, val: bool = ..., **kwargs: Any): ...
    def setEnable2(self, val: bool = ..., **kwargs: Any): ...
    def setEnable3(self, val: bool = ..., **kwargs: Any): ...
    def setEnable4(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setValue1(self, val: bool = ..., **kwargs: Any): ...
    def setValue2(self, val: bool = ..., **kwargs: Any): ...
    def setValue3(self, val: bool = ..., **kwargs: Any): ...
    def setValue4(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class IntSliderGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dragCommand(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExtraLabel(self, **kwargs: Any): ...
    def getFieldMaxValue(self, **kwargs: Any): ...
    def getFieldMinValue(self, **kwargs: Any): ...
    def getFieldStep(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMaxValue(self, **kwargs: Any): ...
    def getMinValue(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSliderStep(self, **kwargs: Any): ...
    def getStep(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setExtraLabel(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setFieldStep(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMaxValue(self, val: bool = ..., **kwargs: Any): ...
    def setMinValue(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSliderStep(self, val: bool = ..., **kwargs: Any): ...
    def setStep(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class MenuBarLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMenuArray(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfMenus(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def menuIndex(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class PaneLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getActiveFrameThickness(self, **kwargs: Any): ...
    def getActivePane(self, **kwargs: Any): ...
    def getActivePaneIndex(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getConfiguration(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getNumberOfVisiblePanes(self, **kwargs: Any): ...
    def getPane1(self, **kwargs: Any): ...
    def getPane2(self, **kwargs: Any): ...
    def getPane3(self, **kwargs: Any): ...
    def getPane4(self, **kwargs: Any): ...
    def getPaneSize(self, **kwargs: Any): ...
    def getPaneUnderPointer(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSeparatorThickness(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def separatorMovedCommand(self, val: bool = ..., **kwargs: Any): ...
    def setActiveFrameThickness(self, val: bool = ..., **kwargs: Any): ...
    def setActivePane(self, val: bool = ..., **kwargs: Any): ...
    def setActivePaneIndex(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setConfiguration(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPane(self, val: bool = ..., **kwargs: Any): ...
    def setPaneSize(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSeparatorThickness(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def staticHeightPane(self, val: bool = ..., **kwargs: Any): ...
    def staticWidthPane(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class RadioButtonGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand1(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand2(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand3(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getAnnotation1(self, **kwargs: Any): ...
    def getAnnotation2(self, **kwargs: Any): ...
    def getAnnotation3(self, **kwargs: Any): ...
    def getAnnotation4(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getData1(self, **kwargs: Any): ...
    def getData2(self, **kwargs: Any): ...
    def getData3(self, **kwargs: Any): ...
    def getData4(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnable1(self, **kwargs: Any): ...
    def getEnable2(self, **kwargs: Any): ...
    def getEnable3(self, **kwargs: Any): ...
    def getEnable4(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabel1(self, **kwargs: Any): ...
    def getLabel2(self, **kwargs: Any): ...
    def getLabel3(self, **kwargs: Any): ...
    def getLabel4(self, **kwargs: Any): ...
    def getLabelAnnotation(self, **kwargs: Any): ...
    def getLabelArray2(self, **kwargs: Any): ...
    def getLabelArray3(self, **kwargs: Any): ...
    def getLabelArray4(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def getVertical(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def offCommand(self, val: bool = ..., **kwargs: Any): ...
    def offCommand1(self, val: bool = ..., **kwargs: Any): ...
    def offCommand2(self, val: bool = ..., **kwargs: Any): ...
    def offCommand3(self, val: bool = ..., **kwargs: Any): ...
    def offCommand4(self, val: bool = ..., **kwargs: Any): ...
    def onCommand(self, val: bool = ..., **kwargs: Any): ...
    def onCommand1(self, val: bool = ..., **kwargs: Any): ...
    def onCommand2(self, val: bool = ..., **kwargs: Any): ...
    def onCommand3(self, val: bool = ..., **kwargs: Any): ...
    def onCommand4(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation1(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation2(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation3(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation4(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setData1(self, val: bool = ..., **kwargs: Any): ...
    def setData2(self, val: bool = ..., **kwargs: Any): ...
    def setData3(self, val: bool = ..., **kwargs: Any): ...
    def setData4(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable1(self, val: bool = ..., **kwargs: Any): ...
    def setEnable2(self, val: bool = ..., **kwargs: Any): ...
    def setEnable3(self, val: bool = ..., **kwargs: Any): ...
    def setEnable4(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel1(self, val: bool = ..., **kwargs: Any): ...
    def setLabel2(self, val: bool = ..., **kwargs: Any): ...
    def setLabel3(self, val: bool = ..., **kwargs: Any): ...
    def setLabel4(self, val: bool = ..., **kwargs: Any): ...
    def setLabelAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setLabelArray2(self, val: bool = ..., **kwargs: Any): ...
    def setLabelArray3(self, val: bool = ..., **kwargs: Any): ...
    def setLabelArray4(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class RowColumnLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset(self, val: bool = ..., **kwargs: Any): ...
    def columnSpacing(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfColumns(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getNumberOfRows(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAlign(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def rowHeight(self, val: bool = ..., **kwargs: Any): ...
    def rowOffset(self, val: bool = ..., **kwargs: Any): ...
    def rowSpacing(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ScrollLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getBorderVisible(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getChildResizable(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMinChildWidth(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPanEnabled(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getScrollAreaHeight(self, **kwargs: Any): ...
    def getScrollAreaValue(self, **kwargs: Any): ...
    def getScrollAreaWidth(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def horizontalScrollBarThickness(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def resizeCommand(self, val: bool = ..., **kwargs: Any): ...
    def scrollByPixel(self, val: bool = ..., **kwargs: Any): ...
    def scrollPage(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setBorderVisible(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPanEnabled(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def verticalScrollBarThickness(self, val: bool = ..., **kwargs: Any): ...

class ShelfLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlignment(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCellHeight(self, **kwargs: Any): ...
    def getCellWidth(self, **kwargs: Any): ...
    def getCellWidthHeight(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHorizontal(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getSpacing(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def position(self, val: bool = ..., **kwargs: Any): ...
    def setAlignment(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCellHeight(self, val: bool = ..., **kwargs: Any): ...
    def setCellWidth(self, val: bool = ..., **kwargs: Any): ...
    def setCellWidthHeight(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHorizontal(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setSpacing(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ShelfTabLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def closeTab(self, val: bool = ..., **kwargs: Any): ...
    def closeTabCommand(self, val: bool = ..., **kwargs: Any): ...
    def doubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getBorderStyle(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getChildResizable(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImageVisible(self, **kwargs: Any): ...
    def getInnerMarginHeight(self, **kwargs: Any): ...
    def getInnerMarginWidth(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMinChildWidth(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getScrollable(self, **kwargs: Any): ...
    def getScrollableTabs(self, **kwargs: Any): ...
    def getSelectCommand(self, **kwargs: Any): ...
    def getSelectTab(self, **kwargs: Any): ...
    def getSelectTabIndex(self, **kwargs: Any): ...
    def getShowNewTab(self, **kwargs: Any): ...
    def getTabLabel(self, **kwargs: Any): ...
    def getTabLabelIndex(self, **kwargs: Any): ...
    def getTabPosition(self, **kwargs: Any): ...
    def getTabTooltip(self, **kwargs: Any): ...
    def getTabTooltipIndex(self, **kwargs: Any): ...
    def getTabsClosable(self, **kwargs: Any): ...
    def getTabsVisible(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def horizontalScrollBarThickness(self, val: bool = ..., **kwargs: Any): ...
    def moveTab(self, val: bool = ..., **kwargs: Any): ...
    def newTabCommand(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def postMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def preSelectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setBorderStyle(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImageVisible(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setScrollableTabs(self, val: bool = ..., **kwargs: Any): ...
    def setSelectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setSelectTab(self, val: bool = ..., **kwargs: Any): ...
    def setSelectTabIndex(self, val: bool = ..., **kwargs: Any): ...
    def setShowNewTab(self, val: bool = ..., **kwargs: Any): ...
    def setTabLabel(self, val: bool = ..., **kwargs: Any): ...
    def setTabLabelIndex(self, val: bool = ..., **kwargs: Any): ...
    def setTabPosition(self, val: bool = ..., **kwargs: Any): ...
    def setTabTooltip(self, val: bool = ..., **kwargs: Any): ...
    def setTabTooltipIndex(self, val: bool = ..., **kwargs: Any): ...
    def setTabsVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def verticalScrollBarThickness(self, val: bool = ..., **kwargs: Any): ...

class TabLayout(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def closeTab(self, val: bool = ..., **kwargs: Any): ...
    def closeTabCommand(self, val: bool = ..., **kwargs: Any): ...
    def doubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getBorderStyle(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getChildResizable(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImageVisible(self, **kwargs: Any): ...
    def getInnerMarginHeight(self, **kwargs: Any): ...
    def getInnerMarginWidth(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMinChildWidth(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getScrollable(self, **kwargs: Any): ...
    def getScrollableTabs(self, **kwargs: Any): ...
    def getSelectCommand(self, **kwargs: Any): ...
    def getSelectTab(self, **kwargs: Any): ...
    def getSelectTabIndex(self, **kwargs: Any): ...
    def getShowNewTab(self, **kwargs: Any): ...
    def getTabLabel(self, **kwargs: Any): ...
    def getTabLabelIndex(self, **kwargs: Any): ...
    def getTabPosition(self, **kwargs: Any): ...
    def getTabTooltip(self, **kwargs: Any): ...
    def getTabTooltipIndex(self, **kwargs: Any): ...
    def getTabsClosable(self, **kwargs: Any): ...
    def getTabsVisible(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def horizontalScrollBarThickness(self, val: bool = ..., **kwargs: Any): ...
    def moveTab(self, val: bool = ..., **kwargs: Any): ...
    def newTabCommand(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def postMenuCommand(self, val: bool = ..., **kwargs: Any): ...
    def preSelectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setBorderStyle(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImageVisible(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setScrollableTabs(self, val: bool = ..., **kwargs: Any): ...
    def setSelectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setSelectTab(self, val: bool = ..., **kwargs: Any): ...
    def setSelectTabIndex(self, val: bool = ..., **kwargs: Any): ...
    def setShowNewTab(self, val: bool = ..., **kwargs: Any): ...
    def setTabLabel(self, val: bool = ..., **kwargs: Any): ...
    def setTabLabelIndex(self, val: bool = ..., **kwargs: Any): ...
    def setTabPosition(self, val: bool = ..., **kwargs: Any): ...
    def setTabTooltip(self, val: bool = ..., **kwargs: Any): ...
    def setTabTooltipIndex(self, val: bool = ..., **kwargs: Any): ...
    def setTabsVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def verticalScrollBarThickness(self, val: bool = ..., **kwargs: Any): ...

class TextFieldGrp(Layout):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def adjustableColumn(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn2(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn3(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn4(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn5(self, val: bool = ..., **kwargs: Any): ...
    def adjustableColumn6(self, val: bool = ..., **kwargs: Any): ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign2(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign3(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign4(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign5(self, val: bool = ..., **kwargs: Any): ...
    def columnAlign6(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach2(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach3(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach4(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach5(self, val: bool = ..., **kwargs: Any): ...
    def columnAttach6(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset2(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset3(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset4(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset5(self, val: bool = ..., **kwargs: Any): ...
    def columnOffset6(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth1(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth2(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth3(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth4(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth5(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth6(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def forceChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFileName(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getInsertionPosition(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPlaceholderText(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def insertText(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowAttach(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFileName(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setInsertionPosition(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPlaceholderText(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def textChangedCommand(self, val: bool = ..., **kwargs: Any): ...

class LayoutDialog(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...

class MenuEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def cellWidthHeight(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCellHeight(self, **kwargs: Any): ...
    def getCellWidth(self, **kwargs: Any): ...
    def getCheckBoxPresent(self, **kwargs: Any): ...
    def getCheckBoxState(self, **kwargs: Any): ...
    def getChildArray(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMenuItemTypes(self, **kwargs: Any): ...
    def getNumberOfChildren(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOptionBoxCommand(self, **kwargs: Any): ...
    def getOptionBoxPresent(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRadioButtonPresent(self, **kwargs: Any): ...
    def getRadioButtonState(self, **kwargs: Any): ...
    def getSeparator(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getSubMenuEditorsOpen(self, **kwargs: Any): ...
    def getTopLevelMenu(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCellHeight(self, val: bool = ..., **kwargs: Any): ...
    def setCellWidth(self, val: bool = ..., **kwargs: Any): ...
    def setCheckBoxPresent(self, val: bool = ..., **kwargs: Any): ...
    def setCheckBoxState(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setOptionBoxCommand(self, val: bool = ..., **kwargs: Any): ...
    def setOptionBoxPresent(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRadioButtonPresent(self, val: bool = ..., **kwargs: Any): ...
    def setRadioButtonState(self, val: bool = ..., **kwargs: Any): ...
    def setSeparator(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setTopLevelMenu(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def subMenuAt(self, val: bool = ..., **kwargs: Any): ...

class MenuSet(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getAllMenuSets(self, **kwargs: Any): ...
    def getCurrentMenuSet(self, **kwargs: Any): ...
    def getExists(self, **kwargs: Any): ...
    def getHotBoxVisible(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuArray(self, **kwargs: Any): ...
    def getNumberOfMenuSets(self, **kwargs: Any): ...
    def getNumberOfMenus(self, **kwargs: Any): ...
    def getPermanent(self, **kwargs: Any): ...
    def setHotBoxVisible(self, val: bool = ..., **kwargs: Any): ...
    def setPermanent(self, val: bool = ..., **kwargs: Any): ...

class MessageLine(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ModelEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def activeCustomEnvironment(self, val: bool = ..., **kwargs: Any): ...
    def addObjects(self, val: bool = ..., **kwargs: Any): ...
    def addSelected(self, val: bool = ..., **kwargs: Any): ...
    def cameraName(self, val: bool = ..., **kwargs: Any): ...
    def getActiveComponentsXray(self, **kwargs: Any): ...
    def getActiveCustomGeometry(self, **kwargs: Any): ...
    def getActiveCustomLighSet(self, **kwargs: Any): ...
    def getActiveCustomOverrideGeometry(self, **kwargs: Any): ...
    def getActiveCustomRenderer(self, **kwargs: Any): ...
    def getActiveOnly(self, **kwargs: Any): ...
    def getActiveShadingGraph(self, **kwargs: Any): ...
    def getActiveView(self, **kwargs: Any): ...
    def getAllObjects(self, **kwargs: Any): ...
    def getBackfaceCulling(self, **kwargs: Any): ...
    def getBufferMode(self, **kwargs: Any): ...
    def getBumpResolution(self, **kwargs: Any): ...
    def getCamera(self, **kwargs: Any): ...
    def getCameraSet(self, **kwargs: Any): ...
    def getCameraSetup(self, **kwargs: Any): ...
    def getCameras(self, **kwargs: Any): ...
    def getCapture(self, **kwargs: Any): ...
    def getCaptureSequenceNumber(self, **kwargs: Any): ...
    def getClipGhosts(self, **kwargs: Any): ...
    def getCmEnabled(self, **kwargs: Any): ...
    def getColorMap(self, **kwargs: Any): ...
    def getColorResolution(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getControlVertices(self, **kwargs: Any): ...
    def getCullingOverride(self, **kwargs: Any): ...
    def getDefault(self, **kwargs: Any): ...
    def getDeformers(self, **kwargs: Any): ...
    def getDimensions(self, **kwargs: Any): ...
    def getDisplayAppearance(self, **kwargs: Any): ...
    def getDisplayLights(self, **kwargs: Any): ...
    def getDisplayTextures(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDynamicConstraints(self, **kwargs: Any): ...
    def getDynamics(self, **kwargs: Any): ...
    def getEditorChanged(self, **kwargs: Any): ...
    def getExposure(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getFilteredObjectList(self, **kwargs: Any): ...
    def getFluids(self, **kwargs: Any): ...
    def getFogColor(self, **kwargs: Any): ...
    def getFogDensity(self, **kwargs: Any): ...
    def getFogEnd(self, **kwargs: Any): ...
    def getFogMode(self, **kwargs: Any): ...
    def getFogSource(self, **kwargs: Any): ...
    def getFogStart(self, **kwargs: Any): ...
    def getFogging(self, **kwargs: Any): ...
    def getFollicles(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getGamma(self, **kwargs: Any): ...
    def getGreasePencils(self, **kwargs: Any): ...
    def getGrid(self, **kwargs: Any): ...
    def getHairSystems(self, **kwargs: Any): ...
    def getHandles(self, **kwargs: Any): ...
    def getHeadsUpDisplay(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getHulls(self, **kwargs: Any): ...
    def getIgnorePanZoom(self, **kwargs: Any): ...
    def getIkHandles(self, **kwargs: Any): ...
    def getImagePlane(self, **kwargs: Any): ...
    def getInteractive(self, **kwargs: Any): ...
    def getInteractiveBackFaceCull(self, **kwargs: Any): ...
    def getInteractiveDisableShadows(self, **kwargs: Any): ...
    def getIsFiltered(self, **kwargs: Any): ...
    def getJointXray(self, **kwargs: Any): ...
    def getJoints(self, **kwargs: Any): ...
    def getLights(self, **kwargs: Any): ...
    def getLineWidth(self, **kwargs: Any): ...
    def getLocators(self, **kwargs: Any): ...
    def getLowQualityLighting(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getManipulators(self, **kwargs: Any): ...
    def getMaxConstantTransparency(self, **kwargs: Any): ...
    def getMaximumNumHardwareLights(self, **kwargs: Any): ...
    def getMotionTrails(self, **kwargs: Any): ...
    def getNCloths(self, **kwargs: Any): ...
    def getNParticles(self, **kwargs: Any): ...
    def getNRigids(self, **kwargs: Any): ...
    def getNurbsCurves(self, **kwargs: Any): ...
    def getNurbsSurfaces(self, **kwargs: Any): ...
    def getObjectFilter(self, **kwargs: Any): ...
    def getObjectFilterList(self, **kwargs: Any): ...
    def getObjectFilterListUI(self, **kwargs: Any): ...
    def getObjectFilterShowInHUD(self, **kwargs: Any): ...
    def getObjectFilterUI(self, **kwargs: Any): ...
    def getOcclusionCulling(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getParticleInstancers(self, **kwargs: Any): ...
    def getPivots(self, **kwargs: Any): ...
    def getPlanes(self, **kwargs: Any): ...
    def getPolymeshes(self, **kwargs: Any): ...
    def getQueryPluginObjects(self, **kwargs: Any): ...
    def getRendererDeviceName(self, **kwargs: Any): ...
    def getRendererList(self, **kwargs: Any): ...
    def getRendererListUI(self, **kwargs: Any): ...
    def getRendererName(self, **kwargs: Any): ...
    def getRendererOverrideList(self, **kwargs: Any): ...
    def getRendererOverrideListUI(self, **kwargs: Any): ...
    def getRendererOverrideName(self, **kwargs: Any): ...
    def getSceneRenderFilter(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getSelectionHiliteDisplay(self, **kwargs: Any): ...
    def getShadingModel(self, **kwargs: Any): ...
    def getShadows(self, **kwargs: Any): ...
    def getSmallObjectCulling(self, **kwargs: Any): ...
    def getSmallObjectThreshold(self, **kwargs: Any): ...
    def getSmoothWireframe(self, **kwargs: Any): ...
    def getSortTransparent(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getStereoDrawMode(self, **kwargs: Any): ...
    def getStrokes(self, **kwargs: Any): ...
    def getSubdivSurfaces(self, **kwargs: Any): ...
    def getTextureAnisotropic(self, **kwargs: Any): ...
    def getTextureCompression(self, **kwargs: Any): ...
    def getTextureDisplay(self, **kwargs: Any): ...
    def getTextureEnvironmentMap(self, **kwargs: Any): ...
    def getTextureHilight(self, **kwargs: Any): ...
    def getTextureMaxSize(self, **kwargs: Any): ...
    def getTextureMemoryUsed(self, **kwargs: Any): ...
    def getTextureSampling(self, **kwargs: Any): ...
    def getTextures(self, **kwargs: Any): ...
    def getTranspInShadows(self, **kwargs: Any): ...
    def getTransparencyAlgorithm(self, **kwargs: Any): ...
    def getTwoSidedLighting(self, **kwargs: Any): ...
    def getUseBaseRenderer(self, **kwargs: Any): ...
    def getUseColorIndex(self, **kwargs: Any): ...
    def getUseDefaultMaterial(self, **kwargs: Any): ...
    def getUseInteractiveMode(self, **kwargs: Any): ...
    def getUseRGBImagePlane(self, **kwargs: Any): ...
    def getUseReducedRenderer(self, **kwargs: Any): ...
    def getUserNode(self, **kwargs: Any): ...
    def getViewObjects(self, **kwargs: Any): ...
    def getViewSelected(self, **kwargs: Any): ...
    def getViewTransformName(self, **kwargs: Any): ...
    def getViewType(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def getWireframeBackingStore(self, **kwargs: Any): ...
    def getWireframeOnShaded(self, **kwargs: Any): ...
    def getXray(self, **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def noUndo(self, val: bool = ..., **kwargs: Any): ...
    def pluginObjects(self, val: bool = ..., **kwargs: Any): ...
    def pluginShapes(self, val: bool = ..., **kwargs: Any): ...
    def removeSelected(self, val: bool = ..., **kwargs: Any): ...
    def resetCustomCamera(self, val: bool = ..., **kwargs: Any): ...
    def setActiveComponentsXray(self, val: bool = ..., **kwargs: Any): ...
    def setActiveCustomGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setActiveCustomLighSet(self, val: bool = ..., **kwargs: Any): ...
    def setActiveCustomOverrideGeometry(self, val: bool = ..., **kwargs: Any): ...
    def setActiveCustomRenderer(self, val: bool = ..., **kwargs: Any): ...
    def setActiveOnly(self, val: bool = ..., **kwargs: Any): ...
    def setActiveShadingGraph(self, val: bool = ..., **kwargs: Any): ...
    def setActiveView(self, val: bool = ..., **kwargs: Any): ...
    def setAllObjects(self, val: bool = ..., **kwargs: Any): ...
    def setBackfaceCulling(self, val: bool = ..., **kwargs: Any): ...
    def setBufferMode(self, val: bool = ..., **kwargs: Any): ...
    def setBumpResolution(self, val: bool = ..., **kwargs: Any): ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setCameraSet(self, val: bool = ..., **kwargs: Any): ...
    def setCameras(self, val: bool = ..., **kwargs: Any): ...
    def setCapture(self, val: bool = ..., **kwargs: Any): ...
    def setCaptureSequenceNumber(self, val: bool = ..., **kwargs: Any): ...
    def setClipGhosts(self, val: bool = ..., **kwargs: Any): ...
    def setCmEnabled(self, val: bool = ..., **kwargs: Any): ...
    def setColorResolution(self, val: bool = ..., **kwargs: Any): ...
    def setControlVertices(self, val: bool = ..., **kwargs: Any): ...
    def setCullingOverride(self, val: bool = ..., **kwargs: Any): ...
    def setDefault(self, val: bool = ..., **kwargs: Any): ...
    def setDeformers(self, val: bool = ..., **kwargs: Any): ...
    def setDimensions(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayAppearance(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayLights(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayTextures(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDynamicConstraints(self, val: bool = ..., **kwargs: Any): ...
    def setDynamics(self, val: bool = ..., **kwargs: Any): ...
    def setEditorChanged(self, val: bool = ..., **kwargs: Any): ...
    def setExposure(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setFluids(self, val: bool = ..., **kwargs: Any): ...
    def setFogColor(self, val: bool = ..., **kwargs: Any): ...
    def setFogDensity(self, val: bool = ..., **kwargs: Any): ...
    def setFogEnd(self, val: bool = ..., **kwargs: Any): ...
    def setFogMode(self, val: bool = ..., **kwargs: Any): ...
    def setFogSource(self, val: bool = ..., **kwargs: Any): ...
    def setFogStart(self, val: bool = ..., **kwargs: Any): ...
    def setFogging(self, val: bool = ..., **kwargs: Any): ...
    def setFollicles(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setGamma(self, val: bool = ..., **kwargs: Any): ...
    def setGreasePencils(self, val: bool = ..., **kwargs: Any): ...
    def setGrid(self, val: bool = ..., **kwargs: Any): ...
    def setHairSystems(self, val: bool = ..., **kwargs: Any): ...
    def setHandles(self, val: bool = ..., **kwargs: Any): ...
    def setHeadsUpDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHulls(self, val: bool = ..., **kwargs: Any): ...
    def setIgnorePanZoom(self, val: bool = ..., **kwargs: Any): ...
    def setIkHandles(self, val: bool = ..., **kwargs: Any): ...
    def setImagePlane(self, val: bool = ..., **kwargs: Any): ...
    def setInteractive(self, val: bool = ..., **kwargs: Any): ...
    def setInteractiveBackFaceCull(self, val: bool = ..., **kwargs: Any): ...
    def setInteractiveDisableShadows(self, val: bool = ..., **kwargs: Any): ...
    def setJointXray(self, val: bool = ..., **kwargs: Any): ...
    def setJoints(self, val: bool = ..., **kwargs: Any): ...
    def setLights(self, val: bool = ..., **kwargs: Any): ...
    def setLineWidth(self, val: bool = ..., **kwargs: Any): ...
    def setLocators(self, val: bool = ..., **kwargs: Any): ...
    def setLowQualityLighting(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setManipulators(self, val: bool = ..., **kwargs: Any): ...
    def setMaxConstantTransparency(self, val: bool = ..., **kwargs: Any): ...
    def setMaximumNumHardwareLights(self, val: bool = ..., **kwargs: Any): ...
    def setMotionTrails(self, val: bool = ..., **kwargs: Any): ...
    def setNCloths(self, val: bool = ..., **kwargs: Any): ...
    def setNParticles(self, val: bool = ..., **kwargs: Any): ...
    def setNRigids(self, val: bool = ..., **kwargs: Any): ...
    def setNurbsCurves(self, val: bool = ..., **kwargs: Any): ...
    def setNurbsSurfaces(self, val: bool = ..., **kwargs: Any): ...
    def setObjectFilter(self, val: bool = ..., **kwargs: Any): ...
    def setObjectFilterShowInHUD(self, val: bool = ..., **kwargs: Any): ...
    def setOcclusionCulling(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setParticleInstancers(self, val: bool = ..., **kwargs: Any): ...
    def setPivots(self, val: bool = ..., **kwargs: Any): ...
    def setPlanes(self, val: bool = ..., **kwargs: Any): ...
    def setPolymeshes(self, val: bool = ..., **kwargs: Any): ...
    def setRendererName(self, val: bool = ..., **kwargs: Any): ...
    def setRendererOverrideName(self, val: bool = ..., **kwargs: Any): ...
    def setSceneRenderFilter(self, val: bool = ..., **kwargs: Any): ...
    def setSelected(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionHiliteDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setShadingModel(self, val: bool = ..., **kwargs: Any): ...
    def setShadows(self, val: bool = ..., **kwargs: Any): ...
    def setSmallObjectCulling(self, val: bool = ..., **kwargs: Any): ...
    def setSmallObjectThreshold(self, val: bool = ..., **kwargs: Any): ...
    def setSmoothWireframe(self, val: bool = ..., **kwargs: Any): ...
    def setSortTransparent(self, val: bool = ..., **kwargs: Any): ...
    def setStereoDrawMode(self, val: bool = ..., **kwargs: Any): ...
    def setStrokes(self, val: bool = ..., **kwargs: Any): ...
    def setSubdivSurfaces(self, val: bool = ..., **kwargs: Any): ...
    def setTextureAnisotropic(self, val: bool = ..., **kwargs: Any): ...
    def setTextureCompression(self, val: bool = ..., **kwargs: Any): ...
    def setTextureDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setTextureEnvironmentMap(self, val: bool = ..., **kwargs: Any): ...
    def setTextureHilight(self, val: bool = ..., **kwargs: Any): ...
    def setTextureMaxSize(self, val: bool = ..., **kwargs: Any): ...
    def setTextureSampling(self, val: bool = ..., **kwargs: Any): ...
    def setTextures(self, val: bool = ..., **kwargs: Any): ...
    def setTranspInShadows(self, val: bool = ..., **kwargs: Any): ...
    def setTransparencyAlgorithm(self, val: bool = ..., **kwargs: Any): ...
    def setTwoSidedLighting(self, val: bool = ..., **kwargs: Any): ...
    def setUseBaseRenderer(self, val: bool = ..., **kwargs: Any): ...
    def setUseColorIndex(self, val: bool = ..., **kwargs: Any): ...
    def setUseDefaultMaterial(self, val: bool = ..., **kwargs: Any): ...
    def setUseInteractiveMode(self, val: bool = ..., **kwargs: Any): ...
    def setUseRGBImagePlane(self, val: bool = ..., **kwargs: Any): ...
    def setUseReducedRenderer(self, val: bool = ..., **kwargs: Any): ...
    def setUserNode(self, val: bool = ..., **kwargs: Any): ...
    def setViewSelected(self, val: bool = ..., **kwargs: Any): ...
    def setViewTransformName(self, val: bool = ..., **kwargs: Any): ...
    def setWireframeBackingStore(self, val: bool = ..., **kwargs: Any): ...
    def setWireframeOnShaded(self, val: bool = ..., **kwargs: Any): ...
    def setXray(self, val: bool = ..., **kwargs: Any): ...
    def toggleExposure(self, val: bool = ..., **kwargs: Any): ...
    def toggleGamma(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateColorMode(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...

class NameField(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDrawInactiveFrame(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNameChangeCommand(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getObject(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getReceiveFocusCommand(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDrawInactiveFrame(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setNameChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setObject(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setReceiveFocusCommand(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class NodeIconButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getDisabledImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFlipX(self, **kwargs: Any): ...
    def getFlipY(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelOffset(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOverlayLabelBackColor(self, **kwargs: Any): ...
    def getOverlayLabelColor(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getUseAlpha(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDisabledImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFlipX(self, val: bool = ..., **kwargs: Any): ...
    def setFlipY(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelOffset(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelBackColor(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelColor(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setUseAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class OutlinerEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def allowMultiSelection(self, val: bool = ..., **kwargs: Any): ...
    def alwaysToggleSelect(self, val: bool = ..., **kwargs: Any): ...
    def directSelect(self, val: bool = ..., **kwargs: Any): ...
    def expandAllItems(self, val: bool = ..., **kwargs: Any): ...
    def expandAllSelectedItems(self, val: bool = ..., **kwargs: Any): ...
    def expandAttribute(self, val: bool = ..., **kwargs: Any): ...
    def getAnimLayerFilterOptions(self, **kwargs: Any): ...
    def getAttrAlphaOrder(self, **kwargs: Any): ...
    def getAttrFilter(self, **kwargs: Any): ...
    def getAutoExpand(self, **kwargs: Any): ...
    def getAutoExpandAnimatedShapes(self, **kwargs: Any): ...
    def getAutoExpandLayers(self, **kwargs: Any): ...
    def getAutoSelectNewObjects(self, **kwargs: Any): ...
    def getContainersIgnoreFilters(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDisplayMode(self, **kwargs: Any): ...
    def getDoNotSelectNewObjects(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDropIsParent(self, **kwargs: Any): ...
    def getEditAttrName(self, **kwargs: Any): ...
    def getExpandConnections(self, **kwargs: Any): ...
    def getExpandObjects(self, **kwargs: Any): ...
    def getFeedbackItemName(self, **kwargs: Any): ...
    def getFeedbackRowNumber(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getGetCurrentSetOfItem(self, **kwargs: Any): ...
    def getHighlightActive(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getHighlightSecondary(self, **kwargs: Any): ...
    def getIgnoreDagHierarchy(self, **kwargs: Any): ...
    def getIgnoreHiddenAttribute(self, **kwargs: Any): ...
    def getIgnoreOutlinerColor(self, **kwargs: Any): ...
    def getIsChildSelected(self, **kwargs: Any): ...
    def getIsSet(self, **kwargs: Any): ...
    def getIsSetMember(self, **kwargs: Any): ...
    def getIsUfeItem(self, **kwargs: Any): ...
    def getLongNames(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getMapMotionTrails(self, **kwargs: Any): ...
    def getMasterOutliner(self, **kwargs: Any): ...
    def getNiceNames(self, **kwargs: Any): ...
    def getObject(self, **kwargs: Any): ...
    def getOrganizeByClip(self, **kwargs: Any): ...
    def getOrganizeByLayer(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getParentObject(self, **kwargs: Any): ...
    def getPinPlug(self, **kwargs: Any): ...
    def getRenderFilterActive(self, **kwargs: Any): ...
    def getRenderFilterIndex(self, **kwargs: Any): ...
    def getRenderFilterVisible(self, **kwargs: Any): ...
    def getSelectCommand(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getSetFilter(self, **kwargs: Any): ...
    def getSetsIgnoreFilters(self, **kwargs: Any): ...
    def getShowAnimCurvesOnly(self, **kwargs: Any): ...
    def getShowAnimLayerWeight(self, **kwargs: Any): ...
    def getShowAssets(self, **kwargs: Any): ...
    def getShowAssignedMaterials(self, **kwargs: Any): ...
    def getShowAttrValues(self, **kwargs: Any): ...
    def getShowAttributes(self, **kwargs: Any): ...
    def getShowCompounds(self, **kwargs: Any): ...
    def getShowConnected(self, **kwargs: Any): ...
    def getShowContainedOnly(self, **kwargs: Any): ...
    def getShowContainerContents(self, **kwargs: Any): ...
    def getShowDagOnly(self, **kwargs: Any): ...
    def getShowLeafs(self, **kwargs: Any): ...
    def getShowMuteInfo(self, **kwargs: Any): ...
    def getShowNamespace(self, **kwargs: Any): ...
    def getShowNumericAttrsOnly(self, **kwargs: Any): ...
    def getShowParentContainers(self, **kwargs: Any): ...
    def getShowPinIcons(self, **kwargs: Any): ...
    def getShowPublishedAsConnected(self, **kwargs: Any): ...
    def getShowReferenceMembers(self, **kwargs: Any): ...
    def getShowReferenceNodes(self, **kwargs: Any): ...
    def getShowSetMembers(self, **kwargs: Any): ...
    def getShowShapes(self, **kwargs: Any): ...
    def getShowTextureNodesOnly(self, **kwargs: Any): ...
    def getShowTimeEditor(self, **kwargs: Any): ...
    def getShowUVAttrsOnly(self, **kwargs: Any): ...
    def getShowUnitlessCurves(self, **kwargs: Any): ...
    def getShowUpstreamCurves(self, **kwargs: Any): ...
    def getSortOrder(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getTransmitFilters(self, **kwargs: Any): ...
    def getUfeFilter(self, **kwargs: Any): ...
    def getUfeFilterValue(self, **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def refresh(self, val: bool = ..., **kwargs: Any): ...
    def removeFromCurrentSet(self, val: bool = ..., **kwargs: Any): ...
    def renameItem(self, val: bool = ..., **kwargs: Any): ...
    def renameSelectedItem(self, val: bool = ..., **kwargs: Any): ...
    def selectionOrder(self, val: bool = ..., **kwargs: Any): ...
    def setAnimLayerFilterOptions(self, val: bool = ..., **kwargs: Any): ...
    def setAttrAlphaOrder(self, val: bool = ..., **kwargs: Any): ...
    def setAttrFilter(self, val: bool = ..., **kwargs: Any): ...
    def setAutoExpand(self, val: bool = ..., **kwargs: Any): ...
    def setAutoExpandAnimatedShapes(self, val: bool = ..., **kwargs: Any): ...
    def setAutoExpandLayers(self, val: bool = ..., **kwargs: Any): ...
    def setAutoSelectNewObjects(self, val: bool = ..., **kwargs: Any): ...
    def setContainersIgnoreFilters(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayMode(self, val: bool = ..., **kwargs: Any): ...
    def setDoNotSelectNewObjects(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDropIsParent(self, val: bool = ..., **kwargs: Any): ...
    def setEditAttrName(self, val: bool = ..., **kwargs: Any): ...
    def setExpandConnections(self, val: bool = ..., **kwargs: Any): ...
    def setExpandObjects(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightActive(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightSecondary(self, val: bool = ..., **kwargs: Any): ...
    def setIgnoreDagHierarchy(self, val: bool = ..., **kwargs: Any): ...
    def setIgnoreHiddenAttribute(self, val: bool = ..., **kwargs: Any): ...
    def setIgnoreOutlinerColor(self, val: bool = ..., **kwargs: Any): ...
    def setLongNames(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMapMotionTrails(self, val: bool = ..., **kwargs: Any): ...
    def setMasterOutliner(self, val: bool = ..., **kwargs: Any): ...
    def setNiceNames(self, val: bool = ..., **kwargs: Any): ...
    def setOrganizeByClip(self, val: bool = ..., **kwargs: Any): ...
    def setOrganizeByLayer(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setPinPlug(self, val: bool = ..., **kwargs: Any): ...
    def setRenderFilterIndex(self, val: bool = ..., **kwargs: Any): ...
    def setRenderFilterVisible(self, val: bool = ..., **kwargs: Any): ...
    def setSelectCommand(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setSetFilter(self, val: bool = ..., **kwargs: Any): ...
    def setSetsIgnoreFilters(self, val: bool = ..., **kwargs: Any): ...
    def setShowAnimCurvesOnly(self, val: bool = ..., **kwargs: Any): ...
    def setShowAnimLayerWeight(self, val: bool = ..., **kwargs: Any): ...
    def setShowAssets(self, val: bool = ..., **kwargs: Any): ...
    def setShowAssignedMaterials(self, val: bool = ..., **kwargs: Any): ...
    def setShowAttrValues(self, val: bool = ..., **kwargs: Any): ...
    def setShowAttributes(self, val: bool = ..., **kwargs: Any): ...
    def setShowCompounds(self, val: bool = ..., **kwargs: Any): ...
    def setShowConnected(self, val: bool = ..., **kwargs: Any): ...
    def setShowContainedOnly(self, val: bool = ..., **kwargs: Any): ...
    def setShowContainerContents(self, val: bool = ..., **kwargs: Any): ...
    def setShowDagOnly(self, val: bool = ..., **kwargs: Any): ...
    def setShowLeafs(self, val: bool = ..., **kwargs: Any): ...
    def setShowMuteInfo(self, val: bool = ..., **kwargs: Any): ...
    def setShowNamespace(self, val: bool = ..., **kwargs: Any): ...
    def setShowNumericAttrsOnly(self, val: bool = ..., **kwargs: Any): ...
    def setShowParentContainers(self, val: bool = ..., **kwargs: Any): ...
    def setShowPinIcons(self, val: bool = ..., **kwargs: Any): ...
    def setShowPublishedAsConnected(self, val: bool = ..., **kwargs: Any): ...
    def setShowReferenceMembers(self, val: bool = ..., **kwargs: Any): ...
    def setShowReferenceNodes(self, val: bool = ..., **kwargs: Any): ...
    def setShowSetMembers(self, val: bool = ..., **kwargs: Any): ...
    def setShowShapes(self, val: bool = ..., **kwargs: Any): ...
    def setShowTextureNodesOnly(self, val: bool = ..., **kwargs: Any): ...
    def setShowTimeEditor(self, val: bool = ..., **kwargs: Any): ...
    def setShowUVAttrsOnly(self, val: bool = ..., **kwargs: Any): ...
    def setShowUnitlessCurves(self, val: bool = ..., **kwargs: Any): ...
    def setShowUpstreamCurves(self, val: bool = ..., **kwargs: Any): ...
    def setSortOrder(self, val: bool = ..., **kwargs: Any): ...
    def setTransmitFilters(self, val: bool = ..., **kwargs: Any): ...
    def setUfeFilter(self, val: bool = ..., **kwargs: Any): ...
    def setUfeFilterValue(self, val: bool = ..., **kwargs: Any): ...
    def showSelected(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def unpinPlug(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...

class PalettePort(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def colorEdited(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getActualTotal(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getColorEditable(self, **kwargs: Any): ...
    def getDimensions(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHsvValue(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRgbValue(self, **kwargs: Any): ...
    def getSetCurCell(self, **kwargs: Any): ...
    def getTransparent(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def redraw(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setColorEditable(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHsvValue(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRgbValue(self, val: bool = ..., **kwargs: Any): ...
    def setSetCurCell(self, val: bool = ..., **kwargs: Any): ...
    def setTransparent(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class BlendShapePanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getBlendShapeEditor(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class DevicePanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class DynRelEdPanel(Panel):
    __melui__: str = ...

class HardwareRenderPanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getCamera(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getGlRenderEditor(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class HyperPanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getHyperEditor(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class ModelPanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getBarLayout(self, **kwargs: Any): ...
    def getCamera(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getModelEditor(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setCamera(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class OutlinerPanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDivider(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getOutlinerEditor(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setDivider(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class ScriptedPanel(Panel):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def copy(self, val: bool = ..., **kwargs: Any): ...
    def createString(self, val: bool = ..., **kwargs: Any): ...
    def editString(self, val: bool = ..., **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getIsUnique(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getMenuBarRepeatLast(self, **kwargs: Any): ...
    def getMenuBarVisible(self, **kwargs: Any): ...
    def getNeedsInit(self, **kwargs: Any): ...
    def getPopupMenuProcedure(self, **kwargs: Any): ...
    def getTearOff(self, **kwargs: Any): ...
    def getType(self, **kwargs: Any): ...
    def init(self, val: bool = ..., **kwargs: Any): ...
    def replacePanel(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarRepeatLast(self, val: bool = ..., **kwargs: Any): ...
    def setMenuBarVisible(self, val: bool = ..., **kwargs: Any): ...
    def setNeedsInit(self, val: bool = ..., **kwargs: Any): ...
    def setPopupMenuProcedure(self, val: bool = ..., **kwargs: Any): ...
    def setTearOff(self, val: bool = ..., **kwargs: Any): ...
    def tearOffRestore(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...

class PromptDialog(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getText(self, **kwargs: Any): ...

class RadioButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getData(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRecomputeSize(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def offCommand(self, val: bool = ..., **kwargs: Any): ...
    def onCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setData(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRecomputeSize(self, val: bool = ..., **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class RadioCollection(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getCollectionItemArray(self, **kwargs: Any): ...
    def getGl(self, **kwargs: Any): ...
    def getNumberOfCollectionItems(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...

class RadioMenuItemCollection(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getGl(self, **kwargs: Any): ...

class RenderLayerButton(PyUI):
    __melui__: str = ...

class RenderWindowEditor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def colorManage(self, val: bool = ..., **kwargs: Any): ...
    def getAutoResize(self, **kwargs: Any): ...
    def getBlendMode(self, **kwargs: Any): ...
    def getCaption(self, **kwargs: Any): ...
    def getChangeCommand(self, **kwargs: Any): ...
    def getClear(self, **kwargs: Any): ...
    def getCmEnabled(self, **kwargs: Any): ...
    def getCompDisplay(self, **kwargs: Any): ...
    def getCompImageFile(self, **kwargs: Any): ...
    def getControl(self, **kwargs: Any): ...
    def getCurrentCamera(self, **kwargs: Any): ...
    def getCurrentCameraRig(self, **kwargs: Any): ...
    def getDisplayImage(self, **kwargs: Any): ...
    def getDisplayImageViewCount(self, **kwargs: Any): ...
    def getDisplayStyle(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDoubleBuffer(self, **kwargs: Any): ...
    def getDrawAxis(self, **kwargs: Any): ...
    def getEditorName(self, **kwargs: Any): ...
    def getExposure(self, **kwargs: Any): ...
    def getFilter(self, **kwargs: Any): ...
    def getForceMainConnection(self, **kwargs: Any): ...
    def getFrameImage(self, **kwargs: Any): ...
    def getFrameRegion(self, **kwargs: Any): ...
    def getGamma(self, **kwargs: Any): ...
    def getHighlightConnection(self, **kwargs: Any): ...
    def getMainListConnection(self, **kwargs: Any): ...
    def getMarquee(self, **kwargs: Any): ...
    def getNbImages(self, **kwargs: Any): ...
    def getPanel(self, **kwargs: Any): ...
    def getPcaption(self, **kwargs: Any): ...
    def getRealSize(self, **kwargs: Any): ...
    def getResetRegion(self, **kwargs: Any): ...
    def getScaleBlue(self, **kwargs: Any): ...
    def getScaleGreen(self, **kwargs: Any): ...
    def getScaleRed(self, **kwargs: Any): ...
    def getSelectionConnection(self, **kwargs: Any): ...
    def getShowRegion(self, **kwargs: Any): ...
    def getSingleBuffer(self, **kwargs: Any): ...
    def getSnapshot(self, **kwargs: Any): ...
    def getSnapshotMode(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getStereo(self, **kwargs: Any): ...
    def getStereoImageOrientation(self, **kwargs: Any): ...
    def getStereoMode(self, **kwargs: Any): ...
    def getToggle(self, **kwargs: Any): ...
    def getViewImageCount(self, **kwargs: Any): ...
    def getViewTransformName(self, **kwargs: Any): ...
    def loadImage(self, val: bool = ..., **kwargs: Any): ...
    def lockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def nextViewImage(self, val: bool = ..., **kwargs: Any): ...
    def outputColorManage(self, val: bool = ..., **kwargs: Any): ...
    def refresh(self, val: bool = ..., **kwargs: Any): ...
    def removeAllImages(self, val: bool = ..., **kwargs: Any): ...
    def removeImage(self, val: bool = ..., **kwargs: Any): ...
    def resetViewImage(self, val: bool = ..., **kwargs: Any): ...
    def saveImage(self, val: bool = ..., **kwargs: Any): ...
    def setAutoResize(self, val: bool = ..., **kwargs: Any): ...
    def setBlendMode(self, val: bool = ..., **kwargs: Any): ...
    def setCaption(self, val: bool = ..., **kwargs: Any): ...
    def setChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setClear(self, val: bool = ..., **kwargs: Any): ...
    def setCmEnabled(self, val: bool = ..., **kwargs: Any): ...
    def setCompDisplay(self, val: bool = ..., **kwargs: Any): ...
    def setCompImageFile(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentCamera(self, val: bool = ..., **kwargs: Any): ...
    def setCurrentCameraRig(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayImage(self, val: bool = ..., **kwargs: Any): ...
    def setDisplayStyle(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDoubleBuffer(self, val: bool = ..., **kwargs: Any): ...
    def setDrawAxis(self, val: bool = ..., **kwargs: Any): ...
    def setExposure(self, val: bool = ..., **kwargs: Any): ...
    def setFilter(self, val: bool = ..., **kwargs: Any): ...
    def setForceMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def setFrameImage(self, val: bool = ..., **kwargs: Any): ...
    def setFrameRegion(self, val: bool = ..., **kwargs: Any): ...
    def setGamma(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMainListConnection(self, val: bool = ..., **kwargs: Any): ...
    def setMarquee(self, val: bool = ..., **kwargs: Any): ...
    def setParent(self, val: bool = ..., **kwargs: Any): ...
    def setPcaption(self, val: bool = ..., **kwargs: Any): ...
    def setRealSize(self, val: bool = ..., **kwargs: Any): ...
    def setResetRegion(self, val: bool = ..., **kwargs: Any): ...
    def setScaleBlue(self, val: bool = ..., **kwargs: Any): ...
    def setScaleGreen(self, val: bool = ..., **kwargs: Any): ...
    def setScaleRed(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionConnection(self, val: bool = ..., **kwargs: Any): ...
    def setShowRegion(self, val: bool = ..., **kwargs: Any): ...
    def setSingleBuffer(self, val: bool = ..., **kwargs: Any): ...
    def setSnapshot(self, val: bool = ..., **kwargs: Any): ...
    def setSnapshotMode(self, val: bool = ..., **kwargs: Any): ...
    def setStereo(self, val: bool = ..., **kwargs: Any): ...
    def setStereoImageOrientation(self, val: bool = ..., **kwargs: Any): ...
    def setStereoMode(self, val: bool = ..., **kwargs: Any): ...
    def setToggle(self, val: bool = ..., **kwargs: Any): ...
    def setViewImageCount(self, val: bool = ..., **kwargs: Any): ...
    def setViewTransformName(self, val: bool = ..., **kwargs: Any): ...
    def unParent(self, val: bool = ..., **kwargs: Any): ...
    def unlockMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def updateMainConnection(self, val: bool = ..., **kwargs: Any): ...
    def writeImage(self, val: bool = ..., **kwargs: Any): ...

class ScriptTable(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def afterCellChangedCmd(self, val: bool = ..., **kwargs: Any): ...
    def cellBackgroundColorCommand(self, val: bool = ..., **kwargs: Any): ...
    def cellChangedCmd(self, val: bool = ..., **kwargs: Any): ...
    def cellForegroundColorCommand(self, val: bool = ..., **kwargs: Any): ...
    def clearRow(self, val: bool = ..., **kwargs: Any): ...
    def clearTable(self, val: bool = ..., **kwargs: Any): ...
    def columnFilter(self, val: bool = ..., **kwargs: Any): ...
    def columnWidth(self, val: bool = ..., **kwargs: Any): ...
    def deleteRow(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCellCmd(self, val: bool = ..., **kwargs: Any): ...
    def getCellIndex(self, **kwargs: Any): ...
    def getCellValue(self, **kwargs: Any): ...
    def getColumns(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getExcludingHeaders(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMultiEditEnabled(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRowHeight(self, **kwargs: Any): ...
    def getRows(self, **kwargs: Any): ...
    def getSelectedCells(self, **kwargs: Any): ...
    def getSelectedColumns(self, **kwargs: Any): ...
    def getSelectedRow(self, **kwargs: Any): ...
    def getSelectedRows(self, **kwargs: Any): ...
    def getSelectionBehavior(self, **kwargs: Any): ...
    def getSelectionMode(self, **kwargs: Any): ...
    def getSortEnabled(self, **kwargs: Any): ...
    def getUnderPointerColumn(self, **kwargs: Any): ...
    def getUnderPointerRow(self, **kwargs: Any): ...
    def getUseDoubleClickEdit(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def insertRow(self, val: bool = ..., **kwargs: Any): ...
    def label(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def rowsRemovedCmd(self, val: bool = ..., **kwargs: Any): ...
    def rowsToBeRemovedCmd(self, val: bool = ..., **kwargs: Any): ...
    def selectionChangedCmd(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCellIndex(self, val: bool = ..., **kwargs: Any): ...
    def setCellValue(self, val: bool = ..., **kwargs: Any): ...
    def setColumns(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMultiEditEnabled(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRowHeight(self, val: bool = ..., **kwargs: Any): ...
    def setRows(self, val: bool = ..., **kwargs: Any): ...
    def setSelectedCells(self, val: bool = ..., **kwargs: Any): ...
    def setSelectedColumns(self, val: bool = ..., **kwargs: Any): ...
    def setSelectedRows(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionBehavior(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionMode(self, val: bool = ..., **kwargs: Any): ...
    def setSortEnabled(self, val: bool = ..., **kwargs: Any): ...
    def setUseDoubleClickEdit(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ScriptedPanelType(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getAddCallback(self, **kwargs: Any): ...
    def getCopyStateCallback(self, **kwargs: Any): ...
    def getCreateCallback(self, **kwargs: Any): ...
    def getCustomView(self, **kwargs: Any): ...
    def getDeleteCallback(self, **kwargs: Any): ...
    def getHotkeyCtxClient(self, **kwargs: Any): ...
    def getInitCallback(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getObsolete(self, **kwargs: Any): ...
    def getRemoveCallback(self, **kwargs: Any): ...
    def getRetainOnFileOpen(self, **kwargs: Any): ...
    def getSaveStateCallback(self, **kwargs: Any): ...
    def getUnique(self, **kwargs: Any): ...
    def setAddCallback(self, val: bool = ..., **kwargs: Any): ...
    def setCopyStateCallback(self, val: bool = ..., **kwargs: Any): ...
    def setCreateCallback(self, val: bool = ..., **kwargs: Any): ...
    def setCustomView(self, val: bool = ..., **kwargs: Any): ...
    def setDeleteCallback(self, val: bool = ..., **kwargs: Any): ...
    def setHotkeyCtxClient(self, val: bool = ..., **kwargs: Any): ...
    def setInitCallback(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setObsolete(self, val: bool = ..., **kwargs: Any): ...
    def setRemoveCallback(self, val: bool = ..., **kwargs: Any): ...
    def setRetainOnFileOpen(self, val: bool = ..., **kwargs: Any): ...
    def setSaveStateCallback(self, val: bool = ..., **kwargs: Any): ...
    def setUnique(self, val: bool = ..., **kwargs: Any): ...

class ScrollField(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def clear(self, val: bool = ..., **kwargs: Any): ...
    def command(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def enterCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFontPointSize(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getInsertionPosition(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfLines(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getQtFont(self, **kwargs: Any): ...
    def getSelection(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def insertText(self, val: bool = ..., **kwargs: Any): ...
    def keyPressCommand(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setFontPointSize(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setInsertionPosition(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setQtFont(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class Separator(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHorizontal(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ShelfButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getCommandRepeatable(self, **kwargs: Any): ...
    def getDisabledImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDoubleClickCommand(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableCommandRepeat(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFlat(self, **kwargs: Any): ...
    def getFlexibleWidthType(self, **kwargs: Any): ...
    def getFlexibleWidthValue(self, **kwargs: Any): ...
    def getFlipX(self, **kwargs: Any): ...
    def getFlipY(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHighlightImage(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getLabelOffset(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getMarginHeight(self, **kwargs: Any): ...
    def getMarginWidth(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOverlayLabelBackColor(self, **kwargs: Any): ...
    def getOverlayLabelColor(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRotation(self, **kwargs: Any): ...
    def getSelectionImage(self, **kwargs: Any): ...
    def getSourceType(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getUseAlpha(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def handleNodeDropCallback(self, val: bool = ..., **kwargs: Any): ...
    def labelEditingCallback(self, val: bool = ..., **kwargs: Any): ...
    def menuItem(self, val: bool = ..., **kwargs: Any): ...
    def menuItemPython(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def scaleIcon(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setCommandRepeatable(self, val: bool = ..., **kwargs: Any): ...
    def setDisabledImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDoubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableCommandRepeat(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFlat(self, val: bool = ..., **kwargs: Any): ...
    def setFlexibleWidthType(self, val: bool = ..., **kwargs: Any): ...
    def setFlexibleWidthValue(self, val: bool = ..., **kwargs: Any): ...
    def setFlipX(self, val: bool = ..., **kwargs: Any): ...
    def setFlipY(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLabelOffset(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setMarginHeight(self, val: bool = ..., **kwargs: Any): ...
    def setMarginWidth(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelBackColor(self, val: bool = ..., **kwargs: Any): ...
    def setOverlayLabelColor(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRotation(self, val: bool = ..., **kwargs: Any): ...
    def setSelectionImage(self, val: bool = ..., **kwargs: Any): ...
    def setSourceType(self, val: bool = ..., **kwargs: Any): ...
    def setStyle(self, val: bool = ..., **kwargs: Any): ...
    def setUseAlpha(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class ShellField(PyUI):
    __melui__: str = ...

class SymbolButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setCommand(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class SymbolCheckBox(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDisableOffImage(self, **kwargs: Any): ...
    def getDisableOnImage(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage(self, **kwargs: Any): ...
    def getInnerMargin(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getOffImage(self, **kwargs: Any): ...
    def getOnImage(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getValue(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def offCommand(self, val: bool = ..., **kwargs: Any): ...
    def onCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDisableOffImage(self, val: bool = ..., **kwargs: Any): ...
    def setDisableOnImage(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage(self, val: bool = ..., **kwargs: Any): ...
    def setInnerMargin(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setOffImage(self, val: bool = ..., **kwargs: Any): ...
    def setOnImage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setValue(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class Text(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropRectCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAlign(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getHyperlink(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLabel(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getRecomputeSize(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def getWordWrap(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def setAlign(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setHyperlink(self, val: bool = ..., **kwargs: Any): ...
    def setLabel(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setRecomputeSize(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...

class TextCurves(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...

class TextField(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def enterCommand(self, val: bool = ..., **kwargs: Any): ...
    def getAlwaysInvokeEnterCommandOnReturn(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDisableButtons(self, **kwargs: Any): ...
    def getDisableClearButton(self, **kwargs: Any): ...
    def getDisableHistoryButton(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getDrawInactiveFrame(self, **kwargs: Any): ...
    def getEditable(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFileName(self, **kwargs: Any): ...
    def getFont(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getInsertionPosition(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPlaceholderText(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getText(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def insertText(self, val: bool = ..., **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def receiveFocusCommand(self, val: bool = ..., **kwargs: Any): ...
    def setAlwaysInvokeEnterCommandOnReturn(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDisableButtons(self, val: bool = ..., **kwargs: Any): ...
    def setDisableClearButton(self, val: bool = ..., **kwargs: Any): ...
    def setDisableHistoryButton(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setDrawInactiveFrame(self, val: bool = ..., **kwargs: Any): ...
    def setEditable(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setFileName(self, val: bool = ..., **kwargs: Any): ...
    def setFont(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setInsertionPosition(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPlaceholderText(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setText(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def textChangedCommand(self, val: bool = ..., **kwargs: Any): ...

class ToolButton(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def changeCommand(self, val: bool = ..., **kwargs: Any): ...
    def collection(self, val: bool = ..., **kwargs: Any): ...
    def doubleClickCommand(self, val: bool = ..., **kwargs: Any): ...
    def dragCallback(self, val: bool = ..., **kwargs: Any): ...
    def dropCallback(self, val: bool = ..., **kwargs: Any): ...
    def getAllowMultipleTools(self, **kwargs: Any): ...
    def getAnnotation(self, **kwargs: Any): ...
    def getBackgroundColor(self, **kwargs: Any): ...
    def getDocTag(self, **kwargs: Any): ...
    def getEnable(self, **kwargs: Any): ...
    def getEnableBackground(self, **kwargs: Any): ...
    def getEnableKeyboardFocus(self, **kwargs: Any): ...
    def getFullPathName(self, **kwargs: Any): ...
    def getHeight(self, **kwargs: Any): ...
    def getHighlightColor(self, **kwargs: Any): ...
    def getImage1(self, **kwargs: Any): ...
    def getImage2(self, **kwargs: Any): ...
    def getImage3(self, **kwargs: Any): ...
    def getImageOverlayLabel(self, **kwargs: Any): ...
    def getIsObscured(self, **kwargs: Any): ...
    def getLtVersion(self, **kwargs: Any): ...
    def getManage(self, **kwargs: Any): ...
    def getNumberOfPopupMenus(self, **kwargs: Any): ...
    def getPopupIndicatorVisible(self, **kwargs: Any): ...
    def getPopupMenuArray(self, **kwargs: Any): ...
    def getPreventOverride(self, **kwargs: Any): ...
    def getTool(self, **kwargs: Any): ...
    def getToolArray(self, **kwargs: Any): ...
    def getToolCount(self, **kwargs: Any): ...
    def getToolImage1(self, **kwargs: Any): ...
    def getToolImage2(self, **kwargs: Any): ...
    def getToolImage3(self, **kwargs: Any): ...
    def getVersion(self, **kwargs: Any): ...
    def getVisible(self, **kwargs: Any): ...
    def getVisibleChangeCommand(self, **kwargs: Any): ...
    def getWidth(self, **kwargs: Any): ...
    def noBackground(self, val: bool = ..., **kwargs: Any): ...
    def offCommand(self, val: bool = ..., **kwargs: Any): ...
    def onCommand(self, val: bool = ..., **kwargs: Any): ...
    def select(self, val: bool = ..., **kwargs: Any): ...
    def setAnnotation(self, val: bool = ..., **kwargs: Any): ...
    def setBackgroundColor(self, val: bool = ..., **kwargs: Any): ...
    def setDocTag(self, val: bool = ..., **kwargs: Any): ...
    def setEnable(self, val: bool = ..., **kwargs: Any): ...
    def setEnableBackground(self, val: bool = ..., **kwargs: Any): ...
    def setEnableKeyboardFocus(self, val: bool = ..., **kwargs: Any): ...
    def setHeight(self, val: bool = ..., **kwargs: Any): ...
    def setHighlightColor(self, val: bool = ..., **kwargs: Any): ...
    def setImage1(self, val: bool = ..., **kwargs: Any): ...
    def setImage2(self, val: bool = ..., **kwargs: Any): ...
    def setImage3(self, val: bool = ..., **kwargs: Any): ...
    def setImageOverlayLabel(self, val: bool = ..., **kwargs: Any): ...
    def setLtVersion(self, val: bool = ..., **kwargs: Any): ...
    def setManage(self, val: bool = ..., **kwargs: Any): ...
    def setPopupIndicatorVisible(self, val: bool = ..., **kwargs: Any): ...
    def setPreventOverride(self, val: bool = ..., **kwargs: Any): ...
    def setTool(self, val: bool = ..., **kwargs: Any): ...
    def setToolImage1(self, val: bool = ..., **kwargs: Any): ...
    def setToolImage2(self, val: bool = ..., **kwargs: Any): ...
    def setToolImage3(self, val: bool = ..., **kwargs: Any): ...
    def setVersion(self, val: bool = ..., **kwargs: Any): ...
    def setVisible(self, val: bool = ..., **kwargs: Any): ...
    def setVisibleChangeCommand(self, val: bool = ..., **kwargs: Any): ...
    def setWidth(self, val: bool = ..., **kwargs: Any): ...
    def statusBarMessage(self, val: bool = ..., **kwargs: Any): ...
    def style(self, val: bool = ..., **kwargs: Any): ...

class ToolCollection(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getCollectionItemArray(self, **kwargs: Any): ...
    def getGl(self, **kwargs: Any): ...
    def getNumberOfCollectionItems(self, **kwargs: Any): ...
    def getSelect(self, **kwargs: Any): ...
    def setSelect(self, val: bool = ..., **kwargs: Any): ...

class Visor(PyUI):
    __melcmd__: Any = ...
    __melcmd_isinfo__: bool = ...
    __melcmdname__: str = ...
    __melui__: str = ...
    def getAddFolder(self, **kwargs: Any): ...
    def getAddNodes(self, **kwargs: Any): ...
    def getAllowPanningInX(self, **kwargs: Any): ...
    def getAllowPanningInY(self, **kwargs: Any): ...
    def getAllowZooming(self, **kwargs: Any): ...
    def getCommand(self, **kwargs: Any): ...
    def getDeleteFolder(self, **kwargs: Any): ...
    def getEditFolder(self, **kwargs: Any): ...
    def getFolderList(self, **kwargs: Any): ...
    def getMenu(self, **kwargs: Any): ...
    def getNodeType(self, **kwargs: Any): ...
    def getOpenDirectories(self, **kwargs: Any): ...
    def getOpenFolder(self, **kwargs: Any): ...
    def getPath(self, **kwargs: Any): ...
    def getPopupMenuScript(self, **kwargs: Any): ...
    def getRebuild(self, **kwargs: Any): ...
    def getRefreshAllSwatches(self, **kwargs: Any): ...
    def getRefreshSelectedSwatches(self, **kwargs: Any): ...
    def getRefreshSwatch(self, **kwargs: Any): ...
    def getReset(self, **kwargs: Any): ...
    def getRestrictPanAndZoom(self, **kwargs: Any): ...
    def getSaveSwatches(self, **kwargs: Any): ...
    def getScrollBar(self, **kwargs: Any): ...
    def getScrollPercent(self, **kwargs: Any): ...
    def getSelectedGadgets(self, **kwargs: Any): ...
    def getShowDividers(self, **kwargs: Any): ...
    def getShowFiles(self, **kwargs: Any): ...
    def getShowFolders(self, **kwargs: Any): ...
    def getShowNodes(self, **kwargs: Any): ...
    def getStateString(self, **kwargs: Any): ...
    def getStyle(self, **kwargs: Any): ...
    def getTransform(self, **kwargs: Any): ...
    def getType(self, **kwargs: Any): ...
